#ifndef _WINERROR_H
#define _WINERROR_H

#ifdef __ORANGEC__ 
#pragma once
#endif

/* Windows error code definitions */

#define __forceinline inline
#ifndef FORCEINLINE
#define FORCEINLINE  __forceinline
#endif /* FORCEINLINE */

#define FACILITY_XPS  82
#define FACILITY_XBOX  2339
#define FACILITY_XAML  43
#define FACILITY_USN  129
#define FACILITY_BLBUI  128
#define FACILITY_SPP  256
#define FACILITY_WSB_ONLINE  133
#define FACILITY_DLS  153
#define FACILITY_BLB_CLI  121
#define FACILITY_BLB  120
#define FACILITY_WSBAPP  122
#define FACILITY_WPN  62
#define FACILITY_WMAAECMA  1996
#define FACILITY_WINRM  51
#define FACILITY_WINPE  61
#define FACILITY_WINDOWSUPDATE  36
#define FACILITY_WINDOWS_STORE  63
#define FACILITY_WINDOWS_SETUP  48
#define FACILITY_WINDOWS_DEFENDER  80
#define FACILITY_WINDOWS_CE  24
#define FACILITY_WINDOWS  8
#define FACILITY_WINCODEC_DWRITE_DWM  2200
#define FACILITY_WIA  33
#define FACILITY_WER  27
#define FACILITY_WEP  2049
#define FACILITY_WEB_SOCKET  886
#define FACILITY_WEB  885
#define FACILITY_USERMODE_VOLSNAP  130
#define FACILITY_USERMODE_VOLMGR  56
#define FACILITY_VISUALCPP  109
#define FACILITY_USERMODE_VIRTUALIZATION 55
#define FACILITY_USERMODE_VHD  58
#define FACILITY_UTC  1989
#define FACILITY_URT  19
#define FACILITY_UMI  22
#define FACILITY_UI  42
#define FACILITY_TPM_SOFTWARE  41
#define FACILITY_TPM_SERVICES  40
#define FACILITY_TIERING  131
#define FACILITY_SYNCENGINE  2050
#define FACILITY_SXS  23
#define FACILITY_STORAGE  3
#define FACILITY_STATEREPOSITORY  103
#define FACILITY_STATE_MANAGEMENT  34
#define FACILITY_SSPI  9
#define FACILITY_SQLITE  1967
#define FACILITY_USERMODE_SPACES  231
#define FACILITY_SOS  160
#define FACILITY_SCARD  16
#define FACILITY_SHELL  39
#define FACILITY_SETUPAPI  15
#define FACILITY_SECURITY  9
#define FACILITY_USER_MODE_SECURITY_CORE 232
#define FACILITY_SDIAG  60
#define FACILITY_USERMODE_SDBUS  2305
#define FACILITY_RPC  1
#define FACILITY_RESTORE  256
#define FACILITY_SCRIPT  112
#define FACILITY_PARSE  113
#define FACILITY_RAS  83
#define FACILITY_POWERSHELL  84
#define FACILITY_PLA  48
#define FACILITY_PIDGENX  2561
#define FACILITY_P2P_INT  98
#define FACILITY_P2P  99
#define FACILITY_OPC  81
#define FACILITY_ONLINE_ID  134
#define FACILITY_WIN32  7
#define FACILITY_CONTROL  10
#define FACILITY_WEBSERVICES  61
#define FACILITY_NULL  0
#define FACILITY_NDIS  52
#define FACILITY_NAP  39
#define FACILITY_MOBILE  1793
#define FACILITY_METADIRECTORY  35
#define FACILITY_MSMQ  14
#define FACILITY_MEDIASERVER  13
#define FACILITY_MBN  84
#define FACILITY_LINGUISTIC_SERVICES  305
#define FACILITY_USERMODE_LICENSING  234
#define FACILITY_LEAP  2184
#define FACILITY_JSCRIPT  2306
#define FACILITY_INTERNET  12
#define FACILITY_ITF  4
#define FACILITY_INPUT  64
#define FACILITY_USERMODE_HYPERVISOR  53
#define FACILITY_ACCELERATOR  1536
#define FACILITY_HTTP  25
#define FACILITY_USERMODE_HNS  59
#define FACILITY_GRAPHICS  38
#define FACILITY_FWP  50
#define FACILITY_FVE  49
#define FACILITY_USERMODE_FILTER_MANAGER 31
#define FACILITY_EAS  85
#define FACILITY_EAP  66
#define FACILITY_DXGI_DDI  2171
#define FACILITY_DXGI  2170
#define FACILITY_DPLAY  21
#define FACILITY_DMSERVER  256
#define FACILITY_DISPATCH  2
#define FACILITY_DIRECTORYSERVICE  37
#define FACILITY_DIRECTMUSIC  2168
#define FACILITY_DIRECT3D12_DEBUG  2175
#define FACILITY_DIRECT3D12  2174
#define FACILITY_DIRECT3D11_DEBUG  2173
#define FACILITY_DIRECT3D11  2172
#define FACILITY_DIRECT3D10  2169
#define FACILITY_DIRECT2D  2201
#define FACILITY_DAF  100
#define FACILITY_DEPLOYMENT_SERVICES_UTIL 260
#define FACILITY_DEPLOYMENT_SERVICES_TRANSPORT_MANAGEMENT 272
#define FACILITY_DEPLOYMENT_SERVICES_TFTP 264
#define FACILITY_DEPLOYMENT_SERVICES_PXE 263
#define FACILITY_DEPLOYMENT_SERVICES_MULTICAST_SERVER 289
#define FACILITY_DEPLOYMENT_SERVICES_MULTICAST_CLIENT 290
#define FACILITY_DEPLOYMENT_SERVICES_MANAGEMENT 259
#define FACILITY_DEPLOYMENT_SERVICES_IMAGING 258
#define FACILITY_DEPLOYMENT_SERVICES_DRIVER_PROVISIONING 278
#define FACILITY_DEPLOYMENT_SERVICES_SERVER 257
#define FACILITY_DEPLOYMENT_SERVICES_CONTENT_PROVIDER 293
#define FACILITY_DEPLOYMENT_SERVICES_BINLSVC 261
#define FACILITY_DELIVERY_OPTIMIZATION  208
#define FACILITY_DEFRAG  2304
#define FACILITY_DEBUGGERS  176
#define FACILITY_CONFIGURATION  33
#define FACILITY_COMPLUS  17
#define FACILITY_USERMODE_COMMONLOG  26
#define FACILITY_CMI  54
#define FACILITY_CERT  11
#define FACILITY_BLUETOOTH_ATT  101
#define FACILITY_BCD  57
#define FACILITY_BACKGROUNDCOPY  32
#define FACILITY_AUDIOSTREAMING  1094
#define FACILITY_AUDCLNT  2185
#define FACILITY_AUDIO  102
#define FACILITY_ACTION_QUEUE  44
#define FACILITY_ACS  20
#define FACILITY_AAF  18

#define ERROR_SUCCESS  0L
#define NO_ERROR 0L
#define SEC_E_OK  ((HRESULT)0x00000000L)

#define ERROR_INVALID_FUNCTION  1L
#define ERROR_FILE_NOT_FOUND  2L
#define ERROR_PATH_NOT_FOUND  3L
#define ERROR_TOO_MANY_OPEN_FILES  4L
#define ERROR_ACCESS_DENIED  5L
#define ERROR_INVALID_HANDLE  6L
#define ERROR_ARENA_TRASHED  7L
#define ERROR_NOT_ENOUGH_MEMORY  8L
#define ERROR_INVALID_BLOCK  9L
#define ERROR_BAD_ENVIRONMENT  10L
#define ERROR_BAD_FORMAT  11L
#define ERROR_INVALID_ACCESS  12L
#define ERROR_INVALID_DATA  13L
#define ERROR_OUTOFMEMORY  14L
#define ERROR_INVALID_DRIVE  15L
#define ERROR_CURRENT_DIRECTORY  16L
#define ERROR_NOT_SAME_DEVICE  17L
#define ERROR_NO_MORE_FILES  18L
#define ERROR_WRITE_PROTECT  19L
#define ERROR_BAD_UNIT  20L
#define ERROR_NOT_READY  21L
#define ERROR_BAD_COMMAND  22L
#define ERROR_CRC  23L
#define ERROR_BAD_LENGTH  24L
#define ERROR_SEEK  25L
#define ERROR_NOT_DOS_DISK  26L
#define ERROR_SECTOR_NOT_FOUND  27L
#define ERROR_OUT_OF_PAPER  28L
#define ERROR_WRITE_FAULT  29L
#define ERROR_READ_FAULT  30L
#define ERROR_GEN_FAILURE  31L
#define ERROR_SHARING_VIOLATION  32L
#define ERROR_LOCK_VIOLATION  33L
#define ERROR_WRONG_DISK  34L
#define ERROR_SHARING_BUFFER_EXCEEDED  36L
#define ERROR_HANDLE_EOF  38L
#define ERROR_HANDLE_DISK_FULL  39L
#define ERROR_NOT_SUPPORTED  50L
#define ERROR_REM_NOT_LIST  51L
#define ERROR_DUP_NAME  52L
#define ERROR_BAD_NETPATH  53L
#define ERROR_NETWORK_BUSY  54L
#define ERROR_DEV_NOT_EXIST  55L
#define ERROR_TOO_MANY_CMDS  56L
#define ERROR_ADAP_HDW_ERR  57L
#define ERROR_BAD_NET_RESP  58L
#define ERROR_UNEXP_NET_ERR  59L
#define ERROR_BAD_REM_ADAP  60L
#define ERROR_PRINTQ_FULL  61L
#define ERROR_NO_SPOOL_SPACE  62L
#define ERROR_PRINT_CANCELLED  63L
#define ERROR_NETNAME_DELETED  64L
#define ERROR_NETWORK_ACCESS_DENIED  65L
#define ERROR_BAD_DEV_TYPE  66L
#define ERROR_BAD_NET_NAME  67L
#define ERROR_TOO_MANY_NAMES  68L
#define ERROR_TOO_MANY_SESS  69L
#define ERROR_SHARING_PAUSED  70L
#define ERROR_REQ_NOT_ACCEP  71L
#define ERROR_REDIR_PAUSED  72L
#define ERROR_FILE_EXISTS  80L
#define ERROR_CANNOT_MAKE  82L
#define ERROR_FAIL_I24  83L
#define ERROR_OUT_OF_STRUCTURES  84L
#define ERROR_ALREADY_ASSIGNED  85L
#define ERROR_INVALID_PASSWORD  86L
#define ERROR_INVALID_PARAMETER  87L
#define ERROR_NET_WRITE_FAULT  88L
#define ERROR_NO_PROC_SLOTS  89L
#define ERROR_TOO_MANY_SEMAPHORES  100L
#define ERROR_EXCL_SEM_ALREADY_OWNED  101L
#define ERROR_SEM_IS_SET  102L
#define ERROR_TOO_MANY_SEM_REQUESTS  103L
#define ERROR_INVALID_AT_INTERRUPT_TIME  104L
#define ERROR_SEM_OWNER_DIED  105L
#define ERROR_SEM_USER_LIMIT  106L
#define ERROR_DISK_CHANGE  107L
#define ERROR_DRIVE_LOCKED  108L
#define ERROR_BROKEN_PIPE  109L
#define ERROR_OPEN_FAILED  110L
#define ERROR_BUFFER_OVERFLOW  111L
#define ERROR_DISK_FULL  112L
#define ERROR_NO_MORE_SEARCH_HANDLES  113L
#define ERROR_INVALID_TARGET_HANDLE  114L
#define ERROR_INVALID_CATEGORY  117L
#define ERROR_INVALID_VERIFY_SWITCH  118L
#define ERROR_BAD_DRIVER_LEVEL  119L
#define ERROR_CALL_NOT_IMPLEMENTED  120L
#define ERROR_SEM_TIMEOUT  121L
#define ERROR_INSUFFICIENT_BUFFER  122L
#define ERROR_INVALID_NAME  123L
#define ERROR_INVALID_LEVEL  124L
#define ERROR_NO_VOLUME_LABEL  125L
#define ERROR_MOD_NOT_FOUND  126L
#define ERROR_PROC_NOT_FOUND  127L
#define ERROR_WAIT_NO_CHILDREN  128L
#define ERROR_CHILD_NOT_COMPLETE  129L
#define ERROR_DIRECT_ACCESS_HANDLE  130L
#define ERROR_NEGATIVE_SEEK  131L
#define ERROR_SEEK_ON_DEVICE  132L
#define ERROR_IS_JOIN_TARGET  133L
#define ERROR_IS_JOINED  134L
#define ERROR_IS_SUBSTED  135L
#define ERROR_NOT_JOINED  136L
#define ERROR_NOT_SUBSTED  137L
#define ERROR_JOIN_TO_JOIN  138L
#define ERROR_SUBST_TO_SUBST  139L
#define ERROR_JOIN_TO_SUBST  140L
#define ERROR_SUBST_TO_JOIN  141L
#define ERROR_BUSY_DRIVE  142L
#define ERROR_SAME_DRIVE  143L
#define ERROR_DIR_NOT_ROOT  144L
#define ERROR_DIR_NOT_EMPTY  145L
#define ERROR_IS_SUBST_PATH  146L
#define ERROR_IS_JOIN_PATH  147L
#define ERROR_PATH_BUSY  148L
#define ERROR_IS_SUBST_TARGET  149L
#define ERROR_SYSTEM_TRACE  150L
#define ERROR_INVALID_EVENT_COUNT  151L
#define ERROR_TOO_MANY_MUXWAITERS  152L
#define ERROR_INVALID_LIST_FORMAT  153L
#define ERROR_LABEL_TOO_LONG  154L
#define ERROR_TOO_MANY_TCBS  155L
#define ERROR_SIGNAL_REFUSED  156L
#define ERROR_DISCARDED  157L
#define ERROR_NOT_LOCKED  158L
#define ERROR_BAD_THREADID_ADDR  159L
#define ERROR_BAD_ARGUMENTS  160L
#define ERROR_BAD_PATHNAME  161L
#define ERROR_SIGNAL_PENDING  162L
#define ERROR_MAX_THRDS_REACHED  164L
#define ERROR_LOCK_FAILED  167L
#define ERROR_BUSY  170L
#define ERROR_DEVICE_SUPPORT_IN_PROGRESS 171L
#define ERROR_CANCEL_VIOLATION  173L
#define ERROR_ATOMIC_LOCKS_NOT_SUPPORTED 174L
#define ERROR_INVALID_SEGMENT_NUMBER  180L
#define ERROR_INVALID_ORDINAL  182L
#define ERROR_ALREADY_EXISTS  183L
#define ERROR_INVALID_FLAG_NUMBER  186L
#define ERROR_SEM_NOT_FOUND  187L
#define ERROR_INVALID_STARTING_CODESEG  188L
#define ERROR_INVALID_STACKSEG  189L
#define ERROR_INVALID_MODULETYPE  190L
#define ERROR_INVALID_EXE_SIGNATURE  191L
#define ERROR_EXE_MARKED_INVALID  192L
#define ERROR_BAD_EXE_FORMAT  193L
#define ERROR_ITERATED_DATA_EXCEEDS_64k  194L
#define ERROR_INVALID_MINALLOCSIZE  195L
#define ERROR_DYNLINK_FROM_INVALID_RING  196L
#define ERROR_IOPL_NOT_ENABLED  197L
#define ERROR_INVALID_SEGDPL  198L
#define ERROR_AUTODATASEG_EXCEEDS_64k  199L
#define ERROR_RING2SEG_MUST_BE_MOVABLE  200L
#define ERROR_RELOC_CHAIN_XEEDS_SEGLIM  201L
#define ERROR_INFLOOP_IN_RELOC_CHAIN  202L
#define ERROR_ENVVAR_NOT_FOUND  203L
#define ERROR_NO_SIGNAL_SENT  205L
#define ERROR_FILENAME_EXCED_RANGE  206L
#define ERROR_RING2_STACK_IN_USE  207L
#define ERROR_META_EXPANSION_TOO_LONG  208L
#define ERROR_INVALID_SIGNAL_NUMBER  209L
#define ERROR_THREAD_1_INACTIVE  210L
#define ERROR_LOCKED  212L
#define ERROR_TOO_MANY_MODULES  214L
#define ERROR_NESTING_NOT_ALLOWED  215L
#define ERROR_EXE_MACHINE_TYPE_MISMATCH  216L
#define ERROR_EXE_CANNOT_MODIFY_SIGNED_BINARY 217L
#define ERROR_EXE_CANNOT_MODIFY_STRONG_SIGNED_BINARY 218L
#define ERROR_FILE_CHECKED_OUT  220L
#define ERROR_CHECKOUT_REQUIRED  221L
#define ERROR_BAD_FILE_TYPE  222L
#define ERROR_FILE_TOO_LARGE  223L
#define ERROR_FORMS_AUTH_REQUIRED  224L
#define ERROR_VIRUS_INFECTED  225L
#define ERROR_VIRUS_DELETED  226L
#define ERROR_PIPE_LOCAL  229L
#define ERROR_BAD_PIPE  230L
#define ERROR_PIPE_BUSY  231L
#define ERROR_NO_DATA  232L
#define ERROR_PIPE_NOT_CONNECTED  233L
#define ERROR_MORE_DATA  234L
#define ERROR_NO_WORK_DONE  235L
#define ERROR_VC_DISCONNECTED  240L
#define ERROR_INVALID_EA_NAME  254L
#define ERROR_EA_LIST_INCONSISTENT  255L
#define WAIT_TIMEOUT  258L
#define ERROR_NO_MORE_ITEMS  259L
#define ERROR_CANNOT_COPY  266L
#define ERROR_DIRECTORY  267L
#define ERROR_EAS_DIDNT_FIT  275L
#define ERROR_EA_FILE_CORRUPT  276L
#define ERROR_EA_TABLE_FULL  277L
#define ERROR_INVALID_EA_HANDLE  278L
#define ERROR_EAS_NOT_SUPPORTED  282L
#define ERROR_NOT_OWNER  288L
#define ERROR_TOO_MANY_POSTS  298L
#define ERROR_PARTIAL_COPY  299L
#define ERROR_OPLOCK_NOT_GRANTED  300L
#define ERROR_INVALID_OPLOCK_PROTOCOL  301L
#define ERROR_DISK_TOO_FRAGMENTED  302L
#define ERROR_DELETE_PENDING  303L
#define ERROR_INCOMPATIBLE_WITH_GLOBAL_SHORT_NAME_REGISTRY_SETTING 304L
#define ERROR_SHORT_NAMES_NOT_ENABLED_ON_VOLUME 305L
#define ERROR_SECURITY_STREAM_IS_INCONSISTENT 306L
#define ERROR_INVALID_LOCK_RANGE  307L
#define ERROR_IMAGE_SUBSYSTEM_NOT_PRESENT 308L
#define ERROR_NOTIFICATION_GUID_ALREADY_DEFINED 309L
#define ERROR_INVALID_EXCEPTION_HANDLER  310L
#define ERROR_DUPLICATE_PRIVILEGES  311L
#define ERROR_NO_RANGES_PROCESSED  312L
#define ERROR_NOT_ALLOWED_ON_SYSTEM_FILE 313L
#define ERROR_DISK_RESOURCES_EXHAUSTED  314L
#define ERROR_INVALID_TOKEN  315L
#define ERROR_DEVICE_FEATURE_NOT_SUPPORTED 316L
#define ERROR_MR_MID_NOT_FOUND  317L
#define ERROR_SCOPE_NOT_FOUND  318L
#define ERROR_UNDEFINED_SCOPE  319L
#define ERROR_INVALID_CAP  320L
#define ERROR_DEVICE_UNREACHABLE  321L
#define ERROR_DEVICE_NO_RESOURCES  322L
#define ERROR_DATA_CHECKSUM_ERROR  323L
#define ERROR_INTERMIXED_KERNEL_EA_OPERATION 324L
#define ERROR_FILE_LEVEL_TRIM_NOT_SUPPORTED 326L
#define ERROR_OFFSET_ALIGNMENT_VIOLATION 327L
#define ERROR_INVALID_FIELD_IN_PARAMETER_LIST 328L
#define ERROR_OPERATION_IN_PROGRESS  329L
#define ERROR_BAD_DEVICE_PATH  330L
#define ERROR_TOO_MANY_DESCRIPTORS  331L
#define ERROR_SCRUB_DATA_DISABLED  332L
#define ERROR_NOT_REDUNDANT_STORAGE  333L
#define ERROR_RESIDENT_FILE_NOT_SUPPORTED 334L
#define ERROR_COMPRESSED_FILE_NOT_SUPPORTED 335L
#define ERROR_DIRECTORY_NOT_SUPPORTED  336L
#define ERROR_NOT_READ_FROM_COPY  337L
#define ERROR_FT_WRITE_FAILURE  338L
#define ERROR_FT_DI_SCAN_REQUIRED  339L
#define ERROR_INVALID_KERNEL_INFO_VERSION 340L
#define ERROR_INVALID_PEP_INFO_VERSION  341L
#define ERROR_OBJECT_NOT_EXTERNALLY_BACKED 342L
#define ERROR_EXTERNAL_BACKING_PROVIDER_UNKNOWN 343L
#define ERROR_COMPRESSION_NOT_BENEFICIAL 344L
#define ERROR_STORAGE_TOPOLOGY_ID_MISMATCH 345L
#define ERROR_BLOCKED_BY_PARENTAL_CONTROLS 346L
#define ERROR_BLOCK_TOO_MANY_REFERENCES  347L
#define ERROR_MARKED_TO_DISALLOW_WRITES  348L
#define ERROR_ENCLAVE_FAILURE  349L
#define ERROR_FAIL_NOACTION_REBOOT  350L
#define ERROR_FAIL_SHUTDOWN  351L
#define ERROR_FAIL_RESTART  352L
#define ERROR_MAX_SESSIONS_REACHED  353L
#define ERROR_NETWORK_ACCESS_DENIED_EDP  354L
#define ERROR_DEVICE_HINT_NAME_BUFFER_TOO_SMALL 355L
#define ERROR_EDP_POLICY_DENIES_OPERATION 356L
#define ERROR_EDP_DPL_POLICY_CANT_BE_SATISFIED 357L
#define ERROR_CLOUD_FILE_PROVIDER_UNKNOWN 358L
#define ERROR_DEVICE_IN_MAINTENANCE  359L
#define ERROR_NOT_SUPPORTED_ON_DAX  360L
#define ERROR_DAX_MAPPING_EXISTS  361L
#define ERROR_CLOUD_FILE_PROVIDER_NOT_RUNNING 362L
#define ERROR_CLOUD_FILE_METADATA_CORRUPT 363L
#define ERROR_CLOUD_FILE_METADATA_TOO_LARGE 364L
#define ERROR_CLOUD_FILE_PROPERTY_BLOB_TOO_LARGE 365L
#define ERROR_CLOUD_FILE_PROPERTY_BLOB_CHECKSUM_MISMATCH 366L
#define ERROR_CHILD_PROCESS_BLOCKED  367L
#define ERROR_STORAGE_LOST_DATA_PERSISTENCE 368L
#define ERROR_THREAD_MODE_ALREADY_BACKGROUND 400L
#define ERROR_THREAD_MODE_NOT_BACKGROUND 401L
#define ERROR_PROCESS_MODE_ALREADY_BACKGROUND 402L
#define ERROR_PROCESS_MODE_NOT_BACKGROUND 403L
#define ERROR_CAPAUTHZ_NOT_DEVUNLOCKED  450L
#define ERROR_CAPAUTHZ_CHANGE_TYPE  451L
#define ERROR_CAPAUTHZ_NOT_PROVISIONED  452L
#define ERROR_CAPAUTHZ_NOT_AUTHORIZED  453L
#define ERROR_CAPAUTHZ_NO_POLICY  454L
#define ERROR_CAPAUTHZ_DB_CORRUPTED  455L
#define ERROR_DEVICE_HARDWARE_ERROR  483L
#define ERROR_INVALID_ADDRESS  487L
#define ERROR_USER_PROFILE_LOAD  500L
#define ERROR_ARITHMETIC_OVERFLOW  534L
#define ERROR_PIPE_CONNECTED  535L
#define ERROR_PIPE_LISTENING  536L
#define ERROR_VERIFIER_STOP  537L
#define ERROR_ABIOS_ERROR  538L
#define ERROR_WX86_WARNING  539L
#define ERROR_WX86_ERROR  540L
#define ERROR_TIMER_NOT_CANCELED  541L
#define ERROR_UNWIND  542L
#define ERROR_BAD_STACK  543L
#define ERROR_INVALID_UNWIND_TARGET  544L
#define ERROR_INVALID_PORT_ATTRIBUTES  545L
#define ERROR_PORT_MESSAGE_TOO_LONG  546L
#define ERROR_INVALID_QUOTA_LOWER  547L
#define ERROR_DEVICE_ALREADY_ATTACHED  548L
#define ERROR_INSTRUCTION_MISALIGNMENT  549L
#define ERROR_PROFILING_NOT_STARTED  550L
#define ERROR_PROFILING_NOT_STOPPED  551L
#define ERROR_COULD_NOT_INTERPRET  552L
#define ERROR_PROFILING_AT_LIMIT  553L
#define ERROR_CANT_WAIT  554L
#define ERROR_CANT_TERMINATE_SELF  555L
#define ERROR_UNEXPECTED_MM_CREATE_ERR  556L
#define ERROR_UNEXPECTED_MM_MAP_ERROR  557L
#define ERROR_UNEXPECTED_MM_EXTEND_ERR  558L
#define ERROR_BAD_FUNCTION_TABLE  559L
#define ERROR_NO_GUID_TRANSLATION  560L
#define ERROR_INVALID_LDT_SIZE  561L
#define ERROR_INVALID_LDT_OFFSET  563L
#define ERROR_INVALID_LDT_DESCRIPTOR  564L
#define ERROR_TOO_MANY_THREADS  565L
#define ERROR_THREAD_NOT_IN_PROCESS  566L
#define ERROR_PAGEFILE_QUOTA_EXCEEDED  567L
#define ERROR_LOGON_SERVER_CONFLICT  568L
#define ERROR_SYNCHRONIZATION_REQUIRED  569L
#define ERROR_NET_OPEN_FAILED  570L
#define ERROR_IO_PRIVILEGE_FAILED  571L
#define ERROR_CONTROL_C_EXIT  572L
#define ERROR_MISSING_SYSTEMFILE  573L
#define ERROR_UNHANDLED_EXCEPTION  574L
#define ERROR_APP_INIT_FAILURE  575L
#define ERROR_PAGEFILE_CREATE_FAILED  576L
#define ERROR_INVALID_IMAGE_HASH  577L
#define ERROR_NO_PAGEFILE  578L
#define ERROR_ILLEGAL_FLOAT_CONTEXT  579L
#define ERROR_NO_EVENT_PAIR  580L
#define ERROR_DOMAIN_CTRLR_CONFIG_ERROR  581L
#define ERROR_ILLEGAL_CHARACTER  582L
#define ERROR_UNDEFINED_CHARACTER  583L
#define ERROR_FLOPPY_VOLUME  584L
#define ERROR_BIOS_FAILED_TO_CONNECT_INTERRUPT 585L
#define ERROR_BACKUP_CONTROLLER  586L
#define ERROR_MUTANT_LIMIT_EXCEEDED  587L
#define ERROR_FS_DRIVER_REQUIRED  588L
#define ERROR_CANNOT_LOAD_REGISTRY_FILE  589L
#define ERROR_DEBUG_ATTACH_FAILED  590L
#define ERROR_SYSTEM_PROCESS_TERMINATED  591L
#define ERROR_DATA_NOT_ACCEPTED  592L
#define ERROR_VDM_HARD_ERROR  593L
#define ERROR_DRIVER_CANCEL_TIMEOUT  594L
#define ERROR_REPLY_MESSAGE_MISMATCH  595L
#define ERROR_LOST_WRITEBEHIND_DATA  596L
#define ERROR_CLIENT_SERVER_PARAMETERS_INVALID 597L
#define ERROR_NOT_TINY_STREAM  598L
#define ERROR_STACK_OVERFLOW_READ  599L
#define ERROR_CONVERT_TO_LARGE  600L
#define ERROR_FOUND_OUT_OF_SCOPE  601L
#define ERROR_ALLOCATE_BUCKET  602L
#define ERROR_MARSHALL_OVERFLOW  603L
#define ERROR_INVALID_VARIANT  604L
#define ERROR_BAD_COMPRESSION_BUFFER  605L
#define ERROR_AUDIT_FAILED  606L
#define ERROR_TIMER_RESOLUTION_NOT_SET  607L
#define ERROR_INSUFFICIENT_LOGON_INFO  608L
#define ERROR_BAD_DLL_ENTRYPOINT  609L
#define ERROR_BAD_SERVICE_ENTRYPOINT  610L
#define ERROR_IP_ADDRESS_CONFLICT1  611L
#define ERROR_IP_ADDRESS_CONFLICT2  612L
#define ERROR_REGISTRY_QUOTA_LIMIT  613L
#define ERROR_NO_CALLBACK_ACTIVE  614L
#define ERROR_PWD_TOO_SHORT  615L
#define ERROR_PWD_TOO_RECENT  616L
#define ERROR_PWD_HISTORY_CONFLICT  617L
#define ERROR_UNSUPPORTED_COMPRESSION  618L
#define ERROR_INVALID_HW_PROFILE  619L
#define ERROR_INVALID_PLUGPLAY_DEVICE_PATH 620L
#define ERROR_QUOTA_LIST_INCONSISTENT  621L
#define ERROR_EVALUATION_EXPIRATION  622L
#define ERROR_ILLEGAL_DLL_RELOCATION  623L
#define ERROR_DLL_INIT_FAILED_LOGOFF  624L
#define ERROR_VALIDATE_CONTINUE  625L
#define ERROR_NO_MORE_MATCHES  626L
#define ERROR_RANGE_LIST_CONFLICT  627L
#define ERROR_SERVER_SID_MISMATCH  628L
#define ERROR_CANT_ENABLE_DENY_ONLY  629L
#define ERROR_FLOAT_MULTIPLE_FAULTS  630L
#define ERROR_FLOAT_MULTIPLE_TRAPS  631L
#define ERROR_NOINTERFACE  632L
#define ERROR_DRIVER_FAILED_SLEEP  633L
#define ERROR_CORRUPT_SYSTEM_FILE  634L
#define ERROR_COMMITMENT_MINIMUM  635L
#define ERROR_PNP_RESTART_ENUMERATION  636L
#define ERROR_SYSTEM_IMAGE_BAD_SIGNATURE 637L
#define ERROR_PNP_REBOOT_REQUIRED  638L
#define ERROR_INSUFFICIENT_POWER  639L
#define ERROR_MULTIPLE_FAULT_VIOLATION  640L
#define ERROR_SYSTEM_SHUTDOWN  641L
#define ERROR_PORT_NOT_SET  642L
#define ERROR_DS_VERSION_CHECK_FAILURE  643L
#define ERROR_RANGE_NOT_FOUND  644L
#define ERROR_NOT_SAFE_MODE_DRIVER  646L
#define ERROR_FAILED_DRIVER_ENTRY  647L
#define ERROR_DEVICE_ENUMERATION_ERROR  648L
#define ERROR_MOUNT_POINT_NOT_RESOLVED  649L
#define ERROR_INVALID_DEVICE_OBJECT_PARAMETER 650L
#define ERROR_MCA_OCCURED  651L
#define ERROR_DRIVER_DATABASE_ERROR  652L
#define ERROR_SYSTEM_HIVE_TOO_LARGE  653L
#define ERROR_DRIVER_FAILED_PRIOR_UNLOAD 654L
#define ERROR_VOLSNAP_PREPARE_HIBERNATE  655L
#define ERROR_HIBERNATION_FAILURE  656L
#define ERROR_PWD_TOO_LONG  657L
#define ERROR_FILE_SYSTEM_LIMITATION  665L
#define ERROR_ASSERTION_FAILURE  668L
#define ERROR_ACPI_ERROR  669L
#define ERROR_WOW_ASSERTION  670L
#define ERROR_PNP_BAD_MPS_TABLE  671L
#define ERROR_PNP_TRANSLATION_FAILED  672L
#define ERROR_PNP_IRQ_TRANSLATION_FAILED 673L
#define ERROR_PNP_INVALID_ID  674L
#define ERROR_WAKE_SYSTEM_DEBUGGER  675L
#define ERROR_HANDLES_CLOSED  676L
#define ERROR_EXTRANEOUS_INFORMATION  677L
#define ERROR_RXACT_COMMIT_NECESSARY  678L
#define ERROR_MEDIA_CHECK  679L
#define ERROR_GUID_SUBSTITUTION_MADE  680L
#define ERROR_STOPPED_ON_SYMLINK  681L
#define ERROR_LONGJUMP  682L
#define ERROR_PLUGPLAY_QUERY_VETOED  683L
#define ERROR_UNWIND_CONSOLIDATE  684L
#define ERROR_REGISTRY_HIVE_RECOVERED  685L
#define ERROR_DLL_MIGHT_BE_INSECURE  686L
#define ERROR_DLL_MIGHT_BE_INCOMPATIBLE  687L
#define ERROR_DBG_EXCEPTION_NOT_HANDLED  688L
#define ERROR_DBG_REPLY_LATER  689L
#define ERROR_DBG_UNABLE_TO_PROVIDE_HANDLE 690L
#define ERROR_DBG_TERMINATE_THREAD  691L
#define ERROR_DBG_TERMINATE_PROCESS  692L
#define ERROR_DBG_CONTROL_C  693L
#define ERROR_DBG_PRINTEXCEPTION_C  694L
#define ERROR_DBG_RIPEXCEPTION  695L
#define ERROR_DBG_CONTROL_BREAK  696L
#define ERROR_DBG_COMMAND_EXCEPTION  697L
#define ERROR_OBJECT_NAME_EXISTS  698L
#define ERROR_THREAD_WAS_SUSPENDED  699L
#define ERROR_IMAGE_NOT_AT_BASE  700L
#define ERROR_RXACT_STATE_CREATED  701L
#define ERROR_SEGMENT_NOTIFICATION  702L
#define ERROR_BAD_CURRENT_DIRECTORY  703L
#define ERROR_FT_READ_RECOVERY_FROM_BACKUP 704L
#define ERROR_FT_WRITE_RECOVERY  705L
#define ERROR_IMAGE_MACHINE_TYPE_MISMATCH 706L
#define ERROR_RECEIVE_PARTIAL  707L
#define ERROR_RECEIVE_EXPEDITED  708L
#define ERROR_RECEIVE_PARTIAL_EXPEDITED  709L
#define ERROR_EVENT_DONE  710L
#define ERROR_EVENT_PENDING  711L
#define ERROR_CHECKING_FILE_SYSTEM  712L
#define ERROR_FATAL_APP_EXIT  713L
#define ERROR_PREDEFINED_HANDLE  714L
#define ERROR_WAS_UNLOCKED  715L
#define ERROR_SERVICE_NOTIFICATION  716L
#define ERROR_WAS_LOCKED  717L
#define ERROR_LOG_HARD_ERROR  718L
#define ERROR_ALREADY_WIN32  719L
#define ERROR_IMAGE_MACHINE_TYPE_MISMATCH_EXE 720L
#define ERROR_NO_YIELD_PERFORMED  721L
#define ERROR_TIMER_RESUME_IGNORED  722L
#define ERROR_ARBITRATION_UNHANDLED  723L
#define ERROR_CARDBUS_NOT_SUPPORTED  724L
#define ERROR_MP_PROCESSOR_MISMATCH  725L
#define ERROR_HIBERNATED  726L
#define ERROR_RESUME_HIBERNATION  727L
#define ERROR_FIRMWARE_UPDATED  728L
#define ERROR_DRIVERS_LEAKING_LOCKED_PAGES 729L
#define ERROR_WAKE_SYSTEM  730L
#define ERROR_WAIT_1  731L
#define ERROR_WAIT_2  732L
#define ERROR_WAIT_3  733L
#define ERROR_WAIT_63  734L
#define ERROR_ABANDONED_WAIT_0  735L
#define ERROR_ABANDONED_WAIT_63  736L
#define ERROR_USER_APC  737L
#define ERROR_KERNEL_APC  738L
#define ERROR_ALERTED  739L
#define ERROR_ELEVATION_REQUIRED  740L
#define ERROR_REPARSE  741L
#define ERROR_OPLOCK_BREAK_IN_PROGRESS  742L
#define ERROR_VOLUME_MOUNTED  743L
#define ERROR_RXACT_COMMITTED  744L
#define ERROR_NOTIFY_CLEANUP  745L
#define ERROR_PRIMARY_TRANSPORT_CONNECT_FAILED 746L
#define ERROR_PAGE_FAULT_TRANSITION  747L
#define ERROR_PAGE_FAULT_DEMAND_ZERO  748L
#define ERROR_PAGE_FAULT_COPY_ON_WRITE  749L
#define ERROR_PAGE_FAULT_GUARD_PAGE  750L
#define ERROR_PAGE_FAULT_PAGING_FILE  751L
#define ERROR_CACHE_PAGE_LOCKED  752L
#define ERROR_CRASH_DUMP  753L
#define ERROR_BUFFER_ALL_ZEROS  754L
#define ERROR_REPARSE_OBJECT  755L
#define ERROR_RESOURCE_REQUIREMENTS_CHANGED 756L
#define ERROR_TRANSLATION_COMPLETE  757L
#define ERROR_NOTHING_TO_TERMINATE  758L
#define ERROR_PROCESS_NOT_IN_JOB  759L
#define ERROR_PROCESS_IN_JOB  760L
#define ERROR_VOLSNAP_HIBERNATE_READY  761L
#define ERROR_FSFILTER_OP_COMPLETED_SUCCESSFULLY 762L
#define ERROR_INTERRUPT_VECTOR_ALREADY_CONNECTED 763L
#define ERROR_INTERRUPT_STILL_CONNECTED  764L
#define ERROR_WAIT_FOR_OPLOCK  765L
#define ERROR_DBG_EXCEPTION_HANDLED  766L
#define ERROR_DBG_CONTINUE  767L
#define ERROR_CALLBACK_POP_STACK  768L
#define ERROR_COMPRESSION_DISABLED  769L
#define ERROR_CANTFETCHBACKWARDS  770L
#define ERROR_CANTSCROLLBACKWARDS  771L
#define ERROR_ROWSNOTRELEASED  772L
#define ERROR_BAD_ACCESSOR_FLAGS  773L
#define ERROR_ERRORS_ENCOUNTERED  774L
#define ERROR_NOT_CAPABLE  775L
#define ERROR_REQUEST_OUT_OF_SEQUENCE  776L
#define ERROR_VERSION_PARSE_ERROR  777L
#define ERROR_BADSTARTPOSITION  778L
#define ERROR_MEMORY_HARDWARE  779L
#define ERROR_DISK_REPAIR_DISABLED  780L
#define ERROR_INSUFFICIENT_RESOURCE_FOR_SPECIFIED_SHARED_SECTION_SIZE 781L
#define ERROR_SYSTEM_POWERSTATE_TRANSITION 782L
#define ERROR_SYSTEM_POWERSTATE_COMPLEX_TRANSITION 783L
#define ERROR_MCA_EXCEPTION  784L
#define ERROR_ACCESS_AUDIT_BY_POLICY  785L
#define ERROR_ACCESS_DISABLED_NO_SAFER_UI_BY_POLICY 786L
#define ERROR_ABANDON_HIBERFILE  787L
#define ERROR_LOST_WRITEBEHIND_DATA_NETWORK_DISCONNECTED 788L
#define ERROR_LOST_WRITEBEHIND_DATA_NETWORK_SERVER_ERROR 789L
#define ERROR_LOST_WRITEBEHIND_DATA_LOCAL_DISK_ERROR 790L
#define ERROR_BAD_MCFG_TABLE  791L
#define ERROR_DISK_REPAIR_REDIRECTED  792L
#define ERROR_DISK_REPAIR_UNSUCCESSFUL  793L
#define ERROR_CORRUPT_LOG_OVERFULL  794L
#define ERROR_CORRUPT_LOG_CORRUPTED  795L
#define ERROR_CORRUPT_LOG_UNAVAILABLE  796L
#define ERROR_CORRUPT_LOG_DELETED_FULL  797L
#define ERROR_CORRUPT_LOG_CLEARED  798L
#define ERROR_ORPHAN_NAME_EXHAUSTED  799L
#define ERROR_OPLOCK_SWITCHED_TO_NEW_HANDLE 800L
#define ERROR_CANNOT_GRANT_REQUESTED_OPLOCK 801L
#define ERROR_CANNOT_BREAK_OPLOCK  802L
#define ERROR_OPLOCK_HANDLE_CLOSED  803L
#define ERROR_NO_ACE_CONDITION  804L
#define ERROR_INVALID_ACE_CONDITION  805L
#define ERROR_FILE_HANDLE_REVOKED  806L
#define ERROR_IMAGE_AT_DIFFERENT_BASE  807L
#define ERROR_ENCRYPTED_IO_NOT_POSSIBLE  808L
#define ERROR_FILE_METADATA_OPTIMIZATION_IN_PROGRESS 809L
#define ERROR_QUOTA_ACTIVITY  810L
#define ERROR_HANDLE_REVOKED  811L
#define ERROR_CALLBACK_INVOKE_INLINE  812L
#define ERROR_CPU_SET_INVALID  813L
#define ERROR_EA_ACCESS_DENIED  994L
#define ERROR_OPERATION_ABORTED  995L
#define ERROR_IO_INCOMPLETE  996L
#define ERROR_IO_PENDING  997L
#define ERROR_NOACCESS  998L
#define ERROR_SWAPERROR  999L
#define ERROR_STACK_OVERFLOW  1001L
#define ERROR_INVALID_MESSAGE  1002L
#define ERROR_CAN_NOT_COMPLETE  1003L
#define ERROR_INVALID_FLAGS  1004L
#define ERROR_UNRECOGNIZED_VOLUME  1005L
#define ERROR_FILE_INVALID  1006L
#define ERROR_FULLSCREEN_MODE  1007L
#define ERROR_NO_TOKEN  1008L
#define ERROR_BADDB  1009L
#define ERROR_BADKEY  1010L
#define ERROR_CANTOPEN  1011L
#define ERROR_CANTREAD  1012L
#define ERROR_CANTWRITE  1013L
#define ERROR_REGISTRY_RECOVERED  1014L
#define ERROR_REGISTRY_CORRUPT  1015L
#define ERROR_REGISTRY_IO_FAILED  1016L
#define ERROR_NOT_REGISTRY_FILE  1017L
#define ERROR_KEY_DELETED  1018L
#define ERROR_NO_LOG_SPACE  1019L
#define ERROR_KEY_HAS_CHILDREN  1020L
#define ERROR_CHILD_MUST_BE_VOLATILE  1021L
#define ERROR_NOTIFY_ENUM_DIR  1022L
#define ERROR_DEPENDENT_SERVICES_RUNNING 1051L
#define ERROR_INVALID_SERVICE_CONTROL  1052L
#define ERROR_SERVICE_REQUEST_TIMEOUT  1053L
#define ERROR_SERVICE_NO_THREAD  1054L
#define ERROR_SERVICE_DATABASE_LOCKED  1055L
#define ERROR_SERVICE_ALREADY_RUNNING  1056L
#define ERROR_INVALID_SERVICE_ACCOUNT  1057L
#define ERROR_SERVICE_DISABLED  1058L
#define ERROR_CIRCULAR_DEPENDENCY  1059L
#define ERROR_SERVICE_DOES_NOT_EXIST  1060L
#define ERROR_SERVICE_CANNOT_ACCEPT_CTRL 1061L
#define ERROR_SERVICE_NOT_ACTIVE  1062L
#define ERROR_FAILED_SERVICE_CONTROLLER_CONNECT 1063L
#define ERROR_EXCEPTION_IN_SERVICE  1064L
#define ERROR_DATABASE_DOES_NOT_EXIST  1065L
#define ERROR_SERVICE_SPECIFIC_ERROR  1066L
#define ERROR_PROCESS_ABORTED  1067L
#define ERROR_SERVICE_DEPENDENCY_FAIL  1068L
#define ERROR_SERVICE_LOGON_FAILED  1069L
#define ERROR_SERVICE_START_HANG  1070L
#define ERROR_INVALID_SERVICE_LOCK  1071L
#define ERROR_SERVICE_MARKED_FOR_DELETE  1072L
#define ERROR_SERVICE_EXISTS  1073L
#define ERROR_ALREADY_RUNNING_LKG  1074L
#define ERROR_SERVICE_DEPENDENCY_DELETED 1075L
#define ERROR_BOOT_ALREADY_ACCEPTED  1076L
#define ERROR_SERVICE_NEVER_STARTED  1077L
#define ERROR_DUPLICATE_SERVICE_NAME  1078L
#define ERROR_DIFFERENT_SERVICE_ACCOUNT  1079L
#define ERROR_CANNOT_DETECT_DRIVER_FAILURE 1080L
#define ERROR_CANNOT_DETECT_PROCESS_ABORT 1081L
#define ERROR_NO_RECOVERY_PROGRAM  1082L
#define ERROR_SERVICE_NOT_IN_EXE  1083L
#define ERROR_NOT_SAFEBOOT_SERVICE  1084L
#define ERROR_END_OF_MEDIA  1100L
#define ERROR_FILEMARK_DETECTED  1101L
#define ERROR_BEGINNING_OF_MEDIA  1102L
#define ERROR_SETMARK_DETECTED  1103L
#define ERROR_NO_DATA_DETECTED  1104L
#define ERROR_PARTITION_FAILURE  1105L
#define ERROR_INVALID_BLOCK_LENGTH  1106L
#define ERROR_DEVICE_NOT_PARTITIONED  1107L
#define ERROR_UNABLE_TO_LOCK_MEDIA  1108L
#define ERROR_UNABLE_TO_UNLOAD_MEDIA  1109L
#define ERROR_MEDIA_CHANGED  1110L
#define ERROR_BUS_RESET  1111L
#define ERROR_NO_MEDIA_IN_DRIVE  1112L
#define ERROR_NO_UNICODE_TRANSLATION  1113L
#define ERROR_DLL_INIT_FAILED  1114L
#define ERROR_SHUTDOWN_IN_PROGRESS  1115L
#define ERROR_NO_SHUTDOWN_IN_PROGRESS  1116L
#define ERROR_IO_DEVICE  1117L
#define ERROR_SERIAL_NO_DEVICE  1118L
#define ERROR_IRQ_BUSY  1119L
#define ERROR_MORE_WRITES  1120L
#define ERROR_COUNTER_TIMEOUT  1121L
#define ERROR_FLOPPY_ID_MARK_NOT_FOUND  1122L
#define ERROR_FLOPPY_WRONG_CYLINDER  1123L
#define ERROR_FLOPPY_UNKNOWN_ERROR  1124L
#define ERROR_FLOPPY_BAD_REGISTERS  1125L
#define ERROR_DISK_RECALIBRATE_FAILED  1126L
#define ERROR_DISK_OPERATION_FAILED  1127L
#define ERROR_DISK_RESET_FAILED  1128L
#define ERROR_EOM_OVERFLOW  1129L
#define ERROR_NOT_ENOUGH_SERVER_MEMORY  1130L
#define ERROR_POSSIBLE_DEADLOCK  1131L
#define ERROR_MAPPED_ALIGNMENT  1132L
#define ERROR_SET_POWER_STATE_VETOED  1140L
#define ERROR_SET_POWER_STATE_FAILED  1141L
#define ERROR_TOO_MANY_LINKS  1142L
#define ERROR_OLD_WIN_VERSION  1150L
#define ERROR_APP_WRONG_OS  1151L
#define ERROR_SINGLE_INSTANCE_APP  1152L
#define ERROR_RMODE_APP  1153L
#define ERROR_INVALID_DLL  1154L
#define ERROR_NO_ASSOCIATION  1155L
#define ERROR_DDE_FAIL  1156L
#define ERROR_DLL_NOT_FOUND  1157L
#define ERROR_NO_MORE_USER_HANDLES  1158L
#define ERROR_MESSAGE_SYNC_ONLY  1159L
#define ERROR_SOURCE_ELEMENT_EMPTY  1160L
#define ERROR_DESTINATION_ELEMENT_FULL  1161L
#define ERROR_ILLEGAL_ELEMENT_ADDRESS  1162L
#define ERROR_MAGAZINE_NOT_PRESENT  1163L
#define ERROR_DEVICE_REINITIALIZATION_NEEDED 1164L
#define ERROR_DEVICE_REQUIRES_CLEANING  1165L
#define ERROR_DEVICE_DOOR_OPEN  1166L
#define ERROR_DEVICE_NOT_CONNECTED  1167L
#define ERROR_NOT_FOUND  1168L
#define ERROR_NO_MATCH  1169L
#define ERROR_SET_NOT_FOUND  1170L
#define ERROR_POINT_NOT_FOUND  1171L
#define ERROR_NO_TRACKING_SERVICE  1172L
#define ERROR_NO_VOLUME_ID  1173L
#define ERROR_UNABLE_TO_REMOVE_REPLACED  1175L
#define ERROR_UNABLE_TO_MOVE_REPLACEMENT 1176L
#define ERROR_UNABLE_TO_MOVE_REPLACEMENT_2 1177L
#define ERROR_JOURNAL_DELETE_IN_PROGRESS 1178L
#define ERROR_JOURNAL_NOT_ACTIVE  1179L
#define ERROR_POTENTIAL_FILE_FOUND  1180L
#define ERROR_JOURNAL_ENTRY_DELETED  1181L
#define ERROR_SHUTDOWN_IS_SCHEDULED  1190L
#define ERROR_SHUTDOWN_USERS_LOGGED_ON  1191L
#define ERROR_BAD_DEVICE  1200L
#define ERROR_CONNECTION_UNAVAIL  1201L
#define ERROR_DEVICE_ALREADY_REMEMBERED  1202L
#define ERROR_NO_NET_OR_BAD_PATH  1203L
#define ERROR_BAD_PROVIDER  1204L
#define ERROR_CANNOT_OPEN_PROFILE  1205L
#define ERROR_BAD_PROFILE  1206L
#define ERROR_NOT_CONTAINER  1207L
#define ERROR_EXTENDED_ERROR  1208L
#define ERROR_INVALID_GROUPNAME  1209L
#define ERROR_INVALID_COMPUTERNAME  1210L
#define ERROR_INVALID_EVENTNAME  1211L
#define ERROR_INVALID_DOMAINNAME  1212L
#define ERROR_INVALID_SERVICENAME  1213L
#define ERROR_INVALID_NETNAME  1214L
#define ERROR_INVALID_SHARENAME  1215L
#define ERROR_INVALID_PASSWORDNAME  1216L
#define ERROR_INVALID_MESSAGENAME  1217L
#define ERROR_INVALID_MESSAGEDEST  1218L
#define ERROR_SESSION_CREDENTIAL_CONFLICT 1219L
#define ERROR_REMOTE_SESSION_LIMIT_EXCEEDED 1220L
#define ERROR_DUP_DOMAINNAME  1221L
#define ERROR_NO_NETWORK  1222L
#define ERROR_CANCELLED  1223L
#define ERROR_USER_MAPPED_FILE  1224L
#define ERROR_CONNECTION_REFUSED  1225L
#define ERROR_GRACEFUL_DISCONNECT  1226L
#define ERROR_ADDRESS_ALREADY_ASSOCIATED 1227L
#define ERROR_ADDRESS_NOT_ASSOCIATED  1228L
#define ERROR_CONNECTION_INVALID  1229L
#define ERROR_CONNECTION_ACTIVE  1230L
#define ERROR_NETWORK_UNREACHABLE  1231L
#define ERROR_HOST_UNREACHABLE  1232L
#define ERROR_PROTOCOL_UNREACHABLE  1233L
#define ERROR_PORT_UNREACHABLE  1234L
#define ERROR_REQUEST_ABORTED  1235L
#define ERROR_CONNECTION_ABORTED  1236L
#define ERROR_RETRY  1237L
#define ERROR_CONNECTION_COUNT_LIMIT  1238L
#define ERROR_LOGIN_TIME_RESTRICTION  1239L
#define ERROR_LOGIN_WKSTA_RESTRICTION  1240L
#define ERROR_INCORRECT_ADDRESS  1241L
#define ERROR_ALREADY_REGISTERED  1242L
#define ERROR_SERVICE_NOT_FOUND  1243L
#define ERROR_NOT_AUTHENTICATED  1244L
#define ERROR_NOT_LOGGED_ON  1245L
#define ERROR_CONTINUE  1246L
#define ERROR_ALREADY_INITIALIZED  1247L
#define ERROR_NO_MORE_DEVICES  1248L
#define ERROR_NO_SUCH_SITE  1249L
#define ERROR_DOMAIN_CONTROLLER_EXISTS  1250L
#define ERROR_ONLY_IF_CONNECTED  1251L
#define ERROR_OVERRIDE_NOCHANGES  1252L
#define ERROR_BAD_USER_PROFILE  1253L
#define ERROR_NOT_SUPPORTED_ON_SBS  1254L
#define ERROR_SERVER_SHUTDOWN_IN_PROGRESS 1255L
#define ERROR_HOST_DOWN  1256L
#define ERROR_NON_ACCOUNT_SID  1257L
#define ERROR_NON_DOMAIN_SID  1258L
#define ERROR_APPHELP_BLOCK  1259L
#define ERROR_ACCESS_DISABLED_BY_POLICY  1260L
#define ERROR_REG_NAT_CONSUMPTION  1261L
#define ERROR_CSCSHARE_OFFLINE  1262L
#define ERROR_PKINIT_FAILURE  1263L
#define ERROR_SMARTCARD_SUBSYSTEM_FAILURE 1264L
#define ERROR_DOWNGRADE_DETECTED  1265L
#define ERROR_MACHINE_LOCKED  1271L
#define ERROR_SMB_GUEST_LOGON_BLOCKED  1272L
#define ERROR_CALLBACK_SUPPLIED_INVALID_DATA 1273L
#define ERROR_SYNC_FOREGROUND_REFRESH_REQUIRED 1274L
#define ERROR_DRIVER_BLOCKED  1275L
#define ERROR_INVALID_IMPORT_OF_NON_DLL  1276L
#define ERROR_ACCESS_DISABLED_WEBBLADE  1277L
#define ERROR_ACCESS_DISABLED_WEBBLADE_TAMPER 1278L
#define ERROR_RECOVERY_FAILURE  1279L
#define ERROR_ALREADY_FIBER  1280L
#define ERROR_ALREADY_THREAD  1281L
#define ERROR_STACK_BUFFER_OVERRUN  1282L
#define ERROR_PARAMETER_QUOTA_EXCEEDED  1283L
#define ERROR_DEBUGGER_INACTIVE  1284L
#define ERROR_DELAY_LOAD_FAILED  1285L
#define ERROR_VDM_DISALLOWED  1286L
#define ERROR_UNIDENTIFIED_ERROR  1287L
#define ERROR_INVALID_CRUNTIME_PARAMETER 1288L
#define ERROR_BEYOND_VDL  1289L
#define ERROR_INCOMPATIBLE_SERVICE_SID_TYPE 1290L
#define ERROR_DRIVER_PROCESS_TERMINATED  1291L
#define ERROR_IMPLEMENTATION_LIMIT  1292L
#define ERROR_PROCESS_IS_PROTECTED  1293L
#define ERROR_SERVICE_NOTIFY_CLIENT_LAGGING 1294L
#define ERROR_DISK_QUOTA_EXCEEDED  1295L
#define ERROR_CONTENT_BLOCKED  1296L
#define ERROR_INCOMPATIBLE_SERVICE_PRIVILEGE 1297L
#define ERROR_APP_HANG  1298L
#define ERROR_INVALID_LABEL  1299L
#define ERROR_NOT_ALL_ASSIGNED  1300L
#define ERROR_SOME_NOT_MAPPED  1301L
#define ERROR_NO_QUOTAS_FOR_ACCOUNT  1302L
#define ERROR_LOCAL_USER_SESSION_KEY  1303L
#define ERROR_NULL_LM_PASSWORD  1304L
#define ERROR_UNKNOWN_REVISION  1305L
#define ERROR_REVISION_MISMATCH  1306L
#define ERROR_INVALID_OWNER  1307L
#define ERROR_INVALID_PRIMARY_GROUP  1308L
#define ERROR_NO_IMPERSONATION_TOKEN  1309L
#define ERROR_CANT_DISABLE_MANDATORY  1310L
#define ERROR_NO_LOGON_SERVERS  1311L
#define ERROR_NO_SUCH_LOGON_SESSION  1312L
#define ERROR_NO_SUCH_PRIVILEGE  1313L
#define ERROR_PRIVILEGE_NOT_HELD  1314L
#define ERROR_INVALID_ACCOUNT_NAME  1315L
#define ERROR_USER_EXISTS  1316L
#define ERROR_NO_SUCH_USER  1317L
#define ERROR_GROUP_EXISTS  1318L
#define ERROR_NO_SUCH_GROUP  1319L
#define ERROR_MEMBER_IN_GROUP  1320L
#define ERROR_MEMBER_NOT_IN_GROUP  1321L
#define ERROR_LAST_ADMIN  1322L
#define ERROR_WRONG_PASSWORD  1323L
#define ERROR_ILL_FORMED_PASSWORD  1324L
#define ERROR_PASSWORD_RESTRICTION  1325L
#define ERROR_LOGON_FAILURE  1326L
#define ERROR_ACCOUNT_RESTRICTION  1327L
#define ERROR_INVALID_LOGON_HOURS  1328L
#define ERROR_INVALID_WORKSTATION  1329L
#define ERROR_PASSWORD_EXPIRED  1330L
#define ERROR_ACCOUNT_DISABLED  1331L
#define ERROR_NONE_MAPPED  1332L
#define ERROR_TOO_MANY_LUIDS_REQUESTED  1333L
#define ERROR_LUIDS_EXHAUSTED  1334L
#define ERROR_INVALID_SUB_AUTHORITY  1335L
#define ERROR_INVALID_ACL  1336L
#define ERROR_INVALID_SID  1337L
#define ERROR_INVALID_SECURITY_DESCR  1338L
#define ERROR_BAD_INHERITANCE_ACL  1340L
#define ERROR_SERVER_DISABLED  1341L
#define ERROR_SERVER_NOT_DISABLED  1342L
#define ERROR_INVALID_ID_AUTHORITY  1343L
#define ERROR_ALLOTTED_SPACE_EXCEEDED  1344L
#define ERROR_INVALID_GROUP_ATTRIBUTES  1345L
#define ERROR_BAD_IMPERSONATION_LEVEL  1346L
#define ERROR_CANT_OPEN_ANONYMOUS  1347L
#define ERROR_BAD_VALIDATION_CLASS  1348L
#define ERROR_BAD_TOKEN_TYPE  1349L
#define ERROR_NO_SECURITY_ON_OBJECT  1350L
#define ERROR_CANT_ACCESS_DOMAIN_INFO  1351L
#define ERROR_INVALID_SERVER_STATE  1352L
#define ERROR_INVALID_DOMAIN_STATE  1353L
#define ERROR_INVALID_DOMAIN_ROLE  1354L
#define ERROR_NO_SUCH_DOMAIN  1355L
#define ERROR_DOMAIN_EXISTS  1356L
#define ERROR_DOMAIN_LIMIT_EXCEEDED  1357L
#define ERROR_INTERNAL_DB_CORRUPTION  1358L
#define ERROR_INTERNAL_ERROR  1359L
#define ERROR_GENERIC_NOT_MAPPED  1360L
#define ERROR_BAD_DESCRIPTOR_FORMAT  1361L
#define ERROR_NOT_LOGON_PROCESS  1362L
#define ERROR_LOGON_SESSION_EXISTS  1363L
#define ERROR_NO_SUCH_PACKAGE  1364L
#define ERROR_BAD_LOGON_SESSION_STATE  1365L
#define ERROR_LOGON_SESSION_COLLISION  1366L
#define ERROR_INVALID_LOGON_TYPE  1367L
#define ERROR_CANNOT_IMPERSONATE  1368L
#define ERROR_RXACT_INVALID_STATE  1369L
#define ERROR_RXACT_COMMIT_FAILURE  1370L
#define ERROR_SPECIAL_ACCOUNT  1371L
#define ERROR_SPECIAL_GROUP  1372L
#define ERROR_SPECIAL_USER  1373L
#define ERROR_MEMBERS_PRIMARY_GROUP  1374L
#define ERROR_TOKEN_ALREADY_IN_USE  1375L
#define ERROR_NO_SUCH_ALIAS  1376L
#define ERROR_MEMBER_NOT_IN_ALIAS  1377L
#define ERROR_MEMBER_IN_ALIAS  1378L
#define ERROR_ALIAS_EXISTS  1379L
#define ERROR_LOGON_NOT_GRANTED  1380L
#define ERROR_TOO_MANY_SECRETS  1381L
#define ERROR_SECRET_TOO_LONG  1382L
#define ERROR_INTERNAL_DB_ERROR  1383L
#define ERROR_TOO_MANY_CONTEXT_IDS  1384L
#define ERROR_LOGON_TYPE_NOT_GRANTED  1385L
#define ERROR_NT_CROSS_ENCRYPTION_REQUIRED 1386L
#define ERROR_NO_SUCH_MEMBER  1387L
#define ERROR_INVALID_MEMBER  1388L
#define ERROR_TOO_MANY_SIDS  1389L
#define ERROR_LM_CROSS_ENCRYPTION_REQUIRED 1390L
#define ERROR_NO_INHERITANCE  1391L
#define ERROR_FILE_CORRUPT  1392L
#define ERROR_DISK_CORRUPT  1393L
#define ERROR_NO_USER_SESSION_KEY  1394L
#define ERROR_LICENSE_QUOTA_EXCEEDED  1395L
#define ERROR_WRONG_TARGET_NAME  1396L
#define ERROR_MUTUAL_AUTH_FAILED  1397L
#define ERROR_TIME_SKEW  1398L
#define ERROR_CURRENT_DOMAIN_NOT_ALLOWED 1399L
#define ERROR_INVALID_WINDOW_HANDLE  1400L
#define ERROR_INVALID_MENU_HANDLE  1401L
#define ERROR_INVALID_CURSOR_HANDLE  1402L
#define ERROR_INVALID_ACCEL_HANDLE  1403L
#define ERROR_INVALID_HOOK_HANDLE  1404L
#define ERROR_INVALID_DWP_HANDLE  1405L
#define ERROR_TLW_WITH_WSCHILD  1406L
#define ERROR_CANNOT_FIND_WND_CLASS  1407L
#define ERROR_WINDOW_OF_OTHER_THREAD  1408L
#define ERROR_HOTKEY_ALREADY_REGISTERED  1409L
#define ERROR_CLASS_ALREADY_EXISTS  1410L
#define ERROR_CLASS_DOES_NOT_EXIST  1411L
#define ERROR_CLASS_HAS_WINDOWS  1412L
#define ERROR_INVALID_INDEX  1413L
#define ERROR_INVALID_ICON_HANDLE  1414L
#define ERROR_PRIVATE_DIALOG_INDEX  1415L
#define ERROR_LISTBOX_ID_NOT_FOUND  1416L
#define ERROR_NO_WILDCARD_CHARACTERS  1417L
#define ERROR_CLIPBOARD_NOT_OPEN  1418L
#define ERROR_HOTKEY_NOT_REGISTERED  1419L
#define ERROR_WINDOW_NOT_DIALOG  1420L
#define ERROR_CONTROL_ID_NOT_FOUND  1421L
#define ERROR_INVALID_COMBOBOX_MESSAGE  1422L
#define ERROR_WINDOW_NOT_COMBOBOX  1423L
#define ERROR_INVALID_EDIT_HEIGHT  1424L
#define ERROR_DC_NOT_FOUND  1425L
#define ERROR_INVALID_HOOK_FILTER  1426L
#define ERROR_INVALID_FILTER_PROC  1427L
#define ERROR_HOOK_NEEDS_HMOD  1428L
#define ERROR_GLOBAL_ONLY_HOOK  1429L
#define ERROR_JOURNAL_HOOK_SET  1430L
#define ERROR_HOOK_NOT_INSTALLED  1431L
#define ERROR_INVALID_LB_MESSAGE  1432L
#define ERROR_SETCOUNT_ON_BAD_LB  1433L
#define ERROR_LB_WITHOUT_TABSTOPS  1434L
#define ERROR_DESTROY_OBJECT_OF_OTHER_THREAD 1435L
#define ERROR_CHILD_WINDOW_MENU  1436L
#define ERROR_NO_SYSTEM_MENU  1437L
#define ERROR_INVALID_MSGBOX_STYLE  1438L
#define ERROR_INVALID_SPI_VALUE  1439L
#define ERROR_SCREEN_ALREADY_LOCKED  1440L
#define ERROR_HWNDS_HAVE_DIFF_PARENT  1441L
#define ERROR_NOT_CHILD_WINDOW  1442L
#define ERROR_INVALID_GW_COMMAND  1443L
#define ERROR_INVALID_THREAD_ID  1444L
#define ERROR_NON_MDICHILD_WINDOW  1445L
#define ERROR_POPUP_ALREADY_ACTIVE  1446L
#define ERROR_NO_SCROLLBARS  1447L
#define ERROR_INVALID_SCROLLBAR_RANGE  1448L
#define ERROR_INVALID_SHOWWIN_COMMAND  1449L
#define ERROR_NO_SYSTEM_RESOURCES  1450L
#define ERROR_NONPAGED_SYSTEM_RESOURCES  1451L
#define ERROR_PAGED_SYSTEM_RESOURCES  1452L
#define ERROR_WORKING_SET_QUOTA  1453L
#define ERROR_PAGEFILE_QUOTA  1454L
#define ERROR_COMMITMENT_LIMIT  1455L
#define ERROR_MENU_ITEM_NOT_FOUND  1456L
#define ERROR_INVALID_KEYBOARD_HANDLE  1457L
#define ERROR_HOOK_TYPE_NOT_ALLOWED  1458L
#define ERROR_REQUIRES_INTERACTIVE_WINDOWSTATION 1459L
#define ERROR_TIMEOUT  1460L
#define ERROR_INVALID_MONITOR_HANDLE  1461L
#define ERROR_INCORRECT_SIZE  1462L
#define ERROR_SYMLINK_CLASS_DISABLED  1463L
#define ERROR_SYMLINK_NOT_SUPPORTED  1464L
#define ERROR_XML_PARSE_ERROR  1465L
#define ERROR_XMLDSIG_ERROR  1466L
#define ERROR_RESTART_APPLICATION  1467L
#define ERROR_WRONG_COMPARTMENT  1468L
#define ERROR_AUTHIP_FAILURE  1469L
#define ERROR_NO_NVRAM_RESOURCES  1470L
#define ERROR_NOT_GUI_PROCESS  1471L
#define ERROR_EVENTLOG_FILE_CORRUPT  1500L
#define ERROR_EVENTLOG_CANT_START  1501L
#define ERROR_LOG_FILE_FULL  1502L
#define ERROR_EVENTLOG_FILE_CHANGED  1503L
#define ERROR_CONTAINER_ASSIGNED  1504L
#define ERROR_JOB_NO_CONTAINER  1505L
#define ERROR_INVALID_TASK_NAME  1550L
#define ERROR_INVALID_TASK_INDEX  1551L
#define ERROR_THREAD_ALREADY_IN_TASK  1552L
#define ERROR_INSTALL_SERVICE_FAILURE  1601L
#define ERROR_INSTALL_USEREXIT  1602L
#define ERROR_INSTALL_FAILURE  1603L
#define ERROR_INSTALL_SUSPEND  1604L
#define ERROR_UNKNOWN_PRODUCT  1605L
#define ERROR_UNKNOWN_FEATURE  1606L
#define ERROR_UNKNOWN_COMPONENT  1607L
#define ERROR_UNKNOWN_PROPERTY  1608L
#define ERROR_INVALID_HANDLE_STATE  1609L
#define ERROR_BAD_CONFIGURATION  1610L
#define ERROR_INDEX_ABSENT  1611L
#define ERROR_INSTALL_SOURCE_ABSENT  1612L
#define ERROR_INSTALL_PACKAGE_VERSION  1613L
#define ERROR_PRODUCT_UNINSTALLED  1614L
#define ERROR_BAD_QUERY_SYNTAX  1615L
#define ERROR_INVALID_FIELD  1616L
#define ERROR_DEVICE_REMOVED  1617L
#define ERROR_INSTALL_ALREADY_RUNNING  1618L
#define ERROR_INSTALL_PACKAGE_OPEN_FAILED 1619L
#define ERROR_INSTALL_PACKAGE_INVALID  1620L
#define ERROR_INSTALL_UI_FAILURE  1621L
#define ERROR_INSTALL_LOG_FAILURE  1622L
#define ERROR_INSTALL_LANGUAGE_UNSUPPORTED 1623L
#define ERROR_INSTALL_TRANSFORM_FAILURE  1624L
#define ERROR_INSTALL_PACKAGE_REJECTED  1625L
#define ERROR_FUNCTION_NOT_CALLED  1626L
#define ERROR_FUNCTION_FAILED  1627L
#define ERROR_INVALID_TABLE  1628L
#define ERROR_DATATYPE_MISMATCH  1629L
#define ERROR_UNSUPPORTED_TYPE  1630L
#define ERROR_CREATE_FAILED  1631L
#define ERROR_INSTALL_TEMP_UNWRITABLE  1632L
#define ERROR_INSTALL_PLATFORM_UNSUPPORTED 1633L
#define ERROR_INSTALL_NOTUSED  1634L
#define ERROR_PATCH_PACKAGE_OPEN_FAILED  1635L
#define ERROR_PATCH_PACKAGE_INVALID  1636L
#define ERROR_PATCH_PACKAGE_UNSUPPORTED  1637L
#define ERROR_PRODUCT_VERSION  1638L
#define ERROR_INVALID_COMMAND_LINE  1639L
#define ERROR_INSTALL_REMOTE_DISALLOWED  1640L
#define ERROR_SUCCESS_REBOOT_INITIATED  1641L
#define ERROR_PATCH_TARGET_NOT_FOUND  1642L
#define ERROR_PATCH_PACKAGE_REJECTED  1643L
#define ERROR_INSTALL_TRANSFORM_REJECTED 1644L
#define ERROR_INSTALL_REMOTE_PROHIBITED  1645L
#define ERROR_PATCH_REMOVAL_UNSUPPORTED  1646L
#define ERROR_UNKNOWN_PATCH  1647L
#define ERROR_PATCH_NO_SEQUENCE  1648L
#define ERROR_PATCH_REMOVAL_DISALLOWED  1649L
#define ERROR_INVALID_PATCH_XML  1650L
#define ERROR_PATCH_MANAGED_ADVERTISED_PRODUCT 1651L
#define ERROR_INSTALL_SERVICE_SAFEBOOT  1652L
#define ERROR_FAIL_FAST_EXCEPTION  1653L
#define ERROR_INSTALL_REJECTED  1654L
#define ERROR_DYNAMIC_CODE_BLOCKED  1655L
#define ERROR_NOT_SAME_OBJECT  1656L
#define RPC_S_INVALID_STRING_BINDING  1700L
#define RPC_S_WRONG_KIND_OF_BINDING  1701L
#define RPC_S_INVALID_BINDING  1702L
#define RPC_S_PROTSEQ_NOT_SUPPORTED  1703L
#define RPC_S_INVALID_RPC_PROTSEQ  1704L
#define RPC_S_INVALID_STRING_UUID  1705L
#define RPC_S_INVALID_ENDPOINT_FORMAT  1706L
#define RPC_S_INVALID_NET_ADDR  1707L
#define RPC_S_NO_ENDPOINT_FOUND  1708L
#define RPC_S_INVALID_TIMEOUT  1709L
#define RPC_S_OBJECT_NOT_FOUND  1710L
#define RPC_S_ALREADY_REGISTERED  1711L
#define RPC_S_TYPE_ALREADY_REGISTERED  1712L
#define RPC_S_ALREADY_LISTENING  1713L
#define RPC_S_NO_PROTSEQS_REGISTERED  1714L
#define RPC_S_NOT_LISTENING  1715L
#define RPC_S_UNKNOWN_MGR_TYPE  1716L
#define RPC_S_UNKNOWN_IF  1717L
#define RPC_S_NO_BINDINGS  1718L
#define RPC_S_NO_PROTSEQS  1719L
#define RPC_S_CANT_CREATE_ENDPOINT  1720L
#define RPC_S_OUT_OF_RESOURCES  1721L
#define RPC_S_SERVER_UNAVAILABLE  1722L
#define RPC_S_SERVER_TOO_BUSY  1723L
#define RPC_S_INVALID_NETWORK_OPTIONS  1724L
#define RPC_S_NO_CALL_ACTIVE  1725L
#define RPC_S_CALL_FAILED  1726L
#define RPC_S_CALL_FAILED_DNE  1727L
#define RPC_S_PROTOCOL_ERROR  1728L
#define RPC_S_PROXY_ACCESS_DENIED  1729L
#define RPC_S_UNSUPPORTED_TRANS_SYN  1730L
#define RPC_S_UNSUPPORTED_TYPE  1732L
#define RPC_S_INVALID_TAG  1733L
#define RPC_S_INVALID_BOUND  1734L
#define RPC_S_NO_ENTRY_NAME  1735L
#define RPC_S_INVALID_NAME_SYNTAX  1736L
#define RPC_S_UNSUPPORTED_NAME_SYNTAX  1737L
#define RPC_S_UUID_NO_ADDRESS  1739L
#define RPC_S_DUPLICATE_ENDPOINT  1740L
#define RPC_S_UNKNOWN_AUTHN_TYPE  1741L
#define RPC_S_MAX_CALLS_TOO_SMALL  1742L
#define RPC_S_STRING_TOO_LONG  1743L
#define RPC_S_PROTSEQ_NOT_FOUND  1744L
#define RPC_S_PROCNUM_OUT_OF_RANGE  1745L
#define RPC_S_BINDING_HAS_NO_AUTH  1746L
#define RPC_S_UNKNOWN_AUTHN_SERVICE  1747L
#define RPC_S_UNKNOWN_AUTHN_LEVEL  1748L
#define RPC_S_INVALID_AUTH_IDENTITY  1749L
#define RPC_S_UNKNOWN_AUTHZ_SERVICE  1750L
#define EPT_S_INVALID_ENTRY  1751L
#define EPT_S_CANT_PERFORM_OP  1752L
#define EPT_S_NOT_REGISTERED  1753L
#define RPC_S_NOTHING_TO_EXPORT  1754L
#define RPC_S_INCOMPLETE_NAME  1755L
#define RPC_S_INVALID_VERS_OPTION  1756L
#define RPC_S_NO_MORE_MEMBERS  1757L
#define RPC_S_NOT_ALL_OBJS_UNEXPORTED  1758L
#define RPC_S_INTERFACE_NOT_FOUND  1759L
#define RPC_S_ENTRY_ALREADY_EXISTS  1760L
#define RPC_S_ENTRY_NOT_FOUND  1761L
#define RPC_S_NAME_SERVICE_UNAVAILABLE  1762L
#define RPC_S_INVALID_NAF_ID  1763L
#define RPC_S_CANNOT_SUPPORT  1764L
#define RPC_S_NO_CONTEXT_AVAILABLE  1765L
#define RPC_S_INTERNAL_ERROR  1766L
#define RPC_S_ZERO_DIVIDE  1767L
#define RPC_S_ADDRESS_ERROR  1768L
#define RPC_S_FP_DIV_ZERO  1769L
#define RPC_S_FP_UNDERFLOW  1770L
#define RPC_S_FP_OVERFLOW  1771L
#define RPC_X_NO_MORE_ENTRIES  1772L
#define RPC_X_SS_CHAR_TRANS_OPEN_FAIL  1773L
#define RPC_X_SS_CHAR_TRANS_SHORT_FILE  1774L
#define RPC_X_SS_IN_NULL_CONTEXT  1775L
#define RPC_X_SS_CONTEXT_DAMAGED  1777L
#define RPC_X_SS_HANDLES_MISMATCH  1778L
#define RPC_X_SS_CANNOT_GET_CALL_HANDLE  1779L
#define RPC_X_NULL_REF_POINTER  1780L
#define RPC_X_ENUM_VALUE_OUT_OF_RANGE  1781L
#define RPC_X_BYTE_COUNT_TOO_SMALL  1782L
#define RPC_X_BAD_STUB_DATA  1783L
#define ERROR_INVALID_USER_BUFFER  1784L
#define ERROR_UNRECOGNIZED_MEDIA  1785L
#define ERROR_NO_TRUST_LSA_SECRET  1786L
#define ERROR_NO_TRUST_SAM_ACCOUNT  1787L
#define ERROR_TRUSTED_DOMAIN_FAILURE  1788L
#define ERROR_TRUSTED_RELATIONSHIP_FAILURE 1789L
#define ERROR_TRUST_FAILURE  1790L
#define RPC_S_CALL_IN_PROGRESS  1791L
#define ERROR_NETLOGON_NOT_STARTED  1792L
#define ERROR_ACCOUNT_EXPIRED  1793L
#define ERROR_REDIRECTOR_HAS_OPEN_HANDLES 1794L
#define ERROR_PRINTER_DRIVER_ALREADY_INSTALLED 1795L
#define ERROR_UNKNOWN_PORT  1796L
#define ERROR_UNKNOWN_PRINTER_DRIVER  1797L
#define ERROR_UNKNOWN_PRINTPROCESSOR  1798L
#define ERROR_INVALID_SEPARATOR_FILE  1799L
#define ERROR_INVALID_PRIORITY  1800L
#define ERROR_INVALID_PRINTER_NAME  1801L
#define ERROR_PRINTER_ALREADY_EXISTS  1802L
#define ERROR_INVALID_PRINTER_COMMAND  1803L
#define ERROR_INVALID_DATATYPE  1804L
#define ERROR_INVALID_ENVIRONMENT  1805L
#define RPC_S_NO_MORE_BINDINGS  1806L
#define ERROR_NOLOGON_INTERDOMAIN_TRUST_ACCOUNT 1807L
#define ERROR_NOLOGON_WORKSTATION_TRUST_ACCOUNT 1808L
#define ERROR_NOLOGON_SERVER_TRUST_ACCOUNT 1809L
#define ERROR_DOMAIN_TRUST_INCONSISTENT  1810L
#define ERROR_SERVER_HAS_OPEN_HANDLES  1811L
#define ERROR_RESOURCE_DATA_NOT_FOUND  1812L
#define ERROR_RESOURCE_TYPE_NOT_FOUND  1813L
#define ERROR_RESOURCE_NAME_NOT_FOUND  1814L
#define ERROR_RESOURCE_LANG_NOT_FOUND  1815L
#define ERROR_NOT_ENOUGH_QUOTA  1816L
#define RPC_S_NO_INTERFACES  1817L
#define RPC_S_CALL_CANCELLED  1818L
#define RPC_S_BINDING_INCOMPLETE  1819L
#define RPC_S_COMM_FAILURE  1820L
#define RPC_S_UNSUPPORTED_AUTHN_LEVEL  1821L
#define RPC_S_NO_PRINC_NAME  1822L
#define RPC_S_NOT_RPC_ERROR  1823L
#define RPC_S_UUID_LOCAL_ONLY  1824L
#define RPC_S_SEC_PKG_ERROR  1825L
#define RPC_S_NOT_CANCELLED  1826L
#define RPC_X_INVALID_ES_ACTION  1827L
#define RPC_X_WRONG_ES_VERSION  1828L
#define RPC_X_WRONG_STUB_VERSION  1829L
#define RPC_X_INVALID_PIPE_OBJECT  1830L
#define RPC_X_WRONG_PIPE_ORDER  1831L
#define RPC_X_WRONG_PIPE_VERSION  1832L
#define RPC_S_COOKIE_AUTH_FAILED  1833L
#define RPC_S_DO_NOT_DISTURB  1834L
#define RPC_S_SYSTEM_HANDLE_COUNT_EXCEEDED 1835L
#define RPC_S_SYSTEM_HANDLE_TYPE_MISMATCH 1836L
#define RPC_S_GROUP_MEMBER_NOT_FOUND  1898L
#define EPT_S_CANT_CREATE  1899L
#define RPC_S_INVALID_OBJECT  1900L
#define ERROR_INVALID_TIME  1901L
#define ERROR_INVALID_FORM_NAME  1902L
#define ERROR_INVALID_FORM_SIZE  1903L
#define ERROR_ALREADY_WAITING  1904L
#define ERROR_PRINTER_DELETED  1905L
#define ERROR_INVALID_PRINTER_STATE  1906L
#define ERROR_PASSWORD_MUST_CHANGE  1907L
#define ERROR_DOMAIN_CONTROLLER_NOT_FOUND 1908L
#define ERROR_ACCOUNT_LOCKED_OUT  1909L
#define OR_INVALID_OXID  1910L
#define OR_INVALID_OID  1911L
#define OR_INVALID_SET  1912L
#define RPC_S_SEND_INCOMPLETE  1913L
#define RPC_S_INVALID_ASYNC_HANDLE  1914L
#define RPC_S_INVALID_ASYNC_CALL  1915L
#define RPC_X_PIPE_CLOSED  1916L
#define RPC_X_PIPE_DISCIPLINE_ERROR  1917L
#define RPC_X_PIPE_EMPTY  1918L
#define ERROR_NO_SITENAME  1919L
#define ERROR_CANT_ACCESS_FILE  1920L
#define ERROR_CANT_RESOLVE_FILENAME  1921L
#define RPC_S_ENTRY_TYPE_MISMATCH  1922L
#define RPC_S_NOT_ALL_OBJS_EXPORTED  1923L
#define RPC_S_INTERFACE_NOT_EXPORTED  1924L
#define RPC_S_PROFILE_NOT_ADDED  1925L
#define RPC_S_PRF_ELT_NOT_ADDED  1926L
#define RPC_S_PRF_ELT_NOT_REMOVED  1927L
#define RPC_S_GRP_ELT_NOT_ADDED  1928L
#define RPC_S_GRP_ELT_NOT_REMOVED  1929L
#define ERROR_KM_DRIVER_BLOCKED  1930L
#define ERROR_CONTEXT_EXPIRED  1931L
#define ERROR_PER_USER_TRUST_QUOTA_EXCEEDED 1932L
#define ERROR_ALL_USER_TRUST_QUOTA_EXCEEDED 1933L
#define ERROR_USER_DELETE_TRUST_QUOTA_EXCEEDED 1934L
#define ERROR_AUTHENTICATION_FIREWALL_FAILED 1935L
#define ERROR_REMOTE_PRINT_CONNECTIONS_BLOCKED 1936L
#define ERROR_NTLM_BLOCKED  1937L
#define ERROR_PASSWORD_CHANGE_REQUIRED  1938L
#define ERROR_INVALID_PIXEL_FORMAT  2000L
#define ERROR_BAD_DRIVER  2001L
#define ERROR_INVALID_WINDOW_STYLE  2002L
#define ERROR_METAFILE_NOT_SUPPORTED  2003L
#define ERROR_TRANSFORM_NOT_SUPPORTED  2004L
#define ERROR_CLIPPING_NOT_SUPPORTED  2005L
#define ERROR_INVALID_CMM  2010L
#define ERROR_INVALID_PROFILE  2011L
#define ERROR_TAG_NOT_FOUND  2012L
#define ERROR_TAG_NOT_PRESENT  2013L
#define ERROR_DUPLICATE_TAG  2014L
#define ERROR_PROFILE_NOT_ASSOCIATED_WITH_DEVICE 2015L
#define ERROR_PROFILE_NOT_FOUND  2016L
#define ERROR_INVALID_COLORSPACE  2017L
#define ERROR_ICM_NOT_ENABLED  2018L
#define ERROR_DELETING_ICM_XFORM  2019L
#define ERROR_INVALID_TRANSFORM  2020L
#define ERROR_COLORSPACE_MISMATCH  2021L
#define ERROR_INVALID_COLORINDEX  2022L
#define ERROR_PROFILE_DOES_NOT_MATCH_DEVICE 2023L
#define ERROR_CONNECTED_OTHER_PASSWORD  2108L
#define ERROR_CONNECTED_OTHER_PASSWORD_DEFAULT 2109L
#define ERROR_BAD_USERNAME  2202L
#define ERROR_NOT_CONNECTED  2250L
#define ERROR_OPEN_FILES  2401L
#define ERROR_ACTIVE_CONNECTIONS  2402L
#define ERROR_DEVICE_IN_USE  2404L
#define ERROR_UNKNOWN_PRINT_MONITOR  3000L
#define ERROR_PRINTER_DRIVER_IN_USE  3001L
#define ERROR_SPOOL_FILE_NOT_FOUND  3002L
#define ERROR_SPL_NO_STARTDOC  3003L
#define ERROR_SPL_NO_ADDJOB  3004L
#define ERROR_PRINT_PROCESSOR_ALREADY_INSTALLED 3005L
#define ERROR_PRINT_MONITOR_ALREADY_INSTALLED 3006L
#define ERROR_INVALID_PRINT_MONITOR  3007L
#define ERROR_PRINT_MONITOR_IN_USE  3008L
#define ERROR_PRINTER_HAS_JOBS_QUEUED  3009L
#define ERROR_SUCCESS_REBOOT_REQUIRED  3010L
#define ERROR_SUCCESS_RESTART_REQUIRED  3011L
#define ERROR_PRINTER_NOT_FOUND  3012L
#define ERROR_PRINTER_DRIVER_WARNED  3013L
#define ERROR_PRINTER_DRIVER_BLOCKED  3014L
#define ERROR_PRINTER_DRIVER_PACKAGE_IN_USE 3015L
#define ERROR_CORE_DRIVER_PACKAGE_NOT_FOUND 3016L
#define ERROR_FAIL_REBOOT_REQUIRED  3017L
#define ERROR_FAIL_REBOOT_INITIATED  3018L
#define ERROR_PRINTER_DRIVER_DOWNLOAD_NEEDED 3019L
#define ERROR_PRINT_JOB_RESTART_REQUIRED 3020L
#define ERROR_INVALID_PRINTER_DRIVER_MANIFEST 3021L
#define ERROR_PRINTER_NOT_SHAREABLE  3022L
#define ERROR_REQUEST_PAUSED  3050L
#define ERROR_IO_REISSUE_AS_CACHED  3950L
#define ERROR_WINS_INTERNAL  4000L
#define ERROR_CAN_NOT_DEL_LOCAL_WINS  4001L
#define ERROR_STATIC_INIT  4002L
#define ERROR_INC_BACKUP  4003L
#define ERROR_FULL_BACKUP  4004L
#define ERROR_REC_NON_EXISTENT  4005L
#define ERROR_RPL_NOT_ALLOWED  4006L
#define PEERDIST_ERROR_CONTENTINFO_VERSION_UNSUPPORTED 4050L
#define PEERDIST_ERROR_CANNOT_PARSE_CONTENTINFO 4051L
#define PEERDIST_ERROR_MISSING_DATA  4052L
#define PEERDIST_ERROR_NO_MORE  4053L
#define PEERDIST_ERROR_NOT_INITIALIZED  4054L
#define PEERDIST_ERROR_ALREADY_INITIALIZED 4055L
#define PEERDIST_ERROR_SHUTDOWN_IN_PROGRESS 4056L
#define PEERDIST_ERROR_INVALIDATED  4057L
#define PEERDIST_ERROR_ALREADY_EXISTS  4058L
#define PEERDIST_ERROR_OPERATION_NOTFOUND 4059L
#define PEERDIST_ERROR_ALREADY_COMPLETED 4060L
#define PEERDIST_ERROR_OUT_OF_BOUNDS  4061L
#define PEERDIST_ERROR_VERSION_UNSUPPORTED 4062L
#define PEERDIST_ERROR_INVALID_CONFIGURATION 4063L
#define PEERDIST_ERROR_NOT_LICENSED  4064L
#define PEERDIST_ERROR_SERVICE_UNAVAILABLE 4065L
#define PEERDIST_ERROR_TRUST_FAILURE  4066L
#define ERROR_DHCP_ADDRESS_CONFLICT  4100L
#define ERROR_WMI_GUID_NOT_FOUND  4200L
#define ERROR_WMI_INSTANCE_NOT_FOUND  4201L
#define ERROR_WMI_ITEMID_NOT_FOUND  4202L
#define ERROR_WMI_TRY_AGAIN  4203L
#define ERROR_WMI_DP_NOT_FOUND  4204L
#define ERROR_WMI_UNRESOLVED_INSTANCE_REF 4205L
#define ERROR_WMI_ALREADY_ENABLED  4206L
#define ERROR_WMI_GUID_DISCONNECTED  4207L
#define ERROR_WMI_SERVER_UNAVAILABLE  4208L
#define ERROR_WMI_DP_FAILED  4209L
#define ERROR_WMI_INVALID_MOF  4210L
#define ERROR_WMI_INVALID_REGINFO  4211L
#define ERROR_WMI_ALREADY_DISABLED  4212L
#define ERROR_WMI_READ_ONLY  4213L
#define ERROR_WMI_SET_FAILURE  4214L
#define ERROR_NOT_APPCONTAINER  4250L
#define ERROR_APPCONTAINER_REQUIRED  4251L
#define ERROR_NOT_SUPPORTED_IN_APPCONTAINER 4252L
#define ERROR_INVALID_PACKAGE_SID_LENGTH 4253L
#define ERROR_INVALID_MEDIA  4300L
#define ERROR_INVALID_LIBRARY  4301L
#define ERROR_INVALID_MEDIA_POOL  4302L
#define ERROR_DRIVE_MEDIA_MISMATCH  4303L
#define ERROR_MEDIA_OFFLINE  4304L
#define ERROR_LIBRARY_OFFLINE  4305L
#define ERROR_EMPTY  4306L
#define ERROR_NOT_EMPTY  4307L
#define ERROR_MEDIA_UNAVAILABLE  4308L
#define ERROR_RESOURCE_DISABLED  4309L
#define ERROR_INVALID_CLEANER  4310L
#define ERROR_UNABLE_TO_CLEAN  4311L
#define ERROR_OBJECT_NOT_FOUND  4312L
#define ERROR_DATABASE_FAILURE  4313L
#define ERROR_DATABASE_FULL  4314L
#define ERROR_MEDIA_INCOMPATIBLE  4315L
#define ERROR_RESOURCE_NOT_PRESENT  4316L
#define ERROR_INVALID_OPERATION  4317L
#define ERROR_MEDIA_NOT_AVAILABLE  4318L
#define ERROR_DEVICE_NOT_AVAILABLE  4319L
#define ERROR_REQUEST_REFUSED  4320L
#define ERROR_INVALID_DRIVE_OBJECT  4321L
#define ERROR_LIBRARY_FULL  4322L
#define ERROR_MEDIUM_NOT_ACCESSIBLE  4323L
#define ERROR_UNABLE_TO_LOAD_MEDIUM  4324L
#define ERROR_UNABLE_TO_INVENTORY_DRIVE  4325L
#define ERROR_UNABLE_TO_INVENTORY_SLOT  4326L
#define ERROR_UNABLE_TO_INVENTORY_TRANSPORT 4327L
#define ERROR_TRANSPORT_FULL  4328L
#define ERROR_CONTROLLING_IEPORT  4329L
#define ERROR_UNABLE_TO_EJECT_MOUNTED_MEDIA 4330L
#define ERROR_CLEANER_SLOT_SET  4331L
#define ERROR_CLEANER_SLOT_NOT_SET  4332L
#define ERROR_CLEANER_CARTRIDGE_SPENT  4333L
#define ERROR_UNEXPECTED_OMID  4334L
#define ERROR_CANT_DELETE_LAST_ITEM  4335L
#define ERROR_MESSAGE_EXCEEDS_MAX_SIZE  4336L
#define ERROR_VOLUME_CONTAINS_SYS_FILES  4337L
#define ERROR_INDIGENOUS_TYPE  4338L
#define ERROR_NO_SUPPORTING_DRIVES  4339L
#define ERROR_CLEANER_CARTRIDGE_INSTALLED 4340L
#define ERROR_IEPORT_FULL  4341L
#define ERROR_FILE_OFFLINE  4350L
#define ERROR_REMOTE_STORAGE_NOT_ACTIVE  4351L
#define ERROR_REMOTE_STORAGE_MEDIA_ERROR 4352L
#define ERROR_NOT_A_REPARSE_POINT  4390L
#define ERROR_REPARSE_ATTRIBUTE_CONFLICT 4391L
#define ERROR_INVALID_REPARSE_DATA  4392L
#define ERROR_REPARSE_TAG_INVALID  4393L
#define ERROR_REPARSE_TAG_MISMATCH  4394L
#define ERROR_REPARSE_POINT_ENCOUNTERED  4395L
#define ERROR_APP_DATA_NOT_FOUND  4400L
#define ERROR_APP_DATA_EXPIRED  4401L
#define ERROR_APP_DATA_CORRUPT  4402L
#define ERROR_APP_DATA_LIMIT_EXCEEDED  4403L
#define ERROR_APP_DATA_REBOOT_REQUIRED  4404L
#define ERROR_SECUREBOOT_ROLLBACK_DETECTED 4420L
#define ERROR_SECUREBOOT_POLICY_VIOLATION 4421L
#define ERROR_SECUREBOOT_INVALID_POLICY  4422L
#define ERROR_SECUREBOOT_POLICY_PUBLISHER_NOT_FOUND 4423L
#define ERROR_SECUREBOOT_POLICY_NOT_SIGNED 4424L
#define ERROR_SECUREBOOT_NOT_ENABLED  4425L
#define ERROR_SECUREBOOT_FILE_REPLACED  4426L
#define ERROR_SECUREBOOT_POLICY_NOT_AUTHORIZED 4427L
#define ERROR_SECUREBOOT_POLICY_UNKNOWN  4428L
#define ERROR_SECUREBOOT_POLICY_MISSING_ANTIROLLBACKVERSION 4429L
#define ERROR_SECUREBOOT_PLATFORM_ID_MISMATCH 4430L
#define ERROR_SECUREBOOT_POLICY_ROLLBACK_DETECTED 4431L
#define ERROR_SECUREBOOT_POLICY_UPGRADE_MISMATCH 4432L
#define ERROR_SECUREBOOT_REQUIRED_POLICY_FILE_MISSING 4433L
#define ERROR_SECUREBOOT_NOT_BASE_POLICY 4434L
#define ERROR_SECUREBOOT_NOT_SUPPLEMENTAL_POLICY 4435L
#define ERROR_OFFLOAD_READ_FLT_NOT_SUPPORTED 4440L
#define ERROR_OFFLOAD_WRITE_FLT_NOT_SUPPORTED 4441L
#define ERROR_OFFLOAD_READ_FILE_NOT_SUPPORTED 4442L
#define ERROR_OFFLOAD_WRITE_FILE_NOT_SUPPORTED 4443L
#define ERROR_VOLUME_NOT_SIS_ENABLED  4500L
#define ERROR_SYSTEM_INTEGRITY_ROLLBACK_DETECTED 4550L
#define ERROR_SYSTEM_INTEGRITY_POLICY_VIOLATION 4551L
#define ERROR_SYSTEM_INTEGRITY_INVALID_POLICY 4552L
#define ERROR_SYSTEM_INTEGRITY_POLICY_NOT_SIGNED 4553L
#define ERROR_VSM_NOT_INITIALIZED  4560L
#define ERROR_VSM_DMA_PROTECTION_NOT_IN_USE 4561L
#define ERROR_PLATFORM_MANIFEST_NOT_AUTHORIZED 4570L
#define ERROR_PLATFORM_MANIFEST_INVALID  4571L
#define ERROR_PLATFORM_MANIFEST_FILE_NOT_AUTHORIZED 4572L
#define ERROR_PLATFORM_MANIFEST_CATALOG_NOT_AUTHORIZED 4573L
#define ERROR_PLATFORM_MANIFEST_BINARY_ID_NOT_FOUND 4574L
#define ERROR_PLATFORM_MANIFEST_NOT_ACTIVE 4575L
#define ERROR_PLATFORM_MANIFEST_NOT_SIGNED 4576L
#define ERROR_DEPENDENT_RESOURCE_EXISTS  5001L
#define ERROR_DEPENDENCY_NOT_FOUND  5002L
#define ERROR_DEPENDENCY_ALREADY_EXISTS  5003L
#define ERROR_RESOURCE_NOT_ONLINE  5004L
#define ERROR_HOST_NODE_NOT_AVAILABLE  5005L
#define ERROR_RESOURCE_NOT_AVAILABLE  5006L
#define ERROR_RESOURCE_NOT_FOUND  5007L
#define ERROR_SHUTDOWN_CLUSTER  5008L
#define ERROR_CANT_EVICT_ACTIVE_NODE  5009L
#define ERROR_OBJECT_ALREADY_EXISTS  5010L
#define ERROR_OBJECT_IN_LIST  5011L
#define ERROR_GROUP_NOT_AVAILABLE  5012L
#define ERROR_GROUP_NOT_FOUND  5013L
#define ERROR_GROUP_NOT_ONLINE  5014L
#define ERROR_HOST_NODE_NOT_RESOURCE_OWNER 5015L
#define ERROR_HOST_NODE_NOT_GROUP_OWNER  5016L
#define ERROR_RESMON_CREATE_FAILED  5017L
#define ERROR_RESMON_ONLINE_FAILED  5018L
#define ERROR_RESOURCE_ONLINE  5019L
#define ERROR_QUORUM_RESOURCE  5020L
#define ERROR_NOT_QUORUM_CAPABLE  5021L
#define ERROR_CLUSTER_SHUTTING_DOWN  5022L
#define ERROR_INVALID_STATE  5023L
#define ERROR_RESOURCE_PROPERTIES_STORED 5024L
#define ERROR_NOT_QUORUM_CLASS  5025L
#define ERROR_CORE_RESOURCE  5026L
#define ERROR_QUORUM_RESOURCE_ONLINE_FAILED 5027L
#define ERROR_QUORUMLOG_OPEN_FAILED  5028L
#define ERROR_CLUSTERLOG_CORRUPT  5029L
#define ERROR_CLUSTERLOG_RECORD_EXCEEDS_MAXSIZE 5030L
#define ERROR_CLUSTERLOG_EXCEEDS_MAXSIZE 5031L
#define ERROR_CLUSTERLOG_CHKPOINT_NOT_FOUND 5032L
#define ERROR_CLUSTERLOG_NOT_ENOUGH_SPACE 5033L
#define ERROR_QUORUM_OWNER_ALIVE  5034L
#define ERROR_NETWORK_NOT_AVAILABLE  5035L
#define ERROR_NODE_NOT_AVAILABLE  5036L
#define ERROR_ALL_NODES_NOT_AVAILABLE  5037L
#define ERROR_RESOURCE_FAILED  5038L
#define ERROR_CLUSTER_INVALID_NODE  5039L
#define ERROR_CLUSTER_NODE_EXISTS  5040L
#define ERROR_CLUSTER_JOIN_IN_PROGRESS  5041L
#define ERROR_CLUSTER_NODE_NOT_FOUND  5042L
#define ERROR_CLUSTER_LOCAL_NODE_NOT_FOUND 5043L
#define ERROR_CLUSTER_NETWORK_EXISTS  5044L
#define ERROR_CLUSTER_NETWORK_NOT_FOUND  5045L
#define ERROR_CLUSTER_NETINTERFACE_EXISTS 5046L
#define ERROR_CLUSTER_NETINTERFACE_NOT_FOUND 5047L
#define ERROR_CLUSTER_INVALID_REQUEST  5048L
#define ERROR_CLUSTER_INVALID_NETWORK_PROVIDER 5049L
#define ERROR_CLUSTER_NODE_DOWN  5050L
#define ERROR_CLUSTER_NODE_UNREACHABLE  5051L
#define ERROR_CLUSTER_NODE_NOT_MEMBER  5052L
#define ERROR_CLUSTER_JOIN_NOT_IN_PROGRESS 5053L
#define ERROR_CLUSTER_INVALID_NETWORK  5054L
#define ERROR_CLUSTER_NODE_UP  5056L
#define ERROR_CLUSTER_IPADDR_IN_USE  5057L
#define ERROR_CLUSTER_NODE_NOT_PAUSED  5058L
#define ERROR_CLUSTER_NO_SECURITY_CONTEXT 5059L
#define ERROR_CLUSTER_NETWORK_NOT_INTERNAL 5060L
#define ERROR_CLUSTER_NODE_ALREADY_UP  5061L
#define ERROR_CLUSTER_NODE_ALREADY_DOWN  5062L
#define ERROR_CLUSTER_NETWORK_ALREADY_ONLINE 5063L
#define ERROR_CLUSTER_NETWORK_ALREADY_OFFLINE 5064L
#define ERROR_CLUSTER_NODE_ALREADY_MEMBER 5065L
#define ERROR_CLUSTER_LAST_INTERNAL_NETWORK 5066L
#define ERROR_CLUSTER_NETWORK_HAS_DEPENDENTS 5067L
#define ERROR_INVALID_OPERATION_ON_QUORUM 5068L
#define ERROR_DEPENDENCY_NOT_ALLOWED  5069L
#define ERROR_CLUSTER_NODE_PAUSED  5070L
#define ERROR_NODE_CANT_HOST_RESOURCE  5071L
#define ERROR_CLUSTER_NODE_NOT_READY  5072L
#define ERROR_CLUSTER_NODE_SHUTTING_DOWN 5073L
#define ERROR_CLUSTER_JOIN_ABORTED  5074L
#define ERROR_CLUSTER_INCOMPATIBLE_VERSIONS 5075L
#define ERROR_CLUSTER_MAXNUM_OF_RESOURCES_EXCEEDED 5076L
#define ERROR_CLUSTER_SYSTEM_CONFIG_CHANGED 5077L
#define ERROR_CLUSTER_RESOURCE_TYPE_NOT_FOUND 5078L
#define ERROR_CLUSTER_RESTYPE_NOT_SUPPORTED 5079L
#define ERROR_CLUSTER_RESNAME_NOT_FOUND  5080L
#define ERROR_CLUSTER_NO_RPC_PACKAGES_REGISTERED 5081L
#define ERROR_CLUSTER_OWNER_NOT_IN_PREFLIST 5082L
#define ERROR_CLUSTER_DATABASE_SEQMISMATCH 5083L
#define ERROR_RESMON_INVALID_STATE  5084L
#define ERROR_CLUSTER_GUM_NOT_LOCKER  5085L
#define ERROR_QUORUM_DISK_NOT_FOUND  5086L
#define ERROR_DATABASE_BACKUP_CORRUPT  5087L
#define ERROR_CLUSTER_NODE_ALREADY_HAS_DFS_ROOT 5088L
#define ERROR_RESOURCE_PROPERTY_UNCHANGEABLE 5089L
#define ERROR_NO_ADMIN_ACCESS_POINT  5090L
#define ERROR_CLUSTER_MEMBERSHIP_INVALID_STATE 5890L
#define ERROR_CLUSTER_QUORUMLOG_NOT_FOUND 5891L
#define ERROR_CLUSTER_MEMBERSHIP_HALT  5892L
#define ERROR_CLUSTER_INSTANCE_ID_MISMATCH 5893L
#define ERROR_CLUSTER_NETWORK_NOT_FOUND_FOR_IP 5894L
#define ERROR_CLUSTER_PROPERTY_DATA_TYPE_MISMATCH 5895L
#define ERROR_CLUSTER_EVICT_WITHOUT_CLEANUP 5896L
#define ERROR_CLUSTER_PARAMETER_MISMATCH 5897L
#define ERROR_NODE_CANNOT_BE_CLUSTERED  5898L
#define ERROR_CLUSTER_WRONG_OS_VERSION  5899L
#define ERROR_CLUSTER_CANT_CREATE_DUP_CLUSTER_NAME 5900L
#define ERROR_CLUSCFG_ALREADY_COMMITTED  5901L
#define ERROR_CLUSCFG_ROLLBACK_FAILED  5902L
#define ERROR_CLUSCFG_SYSTEM_DISK_DRIVE_LETTER_CONFLICT 5903L
#define ERROR_CLUSTER_OLD_VERSION  5904L
#define ERROR_CLUSTER_MISMATCHED_COMPUTER_ACCT_NAME 5905L
#define ERROR_CLUSTER_NO_NET_ADAPTERS  5906L
#define ERROR_CLUSTER_POISONED  5907L
#define ERROR_CLUSTER_GROUP_MOVING  5908L
#define ERROR_CLUSTER_RESOURCE_TYPE_BUSY 5909L
#define ERROR_RESOURCE_CALL_TIMED_OUT  5910L
#define ERROR_INVALID_CLUSTER_IPV6_ADDRESS 5911L
#define ERROR_CLUSTER_INTERNAL_INVALID_FUNCTION 5912L
#define ERROR_CLUSTER_PARAMETER_OUT_OF_BOUNDS 5913L
#define ERROR_CLUSTER_PARTIAL_SEND  5914L
#define ERROR_CLUSTER_REGISTRY_INVALID_FUNCTION 5915L
#define ERROR_CLUSTER_INVALID_STRING_TERMINATION 5916L
#define ERROR_CLUSTER_INVALID_STRING_FORMAT 5917L
#define ERROR_CLUSTER_DATABASE_TRANSACTION_IN_PROGRESS 5918L
#define ERROR_CLUSTER_DATABASE_TRANSACTION_NOT_IN_PROGRESS 5919L
#define ERROR_CLUSTER_NULL_DATA  5920L
#define ERROR_CLUSTER_PARTIAL_READ  5921L
#define ERROR_CLUSTER_PARTIAL_WRITE  5922L
#define ERROR_CLUSTER_CANT_DESERIALIZE_DATA 5923L
#define ERROR_DEPENDENT_RESOURCE_PROPERTY_CONFLICT 5924L
#define ERROR_CLUSTER_NO_QUORUM  5925L
#define ERROR_CLUSTER_INVALID_IPV6_NETWORK 5926L
#define ERROR_CLUSTER_INVALID_IPV6_TUNNEL_NETWORK 5927L
#define ERROR_QUORUM_NOT_ALLOWED_IN_THIS_GROUP 5928L
#define ERROR_DEPENDENCY_TREE_TOO_COMPLEX 5929L
#define ERROR_EXCEPTION_IN_RESOURCE_CALL 5930L
#define ERROR_CLUSTER_RHS_FAILED_INITIALIZATION 5931L
#define ERROR_CLUSTER_NOT_INSTALLED  5932L
#define ERROR_CLUSTER_RESOURCES_MUST_BE_ONLINE_ON_THE_SAME_NODE 5933L
#define ERROR_CLUSTER_MAX_NODES_IN_CLUSTER 5934L
#define ERROR_CLUSTER_TOO_MANY_NODES  5935L
#define ERROR_CLUSTER_OBJECT_ALREADY_USED 5936L
#define ERROR_NONCORE_GROUPS_FOUND  5937L
#define ERROR_FILE_SHARE_RESOURCE_CONFLICT 5938L
#define ERROR_CLUSTER_EVICT_INVALID_REQUEST 5939L
#define ERROR_CLUSTER_SINGLETON_RESOURCE 5940L
#define ERROR_CLUSTER_GROUP_SINGLETON_RESOURCE 5941L
#define ERROR_CLUSTER_RESOURCE_PROVIDER_FAILED 5942L
#define ERROR_CLUSTER_RESOURCE_CONFIGURATION_ERROR 5943L
#define ERROR_CLUSTER_GROUP_BUSY  5944L
#define ERROR_CLUSTER_NOT_SHARED_VOLUME  5945L
#define ERROR_CLUSTER_INVALID_SECURITY_DESCRIPTOR 5946L
#define ERROR_CLUSTER_SHARED_VOLUMES_IN_USE 5947L
#define ERROR_CLUSTER_USE_SHARED_VOLUMES_API 5948L
#define ERROR_CLUSTER_BACKUP_IN_PROGRESS 5949L
#define ERROR_NON_CSV_PATH  5950L
#define ERROR_CSV_VOLUME_NOT_LOCAL  5951L
#define ERROR_CLUSTER_WATCHDOG_TERMINATING 5952L
#define ERROR_CLUSTER_RESOURCE_VETOED_MOVE_INCOMPATIBLE_NODES 5953L
#define ERROR_CLUSTER_INVALID_NODE_WEIGHT 5954L
#define ERROR_CLUSTER_RESOURCE_VETOED_CALL 5955L
#define ERROR_RESMON_SYSTEM_RESOURCES_LACKING 5956L
#define ERROR_CLUSTER_RESOURCE_VETOED_MOVE_NOT_ENOUGH_RESOURCES_ON_DESTINATION 5957L
#define ERROR_CLUSTER_RESOURCE_VETOED_MOVE_NOT_ENOUGH_RESOURCES_ON_SOURCE 5958L
#define ERROR_CLUSTER_GROUP_QUEUED  5959L
#define ERROR_CLUSTER_RESOURCE_LOCKED_STATUS 5960L
#define ERROR_CLUSTER_SHARED_VOLUME_FAILOVER_NOT_ALLOWED 5961L
#define ERROR_CLUSTER_NODE_DRAIN_IN_PROGRESS 5962L
#define ERROR_CLUSTER_DISK_NOT_CONNECTED 5963L
#define ERROR_DISK_NOT_CSV_CAPABLE  5964L
#define ERROR_RESOURCE_NOT_IN_AVAILABLE_STORAGE 5965L
#define ERROR_CLUSTER_SHARED_VOLUME_REDIRECTED 5966L
#define ERROR_CLUSTER_SHARED_VOLUME_NOT_REDIRECTED 5967L
#define ERROR_CLUSTER_CANNOT_RETURN_PROPERTIES 5968L
#define ERROR_CLUSTER_RESOURCE_CONTAINS_UNSUPPORTED_DIFF_AREA_FOR_SHARED_VOLUMES 5969L
#define ERROR_CLUSTER_RESOURCE_IS_IN_MAINTENANCE_MODE 5970L
#define ERROR_CLUSTER_AFFINITY_CONFLICT  5971L
#define ERROR_CLUSTER_RESOURCE_IS_REPLICA_VIRTUAL_MACHINE 5972L
#define ERROR_CLUSTER_UPGRADE_INCOMPATIBLE_VERSIONS 5973L
#define ERROR_CLUSTER_UPGRADE_FIX_QUORUM_NOT_SUPPORTED 5974L
#define ERROR_CLUSTER_UPGRADE_RESTART_REQUIRED 5975L
#define ERROR_CLUSTER_UPGRADE_IN_PROGRESS 5976L
#define ERROR_CLUSTER_UPGRADE_INCOMPLETE 5977L
#define ERROR_CLUSTER_NODE_IN_GRACE_PERIOD 5978L
#define ERROR_CLUSTER_CSV_IO_PAUSE_TIMEOUT 5979L
#define ERROR_NODE_NOT_ACTIVE_CLUSTER_MEMBER 5980L
#define ERROR_CLUSTER_RESOURCE_NOT_MONITORED 5981L
#define ERROR_CLUSTER_RESOURCE_DOES_NOT_SUPPORT_UNMONITORED 5982L
#define ERROR_CLUSTER_RESOURCE_IS_REPLICATED 5983L
#define ERROR_CLUSTER_NODE_ISOLATED  5984L
#define ERROR_CLUSTER_NODE_QUARANTINED  5985L
#define ERROR_CLUSTER_DATABASE_UPDATE_CONDITION_FAILED 5986L
#define ERROR_CLUSTER_SPACE_DEGRADED  5987L
#define ERROR_CLUSTER_TOKEN_DELEGATION_NOT_SUPPORTED 5988L
#define ERROR_CLUSTER_CSV_INVALID_HANDLE 5989L
#define ERROR_CLUSTER_CSV_SUPPORTED_ONLY_ON_COORDINATOR 5990L
#define ERROR_GROUPSET_NOT_AVAILABLE  5991L
#define ERROR_GROUPSET_NOT_FOUND  5992L
#define ERROR_GROUPSET_CANT_PROVIDE  5993L
#define ERROR_CLUSTER_FAULT_DOMAIN_PARENT_NOT_FOUND 5994L
#define ERROR_CLUSTER_FAULT_DOMAIN_INVALID_HIERARCHY 5995L
#define ERROR_CLUSTER_FAULT_DOMAIN_FAILED_S2D_VALIDATION 5996L
#define ERROR_CLUSTER_FAULT_DOMAIN_S2D_CONNECTIVITY_LOSS 5997L
#define ERROR_ENCRYPTION_FAILED  6000L
#define ERROR_DECRYPTION_FAILED  6001L
#define ERROR_FILE_ENCRYPTED  6002L
#define ERROR_NO_RECOVERY_POLICY  6003L
#define ERROR_NO_EFS  6004L
#define ERROR_WRONG_EFS  6005L
#define ERROR_NO_USER_KEYS  6006L
#define ERROR_FILE_NOT_ENCRYPTED  6007L
#define ERROR_NOT_EXPORT_FORMAT  6008L
#define ERROR_FILE_READ_ONLY  6009L
#define ERROR_DIR_EFS_DISALLOWED  6010L
#define ERROR_EFS_SERVER_NOT_TRUSTED  6011L
#define ERROR_BAD_RECOVERY_POLICY  6012L
#define ERROR_EFS_ALG_BLOB_TOO_BIG  6013L
#define ERROR_VOLUME_NOT_SUPPORT_EFS  6014L
#define ERROR_EFS_DISABLED  6015L
#define ERROR_EFS_VERSION_NOT_SUPPORT  6016L
#define ERROR_CS_ENCRYPTION_INVALID_SERVER_RESPONSE 6017L
#define ERROR_CS_ENCRYPTION_UNSUPPORTED_SERVER 6018L
#define ERROR_CS_ENCRYPTION_EXISTING_ENCRYPTED_FILE 6019L
#define ERROR_CS_ENCRYPTION_NEW_ENCRYPTED_FILE 6020L
#define ERROR_CS_ENCRYPTION_FILE_NOT_CSE 6021L
#define ERROR_ENCRYPTION_POLICY_DENIES_OPERATION 6022L
#define ERROR_NO_BROWSER_SERVERS_FOUND  6118L
#define SCHED_E_SERVICE_NOT_LOCALSYSTEM  6200L
#define ERROR_LOG_SECTOR_INVALID  6600L
#define ERROR_LOG_SECTOR_PARITY_INVALID  6601L
#define ERROR_LOG_SECTOR_REMAPPED  6602L
#define ERROR_LOG_BLOCK_INCOMPLETE  6603L
#define ERROR_LOG_INVALID_RANGE  6604L
#define ERROR_LOG_BLOCKS_EXHAUSTED  6605L
#define ERROR_LOG_READ_CONTEXT_INVALID  6606L
#define ERROR_LOG_RESTART_INVALID  6607L
#define ERROR_LOG_BLOCK_VERSION  6608L
#define ERROR_LOG_BLOCK_INVALID  6609L
#define ERROR_LOG_READ_MODE_INVALID  6610L
#define ERROR_LOG_NO_RESTART  6611L
#define ERROR_LOG_METADATA_CORRUPT  6612L
#define ERROR_LOG_METADATA_INVALID  6613L
#define ERROR_LOG_METADATA_INCONSISTENT  6614L
#define ERROR_LOG_RESERVATION_INVALID  6615L
#define ERROR_LOG_CANT_DELETE  6616L
#define ERROR_LOG_CONTAINER_LIMIT_EXCEEDED 6617L
#define ERROR_LOG_START_OF_LOG  6618L
#define ERROR_LOG_POLICY_ALREADY_INSTALLED 6619L
#define ERROR_LOG_POLICY_NOT_INSTALLED  6620L
#define ERROR_LOG_POLICY_INVALID  6621L
#define ERROR_LOG_POLICY_CONFLICT  6622L
#define ERROR_LOG_PINNED_ARCHIVE_TAIL  6623L
#define ERROR_LOG_RECORD_NONEXISTENT  6624L
#define ERROR_LOG_RECORDS_RESERVED_INVALID 6625L
#define ERROR_LOG_SPACE_RESERVED_INVALID 6626L
#define ERROR_LOG_TAIL_INVALID  6627L
#define ERROR_LOG_FULL  6628L
#define ERROR_COULD_NOT_RESIZE_LOG  6629L
#define ERROR_LOG_MULTIPLEXED  6630L
#define ERROR_LOG_DEDICATED  6631L
#define ERROR_LOG_ARCHIVE_NOT_IN_PROGRESS 6632L
#define ERROR_LOG_ARCHIVE_IN_PROGRESS  6633L
#define ERROR_LOG_EPHEMERAL  6634L
#define ERROR_LOG_NOT_ENOUGH_CONTAINERS  6635L
#define ERROR_LOG_CLIENT_ALREADY_REGISTERED 6636L
#define ERROR_LOG_CLIENT_NOT_REGISTERED  6637L
#define ERROR_LOG_FULL_HANDLER_IN_PROGRESS 6638L
#define ERROR_LOG_CONTAINER_READ_FAILED  6639L
#define ERROR_LOG_CONTAINER_WRITE_FAILED 6640L
#define ERROR_LOG_CONTAINER_OPEN_FAILED  6641L
#define ERROR_LOG_CONTAINER_STATE_INVALID 6642L
#define ERROR_LOG_STATE_INVALID  6643L
#define ERROR_LOG_PINNED  6644L
#define ERROR_LOG_METADATA_FLUSH_FAILED  6645L
#define ERROR_LOG_INCONSISTENT_SECURITY  6646L
#define ERROR_LOG_APPENDED_FLUSH_FAILED  6647L
#define ERROR_LOG_PINNED_RESERVATION  6648L
#define ERROR_INVALID_TRANSACTION  6700L
#define ERROR_TRANSACTION_NOT_ACTIVE  6701L
#define ERROR_TRANSACTION_REQUEST_NOT_VALID 6702L
#define ERROR_TRANSACTION_NOT_REQUESTED  6703L
#define ERROR_TRANSACTION_ALREADY_ABORTED 6704L
#define ERROR_TRANSACTION_ALREADY_COMMITTED 6705L
#define ERROR_TM_INITIALIZATION_FAILED  6706L
#define ERROR_RESOURCEMANAGER_READ_ONLY  6707L
#define ERROR_TRANSACTION_NOT_JOINED  6708L
#define ERROR_TRANSACTION_SUPERIOR_EXISTS 6709L
#define ERROR_CRM_PROTOCOL_ALREADY_EXISTS 6710L
#define ERROR_TRANSACTION_PROPAGATION_FAILED 6711L
#define ERROR_CRM_PROTOCOL_NOT_FOUND  6712L
#define ERROR_TRANSACTION_INVALID_MARSHALL_BUFFER 6713L
#define ERROR_CURRENT_TRANSACTION_NOT_VALID 6714L
#define ERROR_TRANSACTION_NOT_FOUND  6715L
#define ERROR_RESOURCEMANAGER_NOT_FOUND  6716L
#define ERROR_ENLISTMENT_NOT_FOUND  6717L
#define ERROR_TRANSACTIONMANAGER_NOT_FOUND 6718L
#define ERROR_TRANSACTIONMANAGER_NOT_ONLINE 6719L
#define ERROR_TRANSACTIONMANAGER_RECOVERY_NAME_COLLISION 6720L
#define ERROR_TRANSACTION_NOT_ROOT  6721L
#define ERROR_TRANSACTION_OBJECT_EXPIRED 6722L
#define ERROR_TRANSACTION_RESPONSE_NOT_ENLISTED 6723L
#define ERROR_TRANSACTION_RECORD_TOO_LONG 6724L
#define ERROR_IMPLICIT_TRANSACTION_NOT_SUPPORTED 6725L
#define ERROR_TRANSACTION_INTEGRITY_VIOLATED 6726L
#define ERROR_TRANSACTIONMANAGER_IDENTITY_MISMATCH 6727L
#define ERROR_RM_CANNOT_BE_FROZEN_FOR_SNAPSHOT 6728L
#define ERROR_TRANSACTION_MUST_WRITETHROUGH 6729L
#define ERROR_TRANSACTION_NO_SUPERIOR  6730L
#define ERROR_HEURISTIC_DAMAGE_POSSIBLE  6731L
#define ERROR_TRANSACTIONAL_CONFLICT  6800L
#define ERROR_RM_NOT_ACTIVE  6801L
#define ERROR_RM_METADATA_CORRUPT  6802L
#define ERROR_DIRECTORY_NOT_RM  6803L
#define ERROR_TRANSACTIONS_UNSUPPORTED_REMOTE 6805L
#define ERROR_LOG_RESIZE_INVALID_SIZE  6806L
#define ERROR_OBJECT_NO_LONGER_EXISTS  6807L
#define ERROR_STREAM_MINIVERSION_NOT_FOUND 6808L
#define ERROR_STREAM_MINIVERSION_NOT_VALID 6809L
#define ERROR_MINIVERSION_INACCESSIBLE_FROM_SPECIFIED_TRANSACTION 6810L
#define ERROR_CANT_OPEN_MINIVERSION_WITH_MODIFY_INTENT 6811L
#define ERROR_CANT_CREATE_MORE_STREAM_MINIVERSIONS 6812L
#define ERROR_REMOTE_FILE_VERSION_MISMATCH 6814L
#define ERROR_HANDLE_NO_LONGER_VALID  6815L
#define ERROR_NO_TXF_METADATA  6816L
#define ERROR_LOG_CORRUPTION_DETECTED  6817L
#define ERROR_CANT_RECOVER_WITH_HANDLE_OPEN 6818L
#define ERROR_RM_DISCONNECTED  6819L
#define ERROR_ENLISTMENT_NOT_SUPERIOR  6820L
#define ERROR_RECOVERY_NOT_NEEDED  6821L
#define ERROR_RM_ALREADY_STARTED  6822L
#define ERROR_FILE_IDENTITY_NOT_PERSISTENT 6823L
#define ERROR_CANT_BREAK_TRANSACTIONAL_DEPENDENCY 6824L
#define ERROR_CANT_CROSS_RM_BOUNDARY  6825L
#define ERROR_TXF_DIR_NOT_EMPTY  6826L
#define ERROR_INDOUBT_TRANSACTIONS_EXIST 6827L
#define ERROR_TM_VOLATILE  6828L
#define ERROR_ROLLBACK_TIMER_EXPIRED  6829L
#define ERROR_TXF_ATTRIBUTE_CORRUPT  6830L
#define ERROR_EFS_NOT_ALLOWED_IN_TRANSACTION 6831L
#define ERROR_TRANSACTIONAL_OPEN_NOT_ALLOWED 6832L
#define ERROR_LOG_GROWTH_FAILED  6833L
#define ERROR_TRANSACTED_MAPPING_UNSUPPORTED_REMOTE 6834L
#define ERROR_TXF_METADATA_ALREADY_PRESENT 6835L
#define ERROR_TRANSACTION_SCOPE_CALLBACKS_NOT_SET 6836L
#define ERROR_TRANSACTION_REQUIRED_PROMOTION 6837L
#define ERROR_CANNOT_EXECUTE_FILE_IN_TRANSACTION 6838L
#define ERROR_TRANSACTIONS_NOT_FROZEN  6839L
#define ERROR_TRANSACTION_FREEZE_IN_PROGRESS 6840L
#define ERROR_NOT_SNAPSHOT_VOLUME  6841L
#define ERROR_NO_SAVEPOINT_WITH_OPEN_FILES 6842L
#define ERROR_DATA_LOST_REPAIR  6843L
#define ERROR_SPARSE_NOT_ALLOWED_IN_TRANSACTION 6844L
#define ERROR_TM_IDENTITY_MISMATCH  6845L
#define ERROR_FLOATED_SECTION  6846L
#define ERROR_CANNOT_ACCEPT_TRANSACTED_WORK 6847L
#define ERROR_CANNOT_ABORT_TRANSACTIONS  6848L
#define ERROR_BAD_CLUSTERS  6849L
#define ERROR_COMPRESSION_NOT_ALLOWED_IN_TRANSACTION 6850L
#define ERROR_VOLUME_DIRTY  6851L
#define ERROR_NO_LINK_TRACKING_IN_TRANSACTION 6852L
#define ERROR_OPERATION_NOT_SUPPORTED_IN_TRANSACTION 6853L
#define ERROR_EXPIRED_HANDLE  6854L
#define ERROR_TRANSACTION_NOT_ENLISTED  6855L
#define ERROR_CTX_WINSTATION_NAME_INVALID 7001L
#define ERROR_CTX_INVALID_PD  7002L
#define ERROR_CTX_PD_NOT_FOUND  7003L
#define ERROR_CTX_WD_NOT_FOUND  7004L
#define ERROR_CTX_CANNOT_MAKE_EVENTLOG_ENTRY 7005L
#define ERROR_CTX_SERVICE_NAME_COLLISION 7006L
#define ERROR_CTX_CLOSE_PENDING  7007L
#define ERROR_CTX_NO_OUTBUF  7008L
#define ERROR_CTX_MODEM_INF_NOT_FOUND  7009L
#define ERROR_CTX_INVALID_MODEMNAME  7010L
#define ERROR_CTX_MODEM_RESPONSE_ERROR  7011L
#define ERROR_CTX_MODEM_RESPONSE_TIMEOUT 7012L
#define ERROR_CTX_MODEM_RESPONSE_NO_CARRIER 7013L
#define ERROR_CTX_MODEM_RESPONSE_NO_DIALTONE 7014L
#define ERROR_CTX_MODEM_RESPONSE_BUSY  7015L
#define ERROR_CTX_MODEM_RESPONSE_VOICE  7016L
#define ERROR_CTX_TD_ERROR  7017L
#define ERROR_CTX_WINSTATION_NOT_FOUND  7022L
#define ERROR_CTX_WINSTATION_ALREADY_EXISTS 7023L
#define ERROR_CTX_WINSTATION_BUSY  7024L
#define ERROR_CTX_BAD_VIDEO_MODE  7025L
#define ERROR_CTX_GRAPHICS_INVALID  7035L
#define ERROR_CTX_LOGON_DISABLED  7037L
#define ERROR_CTX_NOT_CONSOLE  7038L
#define ERROR_CTX_CLIENT_QUERY_TIMEOUT  7040L
#define ERROR_CTX_CONSOLE_DISCONNECT  7041L
#define ERROR_CTX_CONSOLE_CONNECT  7042L
#define ERROR_CTX_SHADOW_DENIED  7044L
#define ERROR_CTX_WINSTATION_ACCESS_DENIED 7045L
#define ERROR_CTX_INVALID_WD  7049L
#define ERROR_CTX_SHADOW_INVALID  7050L
#define ERROR_CTX_SHADOW_DISABLED  7051L
#define ERROR_CTX_CLIENT_LICENSE_IN_USE  7052L
#define ERROR_CTX_CLIENT_LICENSE_NOT_SET 7053L
#define ERROR_CTX_LICENSE_NOT_AVAILABLE  7054L
#define ERROR_CTX_LICENSE_CLIENT_INVALID 7055L
#define ERROR_CTX_LICENSE_EXPIRED  7056L
#define ERROR_CTX_SHADOW_NOT_RUNNING  7057L
#define ERROR_CTX_SHADOW_ENDED_BY_MODE_CHANGE 7058L
#define ERROR_ACTIVATION_COUNT_EXCEEDED  7059L
#define ERROR_CTX_WINSTATIONS_DISABLED  7060L
#define ERROR_CTX_ENCRYPTION_LEVEL_REQUIRED 7061L
#define ERROR_CTX_SESSION_IN_USE  7062L
#define ERROR_CTX_NO_FORCE_LOGOFF  7063L
#define ERROR_CTX_ACCOUNT_RESTRICTION  7064L
#define ERROR_RDP_PROTOCOL_ERROR  7065L
#define ERROR_CTX_CDM_CONNECT  7066L
#define ERROR_CTX_CDM_DISCONNECT  7067L
#define ERROR_CTX_SECURITY_LAYER_ERROR  7068L
#define ERROR_TS_INCOMPATIBLE_SESSIONS  7069L
#define ERROR_TS_VIDEO_SUBSYSTEM_ERROR  7070L
#define FRS_ERR_INVALID_API_SEQUENCE  8001L
#define FRS_ERR_STARTING_SERVICE  8002L
#define FRS_ERR_STOPPING_SERVICE  8003L
#define FRS_ERR_INTERNAL_API  8004L
#define FRS_ERR_INTERNAL  8005L
#define FRS_ERR_SERVICE_COMM  8006L
#define FRS_ERR_INSUFFICIENT_PRIV  8007L
#define FRS_ERR_AUTHENTICATION  8008L
#define FRS_ERR_PARENT_INSUFFICIENT_PRIV 8009L
#define FRS_ERR_PARENT_AUTHENTICATION  8010L
#define FRS_ERR_CHILD_TO_PARENT_COMM  8011L
#define FRS_ERR_PARENT_TO_CHILD_COMM  8012L
#define FRS_ERR_SYSVOL_POPULATE  8013L
#define FRS_ERR_SYSVOL_POPULATE_TIMEOUT  8014L
#define FRS_ERR_SYSVOL_IS_BUSY  8015L
#define FRS_ERR_SYSVOL_DEMOTE  8016L
#define FRS_ERR_INVALID_SERVICE_PARAMETER 8017L
#define DS_S_SUCCESS NO_ERROR
#define ERROR_DS_NOT_INSTALLED  8200L
#define ERROR_DS_MEMBERSHIP_EVALUATED_LOCALLY 8201L
#define ERROR_DS_NO_ATTRIBUTE_OR_VALUE  8202L
#define ERROR_DS_INVALID_ATTRIBUTE_SYNTAX 8203L
#define ERROR_DS_ATTRIBUTE_TYPE_UNDEFINED 8204L
#define ERROR_DS_ATTRIBUTE_OR_VALUE_EXISTS 8205L
#define ERROR_DS_BUSY  8206L
#define ERROR_DS_UNAVAILABLE  8207L
#define ERROR_DS_NO_RIDS_ALLOCATED  8208L
#define ERROR_DS_NO_MORE_RIDS  8209L
#define ERROR_DS_INCORRECT_ROLE_OWNER  8210L
#define ERROR_DS_RIDMGR_INIT_ERROR  8211L
#define ERROR_DS_OBJ_CLASS_VIOLATION  8212L
#define ERROR_DS_CANT_ON_NON_LEAF  8213L
#define ERROR_DS_CANT_ON_RDN  8214L
#define ERROR_DS_CANT_MOD_OBJ_CLASS  8215L
#define ERROR_DS_CROSS_DOM_MOVE_ERROR  8216L
#define ERROR_DS_GC_NOT_AVAILABLE  8217L
#define ERROR_SHARED_POLICY  8218L
#define ERROR_POLICY_OBJECT_NOT_FOUND  8219L
#define ERROR_POLICY_ONLY_IN_DS  8220L
#define ERROR_PROMOTION_ACTIVE  8221L
#define ERROR_NO_PROMOTION_ACTIVE  8222L
#define ERROR_DS_OPERATIONS_ERROR  8224L
#define ERROR_DS_PROTOCOL_ERROR  8225L
#define ERROR_DS_TIMELIMIT_EXCEEDED  8226L
#define ERROR_DS_SIZELIMIT_EXCEEDED  8227L
#define ERROR_DS_ADMIN_LIMIT_EXCEEDED  8228L
#define ERROR_DS_COMPARE_FALSE  8229L
#define ERROR_DS_COMPARE_TRUE  8230L
#define ERROR_DS_AUTH_METHOD_NOT_SUPPORTED 8231L
#define ERROR_DS_STRONG_AUTH_REQUIRED  8232L
#define ERROR_DS_INAPPROPRIATE_AUTH  8233L
#define ERROR_DS_AUTH_UNKNOWN  8234L
#define ERROR_DS_REFERRAL  8235L
#define ERROR_DS_UNAVAILABLE_CRIT_EXTENSION 8236L
#define ERROR_DS_CONFIDENTIALITY_REQUIRED 8237L
#define ERROR_DS_INAPPROPRIATE_MATCHING  8238L
#define ERROR_DS_CONSTRAINT_VIOLATION  8239L
#define ERROR_DS_NO_SUCH_OBJECT  8240L
#define ERROR_DS_ALIAS_PROBLEM  8241L
#define ERROR_DS_INVALID_DN_SYNTAX  8242L
#define ERROR_DS_IS_LEAF  8243L
#define ERROR_DS_ALIAS_DEREF_PROBLEM  8244L
#define ERROR_DS_UNWILLING_TO_PERFORM  8245L
#define ERROR_DS_LOOP_DETECT  8246L
#define ERROR_DS_NAMING_VIOLATION  8247L
#define ERROR_DS_OBJECT_RESULTS_TOO_LARGE 8248L
#define ERROR_DS_AFFECTS_MULTIPLE_DSAS  8249L
#define ERROR_DS_SERVER_DOWN  8250L
#define ERROR_DS_LOCAL_ERROR  8251L
#define ERROR_DS_ENCODING_ERROR  8252L
#define ERROR_DS_DECODING_ERROR  8253L
#define ERROR_DS_FILTER_UNKNOWN  8254L
#define ERROR_DS_PARAM_ERROR  8255L
#define ERROR_DS_NOT_SUPPORTED  8256L
#define ERROR_DS_NO_RESULTS_RETURNED  8257L
#define ERROR_DS_CONTROL_NOT_FOUND  8258L
#define ERROR_DS_CLIENT_LOOP  8259L
#define ERROR_DS_REFERRAL_LIMIT_EXCEEDED 8260L
#define ERROR_DS_SORT_CONTROL_MISSING  8261L
#define ERROR_DS_OFFSET_RANGE_ERROR  8262L
#define ERROR_DS_RIDMGR_DISABLED  8263L
#define ERROR_DS_ROOT_MUST_BE_NC  8301L
#define ERROR_DS_ADD_REPLICA_INHIBITED  8302L
#define ERROR_DS_ATT_NOT_DEF_IN_SCHEMA  8303L
#define ERROR_DS_MAX_OBJ_SIZE_EXCEEDED  8304L
#define ERROR_DS_OBJ_STRING_NAME_EXISTS  8305L
#define ERROR_DS_NO_RDN_DEFINED_IN_SCHEMA 8306L
#define ERROR_DS_RDN_DOESNT_MATCH_SCHEMA 8307L
#define ERROR_DS_NO_REQUESTED_ATTS_FOUND 8308L
#define ERROR_DS_USER_BUFFER_TO_SMALL  8309L
#define ERROR_DS_ATT_IS_NOT_ON_OBJ  8310L
#define ERROR_DS_ILLEGAL_MOD_OPERATION  8311L
#define ERROR_DS_OBJ_TOO_LARGE  8312L
#define ERROR_DS_BAD_INSTANCE_TYPE  8313L
#define ERROR_DS_MASTERDSA_REQUIRED  8314L
#define ERROR_DS_OBJECT_CLASS_REQUIRED  8315L
#define ERROR_DS_MISSING_REQUIRED_ATT  8316L
#define ERROR_DS_ATT_NOT_DEF_FOR_CLASS  8317L
#define ERROR_DS_ATT_ALREADY_EXISTS  8318L
#define ERROR_DS_CANT_ADD_ATT_VALUES  8320L
#define ERROR_DS_SINGLE_VALUE_CONSTRAINT 8321L
#define ERROR_DS_RANGE_CONSTRAINT  8322L
#define ERROR_DS_ATT_VAL_ALREADY_EXISTS  8323L
#define ERROR_DS_CANT_REM_MISSING_ATT  8324L
#define ERROR_DS_CANT_REM_MISSING_ATT_VAL 8325L
#define ERROR_DS_ROOT_CANT_BE_SUBREF  8326L
#define ERROR_DS_NO_CHAINING  8327L
#define ERROR_DS_NO_CHAINED_EVAL  8328L
#define ERROR_DS_NO_PARENT_OBJECT  8329L
#define ERROR_DS_PARENT_IS_AN_ALIAS  8330L
#define ERROR_DS_CANT_MIX_MASTER_AND_REPS 8331L
#define ERROR_DS_CHILDREN_EXIST  8332L
#define ERROR_DS_OBJ_NOT_FOUND  8333L
#define ERROR_DS_ALIASED_OBJ_MISSING  8334L
#define ERROR_DS_BAD_NAME_SYNTAX  8335L
#define ERROR_DS_ALIAS_POINTS_TO_ALIAS  8336L
#define ERROR_DS_CANT_DEREF_ALIAS  8337L
#define ERROR_DS_OUT_OF_SCOPE  8338L
#define ERROR_DS_OBJECT_BEING_REMOVED  8339L
#define ERROR_DS_CANT_DELETE_DSA_OBJ  8340L
#define ERROR_DS_GENERIC_ERROR  8341L
#define ERROR_DS_DSA_MUST_BE_INT_MASTER  8342L
#define ERROR_DS_CLASS_NOT_DSA  8343L
#define ERROR_DS_INSUFF_ACCESS_RIGHTS  8344L
#define ERROR_DS_ILLEGAL_SUPERIOR  8345L
#define ERROR_DS_ATTRIBUTE_OWNED_BY_SAM  8346L
#define ERROR_DS_NAME_TOO_MANY_PARTS  8347L
#define ERROR_DS_NAME_TOO_LONG  8348L
#define ERROR_DS_NAME_VALUE_TOO_LONG  8349L
#define ERROR_DS_NAME_UNPARSEABLE  8350L
#define ERROR_DS_NAME_TYPE_UNKNOWN  8351L
#define ERROR_DS_NOT_AN_OBJECT  8352L
#define ERROR_DS_SEC_DESC_TOO_SHORT  8353L
#define ERROR_DS_SEC_DESC_INVALID  8354L
#define ERROR_DS_NO_DELETED_NAME  8355L
#define ERROR_DS_SUBREF_MUST_HAVE_PARENT 8356L
#define ERROR_DS_NCNAME_MUST_BE_NC  8357L
#define ERROR_DS_CANT_ADD_SYSTEM_ONLY  8358L
#define ERROR_DS_CLASS_MUST_BE_CONCRETE  8359L
#define ERROR_DS_INVALID_DMD  8360L
#define ERROR_DS_OBJ_GUID_EXISTS  8361L
#define ERROR_DS_NOT_ON_BACKLINK  8362L
#define ERROR_DS_NO_CROSSREF_FOR_NC  8363L
#define ERROR_DS_SHUTTING_DOWN  8364L
#define ERROR_DS_UNKNOWN_OPERATION  8365L
#define ERROR_DS_INVALID_ROLE_OWNER  8366L
#define ERROR_DS_COULDNT_CONTACT_FSMO  8367L
#define ERROR_DS_CROSS_NC_DN_RENAME  8368L
#define ERROR_DS_CANT_MOD_SYSTEM_ONLY  8369L
#define ERROR_DS_REPLICATOR_ONLY  8370L
#define ERROR_DS_OBJ_CLASS_NOT_DEFINED  8371L
#define ERROR_DS_OBJ_CLASS_NOT_SUBCLASS  8372L
#define ERROR_DS_NAME_REFERENCE_INVALID  8373L
#define ERROR_DS_CROSS_REF_EXISTS  8374L
#define ERROR_DS_CANT_DEL_MASTER_CROSSREF 8375L
#define ERROR_DS_SUBTREE_NOTIFY_NOT_NC_HEAD 8376L
#define ERROR_DS_NOTIFY_FILTER_TOO_COMPLEX 8377L
#define ERROR_DS_DUP_RDN  8378L
#define ERROR_DS_DUP_OID  8379L
#define ERROR_DS_DUP_MAPI_ID  8380L
#define ERROR_DS_DUP_SCHEMA_ID_GUID  8381L
#define ERROR_DS_DUP_LDAP_DISPLAY_NAME  8382L
#define ERROR_DS_SEMANTIC_ATT_TEST  8383L
#define ERROR_DS_SYNTAX_MISMATCH  8384L
#define ERROR_DS_EXISTS_IN_MUST_HAVE  8385L
#define ERROR_DS_EXISTS_IN_MAY_HAVE  8386L
#define ERROR_DS_NONEXISTENT_MAY_HAVE  8387L
#define ERROR_DS_NONEXISTENT_MUST_HAVE  8388L
#define ERROR_DS_AUX_CLS_TEST_FAIL  8389L
#define ERROR_DS_NONEXISTENT_POSS_SUP  8390L
#define ERROR_DS_SUB_CLS_TEST_FAIL  8391L
#define ERROR_DS_BAD_RDN_ATT_ID_SYNTAX  8392L
#define ERROR_DS_EXISTS_IN_AUX_CLS  8393L
#define ERROR_DS_EXISTS_IN_SUB_CLS  8394L
#define ERROR_DS_EXISTS_IN_POSS_SUP  8395L
#define ERROR_DS_RECALCSCHEMA_FAILED  8396L
#define ERROR_DS_TREE_DELETE_NOT_FINISHED 8397L
#define ERROR_DS_CANT_DELETE  8398L
#define ERROR_DS_ATT_SCHEMA_REQ_ID  8399L
#define ERROR_DS_BAD_ATT_SCHEMA_SYNTAX  8400L
#define ERROR_DS_CANT_CACHE_ATT  8401L
#define ERROR_DS_CANT_CACHE_CLASS  8402L
#define ERROR_DS_CANT_REMOVE_ATT_CACHE  8403L
#define ERROR_DS_CANT_REMOVE_CLASS_CACHE 8404L
#define ERROR_DS_CANT_RETRIEVE_DN  8405L
#define ERROR_DS_MISSING_SUPREF  8406L
#define ERROR_DS_CANT_RETRIEVE_INSTANCE  8407L
#define ERROR_DS_CODE_INCONSISTENCY  8408L
#define ERROR_DS_DATABASE_ERROR  8409L
#define ERROR_DS_GOVERNSID_MISSING  8410L
#define ERROR_DS_MISSING_EXPECTED_ATT  8411L
#define ERROR_DS_NCNAME_MISSING_CR_REF  8412L
#define ERROR_DS_SECURITY_CHECKING_ERROR 8413L
#define ERROR_DS_SCHEMA_NOT_LOADED  8414L
#define ERROR_DS_SCHEMA_ALLOC_FAILED  8415L
#define ERROR_DS_ATT_SCHEMA_REQ_SYNTAX  8416L
#define ERROR_DS_GCVERIFY_ERROR  8417L
#define ERROR_DS_DRA_SCHEMA_MISMATCH  8418L
#define ERROR_DS_CANT_FIND_DSA_OBJ  8419L
#define ERROR_DS_CANT_FIND_EXPECTED_NC  8420L
#define ERROR_DS_CANT_FIND_NC_IN_CACHE  8421L
#define ERROR_DS_CANT_RETRIEVE_CHILD  8422L
#define ERROR_DS_SECURITY_ILLEGAL_MODIFY 8423L
#define ERROR_DS_CANT_REPLACE_HIDDEN_REC 8424L
#define ERROR_DS_BAD_HIERARCHY_FILE  8425L
#define ERROR_DS_BUILD_HIERARCHY_TABLE_FAILED 8426L
#define ERROR_DS_CONFIG_PARAM_MISSING  8427L
#define ERROR_DS_COUNTING_AB_INDICES_FAILED 8428L
#define ERROR_DS_HIERARCHY_TABLE_MALLOC_FAILED 8429L
#define ERROR_DS_INTERNAL_FAILURE  8430L
#define ERROR_DS_UNKNOWN_ERROR  8431L
#define ERROR_DS_ROOT_REQUIRES_CLASS_TOP 8432L
#define ERROR_DS_REFUSING_FSMO_ROLES  8433L
#define ERROR_DS_MISSING_FSMO_SETTINGS  8434L
#define ERROR_DS_UNABLE_TO_SURRENDER_ROLES 8435L
#define ERROR_DS_DRA_GENERIC  8436L
#define ERROR_DS_DRA_INVALID_PARAMETER  8437L
#define ERROR_DS_DRA_BUSY  8438L
#define ERROR_DS_DRA_BAD_DN  8439L
#define ERROR_DS_DRA_BAD_NC  8440L
#define ERROR_DS_DRA_DN_EXISTS  8441L
#define ERROR_DS_DRA_INTERNAL_ERROR  8442L
#define ERROR_DS_DRA_INCONSISTENT_DIT  8443L
#define ERROR_DS_DRA_CONNECTION_FAILED  8444L
#define ERROR_DS_DRA_BAD_INSTANCE_TYPE  8445L
#define ERROR_DS_DRA_OUT_OF_MEM  8446L
#define ERROR_DS_DRA_MAIL_PROBLEM  8447L
#define ERROR_DS_DRA_REF_ALREADY_EXISTS  8448L
#define ERROR_DS_DRA_REF_NOT_FOUND  8449L
#define ERROR_DS_DRA_OBJ_IS_REP_SOURCE  8450L
#define ERROR_DS_DRA_DB_ERROR  8451L
#define ERROR_DS_DRA_NO_REPLICA  8452L
#define ERROR_DS_DRA_ACCESS_DENIED  8453L
#define ERROR_DS_DRA_NOT_SUPPORTED  8454L
#define ERROR_DS_DRA_RPC_CANCELLED  8455L
#define ERROR_DS_DRA_SOURCE_DISABLED  8456L
#define ERROR_DS_DRA_SINK_DISABLED  8457L
#define ERROR_DS_DRA_NAME_COLLISION  8458L
#define ERROR_DS_DRA_SOURCE_REINSTALLED  8459L
#define ERROR_DS_DRA_MISSING_PARENT  8460L
#define ERROR_DS_DRA_PREEMPTED  8461L
#define ERROR_DS_DRA_ABANDON_SYNC  8462L
#define ERROR_DS_DRA_SHUTDOWN  8463L
#define ERROR_DS_DRA_INCOMPATIBLE_PARTIAL_SET 8464L
#define ERROR_DS_DRA_SOURCE_IS_PARTIAL_REPLICA 8465L
#define ERROR_DS_DRA_EXTN_CONNECTION_FAILED 8466L
#define ERROR_DS_INSTALL_SCHEMA_MISMATCH 8467L
#define ERROR_DS_DUP_LINK_ID  8468L
#define ERROR_DS_NAME_ERROR_RESOLVING  8469L
#define ERROR_DS_NAME_ERROR_NOT_FOUND  8470L
#define ERROR_DS_NAME_ERROR_NOT_UNIQUE  8471L
#define ERROR_DS_NAME_ERROR_NO_MAPPING  8472L
#define ERROR_DS_NAME_ERROR_DOMAIN_ONLY  8473L
#define ERROR_DS_NAME_ERROR_NO_SYNTACTICAL_MAPPING 8474L
#define ERROR_DS_CONSTRUCTED_ATT_MOD  8475L
#define ERROR_DS_WRONG_OM_OBJ_CLASS  8476L
#define ERROR_DS_DRA_REPL_PENDING  8477L
#define ERROR_DS_DS_REQUIRED  8478L
#define ERROR_DS_INVALID_LDAP_DISPLAY_NAME 8479L
#define ERROR_DS_NON_BASE_SEARCH  8480L
#define ERROR_DS_CANT_RETRIEVE_ATTS  8481L
#define ERROR_DS_BACKLINK_WITHOUT_LINK  8482L
#define ERROR_DS_EPOCH_MISMATCH  8483L
#define ERROR_DS_SRC_NAME_MISMATCH  8484L
#define ERROR_DS_SRC_AND_DST_NC_IDENTICAL 8485L
#define ERROR_DS_DST_NC_MISMATCH  8486L
#define ERROR_DS_NOT_AUTHORITIVE_FOR_DST_NC 8487L
#define ERROR_DS_SRC_GUID_MISMATCH  8488L
#define ERROR_DS_CANT_MOVE_DELETED_OBJECT 8489L
#define ERROR_DS_PDC_OPERATION_IN_PROGRESS 8490L
#define ERROR_DS_CROSS_DOMAIN_CLEANUP_REQD 8491L
#define ERROR_DS_ILLEGAL_XDOM_MOVE_OPERATION 8492L
#define ERROR_DS_CANT_WITH_ACCT_GROUP_MEMBERSHPS 8493L
#define ERROR_DS_NC_MUST_HAVE_NC_PARENT  8494L
#define ERROR_DS_CR_IMPOSSIBLE_TO_VALIDATE 8495L
#define ERROR_DS_DST_DOMAIN_NOT_NATIVE  8496L
#define ERROR_DS_MISSING_INFRASTRUCTURE_CONTAINER 8497L
#define ERROR_DS_CANT_MOVE_ACCOUNT_GROUP 8498L
#define ERROR_DS_CANT_MOVE_RESOURCE_GROUP 8499L
#define ERROR_DS_INVALID_SEARCH_FLAG  8500L
#define ERROR_DS_NO_TREE_DELETE_ABOVE_NC 8501L
#define ERROR_DS_COULDNT_LOCK_TREE_FOR_DELETE 8502L
#define ERROR_DS_COULDNT_IDENTIFY_OBJECTS_FOR_TREE_DELETE 8503L
#define ERROR_DS_SAM_INIT_FAILURE  8504L
#define ERROR_DS_SENSITIVE_GROUP_VIOLATION 8505L
#define ERROR_DS_CANT_MOD_PRIMARYGROUPID 8506L
#define ERROR_DS_ILLEGAL_BASE_SCHEMA_MOD 8507L
#define ERROR_DS_NONSAFE_SCHEMA_CHANGE  8508L
#define ERROR_DS_SCHEMA_UPDATE_DISALLOWED 8509L
#define ERROR_DS_CANT_CREATE_UNDER_SCHEMA 8510L
#define ERROR_DS_INSTALL_NO_SRC_SCH_VERSION 8511L
#define ERROR_DS_INSTALL_NO_SCH_VERSION_IN_INIFILE 8512L
#define ERROR_DS_INVALID_GROUP_TYPE  8513L
#define ERROR_DS_NO_NEST_GLOBALGROUP_IN_MIXEDDOMAIN 8514L
#define ERROR_DS_NO_NEST_LOCALGROUP_IN_MIXEDDOMAIN 8515L
#define ERROR_DS_GLOBAL_CANT_HAVE_LOCAL_MEMBER 8516L
#define ERROR_DS_GLOBAL_CANT_HAVE_UNIVERSAL_MEMBER 8517L
#define ERROR_DS_UNIVERSAL_CANT_HAVE_LOCAL_MEMBER 8518L
#define ERROR_DS_GLOBAL_CANT_HAVE_CROSSDOMAIN_MEMBER 8519L
#define ERROR_DS_LOCAL_CANT_HAVE_CROSSDOMAIN_LOCAL_MEMBER 8520L
#define ERROR_DS_HAVE_PRIMARY_MEMBERS  8521L
#define ERROR_DS_STRING_SD_CONVERSION_FAILED 8522L
#define ERROR_DS_NAMING_MASTER_GC  8523L
#define ERROR_DS_DNS_LOOKUP_FAILURE  8524L
#define ERROR_DS_COULDNT_UPDATE_SPNS  8525L
#define ERROR_DS_CANT_RETRIEVE_SD  8526L
#define ERROR_DS_KEY_NOT_UNIQUE  8527L
#define ERROR_DS_WRONG_LINKED_ATT_SYNTAX 8528L
#define ERROR_DS_SAM_NEED_BOOTKEY_PASSWORD 8529L
#define ERROR_DS_SAM_NEED_BOOTKEY_FLOPPY 8530L
#define ERROR_DS_CANT_START  8531L
#define ERROR_DS_INIT_FAILURE  8532L
#define ERROR_DS_NO_PKT_PRIVACY_ON_CONNECTION 8533L
#define ERROR_DS_SOURCE_DOMAIN_IN_FOREST 8534L
#define ERROR_DS_DESTINATION_DOMAIN_NOT_IN_FOREST 8535L
#define ERROR_DS_DESTINATION_AUDITING_NOT_ENABLED 8536L
#define ERROR_DS_CANT_FIND_DC_FOR_SRC_DOMAIN 8537L
#define ERROR_DS_SRC_OBJ_NOT_GROUP_OR_USER 8538L
#define ERROR_DS_SRC_SID_EXISTS_IN_FOREST 8539L
#define ERROR_DS_SRC_AND_DST_OBJECT_CLASS_MISMATCH 8540L
#define ERROR_SAM_INIT_FAILURE  8541L
#define ERROR_DS_DRA_SCHEMA_INFO_SHIP  8542L
#define ERROR_DS_DRA_SCHEMA_CONFLICT  8543L
#define ERROR_DS_DRA_EARLIER_SCHEMA_CONFLICT 8544L
#define ERROR_DS_DRA_OBJ_NC_MISMATCH  8545L
#define ERROR_DS_NC_STILL_HAS_DSAS  8546L
#define ERROR_DS_GC_REQUIRED  8547L
#define ERROR_DS_LOCAL_MEMBER_OF_LOCAL_ONLY 8548L
#define ERROR_DS_NO_FPO_IN_UNIVERSAL_GROUPS 8549L
#define ERROR_DS_CANT_ADD_TO_GC  8550L
#define ERROR_DS_NO_CHECKPOINT_WITH_PDC  8551L
#define ERROR_DS_SOURCE_AUDITING_NOT_ENABLED 8552L
#define ERROR_DS_CANT_CREATE_IN_NONDOMAIN_NC 8553L
#define ERROR_DS_INVALID_NAME_FOR_SPN  8554L
#define ERROR_DS_FILTER_USES_CONTRUCTED_ATTRS 8555L
#define ERROR_DS_UNICODEPWD_NOT_IN_QUOTES 8556L
#define ERROR_DS_MACHINE_ACCOUNT_QUOTA_EXCEEDED 8557L
#define ERROR_DS_MUST_BE_RUN_ON_DST_DC  8558L
#define ERROR_DS_SRC_DC_MUST_BE_SP4_OR_GREATER 8559L
#define ERROR_DS_CANT_TREE_DELETE_CRITICAL_OBJ 8560L
#define ERROR_DS_INIT_FAILURE_CONSOLE  8561L
#define ERROR_DS_SAM_INIT_FAILURE_CONSOLE 8562L
#define ERROR_DS_FOREST_VERSION_TOO_HIGH 8563L
#define ERROR_DS_DOMAIN_VERSION_TOO_HIGH 8564L
#define ERROR_DS_FOREST_VERSION_TOO_LOW  8565L
#define ERROR_DS_DOMAIN_VERSION_TOO_LOW  8566L
#define ERROR_DS_INCOMPATIBLE_VERSION  8567L
#define ERROR_DS_LOW_DSA_VERSION  8568L
#define ERROR_DS_NO_BEHAVIOR_VERSION_IN_MIXEDDOMAIN 8569L
#define ERROR_DS_NOT_SUPPORTED_SORT_ORDER 8570L
#define ERROR_DS_NAME_NOT_UNIQUE  8571L
#define ERROR_DS_MACHINE_ACCOUNT_CREATED_PRENT4 8572L
#define ERROR_DS_OUT_OF_VERSION_STORE  8573L
#define ERROR_DS_INCOMPATIBLE_CONTROLS_USED 8574L
#define ERROR_DS_NO_REF_DOMAIN  8575L
#define ERROR_DS_RESERVED_LINK_ID  8576L
#define ERROR_DS_LINK_ID_NOT_AVAILABLE  8577L
#define ERROR_DS_AG_CANT_HAVE_UNIVERSAL_MEMBER 8578L
#define ERROR_DS_MODIFYDN_DISALLOWED_BY_INSTANCE_TYPE 8579L
#define ERROR_DS_NO_OBJECT_MOVE_IN_SCHEMA_NC 8580L
#define ERROR_DS_MODIFYDN_DISALLOWED_BY_FLAG 8581L
#define ERROR_DS_MODIFYDN_WRONG_GRANDPARENT 8582L
#define ERROR_DS_NAME_ERROR_TRUST_REFERRAL 8583L
#define ERROR_NOT_SUPPORTED_ON_STANDARD_SERVER 8584L
#define ERROR_DS_CANT_ACCESS_REMOTE_PART_OF_AD 8585L
#define ERROR_DS_CR_IMPOSSIBLE_TO_VALIDATE_V2 8586L
#define ERROR_DS_THREAD_LIMIT_EXCEEDED  8587L
#define ERROR_DS_NOT_CLOSEST  8588L
#define ERROR_DS_CANT_DERIVE_SPN_WITHOUT_SERVER_REF 8589L
#define ERROR_DS_SINGLE_USER_MODE_FAILED 8590L
#define ERROR_DS_NTDSCRIPT_SYNTAX_ERROR  8591L
#define ERROR_DS_NTDSCRIPT_PROCESS_ERROR 8592L
#define ERROR_DS_DIFFERENT_REPL_EPOCHS  8593L
#define ERROR_DS_DRS_EXTENSIONS_CHANGED  8594L
#define ERROR_DS_REPLICA_SET_CHANGE_NOT_ALLOWED_ON_DISABLED_CR 8595L
#define ERROR_DS_NO_MSDS_INTID  8596L
#define ERROR_DS_DUP_MSDS_INTID  8597L
#define ERROR_DS_EXISTS_IN_RDNATTID  8598L
#define ERROR_DS_AUTHORIZATION_FAILED  8599L
#define ERROR_DS_INVALID_SCRIPT  8600L
#define ERROR_DS_REMOTE_CROSSREF_OP_FAILED 8601L
#define ERROR_DS_CROSS_REF_BUSY  8602L
#define ERROR_DS_CANT_DERIVE_SPN_FOR_DELETED_DOMAIN 8603L
#define ERROR_DS_CANT_DEMOTE_WITH_WRITEABLE_NC 8604L
#define ERROR_DS_DUPLICATE_ID_FOUND  8605L
#define ERROR_DS_INSUFFICIENT_ATTR_TO_CREATE_OBJECT 8606L
#define ERROR_DS_GROUP_CONVERSION_ERROR  8607L
#define ERROR_DS_CANT_MOVE_APP_BASIC_GROUP 8608L
#define ERROR_DS_CANT_MOVE_APP_QUERY_GROUP 8609L
#define ERROR_DS_ROLE_NOT_VERIFIED  8610L
#define ERROR_DS_WKO_CONTAINER_CANNOT_BE_SPECIAL 8611L
#define ERROR_DS_DOMAIN_RENAME_IN_PROGRESS 8612L
#define ERROR_DS_EXISTING_AD_CHILD_NC  8613L
#define ERROR_DS_REPL_LIFETIME_EXCEEDED  8614L
#define ERROR_DS_DISALLOWED_IN_SYSTEM_CONTAINER 8615L
#define ERROR_DS_LDAP_SEND_QUEUE_FULL  8616L
#define ERROR_DS_DRA_OUT_SCHEDULE_WINDOW 8617L
#define ERROR_DS_POLICY_NOT_KNOWN  8618L
#define ERROR_NO_SITE_SETTINGS_OBJECT  8619L
#define ERROR_NO_SECRETS  8620L
#define ERROR_NO_WRITABLE_DC_FOUND  8621L
#define ERROR_DS_NO_SERVER_OBJECT  8622L
#define ERROR_DS_NO_NTDSA_OBJECT  8623L
#define ERROR_DS_NON_ASQ_SEARCH  8624L
#define ERROR_DS_AUDIT_FAILURE  8625L
#define ERROR_DS_INVALID_SEARCH_FLAG_SUBTREE 8626L
#define ERROR_DS_INVALID_SEARCH_FLAG_TUPLE 8627L
#define ERROR_DS_HIERARCHY_TABLE_TOO_DEEP 8628L
#define ERROR_DS_DRA_CORRUPT_UTD_VECTOR  8629L
#define ERROR_DS_DRA_SECRETS_DENIED  8630L
#define ERROR_DS_RESERVED_MAPI_ID  8631L
#define ERROR_DS_MAPI_ID_NOT_AVAILABLE  8632L
#define ERROR_DS_DRA_MISSING_KRBTGT_SECRET 8633L
#define ERROR_DS_DOMAIN_NAME_EXISTS_IN_FOREST 8634L
#define ERROR_DS_FLAT_NAME_EXISTS_IN_FOREST 8635L
#define ERROR_INVALID_USER_PRINCIPAL_NAME 8636L
#define ERROR_DS_OID_MAPPED_GROUP_CANT_HAVE_MEMBERS 8637L
#define ERROR_DS_OID_NOT_FOUND  8638L
#define ERROR_DS_DRA_RECYCLED_TARGET  8639L
#define ERROR_DS_DISALLOWED_NC_REDIRECT  8640L
#define ERROR_DS_HIGH_ADLDS_FFL  8641L
#define ERROR_DS_HIGH_DSA_VERSION  8642L
#define ERROR_DS_LOW_ADLDS_FFL  8643L
#define ERROR_DOMAIN_SID_SAME_AS_LOCAL_WORKSTATION 8644L
#define ERROR_DS_UNDELETE_SAM_VALIDATION_FAILED 8645L
#define ERROR_INCORRECT_ACCOUNT_TYPE  8646L
#define ERROR_DS_SPN_VALUE_NOT_UNIQUE_IN_FOREST 8647L
#define ERROR_DS_UPN_VALUE_NOT_UNIQUE_IN_FOREST 8648L
#define ERROR_DS_MISSING_FOREST_TRUST  8649L
#define ERROR_DS_VALUE_KEY_NOT_UNIQUE  8650L
#define DNS_ERROR_RESPONSE_CODES_BASE 9000
#define DNS_ERROR_RCODE_NO_ERROR NO_ERROR
#define DNS_ERROR_MASK 0x00002328
#define DNS_ERROR_RCODE_FORMAT_ERROR  9001L
#define DNS_ERROR_RCODE_SERVER_FAILURE  9002L
#define DNS_ERROR_RCODE_NAME_ERROR  9003L
#define DNS_ERROR_RCODE_NOT_IMPLEMENTED  9004L
#define DNS_ERROR_RCODE_REFUSED  9005L
#define DNS_ERROR_RCODE_YXDOMAIN  9006L
#define DNS_ERROR_RCODE_YXRRSET  9007L
#define DNS_ERROR_RCODE_NXRRSET  9008L
#define DNS_ERROR_RCODE_NOTAUTH  9009L
#define DNS_ERROR_RCODE_NOTZONE  9010L
#define DNS_ERROR_RCODE_BADSIG  9016L
#define DNS_ERROR_RCODE_BADKEY  9017L
#define DNS_ERROR_RCODE_BADTIME  9018L
#define DNS_ERROR_RCODE_LAST DNS_ERROR_RCODE_BADTIME
#define DNS_ERROR_DNSSEC_BASE 9100
#define DNS_ERROR_KEYMASTER_REQUIRED  9101L
#define DNS_ERROR_NOT_ALLOWED_ON_SIGNED_ZONE 9102L
#define DNS_ERROR_NSEC3_INCOMPATIBLE_WITH_RSA_SHA1 9103L
#define DNS_ERROR_NOT_ENOUGH_SIGNING_KEY_DESCRIPTORS 9104L
#define DNS_ERROR_UNSUPPORTED_ALGORITHM  9105L
#define DNS_ERROR_INVALID_KEY_SIZE  9106L
#define DNS_ERROR_SIGNING_KEY_NOT_ACCESSIBLE 9107L
#define DNS_ERROR_KSP_DOES_NOT_SUPPORT_PROTECTION 9108L
#define DNS_ERROR_UNEXPECTED_DATA_PROTECTION_ERROR 9109L
#define DNS_ERROR_UNEXPECTED_CNG_ERROR  9110L
#define DNS_ERROR_UNKNOWN_SIGNING_PARAMETER_VERSION 9111L
#define DNS_ERROR_KSP_NOT_ACCESSIBLE  9112L
#define DNS_ERROR_TOO_MANY_SKDS  9113L
#define DNS_ERROR_INVALID_ROLLOVER_PERIOD 9114L
#define DNS_ERROR_INVALID_INITIAL_ROLLOVER_OFFSET 9115L
#define DNS_ERROR_ROLLOVER_IN_PROGRESS  9116L
#define DNS_ERROR_STANDBY_KEY_NOT_PRESENT 9117L
#define DNS_ERROR_NOT_ALLOWED_ON_ZSK  9118L
#define DNS_ERROR_NOT_ALLOWED_ON_ACTIVE_SKD 9119L
#define DNS_ERROR_ROLLOVER_ALREADY_QUEUED 9120L
#define DNS_ERROR_NOT_ALLOWED_ON_UNSIGNED_ZONE 9121L
#define DNS_ERROR_BAD_KEYMASTER  9122L
#define DNS_ERROR_INVALID_SIGNATURE_VALIDITY_PERIOD 9123L
#define DNS_ERROR_INVALID_NSEC3_ITERATION_COUNT 9124L
#define DNS_ERROR_DNSSEC_IS_DISABLED  9125L
#define DNS_ERROR_INVALID_XML  9126L
#define DNS_ERROR_NO_VALID_TRUST_ANCHORS 9127L
#define DNS_ERROR_ROLLOVER_NOT_POKEABLE  9128L
#define DNS_ERROR_NSEC3_NAME_COLLISION  9129L
#define DNS_ERROR_NSEC_INCOMPATIBLE_WITH_NSEC3_RSA_SHA1 9130L
#define DNS_ERROR_PACKET_FMT_BASE 9500
#define DNS_INFO_NO_RECORDS  9501L
#define DNS_ERROR_BAD_PACKET  9502L
#define DNS_ERROR_NO_PACKET  9503L
#define DNS_ERROR_RCODE  9504L
#define DNS_ERROR_UNSECURE_PACKET  9505L
#define DNS_STATUS_PACKET_UNSECURE DNS_ERROR_UNSECURE_PACKET
#define DNS_REQUEST_PENDING  9506L
#define DNS_ERROR_NO_MEMORY  ERROR_OUTOFMEMORY
#define DNS_ERROR_INVALID_NAME  ERROR_INVALID_NAME
#define DNS_ERROR_INVALID_DATA  ERROR_INVALID_DATA
#define DNS_ERROR_GENERAL_API_BASE 9550
#define DNS_ERROR_INVALID_TYPE  9551L
#define DNS_ERROR_INVALID_IP_ADDRESS  9552L
#define DNS_ERROR_INVALID_PROPERTY  9553L
#define DNS_ERROR_TRY_AGAIN_LATER  9554L
#define DNS_ERROR_NOT_UNIQUE  9555L
#define DNS_ERROR_NON_RFC_NAME  9556L
#define DNS_STATUS_FQDN  9557L
#define DNS_STATUS_DOTTED_NAME  9558L
#define DNS_STATUS_SINGLE_PART_NAME  9559L
#define DNS_ERROR_INVALID_NAME_CHAR  9560L
#define DNS_ERROR_NUMERIC_NAME  9561L
#define DNS_ERROR_NOT_ALLOWED_ON_ROOT_SERVER 9562L
#define DNS_ERROR_NOT_ALLOWED_UNDER_DELEGATION 9563L
#define DNS_ERROR_CANNOT_FIND_ROOT_HINTS 9564L
#define DNS_ERROR_INCONSISTENT_ROOT_HINTS 9565L
#define DNS_ERROR_DWORD_VALUE_TOO_SMALL  9566L
#define DNS_ERROR_DWORD_VALUE_TOO_LARGE  9567L
#define DNS_ERROR_BACKGROUND_LOADING  9568L
#define DNS_ERROR_NOT_ALLOWED_ON_RODC  9569L
#define DNS_ERROR_NOT_ALLOWED_UNDER_DNAME 9570L
#define DNS_ERROR_DELEGATION_REQUIRED  9571L
#define DNS_ERROR_INVALID_POLICY_TABLE  9572L
#define DNS_ERROR_ADDRESS_REQUIRED  9573L
#define DNS_ERROR_ZONE_BASE 9600
#define DNS_ERROR_ZONE_DOES_NOT_EXIST  9601L
#define DNS_ERROR_NO_ZONE_INFO  9602L
#define DNS_ERROR_INVALID_ZONE_OPERATION 9603L
#define DNS_ERROR_ZONE_CONFIGURATION_ERROR 9604L
#define DNS_ERROR_ZONE_HAS_NO_SOA_RECORD 9605L
#define DNS_ERROR_ZONE_HAS_NO_NS_RECORDS 9606L
#define DNS_ERROR_ZONE_LOCKED  9607L
#define DNS_ERROR_ZONE_CREATION_FAILED  9608L
#define DNS_ERROR_ZONE_ALREADY_EXISTS  9609L
#define DNS_ERROR_AUTOZONE_ALREADY_EXISTS 9610L
#define DNS_ERROR_INVALID_ZONE_TYPE  9611L
#define DNS_ERROR_SECONDARY_REQUIRES_MASTER_IP 9612L
#define DNS_ERROR_ZONE_NOT_SECONDARY  9613L
#define DNS_ERROR_NEED_SECONDARY_ADDRESSES 9614L
#define DNS_ERROR_WINS_INIT_FAILED  9615L
#define DNS_ERROR_NEED_WINS_SERVERS  9616L
#define DNS_ERROR_NBSTAT_INIT_FAILED  9617L
#define DNS_ERROR_SOA_DELETE_INVALID  9618L
#define DNS_ERROR_FORWARDER_ALREADY_EXISTS 9619L
#define DNS_ERROR_ZONE_REQUIRES_MASTER_IP 9620L
#define DNS_ERROR_ZONE_IS_SHUTDOWN  9621L
#define DNS_ERROR_ZONE_LOCKED_FOR_SIGNING 9622L
#define DNS_ERROR_DATAFILE_BASE 9650
#define DNS_ERROR_PRIMARY_REQUIRES_DATAFILE 9651L
#define DNS_ERROR_INVALID_DATAFILE_NAME  9652L
#define DNS_ERROR_DATAFILE_OPEN_FAILURE  9653L
#define DNS_ERROR_FILE_WRITEBACK_FAILED  9654L
#define DNS_ERROR_DATAFILE_PARSING  9655L
#define DNS_ERROR_DATABASE_BASE 9700
#define DNS_ERROR_RECORD_DOES_NOT_EXIST  9701L
#define DNS_ERROR_RECORD_FORMAT  9702L
#define DNS_ERROR_NODE_CREATION_FAILED  9703L
#define DNS_ERROR_UNKNOWN_RECORD_TYPE  9704L
#define DNS_ERROR_RECORD_TIMED_OUT  9705L
#define DNS_ERROR_NAME_NOT_IN_ZONE  9706L
#define DNS_ERROR_CNAME_LOOP  9707L
#define DNS_ERROR_NODE_IS_CNAME  9708L
#define DNS_ERROR_CNAME_COLLISION  9709L
#define DNS_ERROR_RECORD_ONLY_AT_ZONE_ROOT 9710L
#define DNS_ERROR_RECORD_ALREADY_EXISTS  9711L
#define DNS_ERROR_SECONDARY_DATA  9712L
#define DNS_ERROR_NO_CREATE_CACHE_DATA  9713L
#define DNS_ERROR_NAME_DOES_NOT_EXIST  9714L
#define DNS_WARNING_PTR_CREATE_FAILED  9715L
#define DNS_WARNING_DOMAIN_UNDELETED  9716L
#define DNS_ERROR_DS_UNAVAILABLE  9717L
#define DNS_ERROR_DS_ZONE_ALREADY_EXISTS 9718L
#define DNS_ERROR_NO_BOOTFILE_IF_DS_ZONE 9719L
#define DNS_ERROR_NODE_IS_DNAME  9720L
#define DNS_ERROR_DNAME_COLLISION  9721L
#define DNS_ERROR_ALIAS_LOOP  9722L
#define DNS_ERROR_OPERATION_BASE 9750
#define DNS_INFO_AXFR_COMPLETE  9751L
#define DNS_ERROR_AXFR  9752L
#define DNS_INFO_ADDED_LOCAL_WINS  9753L
#define DNS_ERROR_SECURE_BASE 9800
#define DNS_STATUS_CONTINUE_NEEDED  9801L
#define DNS_ERROR_SETUP_BASE 9850
#define DNS_ERROR_NO_TCPIP  9851L
#define DNS_ERROR_NO_DNS_SERVERS  9852L
#define DNS_ERROR_DP_BASE 9900
#define DNS_ERROR_DP_DOES_NOT_EXIST  9901L
#define DNS_ERROR_DP_ALREADY_EXISTS  9902L
#define DNS_ERROR_DP_NOT_ENLISTED  9903L
#define DNS_ERROR_DP_ALREADY_ENLISTED  9904L
#define DNS_ERROR_DP_NOT_AVAILABLE  9905L
#define DNS_ERROR_DP_FSMO_ERROR  9906L
#define DNS_ERROR_RRL_NOT_ENABLED  9911L
#define DNS_ERROR_RRL_INVALID_WINDOW_SIZE 9912L
#define DNS_ERROR_RRL_INVALID_IPV4_PREFIX 9913L
#define DNS_ERROR_RRL_INVALID_IPV6_PREFIX 9914L
#define DNS_ERROR_RRL_INVALID_TC_RATE  9915L
#define DNS_ERROR_RRL_INVALID_LEAK_RATE  9916L
#define DNS_ERROR_RRL_LEAK_RATE_LESSTHAN_TC_RATE 9917L
#define DNS_ERROR_VIRTUALIZATION_INSTANCE_ALREADY_EXISTS 9921L
#define DNS_ERROR_VIRTUALIZATION_INSTANCE_DOES_NOT_EXIST 9922L
#define DNS_ERROR_VIRTUALIZATION_TREE_LOCKED 9923L
#define DNS_ERROR_INVAILD_VIRTUALIZATION_INSTANCE_NAME 9924L
#define DNS_ERROR_DEFAULT_VIRTUALIZATION_INSTANCE 9925L
#define DNS_ERROR_ZONESCOPE_ALREADY_EXISTS 9951L
#define DNS_ERROR_ZONESCOPE_DOES_NOT_EXIST 9952L
#define DNS_ERROR_DEFAULT_ZONESCOPE  9953L
#define DNS_ERROR_INVALID_ZONESCOPE_NAME 9954L
#define DNS_ERROR_NOT_ALLOWED_WITH_ZONESCOPES 9955L
#define DNS_ERROR_LOAD_ZONESCOPE_FAILED  9956L
#define DNS_ERROR_ZONESCOPE_FILE_WRITEBACK_FAILED 9957L
#define DNS_ERROR_INVALID_SCOPE_NAME  9958L
#define DNS_ERROR_SCOPE_DOES_NOT_EXIST  9959L
#define DNS_ERROR_DEFAULT_SCOPE  9960L
#define DNS_ERROR_INVALID_SCOPE_OPERATION 9961L
#define DNS_ERROR_SCOPE_LOCKED  9962L
#define DNS_ERROR_SCOPE_ALREADY_EXISTS  9963L
#define DNS_ERROR_POLICY_ALREADY_EXISTS  9971L
#define DNS_ERROR_POLICY_DOES_NOT_EXIST  9972L
#define DNS_ERROR_POLICY_INVALID_CRITERIA 9973L
#define DNS_ERROR_POLICY_INVALID_SETTINGS 9974L
#define DNS_ERROR_CLIENT_SUBNET_IS_ACCESSED 9975L
#define DNS_ERROR_CLIENT_SUBNET_DOES_NOT_EXIST 9976L
#define DNS_ERROR_CLIENT_SUBNET_ALREADY_EXISTS 9977L
#define DNS_ERROR_SUBNET_DOES_NOT_EXIST  9978L
#define DNS_ERROR_SUBNET_ALREADY_EXISTS  9979L
#define DNS_ERROR_POLICY_LOCKED  9980L
#define DNS_ERROR_POLICY_INVALID_WEIGHT  9981L
#define DNS_ERROR_POLICY_INVALID_NAME  9982L
#define DNS_ERROR_POLICY_MISSING_CRITERIA 9983L
#define DNS_ERROR_INVALID_CLIENT_SUBNET_NAME 9984L
#define DNS_ERROR_POLICY_PROCESSING_ORDER_INVALID 9985L
#define DNS_ERROR_POLICY_SCOPE_MISSING  9986L
#define DNS_ERROR_POLICY_SCOPE_NOT_ALLOWED 9987L
#define DNS_ERROR_SERVERSCOPE_IS_REFERENCED 9988L
#define DNS_ERROR_ZONESCOPE_IS_REFERENCED 9989L
#define DNS_ERROR_POLICY_INVALID_CRITERIA_CLIENT_SUBNET 9990L
#define DNS_ERROR_POLICY_INVALID_CRITERIA_TRANSPORT_PROTOCOL 9991L
#define DNS_ERROR_POLICY_INVALID_CRITERIA_NETWORK_PROTOCOL 9992L
#define DNS_ERROR_POLICY_INVALID_CRITERIA_INTERFACE 9993L
#define DNS_ERROR_POLICY_INVALID_CRITERIA_FQDN 9994L
#define DNS_ERROR_POLICY_INVALID_CRITERIA_QUERY_TYPE 9995L
#define DNS_ERROR_POLICY_INVALID_CRITERIA_TIME_OF_DAY 9996L

#ifndef WSABASEERR
#define WSABASEERR  10000
#define WSAEINTR  10004L
#define WSAEBADF  10009L
#define WSAEACCES  10013L
#define WSAEFAULT  10014L
#define WSAEINVAL  10022L
#define WSAEMFILE  10024L
#define WSAEWOULDBLOCK  10035L
#define WSAEINPROGRESS  10036L
#define WSAEALREADY  10037L
#define WSAENOTSOCK  10038L
#define WSAEDESTADDRREQ  10039L
#define WSAEMSGSIZE  10040L
#define WSAEPROTOTYPE  10041L
#define WSAENOPROTOOPT  10042L
#define WSAEPROTONOSUPPORT  10043L
#define WSAESOCKTNOSUPPORT  10044L
#define WSAEOPNOTSUPP  10045L
#define WSAEPFNOSUPPORT  10046L
#define WSAEAFNOSUPPORT  10047L
#define WSAEADDRINUSE  10048L
#define WSAEADDRNOTAVAIL  10049L
#define WSAENETDOWN  10050L
#define WSAENETUNREACH  10051L
#define WSAENETRESET  10052L
#define WSAECONNABORTED  10053L
#define WSAECONNRESET  10054L
#define WSAENOBUFS  10055L
#define WSAEISCONN  10056L
#define WSAENOTCONN  10057L
#define WSAESHUTDOWN  10058L
#define WSAETOOMANYREFS  10059L
#define WSAETIMEDOUT  10060L
#define WSAECONNREFUSED  10061L
#define WSAELOOP  10062L
#define WSAENAMETOOLONG  10063L
#define WSAEHOSTDOWN  10064L
#define WSAEHOSTUNREACH  10065L
#define WSAENOTEMPTY  10066L
#define WSAEPROCLIM  10067L
#define WSAEUSERS  10068L
#define WSAEDQUOT  10069L
#define WSAESTALE  10070L
#define WSAEREMOTE  10071L
#define WSASYSNOTREADY  10091L
#define WSAVERNOTSUPPORTED  10092L
#define WSANOTINITIALISED  10093L
#define WSAEDISCON  10101L
#define WSAENOMORE  10102L
#define WSAECANCELLED  10103L
#define WSAEINVALIDPROCTABLE  10104L
#define WSAEINVALIDPROVIDER  10105L
#define WSAEPROVIDERFAILEDINIT  10106L
#define WSASYSCALLFAILURE  10107L
#define WSASERVICE_NOT_FOUND  10108L
#define WSATYPE_NOT_FOUND  10109L
#define WSA_E_NO_MORE  10110L
#define WSA_E_CANCELLED  10111L
#define WSAEREFUSED  10112L
#define WSAHOST_NOT_FOUND  11001L
#define WSATRY_AGAIN  11002L
#define WSANO_RECOVERY  11003L
#define WSANO_DATA  11004L
#define WSA_QOS_RECEIVERS  11005L
#define WSA_QOS_SENDERS  11006L
#define WSA_QOS_NO_SENDERS  11007L
#define WSA_QOS_NO_RECEIVERS  11008L
#define WSA_QOS_REQUEST_CONFIRMED  11009L
#define WSA_QOS_ADMISSION_FAILURE  11010L
#define WSA_QOS_POLICY_FAILURE  11011L
#define WSA_QOS_BAD_STYLE  11012L
#define WSA_QOS_BAD_OBJECT  11013L
#define WSA_QOS_TRAFFIC_CTRL_ERROR  11014L
#define WSA_QOS_GENERIC_ERROR  11015L
#define WSA_QOS_ESERVICETYPE  11016L
#define WSA_QOS_EFLOWSPEC  11017L
#define WSA_QOS_EPROVSPECBUF  11018L
#define WSA_QOS_EFILTERSTYLE  11019L
#define WSA_QOS_EFILTERTYPE  11020L
#define WSA_QOS_EFILTERCOUNT  11021L
#define WSA_QOS_EOBJLENGTH  11022L
#define WSA_QOS_EFLOWCOUNT  11023L
#define WSA_QOS_EUNKOWNPSOBJ  11024L
#define WSA_QOS_EPOLICYOBJ  11025L
#define WSA_QOS_EFLOWDESC  11026L
#define WSA_QOS_EPSFLOWSPEC  11027L
#define WSA_QOS_EPSFILTERSPEC  11028L
#define WSA_QOS_ESDMODEOBJ  11029L
#define WSA_QOS_ESHAPERATEOBJ  11030L
#define WSA_QOS_RESERVED_PETYPE  11031L
#define WSA_SECURE_HOST_NOT_FOUND  11032L
#define WSA_IPSEC_NAME_POLICY_ERROR  11033L
#endif /* !WSABASEERR */

#define ERROR_IPSEC_QM_POLICY_EXISTS  13000L
#define ERROR_IPSEC_QM_POLICY_NOT_FOUND  13001L
#define ERROR_IPSEC_QM_POLICY_IN_USE  13002L
#define ERROR_IPSEC_MM_POLICY_EXISTS  13003L
#define ERROR_IPSEC_MM_POLICY_NOT_FOUND  13004L
#define ERROR_IPSEC_MM_POLICY_IN_USE  13005L
#define ERROR_IPSEC_MM_FILTER_EXISTS  13006L
#define ERROR_IPSEC_MM_FILTER_NOT_FOUND  13007L
#define ERROR_IPSEC_TRANSPORT_FILTER_EXISTS 13008L
#define ERROR_IPSEC_TRANSPORT_FILTER_NOT_FOUND 13009L
#define ERROR_IPSEC_MM_AUTH_EXISTS  13010L
#define ERROR_IPSEC_MM_AUTH_NOT_FOUND  13011L
#define ERROR_IPSEC_MM_AUTH_IN_USE  13012L
#define ERROR_IPSEC_DEFAULT_MM_POLICY_NOT_FOUND 13013L
#define ERROR_IPSEC_DEFAULT_MM_AUTH_NOT_FOUND 13014L
#define ERROR_IPSEC_DEFAULT_QM_POLICY_NOT_FOUND 13015L
#define ERROR_IPSEC_TUNNEL_FILTER_EXISTS 13016L
#define ERROR_IPSEC_TUNNEL_FILTER_NOT_FOUND 13017L
#define ERROR_IPSEC_MM_FILTER_PENDING_DELETION 13018L
#define ERROR_IPSEC_TRANSPORT_FILTER_PENDING_DELETION 13019L
#define ERROR_IPSEC_TUNNEL_FILTER_PENDING_DELETION 13020L
#define ERROR_IPSEC_MM_POLICY_PENDING_DELETION 13021L
#define ERROR_IPSEC_MM_AUTH_PENDING_DELETION 13022L
#define ERROR_IPSEC_QM_POLICY_PENDING_DELETION 13023L
#define WARNING_IPSEC_MM_POLICY_PRUNED  13024L
#define WARNING_IPSEC_QM_POLICY_PRUNED  13025L
#define ERROR_IPSEC_IKE_NEG_STATUS_BEGIN 13800L
#define ERROR_IPSEC_IKE_AUTH_FAIL  13801L
#define ERROR_IPSEC_IKE_ATTRIB_FAIL  13802L
#define ERROR_IPSEC_IKE_NEGOTIATION_PENDING 13803L
#define ERROR_IPSEC_IKE_GENERAL_PROCESSING_ERROR 13804L
#define ERROR_IPSEC_IKE_TIMED_OUT  13805L
#define ERROR_IPSEC_IKE_NO_CERT  13806L
#define ERROR_IPSEC_IKE_SA_DELETED  13807L
#define ERROR_IPSEC_IKE_SA_REAPED  13808L
#define ERROR_IPSEC_IKE_MM_ACQUIRE_DROP  13809L
#define ERROR_IPSEC_IKE_QM_ACQUIRE_DROP  13810L
#define ERROR_IPSEC_IKE_QUEUE_DROP_MM  13811L
#define ERROR_IPSEC_IKE_QUEUE_DROP_NO_MM 13812L
#define ERROR_IPSEC_IKE_DROP_NO_RESPONSE 13813L
#define ERROR_IPSEC_IKE_MM_DELAY_DROP  13814L
#define ERROR_IPSEC_IKE_QM_DELAY_DROP  13815L
#define ERROR_IPSEC_IKE_ERROR  13816L
#define ERROR_IPSEC_IKE_CRL_FAILED  13817L
#define ERROR_IPSEC_IKE_INVALID_KEY_USAGE 13818L
#define ERROR_IPSEC_IKE_INVALID_CERT_TYPE 13819L
#define ERROR_IPSEC_IKE_NO_PRIVATE_KEY  13820L
#define ERROR_IPSEC_IKE_SIMULTANEOUS_REKEY 13821L
#define ERROR_IPSEC_IKE_DH_FAIL  13822L
#define ERROR_IPSEC_IKE_CRITICAL_PAYLOAD_NOT_RECOGNIZED 13823L
#define ERROR_IPSEC_IKE_INVALID_HEADER  13824L
#define ERROR_IPSEC_IKE_NO_POLICY  13825L
#define ERROR_IPSEC_IKE_INVALID_SIGNATURE 13826L
#define ERROR_IPSEC_IKE_KERBEROS_ERROR  13827L
#define ERROR_IPSEC_IKE_NO_PUBLIC_KEY  13828L
#define ERROR_IPSEC_IKE_PROCESS_ERR  13829L
#define ERROR_IPSEC_IKE_PROCESS_ERR_SA  13830L
#define ERROR_IPSEC_IKE_PROCESS_ERR_PROP 13831L
#define ERROR_IPSEC_IKE_PROCESS_ERR_TRANS 13832L
#define ERROR_IPSEC_IKE_PROCESS_ERR_KE  13833L
#define ERROR_IPSEC_IKE_PROCESS_ERR_ID  13834L
#define ERROR_IPSEC_IKE_PROCESS_ERR_CERT 13835L
#define ERROR_IPSEC_IKE_PROCESS_ERR_CERT_REQ 13836L
#define ERROR_IPSEC_IKE_PROCESS_ERR_HASH 13837L
#define ERROR_IPSEC_IKE_PROCESS_ERR_SIG  13838L
#define ERROR_IPSEC_IKE_PROCESS_ERR_NONCE 13839L
#define ERROR_IPSEC_IKE_PROCESS_ERR_NOTIFY 13840L
#define ERROR_IPSEC_IKE_PROCESS_ERR_DELETE 13841L
#define ERROR_IPSEC_IKE_PROCESS_ERR_VENDOR 13842L
#define ERROR_IPSEC_IKE_INVALID_PAYLOAD  13843L
#define ERROR_IPSEC_IKE_LOAD_SOFT_SA  13844L
#define ERROR_IPSEC_IKE_SOFT_SA_TORN_DOWN 13845L
#define ERROR_IPSEC_IKE_INVALID_COOKIE  13846L
#define ERROR_IPSEC_IKE_NO_PEER_CERT  13847L
#define ERROR_IPSEC_IKE_PEER_CRL_FAILED  13848L
#define ERROR_IPSEC_IKE_POLICY_CHANGE  13849L
#define ERROR_IPSEC_IKE_NO_MM_POLICY  13850L
#define ERROR_IPSEC_IKE_NOTCBPRIV  13851L
#define ERROR_IPSEC_IKE_SECLOADFAIL  13852L
#define ERROR_IPSEC_IKE_FAILSSPINIT  13853L
#define ERROR_IPSEC_IKE_FAILQUERYSSP  13854L
#define ERROR_IPSEC_IKE_SRVACQFAIL  13855L
#define ERROR_IPSEC_IKE_SRVQUERYCRED  13856L
#define ERROR_IPSEC_IKE_GETSPIFAIL  13857L
#define ERROR_IPSEC_IKE_INVALID_FILTER  13858L
#define ERROR_IPSEC_IKE_OUT_OF_MEMORY  13859L
#define ERROR_IPSEC_IKE_ADD_UPDATE_KEY_FAILED 13860L
#define ERROR_IPSEC_IKE_INVALID_POLICY  13861L
#define ERROR_IPSEC_IKE_UNKNOWN_DOI  13862L
#define ERROR_IPSEC_IKE_INVALID_SITUATION 13863L
#define ERROR_IPSEC_IKE_DH_FAILURE  13864L
#define ERROR_IPSEC_IKE_INVALID_GROUP  13865L
#define ERROR_IPSEC_IKE_ENCRYPT  13866L
#define ERROR_IPSEC_IKE_DECRYPT  13867L
#define ERROR_IPSEC_IKE_POLICY_MATCH  13868L
#define ERROR_IPSEC_IKE_UNSUPPORTED_ID  13869L
#define ERROR_IPSEC_IKE_INVALID_HASH  13870L
#define ERROR_IPSEC_IKE_INVALID_HASH_ALG 13871L
#define ERROR_IPSEC_IKE_INVALID_HASH_SIZE 13872L
#define ERROR_IPSEC_IKE_INVALID_ENCRYPT_ALG 13873L
#define ERROR_IPSEC_IKE_INVALID_AUTH_ALG 13874L
#define ERROR_IPSEC_IKE_INVALID_SIG  13875L
#define ERROR_IPSEC_IKE_LOAD_FAILED  13876L
#define ERROR_IPSEC_IKE_RPC_DELETE  13877L
#define ERROR_IPSEC_IKE_BENIGN_REINIT  13878L
#define ERROR_IPSEC_IKE_INVALID_RESPONDER_LIFETIME_NOTIFY 13879L
#define ERROR_IPSEC_IKE_INVALID_MAJOR_VERSION 13880L
#define ERROR_IPSEC_IKE_INVALID_CERT_KEYLEN 13881L
#define ERROR_IPSEC_IKE_MM_LIMIT  13882L
#define ERROR_IPSEC_IKE_NEGOTIATION_DISABLED 13883L
#define ERROR_IPSEC_IKE_QM_LIMIT  13884L
#define ERROR_IPSEC_IKE_MM_EXPIRED  13885L
#define ERROR_IPSEC_IKE_PEER_MM_ASSUMED_INVALID 13886L
#define ERROR_IPSEC_IKE_CERT_CHAIN_POLICY_MISMATCH 13887L
#define ERROR_IPSEC_IKE_UNEXPECTED_MESSAGE_ID 13888L
#define ERROR_IPSEC_IKE_INVALID_AUTH_PAYLOAD 13889L
#define ERROR_IPSEC_IKE_DOS_COOKIE_SENT  13890L
#define ERROR_IPSEC_IKE_SHUTTING_DOWN  13891L
#define ERROR_IPSEC_IKE_CGA_AUTH_FAILED  13892L
#define ERROR_IPSEC_IKE_PROCESS_ERR_NATOA 13893L
#define ERROR_IPSEC_IKE_INVALID_MM_FOR_QM 13894L
#define ERROR_IPSEC_IKE_QM_EXPIRED  13895L
#define ERROR_IPSEC_IKE_TOO_MANY_FILTERS 13896L
#define ERROR_IPSEC_IKE_NEG_STATUS_END  13897L
#define ERROR_IPSEC_IKE_KILL_DUMMY_NAP_TUNNEL 13898L
#define ERROR_IPSEC_IKE_INNER_IP_ASSIGNMENT_FAILURE 13899L
#define ERROR_IPSEC_IKE_REQUIRE_CP_PAYLOAD_MISSING 13900L
#define ERROR_IPSEC_KEY_MODULE_IMPERSONATION_NEGOTIATION_PENDING 13901L
#define ERROR_IPSEC_IKE_COEXISTENCE_SUPPRESS 13902L
#define ERROR_IPSEC_IKE_RATELIMIT_DROP  13903L
#define ERROR_IPSEC_IKE_PEER_DOESNT_SUPPORT_MOBIKE 13904L
#define ERROR_IPSEC_IKE_AUTHORIZATION_FAILURE 13905L
#define ERROR_IPSEC_IKE_STRONG_CRED_AUTHORIZATION_FAILURE 13906L
#define ERROR_IPSEC_IKE_AUTHORIZATION_FAILURE_WITH_OPTIONAL_RETRY 13907L
#define ERROR_IPSEC_IKE_STRONG_CRED_AUTHORIZATION_AND_CERTMAP_FAILURE 13908L
#define ERROR_IPSEC_IKE_NEG_STATUS_EXTENDED_END 13909L
#define ERROR_IPSEC_BAD_SPI  13910L
#define ERROR_IPSEC_SA_LIFETIME_EXPIRED  13911L
#define ERROR_IPSEC_WRONG_SA  13912L
#define ERROR_IPSEC_REPLAY_CHECK_FAILED  13913L
#define ERROR_IPSEC_INVALID_PACKET  13914L
#define ERROR_IPSEC_INTEGRITY_CHECK_FAILED 13915L
#define ERROR_IPSEC_CLEAR_TEXT_DROP  13916L
#define ERROR_IPSEC_AUTH_FIREWALL_DROP  13917L
#define ERROR_IPSEC_THROTTLE_DROP  13918L
#define ERROR_IPSEC_DOSP_BLOCK  13925L
#define ERROR_IPSEC_DOSP_RECEIVED_MULTICAST 13926L
#define ERROR_IPSEC_DOSP_INVALID_PACKET  13927L
#define ERROR_IPSEC_DOSP_STATE_LOOKUP_FAILED 13928L
#define ERROR_IPSEC_DOSP_MAX_ENTRIES  13929L
#define ERROR_IPSEC_DOSP_KEYMOD_NOT_ALLOWED 13930L
#define ERROR_IPSEC_DOSP_NOT_INSTALLED  13931L
#define ERROR_IPSEC_DOSP_MAX_PER_IP_RATELIMIT_QUEUES 13932L
#define ERROR_SXS_SECTION_NOT_FOUND  14000L
#define ERROR_SXS_CANT_GEN_ACTCTX  14001L
#define ERROR_SXS_INVALID_ACTCTXDATA_FORMAT 14002L
#define ERROR_SXS_ASSEMBLY_NOT_FOUND  14003L
#define ERROR_SXS_MANIFEST_FORMAT_ERROR  14004L
#define ERROR_SXS_MANIFEST_PARSE_ERROR  14005L
#define ERROR_SXS_ACTIVATION_CONTEXT_DISABLED 14006L
#define ERROR_SXS_KEY_NOT_FOUND  14007L
#define ERROR_SXS_VERSION_CONFLICT  14008L
#define ERROR_SXS_WRONG_SECTION_TYPE  14009L
#define ERROR_SXS_THREAD_QUERIES_DISABLED 14010L
#define ERROR_SXS_PROCESS_DEFAULT_ALREADY_SET 14011L
#define ERROR_SXS_UNKNOWN_ENCODING_GROUP 14012L
#define ERROR_SXS_UNKNOWN_ENCODING  14013L
#define ERROR_SXS_INVALID_XML_NAMESPACE_URI 14014L
#define ERROR_SXS_ROOT_MANIFEST_DEPENDENCY_NOT_INSTALLED 14015L
#define ERROR_SXS_LEAF_MANIFEST_DEPENDENCY_NOT_INSTALLED 14016L
#define ERROR_SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE 14017L
#define ERROR_SXS_MANIFEST_MISSING_REQUIRED_DEFAULT_NAMESPACE 14018L
#define ERROR_SXS_MANIFEST_INVALID_REQUIRED_DEFAULT_NAMESPACE 14019L
#define ERROR_SXS_PRIVATE_MANIFEST_CROSS_PATH_WITH_REPARSE_POINT 14020L
#define ERROR_SXS_DUPLICATE_DLL_NAME  14021L
#define ERROR_SXS_DUPLICATE_WINDOWCLASS_NAME 14022L
#define ERROR_SXS_DUPLICATE_CLSID  14023L
#define ERROR_SXS_DUPLICATE_IID  14024L
#define ERROR_SXS_DUPLICATE_TLBID  14025L
#define ERROR_SXS_DUPLICATE_PROGID  14026L
#define ERROR_SXS_DUPLICATE_ASSEMBLY_NAME 14027L
#define ERROR_SXS_FILE_HASH_MISMATCH  14028L
#define ERROR_SXS_POLICY_PARSE_ERROR  14029L
#define ERROR_SXS_XML_E_MISSINGQUOTE  14030L
#define ERROR_SXS_XML_E_COMMENTSYNTAX  14031L
#define ERROR_SXS_XML_E_BADSTARTNAMECHAR 14032L
#define ERROR_SXS_XML_E_BADNAMECHAR  14033L
#define ERROR_SXS_XML_E_BADCHARINSTRING  14034L
#define ERROR_SXS_XML_E_XMLDECLSYNTAX  14035L
#define ERROR_SXS_XML_E_BADCHARDATA  14036L
#define ERROR_SXS_XML_E_MISSINGWHITESPACE 14037L
#define ERROR_SXS_XML_E_EXPECTINGTAGEND  14038L
#define ERROR_SXS_XML_E_MISSINGSEMICOLON 14039L
#define ERROR_SXS_XML_E_UNBALANCEDPAREN  14040L
#define ERROR_SXS_XML_E_INTERNALERROR  14041L
#define ERROR_SXS_XML_E_UNEXPECTED_WHITESPACE 14042L
#define ERROR_SXS_XML_E_INCOMPLETE_ENCODING 14043L
#define ERROR_SXS_XML_E_MISSING_PAREN  14044L
#define ERROR_SXS_XML_E_EXPECTINGCLOSEQUOTE 14045L
#define ERROR_SXS_XML_E_MULTIPLE_COLONS  14046L
#define ERROR_SXS_XML_E_INVALID_DECIMAL  14047L
#define ERROR_SXS_XML_E_INVALID_HEXIDECIMAL 14048L
#define ERROR_SXS_XML_E_INVALID_UNICODE  14049L
#define ERROR_SXS_XML_E_WHITESPACEORQUESTIONMARK 14050L
#define ERROR_SXS_XML_E_UNEXPECTEDENDTAG 14051L
#define ERROR_SXS_XML_E_UNCLOSEDTAG  14052L
#define ERROR_SXS_XML_E_DUPLICATEATTRIBUTE 14053L
#define ERROR_SXS_XML_E_MULTIPLEROOTS  14054L
#define ERROR_SXS_XML_E_INVALIDATROOTLEVEL 14055L
#define ERROR_SXS_XML_E_BADXMLDECL  14056L
#define ERROR_SXS_XML_E_MISSINGROOT  14057L
#define ERROR_SXS_XML_E_UNEXPECTEDEOF  14058L
#define ERROR_SXS_XML_E_BADPEREFINSUBSET 14059L
#define ERROR_SXS_XML_E_UNCLOSEDSTARTTAG 14060L
#define ERROR_SXS_XML_E_UNCLOSEDENDTAG  14061L
#define ERROR_SXS_XML_E_UNCLOSEDSTRING  14062L
#define ERROR_SXS_XML_E_UNCLOSEDCOMMENT  14063L
#define ERROR_SXS_XML_E_UNCLOSEDDECL  14064L
#define ERROR_SXS_XML_E_UNCLOSEDCDATA  14065L
#define ERROR_SXS_XML_E_RESERVEDNAMESPACE 14066L
#define ERROR_SXS_XML_E_INVALIDENCODING  14067L
#define ERROR_SXS_XML_E_INVALIDSWITCH  14068L
#define ERROR_SXS_XML_E_BADXMLCASE  14069L
#define ERROR_SXS_XML_E_INVALID_STANDALONE 14070L
#define ERROR_SXS_XML_E_UNEXPECTED_STANDALONE 14071L
#define ERROR_SXS_XML_E_INVALID_VERSION  14072L
#define ERROR_SXS_XML_E_MISSINGEQUALS  14073L
#define ERROR_SXS_PROTECTION_RECOVERY_FAILED 14074L
#define ERROR_SXS_PROTECTION_PUBLIC_KEY_TOO_SHORT 14075L
#define ERROR_SXS_PROTECTION_CATALOG_NOT_VALID 14076L
#define ERROR_SXS_UNTRANSLATABLE_HRESULT 14077L
#define ERROR_SXS_PROTECTION_CATALOG_FILE_MISSING 14078L
#define ERROR_SXS_MISSING_ASSEMBLY_IDENTITY_ATTRIBUTE 14079L
#define ERROR_SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE_NAME 14080L
#define ERROR_SXS_ASSEMBLY_MISSING  14081L
#define ERROR_SXS_CORRUPT_ACTIVATION_STACK 14082L
#define ERROR_SXS_CORRUPTION  14083L
#define ERROR_SXS_EARLY_DEACTIVATION  14084L
#define ERROR_SXS_INVALID_DEACTIVATION  14085L
#define ERROR_SXS_MULTIPLE_DEACTIVATION  14086L
#define ERROR_SXS_PROCESS_TERMINATION_REQUESTED 14087L
#define ERROR_SXS_RELEASE_ACTIVATION_CONTEXT 14088L
#define ERROR_SXS_SYSTEM_DEFAULT_ACTIVATION_CONTEXT_EMPTY 14089L
#define ERROR_SXS_INVALID_IDENTITY_ATTRIBUTE_VALUE 14090L
#define ERROR_SXS_INVALID_IDENTITY_ATTRIBUTE_NAME 14091L
#define ERROR_SXS_IDENTITY_DUPLICATE_ATTRIBUTE 14092L
#define ERROR_SXS_IDENTITY_PARSE_ERROR  14093L
#define ERROR_MALFORMED_SUBSTITUTION_STRING 14094L
#define ERROR_SXS_INCORRECT_PUBLIC_KEY_TOKEN 14095L
#define ERROR_UNMAPPED_SUBSTITUTION_STRING 14096L
#define ERROR_SXS_ASSEMBLY_NOT_LOCKED  14097L
#define ERROR_SXS_COMPONENT_STORE_CORRUPT 14098L
#define ERROR_ADVANCED_INSTALLER_FAILED  14099L
#define ERROR_XML_ENCODING_MISMATCH  14100L
#define ERROR_SXS_MANIFEST_IDENTITY_SAME_BUT_CONTENTS_DIFFERENT 14101L
#define ERROR_SXS_IDENTITIES_DIFFERENT  14102L
#define ERROR_SXS_ASSEMBLY_IS_NOT_A_DEPLOYMENT 14103L
#define ERROR_SXS_FILE_NOT_PART_OF_ASSEMBLY 14104L
#define ERROR_SXS_MANIFEST_TOO_BIG  14105L
#define ERROR_SXS_SETTING_NOT_REGISTERED 14106L
#define ERROR_SXS_TRANSACTION_CLOSURE_INCOMPLETE 14107L
#define ERROR_SMI_PRIMITIVE_INSTALLER_FAILED 14108L
#define ERROR_GENERIC_COMMAND_FAILED  14109L
#define ERROR_SXS_FILE_HASH_MISSING  14110L
#define ERROR_EVT_INVALID_CHANNEL_PATH  15000L
#define ERROR_EVT_INVALID_QUERY  15001L
#define ERROR_EVT_PUBLISHER_METADATA_NOT_FOUND 15002L
#define ERROR_EVT_EVENT_TEMPLATE_NOT_FOUND 15003L
#define ERROR_EVT_INVALID_PUBLISHER_NAME 15004L
#define ERROR_EVT_INVALID_EVENT_DATA  15005L
#define ERROR_EVT_CHANNEL_NOT_FOUND  15007L
#define ERROR_EVT_MALFORMED_XML_TEXT  15008L
#define ERROR_EVT_SUBSCRIPTION_TO_DIRECT_CHANNEL 15009L
#define ERROR_EVT_CONFIGURATION_ERROR  15010L
#define ERROR_EVT_QUERY_RESULT_STALE  15011L
#define ERROR_EVT_QUERY_RESULT_INVALID_POSITION 15012L
#define ERROR_EVT_NON_VALIDATING_MSXML  15013L
#define ERROR_EVT_FILTER_ALREADYSCOPED  15014L
#define ERROR_EVT_FILTER_NOTELTSET  15015L
#define ERROR_EVT_FILTER_INVARG  15016L
#define ERROR_EVT_FILTER_INVTEST  15017L
#define ERROR_EVT_FILTER_INVTYPE  15018L
#define ERROR_EVT_FILTER_PARSEERR  15019L
#define ERROR_EVT_FILTER_UNSUPPORTEDOP  15020L
#define ERROR_EVT_FILTER_UNEXPECTEDTOKEN 15021L
#define ERROR_EVT_INVALID_OPERATION_OVER_ENABLED_DIRECT_CHANNEL 15022L
#define ERROR_EVT_INVALID_CHANNEL_PROPERTY_VALUE 15023L
#define ERROR_EVT_INVALID_PUBLISHER_PROPERTY_VALUE 15024L
#define ERROR_EVT_CHANNEL_CANNOT_ACTIVATE 15025L
#define ERROR_EVT_FILTER_TOO_COMPLEX  15026L
#define ERROR_EVT_MESSAGE_NOT_FOUND  15027L
#define ERROR_EVT_MESSAGE_ID_NOT_FOUND  15028L
#define ERROR_EVT_UNRESOLVED_VALUE_INSERT 15029L
#define ERROR_EVT_UNRESOLVED_PARAMETER_INSERT 15030L
#define ERROR_EVT_MAX_INSERTS_REACHED  15031L
#define ERROR_EVT_EVENT_DEFINITION_NOT_FOUND 15032L
#define ERROR_EVT_MESSAGE_LOCALE_NOT_FOUND 15033L
#define ERROR_EVT_VERSION_TOO_OLD  15034L
#define ERROR_EVT_VERSION_TOO_NEW  15035L
#define ERROR_EVT_CANNOT_OPEN_CHANNEL_OF_QUERY 15036L
#define ERROR_EVT_PUBLISHER_DISABLED  15037L
#define ERROR_EVT_FILTER_OUT_OF_RANGE  15038L
#define ERROR_EC_SUBSCRIPTION_CANNOT_ACTIVATE 15080L
#define ERROR_EC_LOG_DISABLED  15081L
#define ERROR_EC_CIRCULAR_FORWARDING  15082L
#define ERROR_EC_CREDSTORE_FULL  15083L
#define ERROR_EC_CRED_NOT_FOUND  15084L
#define ERROR_EC_NO_ACTIVE_CHANNEL  15085L
#define ERROR_MUI_FILE_NOT_FOUND  15100L
#define ERROR_MUI_INVALID_FILE  15101L
#define ERROR_MUI_INVALID_RC_CONFIG  15102L
#define ERROR_MUI_INVALID_LOCALE_NAME  15103L
#define ERROR_MUI_INVALID_ULTIMATEFALLBACK_NAME 15104L
#define ERROR_MUI_FILE_NOT_LOADED  15105L
#define ERROR_RESOURCE_ENUM_USER_STOP  15106L
#define ERROR_MUI_INTLSETTINGS_UILANG_NOT_INSTALLED 15107L
#define ERROR_MUI_INTLSETTINGS_INVALID_LOCALE_NAME 15108L
#define ERROR_MRM_RUNTIME_NO_DEFAULT_OR_NEUTRAL_RESOURCE 15110L
#define ERROR_MRM_INVALID_PRICONFIG  15111L
#define ERROR_MRM_INVALID_FILE_TYPE  15112L
#define ERROR_MRM_UNKNOWN_QUALIFIER  15113L
#define ERROR_MRM_INVALID_QUALIFIER_VALUE 15114L
#define ERROR_MRM_NO_CANDIDATE  15115L
#define ERROR_MRM_NO_MATCH_OR_DEFAULT_CANDIDATE 15116L
#define ERROR_MRM_RESOURCE_TYPE_MISMATCH 15117L
#define ERROR_MRM_DUPLICATE_MAP_NAME  15118L
#define ERROR_MRM_DUPLICATE_ENTRY  15119L
#define ERROR_MRM_INVALID_RESOURCE_IDENTIFIER 15120L
#define ERROR_MRM_FILEPATH_TOO_LONG  15121L
#define ERROR_MRM_UNSUPPORTED_DIRECTORY_TYPE 15122L
#define ERROR_MRM_INVALID_PRI_FILE  15126L
#define ERROR_MRM_NAMED_RESOURCE_NOT_FOUND 15127L
#define ERROR_MRM_MAP_NOT_FOUND  15135L
#define ERROR_MRM_UNSUPPORTED_PROFILE_TYPE 15136L
#define ERROR_MRM_INVALID_QUALIFIER_OPERATOR 15137L
#define ERROR_MRM_INDETERMINATE_QUALIFIER_VALUE 15138L
#define ERROR_MRM_AUTOMERGE_ENABLED  15139L
#define ERROR_MRM_TOO_MANY_RESOURCES  15140L
#define ERROR_MRM_UNSUPPORTED_FILE_TYPE_FOR_MERGE 15141L
#define ERROR_MRM_UNSUPPORTED_FILE_TYPE_FOR_LOAD_UNLOAD_PRI_FILE 15142L
#define ERROR_MRM_NO_CURRENT_VIEW_ON_THREAD 15143L
#define ERROR_DIFFERENT_PROFILE_RESOURCE_MANAGER_EXIST 15144L
#define ERROR_OPERATION_NOT_ALLOWED_FROM_SYSTEM_COMPONENT 15145L
#define ERROR_MRM_DIRECT_REF_TO_NON_DEFAULT_RESOURCE 15146L
#define ERROR_MRM_GENERATION_COUNT_MISMATCH 15147L
#define ERROR_PRI_MERGE_VERSION_MISMATCH 15148L
#define ERROR_PRI_MERGE_MISSING_SCHEMA  15149L
#define ERROR_PRI_MERGE_LOAD_FILE_FAILED 15150L
#define ERROR_PRI_MERGE_ADD_FILE_FAILED  15151L
#define ERROR_PRI_MERGE_WRITE_FILE_FAILED 15152L
#define ERROR_MCA_INVALID_CAPABILITIES_STRING 15200L
#define ERROR_MCA_INVALID_VCP_VERSION  15201L
#define ERROR_MCA_MONITOR_VIOLATES_MCCS_SPECIFICATION 15202L
#define ERROR_MCA_MCCS_VERSION_MISMATCH  15203L
#define ERROR_MCA_UNSUPPORTED_MCCS_VERSION 15204L
#define ERROR_MCA_INTERNAL_ERROR  15205L
#define ERROR_MCA_INVALID_TECHNOLOGY_TYPE_RETURNED 15206L
#define ERROR_MCA_UNSUPPORTED_COLOR_TEMPERATURE 15207L
#define ERROR_AMBIGUOUS_SYSTEM_DEVICE  15250L
#define ERROR_SYSTEM_DEVICE_NOT_FOUND  15299L
#define ERROR_HASH_NOT_SUPPORTED  15300L
#define ERROR_HASH_NOT_PRESENT  15301L
#define ERROR_SECONDARY_IC_PROVIDER_NOT_REGISTERED 15321L
#define ERROR_GPIO_CLIENT_INFORMATION_INVALID 15322L
#define ERROR_GPIO_VERSION_NOT_SUPPORTED 15323L
#define ERROR_GPIO_INVALID_REGISTRATION_PACKET 15324L
#define ERROR_GPIO_OPERATION_DENIED  15325L
#define ERROR_GPIO_INCOMPATIBLE_CONNECT_MODE 15326L
#define ERROR_GPIO_INTERRUPT_ALREADY_UNMASKED 15327L
#define ERROR_CANNOT_SWITCH_RUNLEVEL  15400L
#define ERROR_INVALID_RUNLEVEL_SETTING  15401L
#define ERROR_RUNLEVEL_SWITCH_TIMEOUT  15402L
#define ERROR_RUNLEVEL_SWITCH_AGENT_TIMEOUT 15403L
#define ERROR_RUNLEVEL_SWITCH_IN_PROGRESS 15404L
#define ERROR_SERVICES_FAILED_AUTOSTART  15405L
#define ERROR_COM_TASK_STOP_PENDING  15501L
#define ERROR_INSTALL_OPEN_PACKAGE_FAILED 15600L
#define ERROR_INSTALL_PACKAGE_NOT_FOUND  15601L
#define ERROR_INSTALL_INVALID_PACKAGE  15602L
#define ERROR_INSTALL_RESOLVE_DEPENDENCY_FAILED 15603L
#define ERROR_INSTALL_OUT_OF_DISK_SPACE  15604L
#define ERROR_INSTALL_NETWORK_FAILURE  15605L
#define ERROR_INSTALL_REGISTRATION_FAILURE 15606L
#define ERROR_INSTALL_DEREGISTRATION_FAILURE 15607L
#define ERROR_INSTALL_CANCEL  15608L
#define ERROR_INSTALL_FAILED  15609L
#define ERROR_REMOVE_FAILED  15610L
#define ERROR_PACKAGE_ALREADY_EXISTS  15611L
#define ERROR_NEEDS_REMEDIATION  15612L
#define ERROR_INSTALL_PREREQUISITE_FAILED 15613L
#define ERROR_PACKAGE_REPOSITORY_CORRUPTED 15614L
#define ERROR_INSTALL_POLICY_FAILURE  15615L
#define ERROR_PACKAGE_UPDATING  15616L
#define ERROR_DEPLOYMENT_BLOCKED_BY_POLICY 15617L
#define ERROR_PACKAGES_IN_USE  15618L
#define ERROR_RECOVERY_FILE_CORRUPT  15619L
#define ERROR_INVALID_STAGED_SIGNATURE  15620L
#define ERROR_DELETING_EXISTING_APPLICATIONDATA_STORE_FAILED 15621L
#define ERROR_INSTALL_PACKAGE_DOWNGRADE  15622L
#define ERROR_SYSTEM_NEEDS_REMEDIATION  15623L
#define ERROR_APPX_INTEGRITY_FAILURE_CLR_NGEN 15624L
#define ERROR_RESILIENCY_FILE_CORRUPT  15625L
#define ERROR_INSTALL_FIREWALL_SERVICE_NOT_RUNNING 15626L
#define ERROR_PACKAGE_MOVE_FAILED  15627L
#define ERROR_INSTALL_VOLUME_NOT_EMPTY  15628L
#define ERROR_INSTALL_VOLUME_OFFLINE  15629L
#define ERROR_INSTALL_VOLUME_CORRUPT  15630L
#define ERROR_NEEDS_REGISTRATION  15631L
#define ERROR_INSTALL_WRONG_PROCESSOR_ARCHITECTURE 15632L
#define ERROR_DEV_SIDELOAD_LIMIT_EXCEEDED 15633L
#define ERROR_INSTALL_OPTIONAL_PACKAGE_REQUIRES_MAIN_PACKAGE 15634L
#define ERROR_PACKAGE_NOT_SUPPORTED_ON_FILESYSTEM 15635L
#define APPMODEL_ERROR_NO_PACKAGE  15700L
#define APPMODEL_ERROR_PACKAGE_RUNTIME_CORRUPT 15701L
#define APPMODEL_ERROR_PACKAGE_IDENTITY_CORRUPT 15702L
#define APPMODEL_ERROR_NO_APPLICATION  15703L
#define APPMODEL_ERROR_DYNAMIC_PROPERTY_READ_FAILED 15704L
#define APPMODEL_ERROR_DYNAMIC_PROPERTY_INVALID 15705L
#define APPMODEL_ERROR_PACKAGE_NOT_AVAILABLE 15706L
#define ERROR_STATE_LOAD_STORE_FAILED  15800L
#define ERROR_STATE_GET_VERSION_FAILED  15801L
#define ERROR_STATE_SET_VERSION_FAILED  15802L
#define ERROR_STATE_STRUCTURED_RESET_FAILED 15803L
#define ERROR_STATE_OPEN_CONTAINER_FAILED 15804L
#define ERROR_STATE_CREATE_CONTAINER_FAILED 15805L
#define ERROR_STATE_DELETE_CONTAINER_FAILED 15806L
#define ERROR_STATE_READ_SETTING_FAILED  15807L
#define ERROR_STATE_WRITE_SETTING_FAILED 15808L
#define ERROR_STATE_DELETE_SETTING_FAILED 15809L
#define ERROR_STATE_QUERY_SETTING_FAILED 15810L
#define ERROR_STATE_READ_COMPOSITE_SETTING_FAILED 15811L
#define ERROR_STATE_WRITE_COMPOSITE_SETTING_FAILED 15812L
#define ERROR_STATE_ENUMERATE_CONTAINER_FAILED 15813L
#define ERROR_STATE_ENUMERATE_SETTINGS_FAILED 15814L
#define ERROR_STATE_COMPOSITE_SETTING_VALUE_SIZE_LIMIT_EXCEEDED 15815L
#define ERROR_STATE_SETTING_VALUE_SIZE_LIMIT_EXCEEDED 15816L
#define ERROR_STATE_SETTING_NAME_SIZE_LIMIT_EXCEEDED 15817L
#define ERROR_STATE_CONTAINER_NAME_SIZE_LIMIT_EXCEEDED 15818L
#define ERROR_API_UNAVAILABLE  15841L
#define STORE_ERROR_UNLICENSED  15861L
#define STORE_ERROR_UNLICENSED_USER  15862L
#define STORE_ERROR_PENDING_COM_TRANSACTION 15863L
#define STORE_ERROR_LICENSE_REVOKED  15864L

#define SEVERITY_SUCCESS  0
#define SEVERITY_ERROR  1

#define SUCCEEDED(hr) (((HRESULT)(hr)) >= 0)

#define FAILED(hr)  (((HRESULT)(hr)) < 0)

#define IS_ERROR(Status)  (((unsigned long)(Status)) >> 31 == SEVERITY_ERROR)

#define HRESULT_CODE(hr)  ((hr) & 0xFFFF)
#define SCODE_CODE(sc)  ((sc) & 0xFFFF)

#define HRESULT_FACILITY(hr)  (((hr) >> 16) & 0x1fff)
#define SCODE_FACILITY(sc)  (((sc) >> 16) & 0x1fff)

#define HRESULT_SEVERITY(hr)  (((hr) >> 31) & 0x1)
#define SCODE_SEVERITY(sc)  (((sc) >> 31) & 0x1)

#define MAKE_HRESULT(sev,fac,code)  ((HRESULT) (((unsigned long)(sev)<<31) | ((unsigned long)(fac)<<16) | ((unsigned long)(code))) )
#define MAKE_SCODE(sev,fac,code)  ((SCODE) (((unsigned long)(sev)<<31) | ((unsigned long)(fac)<<16) | ((unsigned long)(code))) )

#define FACILITY_NT_BIT  0x10000000

#define __HRESULT_FROM_WIN32(x) ((HRESULT)(x) <= 0 ? ((HRESULT)(x)) : ((HRESULT) (((x) & 0x0000FFFF) | (FACILITY_WIN32 << 16) | 0x80000000)))

#if !defined(_HRESULT_DEFINED) && !defined(__midl)
#define _HRESULT_DEFINED
typedef long HRESULT;
#endif /* _HRESULT_DEFINED */

FORCEINLINE HRESULT HRESULT_FROM_WIN32(unsigned long x) {
    return (HRESULT)(x) <= 0 ? (HRESULT)(x) : (HRESULT)(((x) & 0x0000FFFF) | (FACILITY_WIN32 << 16) | 0x80000000);
}

#define HRESULT_FROM_NT(x)  ((HRESULT) ((x) | FACILITY_NT_BIT))

#define GetScode(hr) ((SCODE) (hr))

#define ResultFromScode(sc) ((HRESULT) (sc))

#define PropagateResult(hrPrevious, scBase)  ((HRESULT)scBase)

#define E_NOT_SET  HRESULT_FROM_WIN32(ERROR_NOT_FOUND)
#define E_NOT_VALID_STATE  HRESULT_FROM_WIN32(ERROR_INVALID_STATE)
#define E_NOT_SUFFICIENT_BUFFER  HRESULT_FROM_WIN32(ERROR_INSUFFICIENT_BUFFER)

#ifdef RC_INVOKED
#define _HRESULT_TYPEDEF_(_sc)  _sc
#else /* !RC_INVOKED */
#define _HRESULT_TYPEDEF_(_sc)  ((HRESULT)_sc)
#endif /* !RC_INVOKED */

#define NOERROR  0

#define E_UNEXPECTED  _HRESULT_TYPEDEF_(0x8000FFFFL)
#define E_NOTIMPL  _HRESULT_TYPEDEF_(0x80004001L)
#define E_OUTOFMEMORY  _HRESULT_TYPEDEF_(0x8007000EL)
#define E_INVALIDARG  _HRESULT_TYPEDEF_(0x80070057L)
#define E_NOINTERFACE  _HRESULT_TYPEDEF_(0x80004002L)
#define E_POINTER  _HRESULT_TYPEDEF_(0x80004003L)
#define E_HANDLE  _HRESULT_TYPEDEF_(0x80070006L)
#define E_ABORT  _HRESULT_TYPEDEF_(0x80004004L)
#define E_FAIL  _HRESULT_TYPEDEF_(0x80004005L)
#define E_ACCESSDENIED  _HRESULT_TYPEDEF_(0x80070005L)
#define E_PENDING  _HRESULT_TYPEDEF_(0x8000000AL)
#define E_BOUNDS  _HRESULT_TYPEDEF_(0x8000000BL)
#define E_CHANGED_STATE  _HRESULT_TYPEDEF_(0x8000000CL)
#define E_ILLEGAL_STATE_CHANGE  _HRESULT_TYPEDEF_(0x8000000DL)
#define E_ILLEGAL_METHOD_CALL  _HRESULT_TYPEDEF_(0x8000000EL)
#define RO_E_METADATA_NAME_NOT_FOUND  _HRESULT_TYPEDEF_(0x8000000FL)
#define RO_E_METADATA_NAME_IS_NAMESPACE  _HRESULT_TYPEDEF_(0x80000010L)
#define RO_E_METADATA_INVALID_TYPE_FORMAT _HRESULT_TYPEDEF_(0x80000011L)
#define RO_E_INVALID_METADATA_FILE  _HRESULT_TYPEDEF_(0x80000012L)
#define RO_E_CLOSED  _HRESULT_TYPEDEF_(0x80000013L)
#define RO_E_EXCLUSIVE_WRITE  _HRESULT_TYPEDEF_(0x80000014L)
#define RO_E_CHANGE_NOTIFICATION_IN_PROGRESS _HRESULT_TYPEDEF_(0x80000015L)
#define RO_E_ERROR_STRING_NOT_FOUND  _HRESULT_TYPEDEF_(0x80000016L)
#define E_STRING_NOT_NULL_TERMINATED  _HRESULT_TYPEDEF_(0x80000017L)
#define E_ILLEGAL_DELEGATE_ASSIGNMENT  _HRESULT_TYPEDEF_(0x80000018L)
#define E_ASYNC_OPERATION_NOT_STARTED  _HRESULT_TYPEDEF_(0x80000019L)
#define E_APPLICATION_EXITING  _HRESULT_TYPEDEF_(0x8000001AL)
#define E_APPLICATION_VIEW_EXITING  _HRESULT_TYPEDEF_(0x8000001BL)
#define RO_E_MUST_BE_AGILE  _HRESULT_TYPEDEF_(0x8000001CL)
#define RO_E_UNSUPPORTED_FROM_MTA  _HRESULT_TYPEDEF_(0x8000001DL)
#define RO_E_COMMITTED  _HRESULT_TYPEDEF_(0x8000001EL)
#define RO_E_BLOCKED_CROSS_ASTA_CALL  _HRESULT_TYPEDEF_(0x8000001FL)
#define CO_E_INIT_TLS  _HRESULT_TYPEDEF_(0x80004006L)
#define CO_E_INIT_SHARED_ALLOCATOR  _HRESULT_TYPEDEF_(0x80004007L)
#define CO_E_INIT_MEMORY_ALLOCATOR  _HRESULT_TYPEDEF_(0x80004008L)
#define CO_E_INIT_CLASS_CACHE  _HRESULT_TYPEDEF_(0x80004009L)
#define CO_E_INIT_RPC_CHANNEL  _HRESULT_TYPEDEF_(0x8000400AL)
#define CO_E_INIT_TLS_SET_CHANNEL_CONTROL _HRESULT_TYPEDEF_(0x8000400BL)
#define CO_E_INIT_TLS_CHANNEL_CONTROL  _HRESULT_TYPEDEF_(0x8000400CL)
#define CO_E_INIT_UNACCEPTED_USER_ALLOCATOR _HRESULT_TYPEDEF_(0x8000400DL)
#define CO_E_INIT_SCM_MUTEX_EXISTS  _HRESULT_TYPEDEF_(0x8000400EL)
#define CO_E_INIT_SCM_FILE_MAPPING_EXISTS _HRESULT_TYPEDEF_(0x8000400FL)
#define CO_E_INIT_SCM_MAP_VIEW_OF_FILE  _HRESULT_TYPEDEF_(0x80004010L)
#define CO_E_INIT_SCM_EXEC_FAILURE  _HRESULT_TYPEDEF_(0x80004011L)
#define CO_E_INIT_ONLY_SINGLE_THREADED  _HRESULT_TYPEDEF_(0x80004012L)
#define CO_E_CANT_REMOTE  _HRESULT_TYPEDEF_(0x80004013L)
#define CO_E_BAD_SERVER_NAME  _HRESULT_TYPEDEF_(0x80004014L)
#define CO_E_WRONG_SERVER_IDENTITY  _HRESULT_TYPEDEF_(0x80004015L)
#define CO_E_OLE1DDE_DISABLED  _HRESULT_TYPEDEF_(0x80004016L)
#define CO_E_RUNAS_SYNTAX  _HRESULT_TYPEDEF_(0x80004017L)
#define CO_E_CREATEPROCESS_FAILURE  _HRESULT_TYPEDEF_(0x80004018L)
#define CO_E_RUNAS_CREATEPROCESS_FAILURE _HRESULT_TYPEDEF_(0x80004019L)
#define CO_E_RUNAS_LOGON_FAILURE  _HRESULT_TYPEDEF_(0x8000401AL)
#define CO_E_LAUNCH_PERMSSION_DENIED  _HRESULT_TYPEDEF_(0x8000401BL)
#define CO_E_START_SERVICE_FAILURE  _HRESULT_TYPEDEF_(0x8000401CL)
#define CO_E_REMOTE_COMMUNICATION_FAILURE _HRESULT_TYPEDEF_(0x8000401DL)
#define CO_E_SERVER_START_TIMEOUT  _HRESULT_TYPEDEF_(0x8000401EL)
#define CO_E_CLSREG_INCONSISTENT  _HRESULT_TYPEDEF_(0x8000401FL)
#define CO_E_IIDREG_INCONSISTENT  _HRESULT_TYPEDEF_(0x80004020L)
#define CO_E_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x80004021L)
#define CO_E_RELOAD_DLL  _HRESULT_TYPEDEF_(0x80004022L)
#define CO_E_MSI_ERROR  _HRESULT_TYPEDEF_(0x80004023L)
#define CO_E_ATTEMPT_TO_CREATE_OUTSIDE_CLIENT_CONTEXT _HRESULT_TYPEDEF_(0x80004024L)
#define CO_E_SERVER_PAUSED  _HRESULT_TYPEDEF_(0x80004025L)
#define CO_E_SERVER_NOT_PAUSED  _HRESULT_TYPEDEF_(0x80004026L)
#define CO_E_CLASS_DISABLED  _HRESULT_TYPEDEF_(0x80004027L)
#define CO_E_CLRNOTAVAILABLE  _HRESULT_TYPEDEF_(0x80004028L)
#define CO_E_ASYNC_WORK_REJECTED  _HRESULT_TYPEDEF_(0x80004029L)
#define CO_E_SERVER_INIT_TIMEOUT  _HRESULT_TYPEDEF_(0x8000402AL)
#define CO_E_NO_SECCTX_IN_ACTIVATE  _HRESULT_TYPEDEF_(0x8000402BL)
#define CO_E_TRACKER_CONFIG  _HRESULT_TYPEDEF_(0x80004030L)
#define CO_E_THREADPOOL_CONFIG  _HRESULT_TYPEDEF_(0x80004031L)
#define CO_E_SXS_CONFIG  _HRESULT_TYPEDEF_(0x80004032L)
#define CO_E_MALFORMED_SPN  _HRESULT_TYPEDEF_(0x80004033L)
#define CO_E_UNREVOKED_REGISTRATION_ON_APARTMENT_SHUTDOWN _HRESULT_TYPEDEF_(0x80004034L)
#define CO_E_PREMATURE_STUB_RUNDOWN  _HRESULT_TYPEDEF_(0x80004035L)

#define S_OK  ((HRESULT)0L)
#define S_FALSE  ((HRESULT)1L)

#define OLE_E_FIRST ((HRESULT)0x80040000L)
#define OLE_E_LAST  ((HRESULT)0x800400FFL)
#define OLE_S_FIRST ((HRESULT)0x00040000L)
#define OLE_S_LAST  ((HRESULT)0x000400FFL)

#define OLE_E_OLEVERB  _HRESULT_TYPEDEF_(0x80040000L)
#define OLE_E_ADVF  _HRESULT_TYPEDEF_(0x80040001L)
#define OLE_E_ENUM_NOMORE  _HRESULT_TYPEDEF_(0x80040002L)
#define OLE_E_ADVISENOTSUPPORTED  _HRESULT_TYPEDEF_(0x80040003L)
#define OLE_E_NOCONNECTION  _HRESULT_TYPEDEF_(0x80040004L)
#define OLE_E_NOTRUNNING  _HRESULT_TYPEDEF_(0x80040005L)
#define OLE_E_NOCACHE  _HRESULT_TYPEDEF_(0x80040006L)
#define OLE_E_BLANK  _HRESULT_TYPEDEF_(0x80040007L)
#define OLE_E_CLASSDIFF  _HRESULT_TYPEDEF_(0x80040008L)
#define OLE_E_CANT_GETMONIKER  _HRESULT_TYPEDEF_(0x80040009L)
#define OLE_E_CANT_BINDTOSOURCE  _HRESULT_TYPEDEF_(0x8004000AL)
#define OLE_E_STATIC  _HRESULT_TYPEDEF_(0x8004000BL)
#define OLE_E_PROMPTSAVECANCELLED  _HRESULT_TYPEDEF_(0x8004000CL)
#define OLE_E_INVALIDRECT  _HRESULT_TYPEDEF_(0x8004000DL)
#define OLE_E_WRONGCOMPOBJ  _HRESULT_TYPEDEF_(0x8004000EL)
#define OLE_E_INVALIDHWND  _HRESULT_TYPEDEF_(0x8004000FL)
#define OLE_E_NOT_INPLACEACTIVE  _HRESULT_TYPEDEF_(0x80040010L)
#define OLE_E_CANTCONVERT  _HRESULT_TYPEDEF_(0x80040011L)
#define OLE_E_NOSTORAGE  _HRESULT_TYPEDEF_(0x80040012L)
#define DV_E_FORMATETC  _HRESULT_TYPEDEF_(0x80040064L)
#define DV_E_DVTARGETDEVICE  _HRESULT_TYPEDEF_(0x80040065L)
#define DV_E_STGMEDIUM  _HRESULT_TYPEDEF_(0x80040066L)
#define DV_E_STATDATA  _HRESULT_TYPEDEF_(0x80040067L)
#define DV_E_LINDEX  _HRESULT_TYPEDEF_(0x80040068L)
#define DV_E_TYMED  _HRESULT_TYPEDEF_(0x80040069L)
#define DV_E_CLIPFORMAT  _HRESULT_TYPEDEF_(0x8004006AL)
#define DV_E_DVASPECT  _HRESULT_TYPEDEF_(0x8004006BL)
#define DV_E_DVTARGETDEVICE_SIZE  _HRESULT_TYPEDEF_(0x8004006CL)
#define DV_E_NOIVIEWOBJECT  _HRESULT_TYPEDEF_(0x8004006DL)

#define DRAGDROP_E_FIRST 0x80040100L
#define DRAGDROP_E_LAST  0x8004010FL
#define DRAGDROP_S_FIRST 0x00040100L
#define DRAGDROP_S_LAST  0x0004010FL

#define DRAGDROP_E_NOTREGISTERED  _HRESULT_TYPEDEF_(0x80040100L)
#define DRAGDROP_E_ALREADYREGISTERED  _HRESULT_TYPEDEF_(0x80040101L)
#define DRAGDROP_E_INVALIDHWND  _HRESULT_TYPEDEF_(0x80040102L)
#define DRAGDROP_E_CONCURRENT_DRAG_ATTEMPTED _HRESULT_TYPEDEF_(0x80040103L)

#define CLASSFACTORY_E_FIRST  0x80040110L
#define CLASSFACTORY_E_LAST  0x8004011FL
#define CLASSFACTORY_S_FIRST  0x00040110L
#define CLASSFACTORY_S_LAST  0x0004011FL

#define CLASS_E_NOAGGREGATION  _HRESULT_TYPEDEF_(0x80040110L)
#define CLASS_E_CLASSNOTAVAILABLE  _HRESULT_TYPEDEF_(0x80040111L)
#define CLASS_E_NOTLICENSED  _HRESULT_TYPEDEF_(0x80040112L)

#define MARSHAL_E_FIRST  0x80040120L
#define MARSHAL_E_LAST  0x8004012FL
#define MARSHAL_S_FIRST  0x00040120L
#define MARSHAL_S_LAST  0x0004012FL
#define DATA_E_FIRST  0x80040130L
#define DATA_E_LAST  0x8004013FL
#define DATA_S_FIRST  0x00040130L
#define DATA_S_LAST  0x0004013FL
#define VIEW_E_FIRST  0x80040140L
#define VIEW_E_LAST  0x8004014FL
#define VIEW_S_FIRST  0x00040140L
#define VIEW_S_LAST  0x0004014FL

#define VIEW_E_DRAW  _HRESULT_TYPEDEF_(0x80040140L)

#define REGDB_E_FIRST  0x80040150L
#define REGDB_E_LAST  0x8004015FL
#define REGDB_S_FIRST  0x00040150L
#define REGDB_S_LAST  0x0004015FL

#define REGDB_E_READREGDB  _HRESULT_TYPEDEF_(0x80040150L)
#define REGDB_E_WRITEREGDB  _HRESULT_TYPEDEF_(0x80040151L)
#define REGDB_E_KEYMISSING  _HRESULT_TYPEDEF_(0x80040152L)
#define REGDB_E_INVALIDVALUE  _HRESULT_TYPEDEF_(0x80040153L)
#define REGDB_E_CLASSNOTREG  _HRESULT_TYPEDEF_(0x80040154L)
#define REGDB_E_IIDNOTREG  _HRESULT_TYPEDEF_(0x80040155L)
#define REGDB_E_BADTHREADINGMODEL  _HRESULT_TYPEDEF_(0x80040156L)
#define REGDB_E_PACKAGEPOLICYVIOLATION  _HRESULT_TYPEDEF_(0x80040157L)

#define CAT_E_FIRST  0x80040160L
#define CAT_E_LAST  0x80040161L

#define CAT_E_CATIDNOEXIST  _HRESULT_TYPEDEF_(0x80040160L)
#define CAT_E_NODESCRIPTION  _HRESULT_TYPEDEF_(0x80040161L)

#define CS_E_FIRST  0x80040164L
#define CS_E_LAST  0x8004016FL

#define CS_E_PACKAGE_NOTFOUND  _HRESULT_TYPEDEF_(0x80040164L)
#define CS_E_NOT_DELETABLE  _HRESULT_TYPEDEF_(0x80040165L)
#define CS_E_CLASS_NOTFOUND  _HRESULT_TYPEDEF_(0x80040166L)
#define CS_E_INVALID_VERSION  _HRESULT_TYPEDEF_(0x80040167L)
#define CS_E_NO_CLASSSTORE  _HRESULT_TYPEDEF_(0x80040168L)
#define CS_E_OBJECT_NOTFOUND  _HRESULT_TYPEDEF_(0x80040169L)
#define CS_E_OBJECT_ALREADY_EXISTS  _HRESULT_TYPEDEF_(0x8004016AL)
#define CS_E_INVALID_PATH  _HRESULT_TYPEDEF_(0x8004016BL)
#define CS_E_NETWORK_ERROR  _HRESULT_TYPEDEF_(0x8004016CL)
#define CS_E_ADMIN_LIMIT_EXCEEDED  _HRESULT_TYPEDEF_(0x8004016DL)
#define CS_E_SCHEMA_MISMATCH  _HRESULT_TYPEDEF_(0x8004016EL)
#define CS_E_INTERNAL_ERROR  _HRESULT_TYPEDEF_(0x8004016FL)

#define CACHE_E_FIRST  0x80040170L
#define CACHE_E_LAST  0x8004017FL
#define CACHE_S_FIRST  0x00040170L
#define CACHE_S_LAST  0x0004017FL

#define CACHE_E_NOCACHE_UPDATED  _HRESULT_TYPEDEF_(0x80040170L)

#define OLEOBJ_E_FIRST  0x80040180L
#define OLEOBJ_E_LAST  0x8004018FL
#define OLEOBJ_S_FIRST  0x00040180L
#define OLEOBJ_S_LAST  0x0004018FL

#define OLEOBJ_E_NOVERBS  _HRESULT_TYPEDEF_(0x80040180L)
#define OLEOBJ_E_INVALIDVERB  _HRESULT_TYPEDEF_(0x80040181L)

#define CLIENTSITE_E_FIRST  0x80040190L
#define CLIENTSITE_E_LAST  0x8004019FL
#define CLIENTSITE_S_FIRST  0x00040190L
#define CLIENTSITE_S_LAST  0x0004019FL

#define INPLACE_E_NOTUNDOABLE  _HRESULT_TYPEDEF_(0x800401A0L)
#define INPLACE_E_NOTOOLSPACE  _HRESULT_TYPEDEF_(0x800401A1L)

#define INPLACE_E_FIRST  0x800401A0L
#define INPLACE_E_LAST  0x800401AFL
#define INPLACE_S_FIRST  0x000401A0L
#define INPLACE_S_LAST  0x000401AFL
#define ENUM_E_FIRST  0x800401B0L
#define ENUM_E_LAST  0x800401BFL
#define ENUM_S_FIRST  0x000401B0L
#define ENUM_S_LAST  0x000401BFL
#define CONVERT10_E_FIRST  0x800401C0L
#define CONVERT10_E_LAST  0x800401CFL
#define CONVERT10_S_FIRST  0x000401C0L
#define CONVERT10_S_LAST  0x000401CFL

#define CONVERT10_E_OLESTREAM_GET  _HRESULT_TYPEDEF_(0x800401C0L)
#define CONVERT10_E_OLESTREAM_PUT  _HRESULT_TYPEDEF_(0x800401C1L)
#define CONVERT10_E_OLESTREAM_FMT  _HRESULT_TYPEDEF_(0x800401C2L)
#define CONVERT10_E_OLESTREAM_BITMAP_TO_DIB _HRESULT_TYPEDEF_(0x800401C3L)
#define CONVERT10_E_STG_FMT  _HRESULT_TYPEDEF_(0x800401C4L)
#define CONVERT10_E_STG_NO_STD_STREAM  _HRESULT_TYPEDEF_(0x800401C5L)
#define CONVERT10_E_STG_DIB_TO_BITMAP  _HRESULT_TYPEDEF_(0x800401C6L)

#define CLIPBRD_E_FIRST  0x800401D0L
#define CLIPBRD_E_LAST  0x800401DFL
#define CLIPBRD_S_FIRST  0x000401D0L
#define CLIPBRD_S_LAST  0x000401DFL

#define CLIPBRD_E_CANT_OPEN  _HRESULT_TYPEDEF_(0x800401D0L)
#define CLIPBRD_E_CANT_EMPTY  _HRESULT_TYPEDEF_(0x800401D1L)
#define CLIPBRD_E_CANT_SET  _HRESULT_TYPEDEF_(0x800401D2L)
#define CLIPBRD_E_BAD_DATA  _HRESULT_TYPEDEF_(0x800401D3L)
#define CLIPBRD_E_CANT_CLOSE  _HRESULT_TYPEDEF_(0x800401D4L)

#define MK_E_FIRST  0x800401E0L
#define MK_E_LAST  0x800401EFL
#define MK_S_FIRST  0x000401E0L
#define MK_S_LAST  0x000401EFL

#define MK_E_CONNECTMANUALLY  _HRESULT_TYPEDEF_(0x800401E0L)
#define MK_E_EXCEEDEDDEADLINE  _HRESULT_TYPEDEF_(0x800401E1L)
#define MK_E_NEEDGENERIC  _HRESULT_TYPEDEF_(0x800401E2L)
#define MK_E_UNAVAILABLE  _HRESULT_TYPEDEF_(0x800401E3L)
#define MK_E_SYNTAX  _HRESULT_TYPEDEF_(0x800401E4L)
#define MK_E_NOOBJECT  _HRESULT_TYPEDEF_(0x800401E5L)
#define MK_E_INVALIDEXTENSION  _HRESULT_TYPEDEF_(0x800401E6L)
#define MK_E_INTERMEDIATEINTERFACENOTSUPPORTED _HRESULT_TYPEDEF_(0x800401E7L)
#define MK_E_NOTBINDABLE  _HRESULT_TYPEDEF_(0x800401E8L)
#define MK_E_NOTBOUND  _HRESULT_TYPEDEF_(0x800401E9L)
#define MK_E_CANTOPENFILE  _HRESULT_TYPEDEF_(0x800401EAL)
#define MK_E_MUSTBOTHERUSER  _HRESULT_TYPEDEF_(0x800401EBL)
#define MK_E_NOINVERSE  _HRESULT_TYPEDEF_(0x800401ECL)
#define MK_E_NOSTORAGE  _HRESULT_TYPEDEF_(0x800401EDL)
#define MK_E_NOPREFIX  _HRESULT_TYPEDEF_(0x800401EEL)
#define MK_E_ENUMERATION_FAILED  _HRESULT_TYPEDEF_(0x800401EFL)

#define CO_E_FIRST  0x800401F0L
#define CO_E_LAST  0x800401FFL
#define CO_S_FIRST  0x000401F0L
#define CO_S_LAST  0x000401FFL

#define CO_E_NOTINITIALIZED  _HRESULT_TYPEDEF_(0x800401F0L)
#define CO_E_ALREADYINITIALIZED  _HRESULT_TYPEDEF_(0x800401F1L)
#define CO_E_CANTDETERMINECLASS  _HRESULT_TYPEDEF_(0x800401F2L)
#define CO_E_CLASSSTRING  _HRESULT_TYPEDEF_(0x800401F3L)
#define CO_E_IIDSTRING  _HRESULT_TYPEDEF_(0x800401F4L)
#define CO_E_APPNOTFOUND  _HRESULT_TYPEDEF_(0x800401F5L)
#define CO_E_APPSINGLEUSE  _HRESULT_TYPEDEF_(0x800401F6L)
#define CO_E_ERRORINAPP  _HRESULT_TYPEDEF_(0x800401F7L)
#define CO_E_DLLNOTFOUND  _HRESULT_TYPEDEF_(0x800401F8L)
#define CO_E_ERRORINDLL  _HRESULT_TYPEDEF_(0x800401F9L)
#define CO_E_WRONGOSFORAPP  _HRESULT_TYPEDEF_(0x800401FAL)
#define CO_E_OBJNOTREG  _HRESULT_TYPEDEF_(0x800401FBL)
#define CO_E_OBJISREG  _HRESULT_TYPEDEF_(0x800401FCL)
#define CO_E_OBJNOTCONNECTED  _HRESULT_TYPEDEF_(0x800401FDL)
#define CO_E_APPDIDNTREG  _HRESULT_TYPEDEF_(0x800401FEL)
#define CO_E_RELEASED  _HRESULT_TYPEDEF_(0x800401FFL)

#define EVENT_E_FIRST  0x80040200L
#define EVENT_E_LAST  0x8004021FL
#define EVENT_S_FIRST  0x00040200L
#define EVENT_S_LAST  0x0004021FL

#define EVENT_S_SOME_SUBSCRIBERS_FAILED  _HRESULT_TYPEDEF_(0x00040200L)
#define EVENT_E_ALL_SUBSCRIBERS_FAILED  _HRESULT_TYPEDEF_(0x80040201L)
#define EVENT_S_NOSUBSCRIBERS  _HRESULT_TYPEDEF_(0x00040202L)
#define EVENT_E_QUERYSYNTAX  _HRESULT_TYPEDEF_(0x80040203L)
#define EVENT_E_QUERYFIELD  _HRESULT_TYPEDEF_(0x80040204L)
#define EVENT_E_INTERNALEXCEPTION  _HRESULT_TYPEDEF_(0x80040205L)
#define EVENT_E_INTERNALERROR  _HRESULT_TYPEDEF_(0x80040206L)
#define EVENT_E_INVALID_PER_USER_SID  _HRESULT_TYPEDEF_(0x80040207L)
#define EVENT_E_USER_EXCEPTION  _HRESULT_TYPEDEF_(0x80040208L)
#define EVENT_E_TOO_MANY_METHODS  _HRESULT_TYPEDEF_(0x80040209L)
#define EVENT_E_MISSING_EVENTCLASS  _HRESULT_TYPEDEF_(0x8004020AL)
#define EVENT_E_NOT_ALL_REMOVED  _HRESULT_TYPEDEF_(0x8004020BL)
#define EVENT_E_COMPLUS_NOT_INSTALLED  _HRESULT_TYPEDEF_(0x8004020CL)
#define EVENT_E_CANT_MODIFY_OR_DELETE_UNCONFIGURED_OBJECT _HRESULT_TYPEDEF_(0x8004020DL)
#define EVENT_E_CANT_MODIFY_OR_DELETE_CONFIGURED_OBJECT _HRESULT_TYPEDEF_(0x8004020EL)
#define EVENT_E_INVALID_EVENT_CLASS_PARTITION _HRESULT_TYPEDEF_(0x8004020FL)
#define EVENT_E_PER_USER_SID_NOT_LOGGED_ON _HRESULT_TYPEDEF_(0x80040210L)
#define TPC_E_INVALID_PROPERTY  _HRESULT_TYPEDEF_(0x80040241L)
#define TPC_E_NO_DEFAULT_TABLET  _HRESULT_TYPEDEF_(0x80040212L)
#define TPC_E_UNKNOWN_PROPERTY  _HRESULT_TYPEDEF_(0x8004021BL)
#define TPC_E_INVALID_INPUT_RECT  _HRESULT_TYPEDEF_(0x80040219L)
#define TPC_E_INVALID_STROKE  _HRESULT_TYPEDEF_(0x80040222L)
#define TPC_E_INITIALIZE_FAIL  _HRESULT_TYPEDEF_(0x80040223L)
#define TPC_E_NOT_RELEVANT  _HRESULT_TYPEDEF_(0x80040232L)
#define TPC_E_INVALID_PACKET_DESCRIPTION _HRESULT_TYPEDEF_(0x80040233L)
#define TPC_E_RECOGNIZER_NOT_REGISTERED  _HRESULT_TYPEDEF_(0x80040235L)
#define TPC_E_INVALID_RIGHTS  _HRESULT_TYPEDEF_(0x80040236L)
#define TPC_E_OUT_OF_ORDER_CALL  _HRESULT_TYPEDEF_(0x80040237L)
#define TPC_E_QUEUE_FULL  _HRESULT_TYPEDEF_(0x80040238L)
#define TPC_E_INVALID_CONFIGURATION  _HRESULT_TYPEDEF_(0x80040239L)
#define TPC_E_INVALID_DATA_FROM_RECOGNIZER _HRESULT_TYPEDEF_(0x8004023AL)
#define TPC_S_TRUNCATED  _HRESULT_TYPEDEF_(0x00040252L)
#define TPC_S_INTERRUPTED  _HRESULT_TYPEDEF_(0x00040253L)
#define TPC_S_NO_DATA_TO_PROCESS  _HRESULT_TYPEDEF_(0x00040254L)

#define XACT_E_FIRST  0x8004D000
#define XACT_E_LAST  0x8004D02B
#define XACT_S_FIRST  0x0004D000
#define XACT_S_LAST  0x0004D010

#define XACT_E_ALREADYOTHERSINGLEPHASE  _HRESULT_TYPEDEF_(0x8004D000L)
#define XACT_E_CANTRETAIN  _HRESULT_TYPEDEF_(0x8004D001L)
#define XACT_E_COMMITFAILED  _HRESULT_TYPEDEF_(0x8004D002L)
#define XACT_E_COMMITPREVENTED  _HRESULT_TYPEDEF_(0x8004D003L)
#define XACT_E_HEURISTICABORT  _HRESULT_TYPEDEF_(0x8004D004L)
#define XACT_E_HEURISTICCOMMIT  _HRESULT_TYPEDEF_(0x8004D005L)
#define XACT_E_HEURISTICDAMAGE  _HRESULT_TYPEDEF_(0x8004D006L)
#define XACT_E_HEURISTICDANGER  _HRESULT_TYPEDEF_(0x8004D007L)
#define XACT_E_ISOLATIONLEVEL  _HRESULT_TYPEDEF_(0x8004D008L)
#define XACT_E_NOASYNC  _HRESULT_TYPEDEF_(0x8004D009L)
#define XACT_E_NOENLIST  _HRESULT_TYPEDEF_(0x8004D00AL)
#define XACT_E_NOISORETAIN  _HRESULT_TYPEDEF_(0x8004D00BL)
#define XACT_E_NORESOURCE  _HRESULT_TYPEDEF_(0x8004D00CL)
#define XACT_E_NOTCURRENT  _HRESULT_TYPEDEF_(0x8004D00DL)
#define XACT_E_NOTRANSACTION  _HRESULT_TYPEDEF_(0x8004D00EL)
#define XACT_E_NOTSUPPORTED  _HRESULT_TYPEDEF_(0x8004D00FL)
#define XACT_E_UNKNOWNRMGRID  _HRESULT_TYPEDEF_(0x8004D010L)
#define XACT_E_WRONGSTATE  _HRESULT_TYPEDEF_(0x8004D011L)
#define XACT_E_WRONGUOW  _HRESULT_TYPEDEF_(0x8004D012L)
#define XACT_E_XTIONEXISTS  _HRESULT_TYPEDEF_(0x8004D013L)
#define XACT_E_NOIMPORTOBJECT  _HRESULT_TYPEDEF_(0x8004D014L)
#define XACT_E_INVALIDCOOKIE  _HRESULT_TYPEDEF_(0x8004D015L)
#define XACT_E_INDOUBT  _HRESULT_TYPEDEF_(0x8004D016L)
#define XACT_E_NOTIMEOUT  _HRESULT_TYPEDEF_(0x8004D017L)
#define XACT_E_ALREADYINPROGRESS  _HRESULT_TYPEDEF_(0x8004D018L)
#define XACT_E_ABORTED  _HRESULT_TYPEDEF_(0x8004D019L)
#define XACT_E_LOGFULL  _HRESULT_TYPEDEF_(0x8004D01AL)
#define XACT_E_TMNOTAVAILABLE  _HRESULT_TYPEDEF_(0x8004D01BL)
#define XACT_E_CONNECTION_DOWN  _HRESULT_TYPEDEF_(0x8004D01CL)
#define XACT_E_CONNECTION_DENIED  _HRESULT_TYPEDEF_(0x8004D01DL)
#define XACT_E_REENLISTTIMEOUT  _HRESULT_TYPEDEF_(0x8004D01EL)
#define XACT_E_TIP_CONNECT_FAILED  _HRESULT_TYPEDEF_(0x8004D01FL)
#define XACT_E_TIP_PROTOCOL_ERROR  _HRESULT_TYPEDEF_(0x8004D020L)
#define XACT_E_TIP_PULL_FAILED  _HRESULT_TYPEDEF_(0x8004D021L)
#define XACT_E_DEST_TMNOTAVAILABLE  _HRESULT_TYPEDEF_(0x8004D022L)
#define XACT_E_TIP_DISABLED  _HRESULT_TYPEDEF_(0x8004D023L)
#define XACT_E_NETWORK_TX_DISABLED  _HRESULT_TYPEDEF_(0x8004D024L)
#define XACT_E_PARTNER_NETWORK_TX_DISABLED _HRESULT_TYPEDEF_(0x8004D025L)
#define XACT_E_XA_TX_DISABLED  _HRESULT_TYPEDEF_(0x8004D026L)
#define XACT_E_UNABLE_TO_READ_DTC_CONFIG _HRESULT_TYPEDEF_(0x8004D027L)
#define XACT_E_UNABLE_TO_LOAD_DTC_PROXY  _HRESULT_TYPEDEF_(0x8004D028L)
#define XACT_E_ABORTING  _HRESULT_TYPEDEF_(0x8004D029L)
#define XACT_E_PUSH_COMM_FAILURE  _HRESULT_TYPEDEF_(0x8004D02AL)
#define XACT_E_PULL_COMM_FAILURE  _HRESULT_TYPEDEF_(0x8004D02BL)
#define XACT_E_LU_TX_DISABLED  _HRESULT_TYPEDEF_(0x8004D02CL)
#define XACT_E_CLERKNOTFOUND  _HRESULT_TYPEDEF_(0x8004D080L)
#define XACT_E_CLERKEXISTS  _HRESULT_TYPEDEF_(0x8004D081L)
#define XACT_E_RECOVERYINPROGRESS  _HRESULT_TYPEDEF_(0x8004D082L)
#define XACT_E_TRANSACTIONCLOSED  _HRESULT_TYPEDEF_(0x8004D083L)
#define XACT_E_INVALIDLSN  _HRESULT_TYPEDEF_(0x8004D084L)
#define XACT_E_REPLAYREQUEST  _HRESULT_TYPEDEF_(0x8004D085L)
#define XACT_S_ASYNC  _HRESULT_TYPEDEF_(0x0004D000L)
#define XACT_S_DEFECT  _HRESULT_TYPEDEF_(0x0004D001L)
#define XACT_S_READONLY  _HRESULT_TYPEDEF_(0x0004D002L)
#define XACT_S_SOMENORETAIN  _HRESULT_TYPEDEF_(0x0004D003L)
#define XACT_S_OKINFORM  _HRESULT_TYPEDEF_(0x0004D004L)
#define XACT_S_MADECHANGESCONTENT  _HRESULT_TYPEDEF_(0x0004D005L)
#define XACT_S_MADECHANGESINFORM  _HRESULT_TYPEDEF_(0x0004D006L)
#define XACT_S_ALLNORETAIN  _HRESULT_TYPEDEF_(0x0004D007L)
#define XACT_S_ABORTING  _HRESULT_TYPEDEF_(0x0004D008L)
#define XACT_S_SINGLEPHASE  _HRESULT_TYPEDEF_(0x0004D009L)
#define XACT_S_LOCALLY_OK  _HRESULT_TYPEDEF_(0x0004D00AL)
#define XACT_S_LASTRESOURCEMANAGER  _HRESULT_TYPEDEF_(0x0004D010L)

#define CONTEXT_E_FIRST  0x8004E000L
#define CONTEXT_E_LAST  0x8004E02FL
#define CONTEXT_S_FIRST  0x0004E000L
#define CONTEXT_S_LAST  0x0004E02FL

#define CONTEXT_E_ABORTED  _HRESULT_TYPEDEF_(0x8004E002L)
#define CONTEXT_E_ABORTING  _HRESULT_TYPEDEF_(0x8004E003L)
#define CONTEXT_E_NOCONTEXT  _HRESULT_TYPEDEF_(0x8004E004L)
#define CONTEXT_E_WOULD_DEADLOCK  _HRESULT_TYPEDEF_(0x8004E005L)
#define CONTEXT_E_SYNCH_TIMEOUT  _HRESULT_TYPEDEF_(0x8004E006L)
#define CONTEXT_E_OLDREF  _HRESULT_TYPEDEF_(0x8004E007L)
#define CONTEXT_E_ROLENOTFOUND  _HRESULT_TYPEDEF_(0x8004E00CL)
#define CONTEXT_E_TMNOTAVAILABLE  _HRESULT_TYPEDEF_(0x8004E00FL)
#define CO_E_ACTIVATIONFAILED  _HRESULT_TYPEDEF_(0x8004E021L)
#define CO_E_ACTIVATIONFAILED_EVENTLOGGED _HRESULT_TYPEDEF_(0x8004E022L)
#define CO_E_ACTIVATIONFAILED_CATALOGERROR _HRESULT_TYPEDEF_(0x8004E023L)
#define CO_E_ACTIVATIONFAILED_TIMEOUT  _HRESULT_TYPEDEF_(0x8004E024L)
#define CO_E_INITIALIZATIONFAILED  _HRESULT_TYPEDEF_(0x8004E025L)
#define CONTEXT_E_NOJIT  _HRESULT_TYPEDEF_(0x8004E026L)
#define CONTEXT_E_NOTRANSACTION  _HRESULT_TYPEDEF_(0x8004E027L)
#define CO_E_THREADINGMODEL_CHANGED  _HRESULT_TYPEDEF_(0x8004E028L)
#define CO_E_NOIISINTRINSICS  _HRESULT_TYPEDEF_(0x8004E029L)
#define CO_E_NOCOOKIES  _HRESULT_TYPEDEF_(0x8004E02AL)
#define CO_E_DBERROR  _HRESULT_TYPEDEF_(0x8004E02BL)
#define CO_E_NOTPOOLED  _HRESULT_TYPEDEF_(0x8004E02CL)
#define CO_E_NOTCONSTRUCTED  _HRESULT_TYPEDEF_(0x8004E02DL)
#define CO_E_NOSYNCHRONIZATION  _HRESULT_TYPEDEF_(0x8004E02EL)
#define CO_E_ISOLEVELMISMATCH  _HRESULT_TYPEDEF_(0x8004E02FL)
#define CO_E_CALL_OUT_OF_TX_SCOPE_NOT_ALLOWED _HRESULT_TYPEDEF_(0x8004E030L)
#define CO_E_EXIT_TRANSACTION_SCOPE_NOT_CALLED _HRESULT_TYPEDEF_(0x8004E031L)
#define OLE_S_USEREG  _HRESULT_TYPEDEF_(0x00040000L)
#define OLE_S_STATIC  _HRESULT_TYPEDEF_(0x00040001L)
#define OLE_S_MAC_CLIPFORMAT  _HRESULT_TYPEDEF_(0x00040002L)
#define DRAGDROP_S_DROP  _HRESULT_TYPEDEF_(0x00040100L)
#define DRAGDROP_S_CANCEL  _HRESULT_TYPEDEF_(0x00040101L)
#define DRAGDROP_S_USEDEFAULTCURSORS  _HRESULT_TYPEDEF_(0x00040102L)
#define DATA_S_SAMEFORMATETC  _HRESULT_TYPEDEF_(0x00040130L)
#define VIEW_S_ALREADY_FROZEN  _HRESULT_TYPEDEF_(0x00040140L)
#define CACHE_S_FORMATETC_NOTSUPPORTED  _HRESULT_TYPEDEF_(0x00040170L)
#define CACHE_S_SAMECACHE  _HRESULT_TYPEDEF_(0x00040171L)
#define CACHE_S_SOMECACHES_NOTUPDATED  _HRESULT_TYPEDEF_(0x00040172L)
#define OLEOBJ_S_INVALIDVERB  _HRESULT_TYPEDEF_(0x00040180L)
#define OLEOBJ_S_CANNOT_DOVERB_NOW  _HRESULT_TYPEDEF_(0x00040181L)
#define OLEOBJ_S_INVALIDHWND  _HRESULT_TYPEDEF_(0x00040182L)
#define INPLACE_S_TRUNCATED  _HRESULT_TYPEDEF_(0x000401A0L)
#define CONVERT10_S_NO_PRESENTATION  _HRESULT_TYPEDEF_(0x000401C0L)
#define MK_S_REDUCED_TO_SELF  _HRESULT_TYPEDEF_(0x000401E2L)
#define MK_S_ME  _HRESULT_TYPEDEF_(0x000401E4L)
#define MK_S_HIM  _HRESULT_TYPEDEF_(0x000401E5L)
#define MK_S_US  _HRESULT_TYPEDEF_(0x000401E6L)
#define MK_S_MONIKERALREADYREGISTERED  _HRESULT_TYPEDEF_(0x000401E7L)
#define SCHED_S_TASK_READY  _HRESULT_TYPEDEF_(0x00041300L)
#define SCHED_S_TASK_RUNNING  _HRESULT_TYPEDEF_(0x00041301L)
#define SCHED_S_TASK_DISABLED  _HRESULT_TYPEDEF_(0x00041302L)
#define SCHED_S_TASK_HAS_NOT_RUN  _HRESULT_TYPEDEF_(0x00041303L)
#define SCHED_S_TASK_NO_MORE_RUNS  _HRESULT_TYPEDEF_(0x00041304L)
#define SCHED_S_TASK_NOT_SCHEDULED  _HRESULT_TYPEDEF_(0x00041305L)
#define SCHED_S_TASK_TERMINATED  _HRESULT_TYPEDEF_(0x00041306L)
#define SCHED_S_TASK_NO_VALID_TRIGGERS  _HRESULT_TYPEDEF_(0x00041307L)
#define SCHED_S_EVENT_TRIGGER  _HRESULT_TYPEDEF_(0x00041308L)
#define SCHED_E_TRIGGER_NOT_FOUND  _HRESULT_TYPEDEF_(0x80041309L)
#define SCHED_E_TASK_NOT_READY  _HRESULT_TYPEDEF_(0x8004130AL)
#define SCHED_E_TASK_NOT_RUNNING  _HRESULT_TYPEDEF_(0x8004130BL)
#define SCHED_E_SERVICE_NOT_INSTALLED  _HRESULT_TYPEDEF_(0x8004130CL)
#define SCHED_E_CANNOT_OPEN_TASK  _HRESULT_TYPEDEF_(0x8004130DL)
#define SCHED_E_INVALID_TASK  _HRESULT_TYPEDEF_(0x8004130EL)
#define SCHED_E_ACCOUNT_INFORMATION_NOT_SET _HRESULT_TYPEDEF_(0x8004130FL)
#define SCHED_E_ACCOUNT_NAME_NOT_FOUND  _HRESULT_TYPEDEF_(0x80041310L)
#define SCHED_E_ACCOUNT_DBASE_CORRUPT  _HRESULT_TYPEDEF_(0x80041311L)
#define SCHED_E_NO_SECURITY_SERVICES  _HRESULT_TYPEDEF_(0x80041312L)
#define SCHED_E_UNKNOWN_OBJECT_VERSION  _HRESULT_TYPEDEF_(0x80041313L)
#define SCHED_E_UNSUPPORTED_ACCOUNT_OPTION _HRESULT_TYPEDEF_(0x80041314L)
#define SCHED_E_SERVICE_NOT_RUNNING  _HRESULT_TYPEDEF_(0x80041315L)
#define SCHED_E_UNEXPECTEDNODE  _HRESULT_TYPEDEF_(0x80041316L)
#define SCHED_E_NAMESPACE  _HRESULT_TYPEDEF_(0x80041317L)
#define SCHED_E_INVALIDVALUE  _HRESULT_TYPEDEF_(0x80041318L)
#define SCHED_E_MISSINGNODE  _HRESULT_TYPEDEF_(0x80041319L)
#define SCHED_E_MALFORMEDXML  _HRESULT_TYPEDEF_(0x8004131AL)
#define SCHED_S_SOME_TRIGGERS_FAILED  _HRESULT_TYPEDEF_(0x0004131BL)
#define SCHED_S_BATCH_LOGON_PROBLEM  _HRESULT_TYPEDEF_(0x0004131CL)
#define SCHED_E_TOO_MANY_NODES  _HRESULT_TYPEDEF_(0x8004131DL)
#define SCHED_E_PAST_END_BOUNDARY  _HRESULT_TYPEDEF_(0x8004131EL)
#define SCHED_E_ALREADY_RUNNING  _HRESULT_TYPEDEF_(0x8004131FL)
#define SCHED_E_USER_NOT_LOGGED_ON  _HRESULT_TYPEDEF_(0x80041320L)
#define SCHED_E_INVALID_TASK_HASH  _HRESULT_TYPEDEF_(0x80041321L)
#define SCHED_E_SERVICE_NOT_AVAILABLE  _HRESULT_TYPEDEF_(0x80041322L)
#define SCHED_E_SERVICE_TOO_BUSY  _HRESULT_TYPEDEF_(0x80041323L)
#define SCHED_E_TASK_ATTEMPTED  _HRESULT_TYPEDEF_(0x80041324L)
#define SCHED_S_TASK_QUEUED  _HRESULT_TYPEDEF_(0x00041325L)
#define SCHED_E_TASK_DISABLED  _HRESULT_TYPEDEF_(0x80041326L)
#define SCHED_E_TASK_NOT_V1_COMPAT  _HRESULT_TYPEDEF_(0x80041327L)
#define SCHED_E_START_ON_DEMAND  _HRESULT_TYPEDEF_(0x80041328L)
#define SCHED_E_TASK_NOT_UBPM_COMPAT  _HRESULT_TYPEDEF_(0x80041329L)
#define SCHED_E_DEPRECATED_FEATURE_USED  _HRESULT_TYPEDEF_(0x80041330L)
#define CO_E_CLASS_CREATE_FAILED  _HRESULT_TYPEDEF_(0x80080001L)
#define CO_E_SCM_ERROR  _HRESULT_TYPEDEF_(0x80080002L)
#define CO_E_SCM_RPC_FAILURE  _HRESULT_TYPEDEF_(0x80080003L)
#define CO_E_BAD_PATH  _HRESULT_TYPEDEF_(0x80080004L)
#define CO_E_SERVER_EXEC_FAILURE  _HRESULT_TYPEDEF_(0x80080005L)
#define CO_E_OBJSRV_RPC_FAILURE  _HRESULT_TYPEDEF_(0x80080006L)
#define MK_E_NO_NORMALIZED  _HRESULT_TYPEDEF_(0x80080007L)
#define CO_E_SERVER_STOPPING  _HRESULT_TYPEDEF_(0x80080008L)
#define MEM_E_INVALID_ROOT  _HRESULT_TYPEDEF_(0x80080009L)
#define MEM_E_INVALID_LINK  _HRESULT_TYPEDEF_(0x80080010L)
#define MEM_E_INVALID_SIZE  _HRESULT_TYPEDEF_(0x80080011L)
#define CO_S_NOTALLINTERFACES  _HRESULT_TYPEDEF_(0x00080012L)
#define CO_S_MACHINENAMENOTFOUND  _HRESULT_TYPEDEF_(0x00080013L)
#define CO_E_MISSING_DISPLAYNAME  _HRESULT_TYPEDEF_(0x80080015L)
#define CO_E_RUNAS_VALUE_MUST_BE_AAA  _HRESULT_TYPEDEF_(0x80080016L)
#define CO_E_ELEVATION_DISABLED  _HRESULT_TYPEDEF_(0x80080017L)
#define APPX_E_PACKAGING_INTERNAL  _HRESULT_TYPEDEF_(0x80080200L)
#define APPX_E_INTERLEAVING_NOT_ALLOWED  _HRESULT_TYPEDEF_(0x80080201L)
#define APPX_E_RELATIONSHIPS_NOT_ALLOWED _HRESULT_TYPEDEF_(0x80080202L)
#define APPX_E_MISSING_REQUIRED_FILE  _HRESULT_TYPEDEF_(0x80080203L)
#define APPX_E_INVALID_MANIFEST  _HRESULT_TYPEDEF_(0x80080204L)
#define APPX_E_INVALID_BLOCKMAP  _HRESULT_TYPEDEF_(0x80080205L)
#define APPX_E_CORRUPT_CONTENT  _HRESULT_TYPEDEF_(0x80080206L)
#define APPX_E_BLOCK_HASH_INVALID  _HRESULT_TYPEDEF_(0x80080207L)
#define APPX_E_REQUESTED_RANGE_TOO_LARGE _HRESULT_TYPEDEF_(0x80080208L)
#define APPX_E_INVALID_SIP_CLIENT_DATA  _HRESULT_TYPEDEF_(0x80080209L)
#define APPX_E_INVALID_KEY_INFO  _HRESULT_TYPEDEF_(0x8008020AL)
#define BT_E_SPURIOUS_ACTIVATION  _HRESULT_TYPEDEF_(0x80080300L)
#define DISP_E_UNKNOWNINTERFACE  _HRESULT_TYPEDEF_(0x80020001L)
#define DISP_E_MEMBERNOTFOUND  _HRESULT_TYPEDEF_(0x80020003L)
#define DISP_E_PARAMNOTFOUND  _HRESULT_TYPEDEF_(0x80020004L)
#define DISP_E_TYPEMISMATCH  _HRESULT_TYPEDEF_(0x80020005L)
#define DISP_E_UNKNOWNNAME  _HRESULT_TYPEDEF_(0x80020006L)
#define DISP_E_NONAMEDARGS  _HRESULT_TYPEDEF_(0x80020007L)
#define DISP_E_BADVARTYPE  _HRESULT_TYPEDEF_(0x80020008L)
#define DISP_E_EXCEPTION  _HRESULT_TYPEDEF_(0x80020009L)
#define DISP_E_OVERFLOW  _HRESULT_TYPEDEF_(0x8002000AL)
#define DISP_E_BADINDEX  _HRESULT_TYPEDEF_(0x8002000BL)
#define DISP_E_UNKNOWNLCID  _HRESULT_TYPEDEF_(0x8002000CL)
#define DISP_E_ARRAYISLOCKED  _HRESULT_TYPEDEF_(0x8002000DL)
#define DISP_E_BADPARAMCOUNT  _HRESULT_TYPEDEF_(0x8002000EL)
#define DISP_E_PARAMNOTOPTIONAL  _HRESULT_TYPEDEF_(0x8002000FL)
#define DISP_E_BADCALLEE  _HRESULT_TYPEDEF_(0x80020010L)
#define DISP_E_NOTACOLLECTION  _HRESULT_TYPEDEF_(0x80020011L)
#define DISP_E_DIVBYZERO  _HRESULT_TYPEDEF_(0x80020012L)
#define DISP_E_BUFFERTOOSMALL  _HRESULT_TYPEDEF_(0x80020013L)
#define TYPE_E_BUFFERTOOSMALL  _HRESULT_TYPEDEF_(0x80028016L)
#define TYPE_E_FIELDNOTFOUND  _HRESULT_TYPEDEF_(0x80028017L)
#define TYPE_E_INVDATAREAD  _HRESULT_TYPEDEF_(0x80028018L)
#define TYPE_E_UNSUPFORMAT  _HRESULT_TYPEDEF_(0x80028019L)
#define TYPE_E_REGISTRYACCESS  _HRESULT_TYPEDEF_(0x8002801CL)
#define TYPE_E_LIBNOTREGISTERED  _HRESULT_TYPEDEF_(0x8002801DL)
#define TYPE_E_UNDEFINEDTYPE  _HRESULT_TYPEDEF_(0x80028027L)
#define TYPE_E_QUALIFIEDNAMEDISALLOWED  _HRESULT_TYPEDEF_(0x80028028L)
#define TYPE_E_INVALIDSTATE  _HRESULT_TYPEDEF_(0x80028029L)
#define TYPE_E_WRONGTYPEKIND  _HRESULT_TYPEDEF_(0x8002802AL)
#define TYPE_E_ELEMENTNOTFOUND  _HRESULT_TYPEDEF_(0x8002802BL)
#define TYPE_E_AMBIGUOUSNAME  _HRESULT_TYPEDEF_(0x8002802CL)
#define TYPE_E_NAMECONFLICT  _HRESULT_TYPEDEF_(0x8002802DL)
#define TYPE_E_UNKNOWNLCID  _HRESULT_TYPEDEF_(0x8002802EL)
#define TYPE_E_DLLFUNCTIONNOTFOUND  _HRESULT_TYPEDEF_(0x8002802FL)
#define TYPE_E_BADMODULEKIND  _HRESULT_TYPEDEF_(0x800288BDL)
#define TYPE_E_SIZETOOBIG  _HRESULT_TYPEDEF_(0x800288C5L)
#define TYPE_E_DUPLICATEID  _HRESULT_TYPEDEF_(0x800288C6L)
#define TYPE_E_INVALIDID  _HRESULT_TYPEDEF_(0x800288CFL)
#define TYPE_E_TYPEMISMATCH  _HRESULT_TYPEDEF_(0x80028CA0L)
#define TYPE_E_OUTOFBOUNDS  _HRESULT_TYPEDEF_(0x80028CA1L)
#define TYPE_E_IOERROR  _HRESULT_TYPEDEF_(0x80028CA2L)
#define TYPE_E_CANTCREATETMPFILE  _HRESULT_TYPEDEF_(0x80028CA3L)
#define TYPE_E_CANTLOADLIBRARY  _HRESULT_TYPEDEF_(0x80029C4AL)
#define TYPE_E_INCONSISTENTPROPFUNCS  _HRESULT_TYPEDEF_(0x80029C83L)
#define TYPE_E_CIRCULARTYPE  _HRESULT_TYPEDEF_(0x80029C84L)
#define STG_E_INVALIDFUNCTION  _HRESULT_TYPEDEF_(0x80030001L)
#define STG_E_FILENOTFOUND  _HRESULT_TYPEDEF_(0x80030002L)
#define STG_E_PATHNOTFOUND  _HRESULT_TYPEDEF_(0x80030003L)
#define STG_E_TOOMANYOPENFILES  _HRESULT_TYPEDEF_(0x80030004L)
#define STG_E_ACCESSDENIED  _HRESULT_TYPEDEF_(0x80030005L)
#define STG_E_INVALIDHANDLE  _HRESULT_TYPEDEF_(0x80030006L)
#define STG_E_INSUFFICIENTMEMORY  _HRESULT_TYPEDEF_(0x80030008L)
#define STG_E_INVALIDPOINTER  _HRESULT_TYPEDEF_(0x80030009L)
#define STG_E_NOMOREFILES  _HRESULT_TYPEDEF_(0x80030012L)
#define STG_E_DISKISWRITEPROTECTED  _HRESULT_TYPEDEF_(0x80030013L)
#define STG_E_SEEKERROR  _HRESULT_TYPEDEF_(0x80030019L)
#define STG_E_WRITEFAULT  _HRESULT_TYPEDEF_(0x8003001DL)
#define STG_E_READFAULT  _HRESULT_TYPEDEF_(0x8003001EL)
#define STG_E_SHAREVIOLATION  _HRESULT_TYPEDEF_(0x80030020L)
#define STG_E_LOCKVIOLATION  _HRESULT_TYPEDEF_(0x80030021L)
#define STG_E_FILEALREADYEXISTS  _HRESULT_TYPEDEF_(0x80030050L)
#define STG_E_INVALIDPARAMETER  _HRESULT_TYPEDEF_(0x80030057L)
#define STG_E_MEDIUMFULL  _HRESULT_TYPEDEF_(0x80030070L)
#define STG_E_PROPSETMISMATCHED  _HRESULT_TYPEDEF_(0x800300F0L)
#define STG_E_ABNORMALAPIEXIT  _HRESULT_TYPEDEF_(0x800300FAL)
#define STG_E_INVALIDHEADER  _HRESULT_TYPEDEF_(0x800300FBL)
#define STG_E_INVALIDNAME  _HRESULT_TYPEDEF_(0x800300FCL)
#define STG_E_UNKNOWN  _HRESULT_TYPEDEF_(0x800300FDL)
#define STG_E_UNIMPLEMENTEDFUNCTION  _HRESULT_TYPEDEF_(0x800300FEL)
#define STG_E_INVALIDFLAG  _HRESULT_TYPEDEF_(0x800300FFL)
#define STG_E_INUSE  _HRESULT_TYPEDEF_(0x80030100L)
#define STG_E_NOTCURRENT  _HRESULT_TYPEDEF_(0x80030101L)
#define STG_E_REVERTED  _HRESULT_TYPEDEF_(0x80030102L)
#define STG_E_CANTSAVE  _HRESULT_TYPEDEF_(0x80030103L)
#define STG_E_OLDFORMAT  _HRESULT_TYPEDEF_(0x80030104L)
#define STG_E_OLDDLL  _HRESULT_TYPEDEF_(0x80030105L)
#define STG_E_SHAREREQUIRED  _HRESULT_TYPEDEF_(0x80030106L)
#define STG_E_NOTFILEBASEDSTORAGE  _HRESULT_TYPEDEF_(0x80030107L)
#define STG_E_EXTANTMARSHALLINGS  _HRESULT_TYPEDEF_(0x80030108L)
#define STG_E_DOCFILECORRUPT  _HRESULT_TYPEDEF_(0x80030109L)
#define STG_E_BADBASEADDRESS  _HRESULT_TYPEDEF_(0x80030110L)
#define STG_E_DOCFILETOOLARGE  _HRESULT_TYPEDEF_(0x80030111L)
#define STG_E_NOTSIMPLEFORMAT  _HRESULT_TYPEDEF_(0x80030112L)
#define STG_E_INCOMPLETE  _HRESULT_TYPEDEF_(0x80030201L)
#define STG_E_TERMINATED  _HRESULT_TYPEDEF_(0x80030202L)
#define STG_S_CONVERTED  _HRESULT_TYPEDEF_(0x00030200L)
#define STG_S_BLOCK  _HRESULT_TYPEDEF_(0x00030201L)
#define STG_S_RETRYNOW  _HRESULT_TYPEDEF_(0x00030202L)
#define STG_S_MONITORING  _HRESULT_TYPEDEF_(0x00030203L)
#define STG_S_MULTIPLEOPENS  _HRESULT_TYPEDEF_(0x00030204L)
#define STG_S_CONSOLIDATIONFAILED  _HRESULT_TYPEDEF_(0x00030205L)
#define STG_S_CANNOTCONSOLIDATE  _HRESULT_TYPEDEF_(0x00030206L)
#define STG_S_POWER_CYCLE_REQUIRED  _HRESULT_TYPEDEF_(0x00030207L)
#define STG_E_FIRMWARE_SLOT_INVALID  _HRESULT_TYPEDEF_(0x80030208L)
#define STG_E_FIRMWARE_IMAGE_INVALID  _HRESULT_TYPEDEF_(0x80030209L)
#define STG_E_DEVICE_UNRESPONSIVE  _HRESULT_TYPEDEF_(0x8003020AL)
#define STG_E_STATUS_COPY_PROTECTION_FAILURE _HRESULT_TYPEDEF_(0x80030305L)
#define STG_E_CSS_AUTHENTICATION_FAILURE _HRESULT_TYPEDEF_(0x80030306L)
#define STG_E_CSS_KEY_NOT_PRESENT  _HRESULT_TYPEDEF_(0x80030307L)
#define STG_E_CSS_KEY_NOT_ESTABLISHED  _HRESULT_TYPEDEF_(0x80030308L)
#define STG_E_CSS_SCRAMBLED_SECTOR  _HRESULT_TYPEDEF_(0x80030309L)
#define STG_E_CSS_REGION_MISMATCH  _HRESULT_TYPEDEF_(0x8003030AL)
#define STG_E_RESETS_EXHAUSTED  _HRESULT_TYPEDEF_(0x8003030BL)
#define RPC_E_CALL_REJECTED  _HRESULT_TYPEDEF_(0x80010001L)
#define RPC_E_CALL_CANCELED  _HRESULT_TYPEDEF_(0x80010002L)
#define RPC_E_CANTPOST_INSENDCALL  _HRESULT_TYPEDEF_(0x80010003L)
#define RPC_E_CANTCALLOUT_INASYNCCALL  _HRESULT_TYPEDEF_(0x80010004L)
#define RPC_E_CANTCALLOUT_INEXTERNALCALL _HRESULT_TYPEDEF_(0x80010005L)
#define RPC_E_CONNECTION_TERMINATED  _HRESULT_TYPEDEF_(0x80010006L)
#define RPC_E_SERVER_DIED  _HRESULT_TYPEDEF_(0x80010007L)
#define RPC_E_CLIENT_DIED  _HRESULT_TYPEDEF_(0x80010008L)
#define RPC_E_INVALID_DATAPACKET  _HRESULT_TYPEDEF_(0x80010009L)
#define RPC_E_CANTTRANSMIT_CALL  _HRESULT_TYPEDEF_(0x8001000AL)
#define RPC_E_CLIENT_CANTMARSHAL_DATA  _HRESULT_TYPEDEF_(0x8001000BL)
#define RPC_E_CLIENT_CANTUNMARSHAL_DATA  _HRESULT_TYPEDEF_(0x8001000CL)
#define RPC_E_SERVER_CANTMARSHAL_DATA  _HRESULT_TYPEDEF_(0x8001000DL)
#define RPC_E_SERVER_CANTUNMARSHAL_DATA  _HRESULT_TYPEDEF_(0x8001000EL)
#define RPC_E_INVALID_DATA  _HRESULT_TYPEDEF_(0x8001000FL)
#define RPC_E_INVALID_PARAMETER  _HRESULT_TYPEDEF_(0x80010010L)
#define RPC_E_CANTCALLOUT_AGAIN  _HRESULT_TYPEDEF_(0x80010011L)
#define RPC_E_SERVER_DIED_DNE  _HRESULT_TYPEDEF_(0x80010012L)
#define RPC_E_SYS_CALL_FAILED  _HRESULT_TYPEDEF_(0x80010100L)
#define RPC_E_OUT_OF_RESOURCES  _HRESULT_TYPEDEF_(0x80010101L)
#define RPC_E_ATTEMPTED_MULTITHREAD  _HRESULT_TYPEDEF_(0x80010102L)
#define RPC_E_NOT_REGISTERED  _HRESULT_TYPEDEF_(0x80010103L)
#define RPC_E_FAULT  _HRESULT_TYPEDEF_(0x80010104L)
#define RPC_E_SERVERFAULT  _HRESULT_TYPEDEF_(0x80010105L)
#define RPC_E_CHANGED_MODE  _HRESULT_TYPEDEF_(0x80010106L)
#define RPC_E_INVALIDMETHOD  _HRESULT_TYPEDEF_(0x80010107L)
#define RPC_E_DISCONNECTED  _HRESULT_TYPEDEF_(0x80010108L)
#define RPC_E_RETRY  _HRESULT_TYPEDEF_(0x80010109L)
#define RPC_E_SERVERCALL_RETRYLATER  _HRESULT_TYPEDEF_(0x8001010AL)
#define RPC_E_SERVERCALL_REJECTED  _HRESULT_TYPEDEF_(0x8001010BL)
#define RPC_E_INVALID_CALLDATA  _HRESULT_TYPEDEF_(0x8001010CL)
#define RPC_E_CANTCALLOUT_ININPUTSYNCCALL _HRESULT_TYPEDEF_(0x8001010DL)
#define RPC_E_WRONG_THREAD  _HRESULT_TYPEDEF_(0x8001010EL)
#define RPC_E_THREAD_NOT_INIT  _HRESULT_TYPEDEF_(0x8001010FL)
#define RPC_E_VERSION_MISMATCH  _HRESULT_TYPEDEF_(0x80010110L)
#define RPC_E_INVALID_HEADER  _HRESULT_TYPEDEF_(0x80010111L)
#define RPC_E_INVALID_EXTENSION  _HRESULT_TYPEDEF_(0x80010112L)
#define RPC_E_INVALID_IPID  _HRESULT_TYPEDEF_(0x80010113L)
#define RPC_E_INVALID_OBJECT  _HRESULT_TYPEDEF_(0x80010114L)
#define RPC_S_CALLPENDING  _HRESULT_TYPEDEF_(0x80010115L)
#define RPC_S_WAITONTIMER  _HRESULT_TYPEDEF_(0x80010116L)
#define RPC_E_CALL_COMPLETE  _HRESULT_TYPEDEF_(0x80010117L)
#define RPC_E_UNSECURE_CALL  _HRESULT_TYPEDEF_(0x80010118L)
#define RPC_E_TOO_LATE  _HRESULT_TYPEDEF_(0x80010119L)
#define RPC_E_NO_GOOD_SECURITY_PACKAGES  _HRESULT_TYPEDEF_(0x8001011AL)
#define RPC_E_ACCESS_DENIED  _HRESULT_TYPEDEF_(0x8001011BL)
#define RPC_E_REMOTE_DISABLED  _HRESULT_TYPEDEF_(0x8001011CL)
#define RPC_E_INVALID_OBJREF  _HRESULT_TYPEDEF_(0x8001011DL)
#define RPC_E_NO_CONTEXT  _HRESULT_TYPEDEF_(0x8001011EL)
#define RPC_E_TIMEOUT  _HRESULT_TYPEDEF_(0x8001011FL)
#define RPC_E_NO_SYNC  _HRESULT_TYPEDEF_(0x80010120L)
#define RPC_E_FULLSIC_REQUIRED  _HRESULT_TYPEDEF_(0x80010121L)
#define RPC_E_INVALID_STD_NAME  _HRESULT_TYPEDEF_(0x80010122L)
#define CO_E_FAILEDTOIMPERSONATE  _HRESULT_TYPEDEF_(0x80010123L)
#define CO_E_FAILEDTOGETSECCTX  _HRESULT_TYPEDEF_(0x80010124L)
#define CO_E_FAILEDTOOPENTHREADTOKEN  _HRESULT_TYPEDEF_(0x80010125L)
#define CO_E_FAILEDTOGETTOKENINFO  _HRESULT_TYPEDEF_(0x80010126L)
#define CO_E_TRUSTEEDOESNTMATCHCLIENT  _HRESULT_TYPEDEF_(0x80010127L)
#define CO_E_FAILEDTOQUERYCLIENTBLANKET  _HRESULT_TYPEDEF_(0x80010128L)
#define CO_E_FAILEDTOSETDACL  _HRESULT_TYPEDEF_(0x80010129L)
#define CO_E_ACCESSCHECKFAILED  _HRESULT_TYPEDEF_(0x8001012AL)
#define CO_E_NETACCESSAPIFAILED  _HRESULT_TYPEDEF_(0x8001012BL)
#define CO_E_WRONGTRUSTEENAMESYNTAX  _HRESULT_TYPEDEF_(0x8001012CL)
#define CO_E_INVALIDSID  _HRESULT_TYPEDEF_(0x8001012DL)
#define CO_E_CONVERSIONFAILED  _HRESULT_TYPEDEF_(0x8001012EL)
#define CO_E_NOMATCHINGSIDFOUND  _HRESULT_TYPEDEF_(0x8001012FL)
#define CO_E_LOOKUPACCSIDFAILED  _HRESULT_TYPEDEF_(0x80010130L)
#define CO_E_NOMATCHINGNAMEFOUND  _HRESULT_TYPEDEF_(0x80010131L)
#define CO_E_LOOKUPACCNAMEFAILED  _HRESULT_TYPEDEF_(0x80010132L)
#define CO_E_SETSERLHNDLFAILED  _HRESULT_TYPEDEF_(0x80010133L)
#define CO_E_FAILEDTOGETWINDIR  _HRESULT_TYPEDEF_(0x80010134L)
#define CO_E_PATHTOOLONG  _HRESULT_TYPEDEF_(0x80010135L)
#define CO_E_FAILEDTOGENUUID  _HRESULT_TYPEDEF_(0x80010136L)
#define CO_E_FAILEDTOCREATEFILE  _HRESULT_TYPEDEF_(0x80010137L)
#define CO_E_FAILEDTOCLOSEHANDLE  _HRESULT_TYPEDEF_(0x80010138L)
#define CO_E_EXCEEDSYSACLLIMIT  _HRESULT_TYPEDEF_(0x80010139L)
#define CO_E_ACESINWRONGORDER  _HRESULT_TYPEDEF_(0x8001013AL)
#define CO_E_INCOMPATIBLESTREAMVERSION  _HRESULT_TYPEDEF_(0x8001013BL)
#define CO_E_FAILEDTOOPENPROCESSTOKEN  _HRESULT_TYPEDEF_(0x8001013CL)
#define CO_E_DECODEFAILED  _HRESULT_TYPEDEF_(0x8001013DL)
#define CO_E_ACNOTINITIALIZED  _HRESULT_TYPEDEF_(0x8001013FL)
#define CO_E_CANCEL_DISABLED  _HRESULT_TYPEDEF_(0x80010140L)
#define RPC_E_UNEXPECTED  _HRESULT_TYPEDEF_(0x8001FFFFL)
#define ERROR_AUDITING_DISABLED  _HRESULT_TYPEDEF_(0xC0090001L)
#define ERROR_ALL_SIDS_FILTERED  _HRESULT_TYPEDEF_(0xC0090002L)
#define ERROR_BIZRULES_NOT_ENABLED  _HRESULT_TYPEDEF_(0xC0090003L)
#define NTE_BAD_UID  _HRESULT_TYPEDEF_(0x80090001L)
#define NTE_BAD_HASH  _HRESULT_TYPEDEF_(0x80090002L)
#define NTE_BAD_KEY  _HRESULT_TYPEDEF_(0x80090003L)
#define NTE_BAD_LEN  _HRESULT_TYPEDEF_(0x80090004L)
#define NTE_BAD_DATA  _HRESULT_TYPEDEF_(0x80090005L)
#define NTE_BAD_SIGNATURE  _HRESULT_TYPEDEF_(0x80090006L)
#define NTE_BAD_VER  _HRESULT_TYPEDEF_(0x80090007L)
#define NTE_BAD_ALGID  _HRESULT_TYPEDEF_(0x80090008L)
#define NTE_BAD_FLAGS  _HRESULT_TYPEDEF_(0x80090009L)
#define NTE_BAD_TYPE  _HRESULT_TYPEDEF_(0x8009000AL)
#define NTE_BAD_KEY_STATE  _HRESULT_TYPEDEF_(0x8009000BL)
#define NTE_BAD_HASH_STATE  _HRESULT_TYPEDEF_(0x8009000CL)
#define NTE_NO_KEY  _HRESULT_TYPEDEF_(0x8009000DL)
#define NTE_NO_MEMORY  _HRESULT_TYPEDEF_(0x8009000EL)
#define NTE_EXISTS  _HRESULT_TYPEDEF_(0x8009000FL)
#define NTE_PERM  _HRESULT_TYPEDEF_(0x80090010L)
#define NTE_NOT_FOUND  _HRESULT_TYPEDEF_(0x80090011L)
#define NTE_DOUBLE_ENCRYPT  _HRESULT_TYPEDEF_(0x80090012L)
#define NTE_BAD_PROVIDER  _HRESULT_TYPEDEF_(0x80090013L)
#define NTE_BAD_PROV_TYPE  _HRESULT_TYPEDEF_(0x80090014L)
#define NTE_BAD_PUBLIC_KEY  _HRESULT_TYPEDEF_(0x80090015L)
#define NTE_BAD_KEYSET  _HRESULT_TYPEDEF_(0x80090016L)
#define NTE_PROV_TYPE_NOT_DEF  _HRESULT_TYPEDEF_(0x80090017L)
#define NTE_PROV_TYPE_ENTRY_BAD  _HRESULT_TYPEDEF_(0x80090018L)
#define NTE_KEYSET_NOT_DEF  _HRESULT_TYPEDEF_(0x80090019L)
#define NTE_KEYSET_ENTRY_BAD  _HRESULT_TYPEDEF_(0x8009001AL)
#define NTE_PROV_TYPE_NO_MATCH  _HRESULT_TYPEDEF_(0x8009001BL)
#define NTE_SIGNATURE_FILE_BAD  _HRESULT_TYPEDEF_(0x8009001CL)
#define NTE_PROVIDER_DLL_FAIL  _HRESULT_TYPEDEF_(0x8009001DL)
#define NTE_PROV_DLL_NOT_FOUND  _HRESULT_TYPEDEF_(0x8009001EL)
#define NTE_BAD_KEYSET_PARAM  _HRESULT_TYPEDEF_(0x8009001FL)
#define NTE_FAIL  _HRESULT_TYPEDEF_(0x80090020L)
#define NTE_SYS_ERR  _HRESULT_TYPEDEF_(0x80090021L)
#define NTE_SILENT_CONTEXT  _HRESULT_TYPEDEF_(0x80090022L)
#define NTE_TOKEN_KEYSET_STORAGE_FULL  _HRESULT_TYPEDEF_(0x80090023L)
#define NTE_TEMPORARY_PROFILE  _HRESULT_TYPEDEF_(0x80090024L)
#define NTE_FIXEDPARAMETER  _HRESULT_TYPEDEF_(0x80090025L)
#define NTE_INVALID_HANDLE  _HRESULT_TYPEDEF_(0x80090026L)
#define NTE_INVALID_PARAMETER  _HRESULT_TYPEDEF_(0x80090027L)
#define NTE_BUFFER_TOO_SMALL  _HRESULT_TYPEDEF_(0x80090028L)
#define NTE_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x80090029L)
#define NTE_NO_MORE_ITEMS  _HRESULT_TYPEDEF_(0x8009002AL)
#define NTE_BUFFERS_OVERLAP  _HRESULT_TYPEDEF_(0x8009002BL)
#define NTE_DECRYPTION_FAILURE  _HRESULT_TYPEDEF_(0x8009002CL)
#define NTE_INTERNAL_ERROR  _HRESULT_TYPEDEF_(0x8009002DL)
#define NTE_UI_REQUIRED  _HRESULT_TYPEDEF_(0x8009002EL)
#define NTE_HMAC_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x8009002FL)
#define NTE_DEVICE_NOT_READY  _HRESULT_TYPEDEF_(0x80090030L)
#define NTE_AUTHENTICATION_IGNORED  _HRESULT_TYPEDEF_(0x80090031L)
#define NTE_VALIDATION_FAILED  _HRESULT_TYPEDEF_(0x80090032L)
#define NTE_INCORRECT_PASSWORD  _HRESULT_TYPEDEF_(0x80090033L)
#define NTE_ENCRYPTION_FAILURE  _HRESULT_TYPEDEF_(0x80090034L)
#define NTE_DEVICE_NOT_FOUND  _HRESULT_TYPEDEF_(0x80090035L)
#define NTE_USER_CANCELLED  _HRESULT_TYPEDEF_(0x80090036L)
#define NTE_PASSWORD_CHANGE_REQUIRED  _HRESULT_TYPEDEF_(0x80090037L)
#define NTE_NOT_ACTIVE_CONSOLE  _HRESULT_TYPEDEF_(0x80090038L)
#define SEC_E_INSUFFICIENT_MEMORY  _HRESULT_TYPEDEF_(0x80090300L)
#define SEC_E_INVALID_HANDLE  _HRESULT_TYPEDEF_(0x80090301L)
#define SEC_E_UNSUPPORTED_FUNCTION  _HRESULT_TYPEDEF_(0x80090302L)
#define SEC_E_TARGET_UNKNOWN  _HRESULT_TYPEDEF_(0x80090303L)
#define SEC_E_INTERNAL_ERROR  _HRESULT_TYPEDEF_(0x80090304L)
#define SEC_E_SECPKG_NOT_FOUND  _HRESULT_TYPEDEF_(0x80090305L)
#define SEC_E_NOT_OWNER  _HRESULT_TYPEDEF_(0x80090306L)
#define SEC_E_CANNOT_INSTALL  _HRESULT_TYPEDEF_(0x80090307L)
#define SEC_E_INVALID_TOKEN  _HRESULT_TYPEDEF_(0x80090308L)
#define SEC_E_CANNOT_PACK  _HRESULT_TYPEDEF_(0x80090309L)
#define SEC_E_QOP_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x8009030AL)
#define SEC_E_NO_IMPERSONATION  _HRESULT_TYPEDEF_(0x8009030BL)
#define SEC_E_LOGON_DENIED  _HRESULT_TYPEDEF_(0x8009030CL)
#define SEC_E_UNKNOWN_CREDENTIALS  _HRESULT_TYPEDEF_(0x8009030DL)
#define SEC_E_NO_CREDENTIALS  _HRESULT_TYPEDEF_(0x8009030EL)
#define SEC_E_MESSAGE_ALTERED  _HRESULT_TYPEDEF_(0x8009030FL)
#define SEC_E_OUT_OF_SEQUENCE  _HRESULT_TYPEDEF_(0x80090310L)
#define SEC_E_NO_AUTHENTICATING_AUTHORITY _HRESULT_TYPEDEF_(0x80090311L)
#define SEC_I_CONTINUE_NEEDED  _HRESULT_TYPEDEF_(0x00090312L)
#define SEC_I_COMPLETE_NEEDED  _HRESULT_TYPEDEF_(0x00090313L)
#define SEC_I_COMPLETE_AND_CONTINUE  _HRESULT_TYPEDEF_(0x00090314L)
#define SEC_I_LOCAL_LOGON  _HRESULT_TYPEDEF_(0x00090315L)
#define SEC_E_BAD_PKGID  _HRESULT_TYPEDEF_(0x80090316L)
#define SEC_E_CONTEXT_EXPIRED  _HRESULT_TYPEDEF_(0x80090317L)
#define SEC_I_CONTEXT_EXPIRED  _HRESULT_TYPEDEF_(0x00090317L)
#define SEC_E_INCOMPLETE_MESSAGE  _HRESULT_TYPEDEF_(0x80090318L)
#define SEC_E_INCOMPLETE_CREDENTIALS  _HRESULT_TYPEDEF_(0x80090320L)
#define SEC_E_BUFFER_TOO_SMALL  _HRESULT_TYPEDEF_(0x80090321L)
#define SEC_I_INCOMPLETE_CREDENTIALS  _HRESULT_TYPEDEF_(0x00090320L)
#define SEC_I_RENEGOTIATE  _HRESULT_TYPEDEF_(0x00090321L)
#define SEC_E_WRONG_PRINCIPAL  _HRESULT_TYPEDEF_(0x80090322L)
#define SEC_I_NO_LSA_CONTEXT  _HRESULT_TYPEDEF_(0x00090323L)
#define SEC_E_TIME_SKEW  _HRESULT_TYPEDEF_(0x80090324L)
#define SEC_E_UNTRUSTED_ROOT  _HRESULT_TYPEDEF_(0x80090325L)
#define SEC_E_ILLEGAL_MESSAGE  _HRESULT_TYPEDEF_(0x80090326L)
#define SEC_E_CERT_UNKNOWN  _HRESULT_TYPEDEF_(0x80090327L)
#define SEC_E_CERT_EXPIRED  _HRESULT_TYPEDEF_(0x80090328L)
#define SEC_E_ENCRYPT_FAILURE  _HRESULT_TYPEDEF_(0x80090329L)
#define SEC_E_DECRYPT_FAILURE  _HRESULT_TYPEDEF_(0x80090330L)
#define SEC_E_ALGORITHM_MISMATCH  _HRESULT_TYPEDEF_(0x80090331L)
#define SEC_E_SECURITY_QOS_FAILED  _HRESULT_TYPEDEF_(0x80090332L)
#define SEC_E_UNFINISHED_CONTEXT_DELETED _HRESULT_TYPEDEF_(0x80090333L)
#define SEC_E_NO_TGT_REPLY  _HRESULT_TYPEDEF_(0x80090334L)
#define SEC_E_NO_IP_ADDRESSES  _HRESULT_TYPEDEF_(0x80090335L)
#define SEC_E_WRONG_CREDENTIAL_HANDLE  _HRESULT_TYPEDEF_(0x80090336L)
#define SEC_E_CRYPTO_SYSTEM_INVALID  _HRESULT_TYPEDEF_(0x80090337L)
#define SEC_E_MAX_REFERRALS_EXCEEDED  _HRESULT_TYPEDEF_(0x80090338L)
#define SEC_E_MUST_BE_KDC  _HRESULT_TYPEDEF_(0x80090339L)
#define SEC_E_STRONG_CRYPTO_NOT_SUPPORTED _HRESULT_TYPEDEF_(0x8009033AL)
#define SEC_E_TOO_MANY_PRINCIPALS  _HRESULT_TYPEDEF_(0x8009033BL)
#define SEC_E_NO_PA_DATA  _HRESULT_TYPEDEF_(0x8009033CL)
#define SEC_E_PKINIT_NAME_MISMATCH  _HRESULT_TYPEDEF_(0x8009033DL)
#define SEC_E_SMARTCARD_LOGON_REQUIRED  _HRESULT_TYPEDEF_(0x8009033EL)
#define SEC_E_SHUTDOWN_IN_PROGRESS  _HRESULT_TYPEDEF_(0x8009033FL)
#define SEC_E_KDC_INVALID_REQUEST  _HRESULT_TYPEDEF_(0x80090340L)
#define SEC_E_KDC_UNABLE_TO_REFER  _HRESULT_TYPEDEF_(0x80090341L)
#define SEC_E_KDC_UNKNOWN_ETYPE  _HRESULT_TYPEDEF_(0x80090342L)
#define SEC_E_UNSUPPORTED_PREAUTH  _HRESULT_TYPEDEF_(0x80090343L)
#define SEC_E_DELEGATION_REQUIRED  _HRESULT_TYPEDEF_(0x80090345L)
#define SEC_E_BAD_BINDINGS  _HRESULT_TYPEDEF_(0x80090346L)
#define SEC_E_MULTIPLE_ACCOUNTS  _HRESULT_TYPEDEF_(0x80090347L)
#define SEC_E_NO_KERB_KEY  _HRESULT_TYPEDEF_(0x80090348L)
#define SEC_E_CERT_WRONG_USAGE  _HRESULT_TYPEDEF_(0x80090349L)
#define SEC_E_DOWNGRADE_DETECTED  _HRESULT_TYPEDEF_(0x80090350L)
#define SEC_E_SMARTCARD_CERT_REVOKED  _HRESULT_TYPEDEF_(0x80090351L)
#define SEC_E_ISSUING_CA_UNTRUSTED  _HRESULT_TYPEDEF_(0x80090352L)
#define SEC_E_REVOCATION_OFFLINE_C  _HRESULT_TYPEDEF_(0x80090353L)
#define SEC_E_PKINIT_CLIENT_FAILURE  _HRESULT_TYPEDEF_(0x80090354L)
#define SEC_E_SMARTCARD_CERT_EXPIRED  _HRESULT_TYPEDEF_(0x80090355L)
#define SEC_E_NO_S4U_PROT_SUPPORT  _HRESULT_TYPEDEF_(0x80090356L)
#define SEC_E_CROSSREALM_DELEGATION_FAILURE _HRESULT_TYPEDEF_(0x80090357L)
#define SEC_E_REVOCATION_OFFLINE_KDC  _HRESULT_TYPEDEF_(0x80090358L)
#define SEC_E_ISSUING_CA_UNTRUSTED_KDC  _HRESULT_TYPEDEF_(0x80090359L)
#define SEC_E_KDC_CERT_EXPIRED  _HRESULT_TYPEDEF_(0x8009035AL)
#define SEC_E_KDC_CERT_REVOKED  _HRESULT_TYPEDEF_(0x8009035BL)
#define SEC_I_SIGNATURE_NEEDED  _HRESULT_TYPEDEF_(0x0009035CL)
#define SEC_E_INVALID_PARAMETER  _HRESULT_TYPEDEF_(0x8009035DL)
#define SEC_E_DELEGATION_POLICY  _HRESULT_TYPEDEF_(0x8009035EL)
#define SEC_E_POLICY_NLTM_ONLY  _HRESULT_TYPEDEF_(0x8009035FL)
#define SEC_I_NO_RENEGOTIATION  _HRESULT_TYPEDEF_(0x00090360L)
#define SEC_E_NO_CONTEXT  _HRESULT_TYPEDEF_(0x80090361L)
#define SEC_E_PKU2U_CERT_FAILURE  _HRESULT_TYPEDEF_(0x80090362L)
#define SEC_E_MUTUAL_AUTH_FAILED  _HRESULT_TYPEDEF_(0x80090363L)
#define SEC_I_MESSAGE_FRAGMENT  _HRESULT_TYPEDEF_(0x00090364L)
#define SEC_E_ONLY_HTTPS_ALLOWED  _HRESULT_TYPEDEF_(0x80090365L)
#define SEC_I_CONTINUE_NEEDED_MESSAGE_OK _HRESULT_TYPEDEF_(0x00090366L)
#define SEC_E_APPLICATION_PROTOCOL_MISMATCH _HRESULT_TYPEDEF_(0x80090367L)
#define SEC_I_ASYNC_CALL_PENDING  _HRESULT_TYPEDEF_(0x00090368L)
#define SEC_E_INVALID_UPN_NAME  _HRESULT_TYPEDEF_(0x80090369L)
#define SEC_E_NO_SPM SEC_E_INTERNAL_ERROR
#define SEC_E_NOT_SUPPORTED SEC_E_UNSUPPORTED_FUNCTION
#define CRYPT_E_MSG_ERROR  _HRESULT_TYPEDEF_(0x80091001L)
#define CRYPT_E_UNKNOWN_ALGO  _HRESULT_TYPEDEF_(0x80091002L)
#define CRYPT_E_OID_FORMAT  _HRESULT_TYPEDEF_(0x80091003L)
#define CRYPT_E_INVALID_MSG_TYPE  _HRESULT_TYPEDEF_(0x80091004L)
#define CRYPT_E_UNEXPECTED_ENCODING  _HRESULT_TYPEDEF_(0x80091005L)
#define CRYPT_E_AUTH_ATTR_MISSING  _HRESULT_TYPEDEF_(0x80091006L)
#define CRYPT_E_HASH_VALUE  _HRESULT_TYPEDEF_(0x80091007L)
#define CRYPT_E_INVALID_INDEX  _HRESULT_TYPEDEF_(0x80091008L)
#define CRYPT_E_ALREADY_DECRYPTED  _HRESULT_TYPEDEF_(0x80091009L)
#define CRYPT_E_NOT_DECRYPTED  _HRESULT_TYPEDEF_(0x8009100AL)
#define CRYPT_E_RECIPIENT_NOT_FOUND  _HRESULT_TYPEDEF_(0x8009100BL)
#define CRYPT_E_CONTROL_TYPE  _HRESULT_TYPEDEF_(0x8009100CL)
#define CRYPT_E_ISSUER_SERIALNUMBER  _HRESULT_TYPEDEF_(0x8009100DL)
#define CRYPT_E_SIGNER_NOT_FOUND  _HRESULT_TYPEDEF_(0x8009100EL)
#define CRYPT_E_ATTRIBUTES_MISSING  _HRESULT_TYPEDEF_(0x8009100FL)
#define CRYPT_E_STREAM_MSG_NOT_READY  _HRESULT_TYPEDEF_(0x80091010L)
#define CRYPT_E_STREAM_INSUFFICIENT_DATA _HRESULT_TYPEDEF_(0x80091011L)
#define CRYPT_I_NEW_PROTECTION_REQUIRED  _HRESULT_TYPEDEF_(0x00091012L)
#define CRYPT_E_BAD_LEN  _HRESULT_TYPEDEF_(0x80092001L)
#define CRYPT_E_BAD_ENCODE  _HRESULT_TYPEDEF_(0x80092002L)
#define CRYPT_E_FILE_ERROR  _HRESULT_TYPEDEF_(0x80092003L)
#define CRYPT_E_NOT_FOUND  _HRESULT_TYPEDEF_(0x80092004L)
#define CRYPT_E_EXISTS  _HRESULT_TYPEDEF_(0x80092005L)
#define CRYPT_E_NO_PROVIDER  _HRESULT_TYPEDEF_(0x80092006L)
#define CRYPT_E_SELF_SIGNED  _HRESULT_TYPEDEF_(0x80092007L)
#define CRYPT_E_DELETED_PREV  _HRESULT_TYPEDEF_(0x80092008L)
#define CRYPT_E_NO_MATCH  _HRESULT_TYPEDEF_(0x80092009L)
#define CRYPT_E_UNEXPECTED_MSG_TYPE  _HRESULT_TYPEDEF_(0x8009200AL)
#define CRYPT_E_NO_KEY_PROPERTY  _HRESULT_TYPEDEF_(0x8009200BL)
#define CRYPT_E_NO_DECRYPT_CERT  _HRESULT_TYPEDEF_(0x8009200CL)
#define CRYPT_E_BAD_MSG  _HRESULT_TYPEDEF_(0x8009200DL)
#define CRYPT_E_NO_SIGNER  _HRESULT_TYPEDEF_(0x8009200EL)
#define CRYPT_E_PENDING_CLOSE  _HRESULT_TYPEDEF_(0x8009200FL)
#define CRYPT_E_REVOKED  _HRESULT_TYPEDEF_(0x80092010L)
#define CRYPT_E_NO_REVOCATION_DLL  _HRESULT_TYPEDEF_(0x80092011L)
#define CRYPT_E_NO_REVOCATION_CHECK  _HRESULT_TYPEDEF_(0x80092012L)
#define CRYPT_E_REVOCATION_OFFLINE  _HRESULT_TYPEDEF_(0x80092013L)
#define CRYPT_E_NOT_IN_REVOCATION_DATABASE _HRESULT_TYPEDEF_(0x80092014L)
#define CRYPT_E_INVALID_NUMERIC_STRING  _HRESULT_TYPEDEF_(0x80092020L)
#define CRYPT_E_INVALID_PRINTABLE_STRING _HRESULT_TYPEDEF_(0x80092021L)
#define CRYPT_E_INVALID_IA5_STRING  _HRESULT_TYPEDEF_(0x80092022L)
#define CRYPT_E_INVALID_X500_STRING  _HRESULT_TYPEDEF_(0x80092023L)
#define CRYPT_E_NOT_CHAR_STRING  _HRESULT_TYPEDEF_(0x80092024L)
#define CRYPT_E_FILERESIZED  _HRESULT_TYPEDEF_(0x80092025L)
#define CRYPT_E_SECURITY_SETTINGS  _HRESULT_TYPEDEF_(0x80092026L)
#define CRYPT_E_NO_VERIFY_USAGE_DLL  _HRESULT_TYPEDEF_(0x80092027L)
#define CRYPT_E_NO_VERIFY_USAGE_CHECK  _HRESULT_TYPEDEF_(0x80092028L)
#define CRYPT_E_VERIFY_USAGE_OFFLINE  _HRESULT_TYPEDEF_(0x80092029L)
#define CRYPT_E_NOT_IN_CTL  _HRESULT_TYPEDEF_(0x8009202AL)
#define CRYPT_E_NO_TRUSTED_SIGNER  _HRESULT_TYPEDEF_(0x8009202BL)
#define CRYPT_E_MISSING_PUBKEY_PARA  _HRESULT_TYPEDEF_(0x8009202CL)
#define CRYPT_E_OBJECT_LOCATOR_OBJECT_NOT_FOUND _HRESULT_TYPEDEF_(0x8009202DL)
#define CRYPT_E_OSS_ERROR  _HRESULT_TYPEDEF_(0x80093000L)
#define OSS_MORE_BUF  _HRESULT_TYPEDEF_(0x80093001L)
#define OSS_NEGATIVE_UINTEGER  _HRESULT_TYPEDEF_(0x80093002L)
#define OSS_PDU_RANGE  _HRESULT_TYPEDEF_(0x80093003L)
#define OSS_MORE_INPUT  _HRESULT_TYPEDEF_(0x80093004L)
#define OSS_DATA_ERROR  _HRESULT_TYPEDEF_(0x80093005L)
#define OSS_BAD_ARG  _HRESULT_TYPEDEF_(0x80093006L)
#define OSS_BAD_VERSION  _HRESULT_TYPEDEF_(0x80093007L)
#define OSS_OUT_MEMORY  _HRESULT_TYPEDEF_(0x80093008L)
#define OSS_PDU_MISMATCH  _HRESULT_TYPEDEF_(0x80093009L)
#define OSS_LIMITED  _HRESULT_TYPEDEF_(0x8009300AL)
#define OSS_BAD_PTR  _HRESULT_TYPEDEF_(0x8009300BL)
#define OSS_BAD_TIME  _HRESULT_TYPEDEF_(0x8009300CL)
#define OSS_INDEFINITE_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x8009300DL)
#define OSS_MEM_ERROR  _HRESULT_TYPEDEF_(0x8009300EL)
#define OSS_BAD_TABLE  _HRESULT_TYPEDEF_(0x8009300FL)
#define OSS_TOO_LONG  _HRESULT_TYPEDEF_(0x80093010L)
#define OSS_CONSTRAINT_VIOLATED  _HRESULT_TYPEDEF_(0x80093011L)
#define OSS_FATAL_ERROR  _HRESULT_TYPEDEF_(0x80093012L)
#define OSS_ACCESS_SERIALIZATION_ERROR  _HRESULT_TYPEDEF_(0x80093013L)
#define OSS_NULL_TBL  _HRESULT_TYPEDEF_(0x80093014L)
#define OSS_NULL_FCN  _HRESULT_TYPEDEF_(0x80093015L)
#define OSS_BAD_ENCRULES  _HRESULT_TYPEDEF_(0x80093016L)
#define OSS_UNAVAIL_ENCRULES  _HRESULT_TYPEDEF_(0x80093017L)
#define OSS_CANT_OPEN_TRACE_WINDOW  _HRESULT_TYPEDEF_(0x80093018L)
#define OSS_UNIMPLEMENTED  _HRESULT_TYPEDEF_(0x80093019L)
#define OSS_OID_DLL_NOT_LINKED  _HRESULT_TYPEDEF_(0x8009301AL)
#define OSS_CANT_OPEN_TRACE_FILE  _HRESULT_TYPEDEF_(0x8009301BL)
#define OSS_TRACE_FILE_ALREADY_OPEN  _HRESULT_TYPEDEF_(0x8009301CL)
#define OSS_TABLE_MISMATCH  _HRESULT_TYPEDEF_(0x8009301DL)
#define OSS_TYPE_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x8009301EL)
#define OSS_REAL_DLL_NOT_LINKED  _HRESULT_TYPEDEF_(0x8009301FL)
#define OSS_REAL_CODE_NOT_LINKED  _HRESULT_TYPEDEF_(0x80093020L)
#define OSS_OUT_OF_RANGE  _HRESULT_TYPEDEF_(0x80093021L)
#define OSS_COPIER_DLL_NOT_LINKED  _HRESULT_TYPEDEF_(0x80093022L)
#define OSS_CONSTRAINT_DLL_NOT_LINKED  _HRESULT_TYPEDEF_(0x80093023L)
#define OSS_COMPARATOR_DLL_NOT_LINKED  _HRESULT_TYPEDEF_(0x80093024L)
#define OSS_COMPARATOR_CODE_NOT_LINKED  _HRESULT_TYPEDEF_(0x80093025L)
#define OSS_MEM_MGR_DLL_NOT_LINKED  _HRESULT_TYPEDEF_(0x80093026L)
#define OSS_PDV_DLL_NOT_LINKED  _HRESULT_TYPEDEF_(0x80093027L)
#define OSS_PDV_CODE_NOT_LINKED  _HRESULT_TYPEDEF_(0x80093028L)
#define OSS_API_DLL_NOT_LINKED  _HRESULT_TYPEDEF_(0x80093029L)
#define OSS_BERDER_DLL_NOT_LINKED  _HRESULT_TYPEDEF_(0x8009302AL)
#define OSS_PER_DLL_NOT_LINKED  _HRESULT_TYPEDEF_(0x8009302BL)
#define OSS_OPEN_TYPE_ERROR  _HRESULT_TYPEDEF_(0x8009302CL)
#define OSS_MUTEX_NOT_CREATED  _HRESULT_TYPEDEF_(0x8009302DL)
#define OSS_CANT_CLOSE_TRACE_FILE  _HRESULT_TYPEDEF_(0x8009302EL)
#define CRYPT_E_ASN1_ERROR  _HRESULT_TYPEDEF_(0x80093100L)
#define CRYPT_E_ASN1_INTERNAL  _HRESULT_TYPEDEF_(0x80093101L)
#define CRYPT_E_ASN1_EOD  _HRESULT_TYPEDEF_(0x80093102L)
#define CRYPT_E_ASN1_CORRUPT  _HRESULT_TYPEDEF_(0x80093103L)
#define CRYPT_E_ASN1_LARGE  _HRESULT_TYPEDEF_(0x80093104L)
#define CRYPT_E_ASN1_CONSTRAINT  _HRESULT_TYPEDEF_(0x80093105L)
#define CRYPT_E_ASN1_MEMORY  _HRESULT_TYPEDEF_(0x80093106L)
#define CRYPT_E_ASN1_OVERFLOW  _HRESULT_TYPEDEF_(0x80093107L)
#define CRYPT_E_ASN1_BADPDU  _HRESULT_TYPEDEF_(0x80093108L)
#define CRYPT_E_ASN1_BADARGS  _HRESULT_TYPEDEF_(0x80093109L)
#define CRYPT_E_ASN1_BADREAL  _HRESULT_TYPEDEF_(0x8009310AL)
#define CRYPT_E_ASN1_BADTAG  _HRESULT_TYPEDEF_(0x8009310BL)
#define CRYPT_E_ASN1_CHOICE  _HRESULT_TYPEDEF_(0x8009310CL)
#define CRYPT_E_ASN1_RULE  _HRESULT_TYPEDEF_(0x8009310DL)
#define CRYPT_E_ASN1_UTF8  _HRESULT_TYPEDEF_(0x8009310EL)
#define CRYPT_E_ASN1_PDU_TYPE  _HRESULT_TYPEDEF_(0x80093133L)
#define CRYPT_E_ASN1_NYI  _HRESULT_TYPEDEF_(0x80093134L)
#define CRYPT_E_ASN1_EXTENDED  _HRESULT_TYPEDEF_(0x80093201L)
#define CRYPT_E_ASN1_NOEOD  _HRESULT_TYPEDEF_(0x80093202L)
#define CERTSRV_E_BAD_REQUESTSUBJECT  _HRESULT_TYPEDEF_(0x80094001L)
#define CERTSRV_E_NO_REQUEST  _HRESULT_TYPEDEF_(0x80094002L)
#define CERTSRV_E_BAD_REQUESTSTATUS  _HRESULT_TYPEDEF_(0x80094003L)
#define CERTSRV_E_PROPERTY_EMPTY  _HRESULT_TYPEDEF_(0x80094004L)
#define CERTSRV_E_INVALID_CA_CERTIFICATE _HRESULT_TYPEDEF_(0x80094005L)
#define CERTSRV_E_SERVER_SUSPENDED  _HRESULT_TYPEDEF_(0x80094006L)
#define CERTSRV_E_ENCODING_LENGTH  _HRESULT_TYPEDEF_(0x80094007L)
#define CERTSRV_E_ROLECONFLICT  _HRESULT_TYPEDEF_(0x80094008L)
#define CERTSRV_E_RESTRICTEDOFFICER  _HRESULT_TYPEDEF_(0x80094009L)
#define CERTSRV_E_KEY_ARCHIVAL_NOT_CONFIGURED _HRESULT_TYPEDEF_(0x8009400AL)
#define CERTSRV_E_NO_VALID_KRA  _HRESULT_TYPEDEF_(0x8009400BL)
#define CERTSRV_E_BAD_REQUEST_KEY_ARCHIVAL _HRESULT_TYPEDEF_(0x8009400CL)
#define CERTSRV_E_NO_CAADMIN_DEFINED  _HRESULT_TYPEDEF_(0x8009400DL)
#define CERTSRV_E_BAD_RENEWAL_CERT_ATTRIBUTE _HRESULT_TYPEDEF_(0x8009400EL)
#define CERTSRV_E_NO_DB_SESSIONS  _HRESULT_TYPEDEF_(0x8009400FL)
#define CERTSRV_E_ALIGNMENT_FAULT  _HRESULT_TYPEDEF_(0x80094010L)
#define CERTSRV_E_ENROLL_DENIED  _HRESULT_TYPEDEF_(0x80094011L)
#define CERTSRV_E_TEMPLATE_DENIED  _HRESULT_TYPEDEF_(0x80094012L)
#define CERTSRV_E_DOWNLEVEL_DC_SSL_OR_UPGRADE _HRESULT_TYPEDEF_(0x80094013L)
#define CERTSRV_E_ADMIN_DENIED_REQUEST  _HRESULT_TYPEDEF_(0x80094014L)
#define CERTSRV_E_NO_POLICY_SERVER  _HRESULT_TYPEDEF_(0x80094015L)
#define CERTSRV_E_WEAK_SIGNATURE_OR_KEY  _HRESULT_TYPEDEF_(0x80094016L)
#define CERTSRV_E_KEY_ATTESTATION_NOT_SUPPORTED _HRESULT_TYPEDEF_(0x80094017L)
#define CERTSRV_E_ENCRYPTION_CERT_REQUIRED _HRESULT_TYPEDEF_(0x80094018L)
#define CERTSRV_E_UNSUPPORTED_CERT_TYPE  _HRESULT_TYPEDEF_(0x80094800L)
#define CERTSRV_E_NO_CERT_TYPE  _HRESULT_TYPEDEF_(0x80094801L)
#define CERTSRV_E_TEMPLATE_CONFLICT  _HRESULT_TYPEDEF_(0x80094802L)
#define CERTSRV_E_SUBJECT_ALT_NAME_REQUIRED _HRESULT_TYPEDEF_(0x80094803L)
#define CERTSRV_E_ARCHIVED_KEY_REQUIRED  _HRESULT_TYPEDEF_(0x80094804L)
#define CERTSRV_E_SMIME_REQUIRED  _HRESULT_TYPEDEF_(0x80094805L)
#define CERTSRV_E_BAD_RENEWAL_SUBJECT  _HRESULT_TYPEDEF_(0x80094806L)
#define CERTSRV_E_BAD_TEMPLATE_VERSION  _HRESULT_TYPEDEF_(0x80094807L)
#define CERTSRV_E_TEMPLATE_POLICY_REQUIRED _HRESULT_TYPEDEF_(0x80094808L)
#define CERTSRV_E_SIGNATURE_POLICY_REQUIRED _HRESULT_TYPEDEF_(0x80094809L)
#define CERTSRV_E_SIGNATURE_COUNT  _HRESULT_TYPEDEF_(0x8009480AL)
#define CERTSRV_E_SIGNATURE_REJECTED  _HRESULT_TYPEDEF_(0x8009480BL)
#define CERTSRV_E_ISSUANCE_POLICY_REQUIRED _HRESULT_TYPEDEF_(0x8009480CL)
#define CERTSRV_E_SUBJECT_UPN_REQUIRED  _HRESULT_TYPEDEF_(0x8009480DL)
#define CERTSRV_E_SUBJECT_DIRECTORY_GUID_REQUIRED _HRESULT_TYPEDEF_(0x8009480EL)
#define CERTSRV_E_SUBJECT_DNS_REQUIRED  _HRESULT_TYPEDEF_(0x8009480FL)
#define CERTSRV_E_ARCHIVED_KEY_UNEXPECTED _HRESULT_TYPEDEF_(0x80094810L)
#define CERTSRV_E_KEY_LENGTH  _HRESULT_TYPEDEF_(0x80094811L)
#define CERTSRV_E_SUBJECT_EMAIL_REQUIRED _HRESULT_TYPEDEF_(0x80094812L)
#define CERTSRV_E_UNKNOWN_CERT_TYPE  _HRESULT_TYPEDEF_(0x80094813L)
#define CERTSRV_E_CERT_TYPE_OVERLAP  _HRESULT_TYPEDEF_(0x80094814L)
#define CERTSRV_E_TOO_MANY_SIGNATURES  _HRESULT_TYPEDEF_(0x80094815L)
#define CERTSRV_E_RENEWAL_BAD_PUBLIC_KEY _HRESULT_TYPEDEF_(0x80094816L)
#define CERTSRV_E_INVALID_EK  _HRESULT_TYPEDEF_(0x80094817L)
#define CERTSRV_E_INVALID_IDBINDING  _HRESULT_TYPEDEF_(0x80094818L)
#define CERTSRV_E_INVALID_ATTESTATION  _HRESULT_TYPEDEF_(0x80094819L)
#define CERTSRV_E_KEY_ATTESTATION  _HRESULT_TYPEDEF_(0x8009481AL)
#define CERTSRV_E_CORRUPT_KEY_ATTESTATION _HRESULT_TYPEDEF_(0x8009481BL)
#define CERTSRV_E_EXPIRED_CHALLENGE  _HRESULT_TYPEDEF_(0x8009481CL)
#define CERTSRV_E_INVALID_RESPONSE  _HRESULT_TYPEDEF_(0x8009481DL)
#define CERTSRV_E_INVALID_REQUESTID  _HRESULT_TYPEDEF_(0x8009481EL)
#define XENROLL_E_KEY_NOT_EXPORTABLE  _HRESULT_TYPEDEF_(0x80095000L)
#define XENROLL_E_CANNOT_ADD_ROOT_CERT  _HRESULT_TYPEDEF_(0x80095001L)
#define XENROLL_E_RESPONSE_KA_HASH_NOT_FOUND _HRESULT_TYPEDEF_(0x80095002L)
#define XENROLL_E_RESPONSE_UNEXPECTED_KA_HASH _HRESULT_TYPEDEF_(0x80095003L)
#define XENROLL_E_RESPONSE_KA_HASH_MISMATCH _HRESULT_TYPEDEF_(0x80095004L)
#define XENROLL_E_KEYSPEC_SMIME_MISMATCH _HRESULT_TYPEDEF_(0x80095005L)
#define TRUST_E_SYSTEM_ERROR  _HRESULT_TYPEDEF_(0x80096001L)
#define TRUST_E_NO_SIGNER_CERT  _HRESULT_TYPEDEF_(0x80096002L)
#define TRUST_E_COUNTER_SIGNER  _HRESULT_TYPEDEF_(0x80096003L)
#define TRUST_E_CERT_SIGNATURE  _HRESULT_TYPEDEF_(0x80096004L)
#define TRUST_E_TIME_STAMP  _HRESULT_TYPEDEF_(0x80096005L)
#define TRUST_E_BAD_DIGEST  _HRESULT_TYPEDEF_(0x80096010L)
#define TRUST_E_MALFORMED_SIGNATURE  _HRESULT_TYPEDEF_(0x80096011L)
#define TRUST_E_BASIC_CONSTRAINTS  _HRESULT_TYPEDEF_(0x80096019L)
#define TRUST_E_FINANCIAL_CRITERIA  _HRESULT_TYPEDEF_(0x8009601EL)
#define MSSIPOTF_E_OUTOFMEMRANGE  _HRESULT_TYPEDEF_(0x80097001L)
#define MSSIPOTF_E_CANTGETOBJECT  _HRESULT_TYPEDEF_(0x80097002L)
#define MSSIPOTF_E_NOHEADTABLE  _HRESULT_TYPEDEF_(0x80097003L)
#define MSSIPOTF_E_BAD_MAGICNUMBER  _HRESULT_TYPEDEF_(0x80097004L)
#define MSSIPOTF_E_BAD_OFFSET_TABLE  _HRESULT_TYPEDEF_(0x80097005L)
#define MSSIPOTF_E_TABLE_TAGORDER  _HRESULT_TYPEDEF_(0x80097006L)
#define MSSIPOTF_E_TABLE_LONGWORD  _HRESULT_TYPEDEF_(0x80097007L)
#define MSSIPOTF_E_BAD_FIRST_TABLE_PLACEMENT _HRESULT_TYPEDEF_(0x80097008L)
#define MSSIPOTF_E_TABLES_OVERLAP  _HRESULT_TYPEDEF_(0x80097009L)
#define MSSIPOTF_E_TABLE_PADBYTES  _HRESULT_TYPEDEF_(0x8009700AL)
#define MSSIPOTF_E_FILETOOSMALL  _HRESULT_TYPEDEF_(0x8009700BL)
#define MSSIPOTF_E_TABLE_CHECKSUM  _HRESULT_TYPEDEF_(0x8009700CL)
#define MSSIPOTF_E_FILE_CHECKSUM  _HRESULT_TYPEDEF_(0x8009700DL)
#define MSSIPOTF_E_FAILED_POLICY  _HRESULT_TYPEDEF_(0x80097010L)
#define MSSIPOTF_E_FAILED_HINTS_CHECK  _HRESULT_TYPEDEF_(0x80097011L)
#define MSSIPOTF_E_NOT_OPENTYPE  _HRESULT_TYPEDEF_(0x80097012L)
#define MSSIPOTF_E_FILE  _HRESULT_TYPEDEF_(0x80097013L)
#define MSSIPOTF_E_CRYPT  _HRESULT_TYPEDEF_(0x80097014L)
#define MSSIPOTF_E_BADVERSION  _HRESULT_TYPEDEF_(0x80097015L)
#define MSSIPOTF_E_DSIG_STRUCTURE  _HRESULT_TYPEDEF_(0x80097016L)
#define MSSIPOTF_E_PCONST_CHECK  _HRESULT_TYPEDEF_(0x80097017L)
#define MSSIPOTF_E_STRUCTURE  _HRESULT_TYPEDEF_(0x80097018L)
#define ERROR_CRED_REQUIRES_CONFIRMATION _HRESULT_TYPEDEF_(0x80097019L)
#define NTE_OP_OK 0
#define TRUST_E_PROVIDER_UNKNOWN  _HRESULT_TYPEDEF_(0x800B0001L)
#define TRUST_E_ACTION_UNKNOWN  _HRESULT_TYPEDEF_(0x800B0002L)
#define TRUST_E_SUBJECT_FORM_UNKNOWN  _HRESULT_TYPEDEF_(0x800B0003L)
#define TRUST_E_SUBJECT_NOT_TRUSTED  _HRESULT_TYPEDEF_(0x800B0004L)
#define DIGSIG_E_ENCODE  _HRESULT_TYPEDEF_(0x800B0005L)
#define DIGSIG_E_DECODE  _HRESULT_TYPEDEF_(0x800B0006L)
#define DIGSIG_E_EXTENSIBILITY  _HRESULT_TYPEDEF_(0x800B0007L)
#define DIGSIG_E_CRYPTO  _HRESULT_TYPEDEF_(0x800B0008L)
#define PERSIST_E_SIZEDEFINITE  _HRESULT_TYPEDEF_(0x800B0009L)
#define PERSIST_E_SIZEINDEFINITE  _HRESULT_TYPEDEF_(0x800B000AL)
#define PERSIST_E_NOTSELFSIZING  _HRESULT_TYPEDEF_(0x800B000BL)
#define TRUST_E_NOSIGNATURE  _HRESULT_TYPEDEF_(0x800B0100L)
#define CERT_E_EXPIRED  _HRESULT_TYPEDEF_(0x800B0101L)
#define CERT_E_VALIDITYPERIODNESTING  _HRESULT_TYPEDEF_(0x800B0102L)
#define CERT_E_ROLE  _HRESULT_TYPEDEF_(0x800B0103L)
#define CERT_E_PATHLENCONST  _HRESULT_TYPEDEF_(0x800B0104L)
#define CERT_E_CRITICAL  _HRESULT_TYPEDEF_(0x800B0105L)
#define CERT_E_PURPOSE  _HRESULT_TYPEDEF_(0x800B0106L)
#define CERT_E_ISSUERCHAINING  _HRESULT_TYPEDEF_(0x800B0107L)
#define CERT_E_MALFORMED  _HRESULT_TYPEDEF_(0x800B0108L)
#define CERT_E_UNTRUSTEDROOT  _HRESULT_TYPEDEF_(0x800B0109L)
#define CERT_E_CHAINING  _HRESULT_TYPEDEF_(0x800B010AL)
#define TRUST_E_FAIL  _HRESULT_TYPEDEF_(0x800B010BL)
#define CERT_E_REVOKED  _HRESULT_TYPEDEF_(0x800B010CL)
#define CERT_E_UNTRUSTEDTESTROOT  _HRESULT_TYPEDEF_(0x800B010DL)
#define CERT_E_REVOCATION_FAILURE  _HRESULT_TYPEDEF_(0x800B010EL)
#define CERT_E_CN_NO_MATCH  _HRESULT_TYPEDEF_(0x800B010FL)
#define CERT_E_WRONG_USAGE  _HRESULT_TYPEDEF_(0x800B0110L)
#define TRUST_E_EXPLICIT_DISTRUST  _HRESULT_TYPEDEF_(0x800B0111L)
#define CERT_E_UNTRUSTEDCA  _HRESULT_TYPEDEF_(0x800B0112L)
#define CERT_E_INVALID_POLICY  _HRESULT_TYPEDEF_(0x800B0113L)
#define CERT_E_INVALID_NAME  _HRESULT_TYPEDEF_(0x800B0114L)

#define HRESULT_FROM_SETUPAPI(x)  ((((x) & (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR)) == (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR)) ? ((HRESULT) (((x) & 0x0000FFFF) | (FACILITY_SETUPAPI << 16) | 0x80000000)) : HRESULT_FROM_WIN32(x))

#define SPAPI_E_EXPECTED_SECTION_NAME  _HRESULT_TYPEDEF_(0x800F0000L)
#define SPAPI_E_BAD_SECTION_NAME_LINE  _HRESULT_TYPEDEF_(0x800F0001L)
#define SPAPI_E_SECTION_NAME_TOO_LONG  _HRESULT_TYPEDEF_(0x800F0002L)
#define SPAPI_E_GENERAL_SYNTAX  _HRESULT_TYPEDEF_(0x800F0003L)
#define SPAPI_E_WRONG_INF_STYLE  _HRESULT_TYPEDEF_(0x800F0100L)
#define SPAPI_E_SECTION_NOT_FOUND  _HRESULT_TYPEDEF_(0x800F0101L)
#define SPAPI_E_LINE_NOT_FOUND  _HRESULT_TYPEDEF_(0x800F0102L)
#define SPAPI_E_NO_BACKUP  _HRESULT_TYPEDEF_(0x800F0103L)
#define SPAPI_E_NO_ASSOCIATED_CLASS  _HRESULT_TYPEDEF_(0x800F0200L)
#define SPAPI_E_CLASS_MISMATCH  _HRESULT_TYPEDEF_(0x800F0201L)
#define SPAPI_E_DUPLICATE_FOUND  _HRESULT_TYPEDEF_(0x800F0202L)
#define SPAPI_E_NO_DRIVER_SELECTED  _HRESULT_TYPEDEF_(0x800F0203L)
#define SPAPI_E_KEY_DOES_NOT_EXIST  _HRESULT_TYPEDEF_(0x800F0204L)
#define SPAPI_E_INVALID_DEVINST_NAME  _HRESULT_TYPEDEF_(0x800F0205L)
#define SPAPI_E_INVALID_CLASS  _HRESULT_TYPEDEF_(0x800F0206L)
#define SPAPI_E_DEVINST_ALREADY_EXISTS  _HRESULT_TYPEDEF_(0x800F0207L)
#define SPAPI_E_DEVINFO_NOT_REGISTERED  _HRESULT_TYPEDEF_(0x800F0208L)
#define SPAPI_E_INVALID_REG_PROPERTY  _HRESULT_TYPEDEF_(0x800F0209L)
#define SPAPI_E_NO_INF  _HRESULT_TYPEDEF_(0x800F020AL)
#define SPAPI_E_NO_SUCH_DEVINST  _HRESULT_TYPEDEF_(0x800F020BL)
#define SPAPI_E_CANT_LOAD_CLASS_ICON  _HRESULT_TYPEDEF_(0x800F020CL)
#define SPAPI_E_INVALID_CLASS_INSTALLER  _HRESULT_TYPEDEF_(0x800F020DL)
#define SPAPI_E_DI_DO_DEFAULT  _HRESULT_TYPEDEF_(0x800F020EL)
#define SPAPI_E_DI_NOFILECOPY  _HRESULT_TYPEDEF_(0x800F020FL)
#define SPAPI_E_INVALID_HWPROFILE  _HRESULT_TYPEDEF_(0x800F0210L)
#define SPAPI_E_NO_DEVICE_SELECTED  _HRESULT_TYPEDEF_(0x800F0211L)
#define SPAPI_E_DEVINFO_LIST_LOCKED  _HRESULT_TYPEDEF_(0x800F0212L)
#define SPAPI_E_DEVINFO_DATA_LOCKED  _HRESULT_TYPEDEF_(0x800F0213L)
#define SPAPI_E_DI_BAD_PATH  _HRESULT_TYPEDEF_(0x800F0214L)
#define SPAPI_E_NO_CLASSINSTALL_PARAMS  _HRESULT_TYPEDEF_(0x800F0215L)
#define SPAPI_E_FILEQUEUE_LOCKED  _HRESULT_TYPEDEF_(0x800F0216L)
#define SPAPI_E_BAD_SERVICE_INSTALLSECT  _HRESULT_TYPEDEF_(0x800F0217L)
#define SPAPI_E_NO_CLASS_DRIVER_LIST  _HRESULT_TYPEDEF_(0x800F0218L)
#define SPAPI_E_NO_ASSOCIATED_SERVICE  _HRESULT_TYPEDEF_(0x800F0219L)
#define SPAPI_E_NO_DEFAULT_DEVICE_INTERFACE _HRESULT_TYPEDEF_(0x800F021AL)
#define SPAPI_E_DEVICE_INTERFACE_ACTIVE  _HRESULT_TYPEDEF_(0x800F021BL)
#define SPAPI_E_DEVICE_INTERFACE_REMOVED _HRESULT_TYPEDEF_(0x800F021CL)
#define SPAPI_E_BAD_INTERFACE_INSTALLSECT _HRESULT_TYPEDEF_(0x800F021DL)
#define SPAPI_E_NO_SUCH_INTERFACE_CLASS  _HRESULT_TYPEDEF_(0x800F021EL)
#define SPAPI_E_INVALID_REFERENCE_STRING _HRESULT_TYPEDEF_(0x800F021FL)
#define SPAPI_E_INVALID_MACHINENAME  _HRESULT_TYPEDEF_(0x800F0220L)
#define SPAPI_E_REMOTE_COMM_FAILURE  _HRESULT_TYPEDEF_(0x800F0221L)
#define SPAPI_E_MACHINE_UNAVAILABLE  _HRESULT_TYPEDEF_(0x800F0222L)
#define SPAPI_E_NO_CONFIGMGR_SERVICES  _HRESULT_TYPEDEF_(0x800F0223L)
#define SPAPI_E_INVALID_PROPPAGE_PROVIDER _HRESULT_TYPEDEF_(0x800F0224L)
#define SPAPI_E_NO_SUCH_DEVICE_INTERFACE _HRESULT_TYPEDEF_(0x800F0225L)
#define SPAPI_E_DI_POSTPROCESSING_REQUIRED _HRESULT_TYPEDEF_(0x800F0226L)
#define SPAPI_E_INVALID_COINSTALLER  _HRESULT_TYPEDEF_(0x800F0227L)
#define SPAPI_E_NO_COMPAT_DRIVERS  _HRESULT_TYPEDEF_(0x800F0228L)
#define SPAPI_E_NO_DEVICE_ICON  _HRESULT_TYPEDEF_(0x800F0229L)
#define SPAPI_E_INVALID_INF_LOGCONFIG  _HRESULT_TYPEDEF_(0x800F022AL)
#define SPAPI_E_DI_DONT_INSTALL  _HRESULT_TYPEDEF_(0x800F022BL)
#define SPAPI_E_INVALID_FILTER_DRIVER  _HRESULT_TYPEDEF_(0x800F022CL)
#define SPAPI_E_NON_WINDOWS_NT_DRIVER  _HRESULT_TYPEDEF_(0x800F022DL)
#define SPAPI_E_NON_WINDOWS_DRIVER  _HRESULT_TYPEDEF_(0x800F022EL)
#define SPAPI_E_NO_CATALOG_FOR_OEM_INF  _HRESULT_TYPEDEF_(0x800F022FL)
#define SPAPI_E_DEVINSTALL_QUEUE_NONNATIVE _HRESULT_TYPEDEF_(0x800F0230L)
#define SPAPI_E_NOT_DISABLEABLE  _HRESULT_TYPEDEF_(0x800F0231L)
#define SPAPI_E_CANT_REMOVE_DEVINST  _HRESULT_TYPEDEF_(0x800F0232L)
#define SPAPI_E_INVALID_TARGET  _HRESULT_TYPEDEF_(0x800F0233L)
#define SPAPI_E_DRIVER_NONNATIVE  _HRESULT_TYPEDEF_(0x800F0234L)
#define SPAPI_E_IN_WOW64  _HRESULT_TYPEDEF_(0x800F0235L)
#define SPAPI_E_SET_SYSTEM_RESTORE_POINT _HRESULT_TYPEDEF_(0x800F0236L)
#define SPAPI_E_INCORRECTLY_COPIED_INF  _HRESULT_TYPEDEF_(0x800F0237L)
#define SPAPI_E_SCE_DISABLED  _HRESULT_TYPEDEF_(0x800F0238L)
#define SPAPI_E_UNKNOWN_EXCEPTION  _HRESULT_TYPEDEF_(0x800F0239L)
#define SPAPI_E_PNP_REGISTRY_ERROR  _HRESULT_TYPEDEF_(0x800F023AL)
#define SPAPI_E_REMOTE_REQUEST_UNSUPPORTED _HRESULT_TYPEDEF_(0x800F023BL)
#define SPAPI_E_NOT_AN_INSTALLED_OEM_INF _HRESULT_TYPEDEF_(0x800F023CL)
#define SPAPI_E_INF_IN_USE_BY_DEVICES  _HRESULT_TYPEDEF_(0x800F023DL)
#define SPAPI_E_DI_FUNCTION_OBSOLETE  _HRESULT_TYPEDEF_(0x800F023EL)
#define SPAPI_E_NO_AUTHENTICODE_CATALOG  _HRESULT_TYPEDEF_(0x800F023FL)
#define SPAPI_E_AUTHENTICODE_DISALLOWED  _HRESULT_TYPEDEF_(0x800F0240L)
#define SPAPI_E_AUTHENTICODE_TRUSTED_PUBLISHER _HRESULT_TYPEDEF_(0x800F0241L)
#define SPAPI_E_AUTHENTICODE_TRUST_NOT_ESTABLISHED _HRESULT_TYPEDEF_(0x800F0242L)
#define SPAPI_E_AUTHENTICODE_PUBLISHER_NOT_TRUSTED _HRESULT_TYPEDEF_(0x800F0243L)
#define SPAPI_E_SIGNATURE_OSATTRIBUTE_MISMATCH _HRESULT_TYPEDEF_(0x800F0244L)
#define SPAPI_E_ONLY_VALIDATE_VIA_AUTHENTICODE _HRESULT_TYPEDEF_(0x800F0245L)
#define SPAPI_E_DEVICE_INSTALLER_NOT_READY _HRESULT_TYPEDEF_(0x800F0246L)
#define SPAPI_E_DRIVER_STORE_ADD_FAILED  _HRESULT_TYPEDEF_(0x800F0247L)
#define SPAPI_E_DEVICE_INSTALL_BLOCKED  _HRESULT_TYPEDEF_(0x800F0248L)
#define SPAPI_E_DRIVER_INSTALL_BLOCKED  _HRESULT_TYPEDEF_(0x800F0249L)
#define SPAPI_E_WRONG_INF_TYPE  _HRESULT_TYPEDEF_(0x800F024AL)
#define SPAPI_E_FILE_HASH_NOT_IN_CATALOG _HRESULT_TYPEDEF_(0x800F024BL)
#define SPAPI_E_DRIVER_STORE_DELETE_FAILED _HRESULT_TYPEDEF_(0x800F024CL)
#define SPAPI_E_UNRECOVERABLE_STACK_OVERFLOW _HRESULT_TYPEDEF_(0x800F0300L)
#define SPAPI_E_ERROR_NOT_INSTALLED  _HRESULT_TYPEDEF_(0x800F1000L)
#define SCARD_S_SUCCESS NO_ERROR
#define SCARD_F_INTERNAL_ERROR  _HRESULT_TYPEDEF_(0x80100001L)
#define SCARD_E_CANCELLED  _HRESULT_TYPEDEF_(0x80100002L)
#define SCARD_E_INVALID_HANDLE  _HRESULT_TYPEDEF_(0x80100003L)
#define SCARD_E_INVALID_PARAMETER  _HRESULT_TYPEDEF_(0x80100004L)
#define SCARD_E_INVALID_TARGET  _HRESULT_TYPEDEF_(0x80100005L)
#define SCARD_E_NO_MEMORY  _HRESULT_TYPEDEF_(0x80100006L)
#define SCARD_F_WAITED_TOO_LONG  _HRESULT_TYPEDEF_(0x80100007L)
#define SCARD_E_INSUFFICIENT_BUFFER  _HRESULT_TYPEDEF_(0x80100008L)
#define SCARD_E_UNKNOWN_READER  _HRESULT_TYPEDEF_(0x80100009L)
#define SCARD_E_TIMEOUT  _HRESULT_TYPEDEF_(0x8010000AL)
#define SCARD_E_SHARING_VIOLATION  _HRESULT_TYPEDEF_(0x8010000BL)
#define SCARD_E_NO_SMARTCARD  _HRESULT_TYPEDEF_(0x8010000CL)
#define SCARD_E_UNKNOWN_CARD  _HRESULT_TYPEDEF_(0x8010000DL)
#define SCARD_E_CANT_DISPOSE  _HRESULT_TYPEDEF_(0x8010000EL)
#define SCARD_E_PROTO_MISMATCH  _HRESULT_TYPEDEF_(0x8010000FL)
#define SCARD_E_NOT_READY  _HRESULT_TYPEDEF_(0x80100010L)
#define SCARD_E_INVALID_VALUE  _HRESULT_TYPEDEF_(0x80100011L)
#define SCARD_E_SYSTEM_CANCELLED  _HRESULT_TYPEDEF_(0x80100012L)
#define SCARD_F_COMM_ERROR  _HRESULT_TYPEDEF_(0x80100013L)
#define SCARD_F_UNKNOWN_ERROR  _HRESULT_TYPEDEF_(0x80100014L)
#define SCARD_E_INVALID_ATR  _HRESULT_TYPEDEF_(0x80100015L)
#define SCARD_E_NOT_TRANSACTED  _HRESULT_TYPEDEF_(0x80100016L)
#define SCARD_E_READER_UNAVAILABLE  _HRESULT_TYPEDEF_(0x80100017L)
#define SCARD_P_SHUTDOWN  _HRESULT_TYPEDEF_(0x80100018L)
#define SCARD_E_PCI_TOO_SMALL  _HRESULT_TYPEDEF_(0x80100019L)
#define SCARD_E_READER_UNSUPPORTED  _HRESULT_TYPEDEF_(0x8010001AL)
#define SCARD_E_DUPLICATE_READER  _HRESULT_TYPEDEF_(0x8010001BL)
#define SCARD_E_CARD_UNSUPPORTED  _HRESULT_TYPEDEF_(0x8010001CL)
#define SCARD_E_NO_SERVICE  _HRESULT_TYPEDEF_(0x8010001DL)
#define SCARD_E_SERVICE_STOPPED  _HRESULT_TYPEDEF_(0x8010001EL)
#define SCARD_E_UNEXPECTED  _HRESULT_TYPEDEF_(0x8010001FL)
#define SCARD_E_ICC_INSTALLATION  _HRESULT_TYPEDEF_(0x80100020L)
#define SCARD_E_ICC_CREATEORDER  _HRESULT_TYPEDEF_(0x80100021L)
#define SCARD_E_UNSUPPORTED_FEATURE  _HRESULT_TYPEDEF_(0x80100022L)
#define SCARD_E_DIR_NOT_FOUND  _HRESULT_TYPEDEF_(0x80100023L)
#define SCARD_E_FILE_NOT_FOUND  _HRESULT_TYPEDEF_(0x80100024L)
#define SCARD_E_NO_DIR  _HRESULT_TYPEDEF_(0x80100025L)
#define SCARD_E_NO_FILE  _HRESULT_TYPEDEF_(0x80100026L)
#define SCARD_E_NO_ACCESS  _HRESULT_TYPEDEF_(0x80100027L)
#define SCARD_E_WRITE_TOO_MANY  _HRESULT_TYPEDEF_(0x80100028L)
#define SCARD_E_BAD_SEEK  _HRESULT_TYPEDEF_(0x80100029L)
#define SCARD_E_INVALID_CHV  _HRESULT_TYPEDEF_(0x8010002AL)
#define SCARD_E_UNKNOWN_RES_MNG  _HRESULT_TYPEDEF_(0x8010002BL)
#define SCARD_E_NO_SUCH_CERTIFICATE  _HRESULT_TYPEDEF_(0x8010002CL)
#define SCARD_E_CERTIFICATE_UNAVAILABLE  _HRESULT_TYPEDEF_(0x8010002DL)
#define SCARD_E_NO_READERS_AVAILABLE  _HRESULT_TYPEDEF_(0x8010002EL)
#define SCARD_E_COMM_DATA_LOST  _HRESULT_TYPEDEF_(0x8010002FL)
#define SCARD_E_NO_KEY_CONTAINER  _HRESULT_TYPEDEF_(0x80100030L)
#define SCARD_E_SERVER_TOO_BUSY  _HRESULT_TYPEDEF_(0x80100031L)
#define SCARD_E_PIN_CACHE_EXPIRED  _HRESULT_TYPEDEF_(0x80100032L)
#define SCARD_E_NO_PIN_CACHE  _HRESULT_TYPEDEF_(0x80100033L)
#define SCARD_E_READ_ONLY_CARD  _HRESULT_TYPEDEF_(0x80100034L)
#define SCARD_W_UNSUPPORTED_CARD  _HRESULT_TYPEDEF_(0x80100065L)
#define SCARD_W_UNRESPONSIVE_CARD  _HRESULT_TYPEDEF_(0x80100066L)
#define SCARD_W_UNPOWERED_CARD  _HRESULT_TYPEDEF_(0x80100067L)
#define SCARD_W_RESET_CARD  _HRESULT_TYPEDEF_(0x80100068L)
#define SCARD_W_REMOVED_CARD  _HRESULT_TYPEDEF_(0x80100069L)
#define SCARD_W_SECURITY_VIOLATION  _HRESULT_TYPEDEF_(0x8010006AL)
#define SCARD_W_WRONG_CHV  _HRESULT_TYPEDEF_(0x8010006BL)
#define SCARD_W_CHV_BLOCKED  _HRESULT_TYPEDEF_(0x8010006CL)
#define SCARD_W_EOF  _HRESULT_TYPEDEF_(0x8010006DL)
#define SCARD_W_CANCELLED_BY_USER  _HRESULT_TYPEDEF_(0x8010006EL)
#define SCARD_W_CARD_NOT_AUTHENTICATED  _HRESULT_TYPEDEF_(0x8010006FL)
#define SCARD_W_CACHE_ITEM_NOT_FOUND  _HRESULT_TYPEDEF_(0x80100070L)
#define SCARD_W_CACHE_ITEM_STALE  _HRESULT_TYPEDEF_(0x80100071L)
#define SCARD_W_CACHE_ITEM_TOO_BIG  _HRESULT_TYPEDEF_(0x80100072L)
#define COMADMIN_E_OBJECTERRORS  _HRESULT_TYPEDEF_(0x80110401L)
#define COMADMIN_E_OBJECTINVALID  _HRESULT_TYPEDEF_(0x80110402L)
#define COMADMIN_E_KEYMISSING  _HRESULT_TYPEDEF_(0x80110403L)
#define COMADMIN_E_ALREADYINSTALLED  _HRESULT_TYPEDEF_(0x80110404L)
#define COMADMIN_E_APP_FILE_WRITEFAIL  _HRESULT_TYPEDEF_(0x80110407L)
#define COMADMIN_E_APP_FILE_READFAIL  _HRESULT_TYPEDEF_(0x80110408L)
#define COMADMIN_E_APP_FILE_VERSION  _HRESULT_TYPEDEF_(0x80110409L)
#define COMADMIN_E_BADPATH  _HRESULT_TYPEDEF_(0x8011040AL)
#define COMADMIN_E_APPLICATIONEXISTS  _HRESULT_TYPEDEF_(0x8011040BL)
#define COMADMIN_E_ROLEEXISTS  _HRESULT_TYPEDEF_(0x8011040CL)
#define COMADMIN_E_CANTCOPYFILE  _HRESULT_TYPEDEF_(0x8011040DL)
#define COMADMIN_E_NOUSER  _HRESULT_TYPEDEF_(0x8011040FL)
#define COMADMIN_E_INVALIDUSERIDS  _HRESULT_TYPEDEF_(0x80110410L)
#define COMADMIN_E_NOREGISTRYCLSID  _HRESULT_TYPEDEF_(0x80110411L)
#define COMADMIN_E_BADREGISTRYPROGID  _HRESULT_TYPEDEF_(0x80110412L)
#define COMADMIN_E_AUTHENTICATIONLEVEL  _HRESULT_TYPEDEF_(0x80110413L)
#define COMADMIN_E_USERPASSWDNOTVALID  _HRESULT_TYPEDEF_(0x80110414L)
#define COMADMIN_E_CLSIDORIIDMISMATCH  _HRESULT_TYPEDEF_(0x80110418L)
#define COMADMIN_E_REMOTEINTERFACE  _HRESULT_TYPEDEF_(0x80110419L)
#define COMADMIN_E_DLLREGISTERSERVER  _HRESULT_TYPEDEF_(0x8011041AL)
#define COMADMIN_E_NOSERVERSHARE  _HRESULT_TYPEDEF_(0x8011041BL)
#define COMADMIN_E_DLLLOADFAILED  _HRESULT_TYPEDEF_(0x8011041DL)
#define COMADMIN_E_BADREGISTRYLIBID  _HRESULT_TYPEDEF_(0x8011041EL)
#define COMADMIN_E_APPDIRNOTFOUND  _HRESULT_TYPEDEF_(0x8011041FL)
#define COMADMIN_E_REGISTRARFAILED  _HRESULT_TYPEDEF_(0x80110423L)
#define COMADMIN_E_COMPFILE_DOESNOTEXIST _HRESULT_TYPEDEF_(0x80110424L)
#define COMADMIN_E_COMPFILE_LOADDLLFAIL  _HRESULT_TYPEDEF_(0x80110425L)
#define COMADMIN_E_COMPFILE_GETCLASSOBJ  _HRESULT_TYPEDEF_(0x80110426L)
#define COMADMIN_E_COMPFILE_CLASSNOTAVAIL _HRESULT_TYPEDEF_(0x80110427L)
#define COMADMIN_E_COMPFILE_BADTLB  _HRESULT_TYPEDEF_(0x80110428L)
#define COMADMIN_E_COMPFILE_NOTINSTALLABLE _HRESULT_TYPEDEF_(0x80110429L)
#define COMADMIN_E_NOTCHANGEABLE  _HRESULT_TYPEDEF_(0x8011042AL)
#define COMADMIN_E_NOTDELETEABLE  _HRESULT_TYPEDEF_(0x8011042BL)
#define COMADMIN_E_SESSION  _HRESULT_TYPEDEF_(0x8011042CL)
#define COMADMIN_E_COMP_MOVE_LOCKED  _HRESULT_TYPEDEF_(0x8011042DL)
#define COMADMIN_E_COMP_MOVE_BAD_DEST  _HRESULT_TYPEDEF_(0x8011042EL)
#define COMADMIN_E_REGISTERTLB  _HRESULT_TYPEDEF_(0x80110430L)
#define COMADMIN_E_SYSTEMAPP  _HRESULT_TYPEDEF_(0x80110433L)
#define COMADMIN_E_COMPFILE_NOREGISTRAR  _HRESULT_TYPEDEF_(0x80110434L)
#define COMADMIN_E_COREQCOMPINSTALLED  _HRESULT_TYPEDEF_(0x80110435L)
#define COMADMIN_E_SERVICENOTINSTALLED  _HRESULT_TYPEDEF_(0x80110436L)
#define COMADMIN_E_PROPERTYSAVEFAILED  _HRESULT_TYPEDEF_(0x80110437L)
#define COMADMIN_E_OBJECTEXISTS  _HRESULT_TYPEDEF_(0x80110438L)
#define COMADMIN_E_COMPONENTEXISTS  _HRESULT_TYPEDEF_(0x80110439L)
#define COMADMIN_E_REGFILE_CORRUPT  _HRESULT_TYPEDEF_(0x8011043BL)
#define COMADMIN_E_PROPERTY_OVERFLOW  _HRESULT_TYPEDEF_(0x8011043CL)
#define COMADMIN_E_NOTINREGISTRY  _HRESULT_TYPEDEF_(0x8011043EL)
#define COMADMIN_E_OBJECTNOTPOOLABLE  _HRESULT_TYPEDEF_(0x8011043FL)
#define COMADMIN_E_APPLID_MATCHES_CLSID  _HRESULT_TYPEDEF_(0x80110446L)
#define COMADMIN_E_ROLE_DOES_NOT_EXIST  _HRESULT_TYPEDEF_(0x80110447L)
#define COMADMIN_E_START_APP_NEEDS_COMPONENTS _HRESULT_TYPEDEF_(0x80110448L)
#define COMADMIN_E_REQUIRES_DIFFERENT_PLATFORM _HRESULT_TYPEDEF_(0x80110449L)
#define COMADMIN_E_CAN_NOT_EXPORT_APP_PROXY _HRESULT_TYPEDEF_(0x8011044AL)
#define COMADMIN_E_CAN_NOT_START_APP  _HRESULT_TYPEDEF_(0x8011044BL)
#define COMADMIN_E_CAN_NOT_EXPORT_SYS_APP _HRESULT_TYPEDEF_(0x8011044CL)
#define COMADMIN_E_CANT_SUBSCRIBE_TO_COMPONENT _HRESULT_TYPEDEF_(0x8011044DL)
#define COMADMIN_E_EVENTCLASS_CANT_BE_SUBSCRIBER _HRESULT_TYPEDEF_(0x8011044EL)
#define COMADMIN_E_LIB_APP_PROXY_INCOMPATIBLE _HRESULT_TYPEDEF_(0x8011044FL)
#define COMADMIN_E_BASE_PARTITION_ONLY  _HRESULT_TYPEDEF_(0x80110450L)
#define COMADMIN_E_START_APP_DISABLED  _HRESULT_TYPEDEF_(0x80110451L)
#define COMADMIN_E_CAT_DUPLICATE_PARTITION_NAME _HRESULT_TYPEDEF_(0x80110457L)
#define COMADMIN_E_CAT_INVALID_PARTITION_NAME _HRESULT_TYPEDEF_(0x80110458L)
#define COMADMIN_E_CAT_PARTITION_IN_USE  _HRESULT_TYPEDEF_(0x80110459L)
#define COMADMIN_E_FILE_PARTITION_DUPLICATE_FILES _HRESULT_TYPEDEF_(0x8011045AL)
#define COMADMIN_E_CAT_IMPORTED_COMPONENTS_NOT_ALLOWED _HRESULT_TYPEDEF_(0x8011045BL)
#define COMADMIN_E_AMBIGUOUS_APPLICATION_NAME _HRESULT_TYPEDEF_(0x8011045CL)
#define COMADMIN_E_AMBIGUOUS_PARTITION_NAME _HRESULT_TYPEDEF_(0x8011045DL)
#define COMADMIN_E_REGDB_NOTINITIALIZED  _HRESULT_TYPEDEF_(0x80110472L)
#define COMADMIN_E_REGDB_NOTOPEN  _HRESULT_TYPEDEF_(0x80110473L)
#define COMADMIN_E_REGDB_SYSTEMERR  _HRESULT_TYPEDEF_(0x80110474L)
#define COMADMIN_E_REGDB_ALREADYRUNNING  _HRESULT_TYPEDEF_(0x80110475L)
#define COMADMIN_E_MIG_VERSIONNOTSUPPORTED _HRESULT_TYPEDEF_(0x80110480L)
#define COMADMIN_E_MIG_SCHEMANOTFOUND  _HRESULT_TYPEDEF_(0x80110481L)
#define COMADMIN_E_CAT_BITNESSMISMATCH  _HRESULT_TYPEDEF_(0x80110482L)
#define COMADMIN_E_CAT_UNACCEPTABLEBITNESS _HRESULT_TYPEDEF_(0x80110483L)
#define COMADMIN_E_CAT_WRONGAPPBITNESS  _HRESULT_TYPEDEF_(0x80110484L)
#define COMADMIN_E_CAT_PAUSE_RESUME_NOT_SUPPORTED _HRESULT_TYPEDEF_(0x80110485L)
#define COMADMIN_E_CAT_SERVERFAULT  _HRESULT_TYPEDEF_(0x80110486L)
#define COMQC_E_APPLICATION_NOT_QUEUED  _HRESULT_TYPEDEF_(0x80110600L)
#define COMQC_E_NO_QUEUEABLE_INTERFACES  _HRESULT_TYPEDEF_(0x80110601L)
#define COMQC_E_QUEUING_SERVICE_NOT_AVAILABLE _HRESULT_TYPEDEF_(0x80110602L)
#define COMQC_E_NO_IPERSISTSTREAM  _HRESULT_TYPEDEF_(0x80110603L)
#define COMQC_E_BAD_MESSAGE  _HRESULT_TYPEDEF_(0x80110604L)
#define COMQC_E_UNAUTHENTICATED  _HRESULT_TYPEDEF_(0x80110605L)
#define COMQC_E_UNTRUSTED_ENQUEUER  _HRESULT_TYPEDEF_(0x80110606L)
#define MSDTC_E_DUPLICATE_RESOURCE  _HRESULT_TYPEDEF_(0x80110701L)
#define COMADMIN_E_OBJECT_PARENT_MISSING _HRESULT_TYPEDEF_(0x80110808L)
#define COMADMIN_E_OBJECT_DOES_NOT_EXIST _HRESULT_TYPEDEF_(0x80110809L)
#define COMADMIN_E_APP_NOT_RUNNING  _HRESULT_TYPEDEF_(0x8011080AL)
#define COMADMIN_E_INVALID_PARTITION  _HRESULT_TYPEDEF_(0x8011080BL)
#define COMADMIN_E_SVCAPP_NOT_POOLABLE_OR_RECYCLABLE _HRESULT_TYPEDEF_(0x8011080DL)
#define COMADMIN_E_USER_IN_SET  _HRESULT_TYPEDEF_(0x8011080EL)
#define COMADMIN_E_CANTRECYCLELIBRARYAPPS _HRESULT_TYPEDEF_(0x8011080FL)
#define COMADMIN_E_CANTRECYCLESERVICEAPPS _HRESULT_TYPEDEF_(0x80110811L)
#define COMADMIN_E_PROCESSALREADYRECYCLED _HRESULT_TYPEDEF_(0x80110812L)
#define COMADMIN_E_PAUSEDPROCESSMAYNOTBERECYCLED _HRESULT_TYPEDEF_(0x80110813L)
#define COMADMIN_E_CANTMAKEINPROCSERVICE _HRESULT_TYPEDEF_(0x80110814L)
#define COMADMIN_E_PROGIDINUSEBYCLSID  _HRESULT_TYPEDEF_(0x80110815L)
#define COMADMIN_E_DEFAULT_PARTITION_NOT_IN_SET _HRESULT_TYPEDEF_(0x80110816L)
#define COMADMIN_E_RECYCLEDPROCESSMAYNOTBEPAUSED _HRESULT_TYPEDEF_(0x80110817L)
#define COMADMIN_E_PARTITION_ACCESSDENIED _HRESULT_TYPEDEF_(0x80110818L)
#define COMADMIN_E_PARTITION_MSI_ONLY  _HRESULT_TYPEDEF_(0x80110819L)
#define COMADMIN_E_LEGACYCOMPS_NOT_ALLOWED_IN_1_0_FORMAT _HRESULT_TYPEDEF_(0x8011081AL)
#define COMADMIN_E_LEGACYCOMPS_NOT_ALLOWED_IN_NONBASE_PARTITIONS _HRESULT_TYPEDEF_(0x8011081BL)
#define COMADMIN_E_COMP_MOVE_SOURCE  _HRESULT_TYPEDEF_(0x8011081CL)
#define COMADMIN_E_COMP_MOVE_DEST  _HRESULT_TYPEDEF_(0x8011081DL)
#define COMADMIN_E_COMP_MOVE_PRIVATE  _HRESULT_TYPEDEF_(0x8011081EL)
#define COMADMIN_E_BASEPARTITION_REQUIRED_IN_SET _HRESULT_TYPEDEF_(0x8011081FL)
#define COMADMIN_E_CANNOT_ALIAS_EVENTCLASS _HRESULT_TYPEDEF_(0x80110820L)
#define COMADMIN_E_PRIVATE_ACCESSDENIED  _HRESULT_TYPEDEF_(0x80110821L)
#define COMADMIN_E_SAFERINVALID  _HRESULT_TYPEDEF_(0x80110822L)
#define COMADMIN_E_REGISTRY_ACCESSDENIED _HRESULT_TYPEDEF_(0x80110823L)
#define COMADMIN_E_PARTITIONS_DISABLED  _HRESULT_TYPEDEF_(0x80110824L)
#define WER_S_REPORT_DEBUG  _HRESULT_TYPEDEF_(0x001B0000L)
#define WER_S_REPORT_UPLOADED  _HRESULT_TYPEDEF_(0x001B0001L)
#define WER_S_REPORT_QUEUED  _HRESULT_TYPEDEF_(0x001B0002L)
#define WER_S_DISABLED  _HRESULT_TYPEDEF_(0x001B0003L)
#define WER_S_SUSPENDED_UPLOAD  _HRESULT_TYPEDEF_(0x001B0004L)
#define WER_S_DISABLED_QUEUE  _HRESULT_TYPEDEF_(0x001B0005L)
#define WER_S_DISABLED_ARCHIVE  _HRESULT_TYPEDEF_(0x001B0006L)
#define WER_S_REPORT_ASYNC  _HRESULT_TYPEDEF_(0x001B0007L)
#define WER_S_IGNORE_ASSERT_INSTANCE  _HRESULT_TYPEDEF_(0x001B0008L)
#define WER_S_IGNORE_ALL_ASSERTS  _HRESULT_TYPEDEF_(0x001B0009L)
#define WER_S_ASSERT_CONTINUE  _HRESULT_TYPEDEF_(0x001B000AL)
#define WER_S_THROTTLED  _HRESULT_TYPEDEF_(0x001B000BL)
#define WER_S_REPORT_UPLOADED_CAB  _HRESULT_TYPEDEF_(0x001B000CL)
#define WER_E_CRASH_FAILURE  _HRESULT_TYPEDEF_(0x801B8000L)
#define WER_E_CANCELED  _HRESULT_TYPEDEF_(0x801B8001L)
#define WER_E_NETWORK_FAILURE  _HRESULT_TYPEDEF_(0x801B8002L)
#define WER_E_NOT_INITIALIZED  _HRESULT_TYPEDEF_(0x801B8003L)
#define WER_E_ALREADY_REPORTING  _HRESULT_TYPEDEF_(0x801B8004L)
#define WER_E_DUMP_THROTTLED  _HRESULT_TYPEDEF_(0x801B8005L)
#define WER_E_INSUFFICIENT_CONSENT  _HRESULT_TYPEDEF_(0x801B8006L)

#define FILTER_HRESULT_FROM_FLT_NTSTATUS(x)  (ASSERT((x & 0xfff0000) == 0x001c0000),(HRESULT) (((x) & 0x8000FFFF) | (FACILITY_USERMODE_FILTER_MANAGER << 16)))

#define ERROR_FLT_IO_COMPLETE  _HRESULT_TYPEDEF_(0x001F0001L)
#define ERROR_FLT_NO_HANDLER_DEFINED  _HRESULT_TYPEDEF_(0x801F0001L)
#define ERROR_FLT_CONTEXT_ALREADY_DEFINED _HRESULT_TYPEDEF_(0x801F0002L)
#define ERROR_FLT_INVALID_ASYNCHRONOUS_REQUEST _HRESULT_TYPEDEF_(0x801F0003L)
#define ERROR_FLT_DISALLOW_FAST_IO  _HRESULT_TYPEDEF_(0x801F0004L)
#define ERROR_FLT_INVALID_NAME_REQUEST  _HRESULT_TYPEDEF_(0x801F0005L)
#define ERROR_FLT_NOT_SAFE_TO_POST_OPERATION _HRESULT_TYPEDEF_(0x801F0006L)
#define ERROR_FLT_NOT_INITIALIZED  _HRESULT_TYPEDEF_(0x801F0007L)
#define ERROR_FLT_FILTER_NOT_READY  _HRESULT_TYPEDEF_(0x801F0008L)
#define ERROR_FLT_POST_OPERATION_CLEANUP _HRESULT_TYPEDEF_(0x801F0009L)
#define ERROR_FLT_INTERNAL_ERROR  _HRESULT_TYPEDEF_(0x801F000AL)
#define ERROR_FLT_DELETING_OBJECT  _HRESULT_TYPEDEF_(0x801F000BL)
#define ERROR_FLT_MUST_BE_NONPAGED_POOL  _HRESULT_TYPEDEF_(0x801F000CL)
#define ERROR_FLT_DUPLICATE_ENTRY  _HRESULT_TYPEDEF_(0x801F000DL)
#define ERROR_FLT_CBDQ_DISABLED  _HRESULT_TYPEDEF_(0x801F000EL)
#define ERROR_FLT_DO_NOT_ATTACH  _HRESULT_TYPEDEF_(0x801F000FL)
#define ERROR_FLT_DO_NOT_DETACH  _HRESULT_TYPEDEF_(0x801F0010L)
#define ERROR_FLT_INSTANCE_ALTITUDE_COLLISION _HRESULT_TYPEDEF_(0x801F0011L)
#define ERROR_FLT_INSTANCE_NAME_COLLISION _HRESULT_TYPEDEF_(0x801F0012L)
#define ERROR_FLT_FILTER_NOT_FOUND  _HRESULT_TYPEDEF_(0x801F0013L)
#define ERROR_FLT_VOLUME_NOT_FOUND  _HRESULT_TYPEDEF_(0x801F0014L)
#define ERROR_FLT_INSTANCE_NOT_FOUND  _HRESULT_TYPEDEF_(0x801F0015L)
#define ERROR_FLT_CONTEXT_ALLOCATION_NOT_FOUND _HRESULT_TYPEDEF_(0x801F0016L)
#define ERROR_FLT_INVALID_CONTEXT_REGISTRATION _HRESULT_TYPEDEF_(0x801F0017L)
#define ERROR_FLT_NAME_CACHE_MISS  _HRESULT_TYPEDEF_(0x801F0018L)
#define ERROR_FLT_NO_DEVICE_OBJECT  _HRESULT_TYPEDEF_(0x801F0019L)
#define ERROR_FLT_VOLUME_ALREADY_MOUNTED _HRESULT_TYPEDEF_(0x801F001AL)
#define ERROR_FLT_ALREADY_ENLISTED  _HRESULT_TYPEDEF_(0x801F001BL)
#define ERROR_FLT_CONTEXT_ALREADY_LINKED _HRESULT_TYPEDEF_(0x801F001CL)
#define ERROR_FLT_NO_WAITER_FOR_REPLY  _HRESULT_TYPEDEF_(0x801F0020L)
#define ERROR_FLT_REGISTRATION_BUSY  _HRESULT_TYPEDEF_(0x801F0023L)
#define ERROR_HUNG_DISPLAY_DRIVER_THREAD _HRESULT_TYPEDEF_(0x80260001L)
#define DWM_E_COMPOSITIONDISABLED  _HRESULT_TYPEDEF_(0x80263001L)
#define DWM_E_REMOTING_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x80263002L)
#define DWM_E_NO_REDIRECTION_SURFACE_AVAILABLE _HRESULT_TYPEDEF_(0x80263003L)
#define DWM_E_NOT_QUEUING_PRESENTS  _HRESULT_TYPEDEF_(0x80263004L)
#define DWM_E_ADAPTER_NOT_FOUND  _HRESULT_TYPEDEF_(0x80263005L)
#define DWM_S_GDI_REDIRECTION_SURFACE  _HRESULT_TYPEDEF_(0x00263005L)
#define DWM_E_TEXTURE_TOO_LARGE  _HRESULT_TYPEDEF_(0x80263007L)
#define DWM_S_GDI_REDIRECTION_SURFACE_BLT_VIA_GDI _HRESULT_TYPEDEF_(0x00263008L)
#define ERROR_MONITOR_NO_DESCRIPTOR  _HRESULT_TYPEDEF_(0x00261001L)
#define ERROR_MONITOR_UNKNOWN_DESCRIPTOR_FORMAT _HRESULT_TYPEDEF_(0x00261002L)
#define ERROR_MONITOR_INVALID_DESCRIPTOR_CHECKSUM _HRESULT_TYPEDEF_(0xC0261003L)
#define ERROR_MONITOR_INVALID_STANDARD_TIMING_BLOCK _HRESULT_TYPEDEF_(0xC0261004L)
#define ERROR_MONITOR_WMI_DATABLOCK_REGISTRATION_FAILED _HRESULT_TYPEDEF_(0xC0261005L)
#define ERROR_MONITOR_INVALID_SERIAL_NUMBER_MONDSC_BLOCK _HRESULT_TYPEDEF_(0xC0261006L)
#define ERROR_MONITOR_INVALID_USER_FRIENDLY_MONDSC_BLOCK _HRESULT_TYPEDEF_(0xC0261007L)
#define ERROR_MONITOR_NO_MORE_DESCRIPTOR_DATA _HRESULT_TYPEDEF_(0xC0261008L)
#define ERROR_MONITOR_INVALID_DETAILED_TIMING_BLOCK _HRESULT_TYPEDEF_(0xC0261009L)
#define ERROR_MONITOR_INVALID_MANUFACTURE_DATE _HRESULT_TYPEDEF_(0xC026100AL)
#define ERROR_GRAPHICS_NOT_EXCLUSIVE_MODE_OWNER _HRESULT_TYPEDEF_(0xC0262000L)
#define ERROR_GRAPHICS_INSUFFICIENT_DMA_BUFFER _HRESULT_TYPEDEF_(0xC0262001L)
#define ERROR_GRAPHICS_INVALID_DISPLAY_ADAPTER _HRESULT_TYPEDEF_(0xC0262002L)
#define ERROR_GRAPHICS_ADAPTER_WAS_RESET _HRESULT_TYPEDEF_(0xC0262003L)
#define ERROR_GRAPHICS_INVALID_DRIVER_MODEL _HRESULT_TYPEDEF_(0xC0262004L)
#define ERROR_GRAPHICS_PRESENT_MODE_CHANGED _HRESULT_TYPEDEF_(0xC0262005L)
#define ERROR_GRAPHICS_PRESENT_OCCLUDED  _HRESULT_TYPEDEF_(0xC0262006L)
#define ERROR_GRAPHICS_PRESENT_DENIED  _HRESULT_TYPEDEF_(0xC0262007L)
#define ERROR_GRAPHICS_CANNOTCOLORCONVERT _HRESULT_TYPEDEF_(0xC0262008L)
#define ERROR_GRAPHICS_DRIVER_MISMATCH  _HRESULT_TYPEDEF_(0xC0262009L)
#define ERROR_GRAPHICS_PARTIAL_DATA_POPULATED _HRESULT_TYPEDEF_(0x4026200AL)
#define ERROR_GRAPHICS_PRESENT_REDIRECTION_DISABLED _HRESULT_TYPEDEF_(0xC026200BL)
#define ERROR_GRAPHICS_PRESENT_UNOCCLUDED _HRESULT_TYPEDEF_(0xC026200CL)
#define ERROR_GRAPHICS_WINDOWDC_NOT_AVAILABLE _HRESULT_TYPEDEF_(0xC026200DL)
#define ERROR_GRAPHICS_WINDOWLESS_PRESENT_DISABLED _HRESULT_TYPEDEF_(0xC026200EL)
#define ERROR_GRAPHICS_NO_VIDEO_MEMORY  _HRESULT_TYPEDEF_(0xC0262100L)
#define ERROR_GRAPHICS_CANT_LOCK_MEMORY  _HRESULT_TYPEDEF_(0xC0262101L)
#define ERROR_GRAPHICS_ALLOCATION_BUSY  _HRESULT_TYPEDEF_(0xC0262102L)
#define ERROR_GRAPHICS_TOO_MANY_REFERENCES _HRESULT_TYPEDEF_(0xC0262103L)
#define ERROR_GRAPHICS_TRY_AGAIN_LATER  _HRESULT_TYPEDEF_(0xC0262104L)
#define ERROR_GRAPHICS_TRY_AGAIN_NOW  _HRESULT_TYPEDEF_(0xC0262105L)
#define ERROR_GRAPHICS_ALLOCATION_INVALID _HRESULT_TYPEDEF_(0xC0262106L)
#define ERROR_GRAPHICS_UNSWIZZLING_APERTURE_UNAVAILABLE _HRESULT_TYPEDEF_(0xC0262107L)
#define ERROR_GRAPHICS_UNSWIZZLING_APERTURE_UNSUPPORTED _HRESULT_TYPEDEF_(0xC0262108L)
#define ERROR_GRAPHICS_CANT_EVICT_PINNED_ALLOCATION _HRESULT_TYPEDEF_(0xC0262109L)
#define ERROR_GRAPHICS_INVALID_ALLOCATION_USAGE _HRESULT_TYPEDEF_(0xC0262110L)
#define ERROR_GRAPHICS_CANT_RENDER_LOCKED_ALLOCATION _HRESULT_TYPEDEF_(0xC0262111L)
#define ERROR_GRAPHICS_ALLOCATION_CLOSED _HRESULT_TYPEDEF_(0xC0262112L)
#define ERROR_GRAPHICS_INVALID_ALLOCATION_INSTANCE _HRESULT_TYPEDEF_(0xC0262113L)
#define ERROR_GRAPHICS_INVALID_ALLOCATION_HANDLE _HRESULT_TYPEDEF_(0xC0262114L)
#define ERROR_GRAPHICS_WRONG_ALLOCATION_DEVICE _HRESULT_TYPEDEF_(0xC0262115L)
#define ERROR_GRAPHICS_ALLOCATION_CONTENT_LOST _HRESULT_TYPEDEF_(0xC0262116L)
#define ERROR_GRAPHICS_GPU_EXCEPTION_ON_DEVICE _HRESULT_TYPEDEF_(0xC0262200L)
#define ERROR_GRAPHICS_SKIP_ALLOCATION_PREPARATION _HRESULT_TYPEDEF_(0x40262201L)
#define ERROR_GRAPHICS_INVALID_VIDPN_TOPOLOGY _HRESULT_TYPEDEF_(0xC0262300L)
#define ERROR_GRAPHICS_VIDPN_TOPOLOGY_NOT_SUPPORTED _HRESULT_TYPEDEF_(0xC0262301L)
#define ERROR_GRAPHICS_VIDPN_TOPOLOGY_CURRENTLY_NOT_SUPPORTED _HRESULT_TYPEDEF_(0xC0262302L)
#define ERROR_GRAPHICS_INVALID_VIDPN  _HRESULT_TYPEDEF_(0xC0262303L)
#define ERROR_GRAPHICS_INVALID_VIDEO_PRESENT_SOURCE _HRESULT_TYPEDEF_(0xC0262304L)
#define ERROR_GRAPHICS_INVALID_VIDEO_PRESENT_TARGET _HRESULT_TYPEDEF_(0xC0262305L)
#define ERROR_GRAPHICS_VIDPN_MODALITY_NOT_SUPPORTED _HRESULT_TYPEDEF_(0xC0262306L)
#define ERROR_GRAPHICS_MODE_NOT_PINNED  _HRESULT_TYPEDEF_(0x00262307L)
#define ERROR_GRAPHICS_INVALID_VIDPN_SOURCEMODESET _HRESULT_TYPEDEF_(0xC0262308L)
#define ERROR_GRAPHICS_INVALID_VIDPN_TARGETMODESET _HRESULT_TYPEDEF_(0xC0262309L)
#define ERROR_GRAPHICS_INVALID_FREQUENCY _HRESULT_TYPEDEF_(0xC026230AL)
#define ERROR_GRAPHICS_INVALID_ACTIVE_REGION _HRESULT_TYPEDEF_(0xC026230BL)
#define ERROR_GRAPHICS_INVALID_TOTAL_REGION _HRESULT_TYPEDEF_(0xC026230CL)
#define ERROR_GRAPHICS_INVALID_VIDEO_PRESENT_SOURCE_MODE _HRESULT_TYPEDEF_(0xC0262310L)
#define ERROR_GRAPHICS_INVALID_VIDEO_PRESENT_TARGET_MODE _HRESULT_TYPEDEF_(0xC0262311L)
#define ERROR_GRAPHICS_PINNED_MODE_MUST_REMAIN_IN_SET _HRESULT_TYPEDEF_(0xC0262312L)
#define ERROR_GRAPHICS_PATH_ALREADY_IN_TOPOLOGY _HRESULT_TYPEDEF_(0xC0262313L)
#define ERROR_GRAPHICS_MODE_ALREADY_IN_MODESET _HRESULT_TYPEDEF_(0xC0262314L)
#define ERROR_GRAPHICS_INVALID_VIDEOPRESENTSOURCESET _HRESULT_TYPEDEF_(0xC0262315L)
#define ERROR_GRAPHICS_INVALID_VIDEOPRESENTTARGETSET _HRESULT_TYPEDEF_(0xC0262316L)
#define ERROR_GRAPHICS_SOURCE_ALREADY_IN_SET _HRESULT_TYPEDEF_(0xC0262317L)
#define ERROR_GRAPHICS_TARGET_ALREADY_IN_SET _HRESULT_TYPEDEF_(0xC0262318L)
#define ERROR_GRAPHICS_INVALID_VIDPN_PRESENT_PATH _HRESULT_TYPEDEF_(0xC0262319L)
#define ERROR_GRAPHICS_NO_RECOMMENDED_VIDPN_TOPOLOGY _HRESULT_TYPEDEF_(0xC026231AL)
#define ERROR_GRAPHICS_INVALID_MONITOR_FREQUENCYRANGESET _HRESULT_TYPEDEF_(0xC026231BL)
#define ERROR_GRAPHICS_INVALID_MONITOR_FREQUENCYRANGE _HRESULT_TYPEDEF_(0xC026231CL)
#define ERROR_GRAPHICS_FREQUENCYRANGE_NOT_IN_SET _HRESULT_TYPEDEF_(0xC026231DL)
#define ERROR_GRAPHICS_NO_PREFERRED_MODE _HRESULT_TYPEDEF_(0x0026231EL)
#define ERROR_GRAPHICS_FREQUENCYRANGE_ALREADY_IN_SET _HRESULT_TYPEDEF_(0xC026231FL)
#define ERROR_GRAPHICS_STALE_MODESET  _HRESULT_TYPEDEF_(0xC0262320L)
#define ERROR_GRAPHICS_INVALID_MONITOR_SOURCEMODESET _HRESULT_TYPEDEF_(0xC0262321L)
#define ERROR_GRAPHICS_INVALID_MONITOR_SOURCE_MODE _HRESULT_TYPEDEF_(0xC0262322L)
#define ERROR_GRAPHICS_NO_RECOMMENDED_FUNCTIONAL_VIDPN _HRESULT_TYPEDEF_(0xC0262323L)
#define ERROR_GRAPHICS_MODE_ID_MUST_BE_UNIQUE _HRESULT_TYPEDEF_(0xC0262324L)
#define ERROR_GRAPHICS_EMPTY_ADAPTER_MONITOR_MODE_SUPPORT_INTERSECTION _HRESULT_TYPEDEF_(0xC0262325L)
#define ERROR_GRAPHICS_VIDEO_PRESENT_TARGETS_LESS_THAN_SOURCES _HRESULT_TYPEDEF_(0xC0262326L)
#define ERROR_GRAPHICS_PATH_NOT_IN_TOPOLOGY _HRESULT_TYPEDEF_(0xC0262327L)
#define ERROR_GRAPHICS_ADAPTER_MUST_HAVE_AT_LEAST_ONE_SOURCE _HRESULT_TYPEDEF_(0xC0262328L)
#define ERROR_GRAPHICS_ADAPTER_MUST_HAVE_AT_LEAST_ONE_TARGET _HRESULT_TYPEDEF_(0xC0262329L)
#define ERROR_GRAPHICS_INVALID_MONITORDESCRIPTORSET _HRESULT_TYPEDEF_(0xC026232AL)
#define ERROR_GRAPHICS_INVALID_MONITORDESCRIPTOR _HRESULT_TYPEDEF_(0xC026232BL)
#define ERROR_GRAPHICS_MONITORDESCRIPTOR_NOT_IN_SET _HRESULT_TYPEDEF_(0xC026232CL)
#define ERROR_GRAPHICS_MONITORDESCRIPTOR_ALREADY_IN_SET _HRESULT_TYPEDEF_(0xC026232DL)
#define ERROR_GRAPHICS_MONITORDESCRIPTOR_ID_MUST_BE_UNIQUE _HRESULT_TYPEDEF_(0xC026232EL)
#define ERROR_GRAPHICS_INVALID_VIDPN_TARGET_SUBSET_TYPE _HRESULT_TYPEDEF_(0xC026232FL)
#define ERROR_GRAPHICS_RESOURCES_NOT_RELATED _HRESULT_TYPEDEF_(0xC0262330L)
#define ERROR_GRAPHICS_SOURCE_ID_MUST_BE_UNIQUE _HRESULT_TYPEDEF_(0xC0262331L)
#define ERROR_GRAPHICS_TARGET_ID_MUST_BE_UNIQUE _HRESULT_TYPEDEF_(0xC0262332L)
#define ERROR_GRAPHICS_NO_AVAILABLE_VIDPN_TARGET _HRESULT_TYPEDEF_(0xC0262333L)
#define ERROR_GRAPHICS_MONITOR_COULD_NOT_BE_ASSOCIATED_WITH_ADAPTER _HRESULT_TYPEDEF_(0xC0262334L)
#define ERROR_GRAPHICS_NO_VIDPNMGR  _HRESULT_TYPEDEF_(0xC0262335L)
#define ERROR_GRAPHICS_NO_ACTIVE_VIDPN  _HRESULT_TYPEDEF_(0xC0262336L)
#define ERROR_GRAPHICS_STALE_VIDPN_TOPOLOGY _HRESULT_TYPEDEF_(0xC0262337L)
#define ERROR_GRAPHICS_MONITOR_NOT_CONNECTED _HRESULT_TYPEDEF_(0xC0262338L)
#define ERROR_GRAPHICS_SOURCE_NOT_IN_TOPOLOGY _HRESULT_TYPEDEF_(0xC0262339L)
#define ERROR_GRAPHICS_INVALID_PRIMARYSURFACE_SIZE _HRESULT_TYPEDEF_(0xC026233AL)
#define ERROR_GRAPHICS_INVALID_VISIBLEREGION_SIZE _HRESULT_TYPEDEF_(0xC026233BL)
#define ERROR_GRAPHICS_INVALID_STRIDE  _HRESULT_TYPEDEF_(0xC026233CL)
#define ERROR_GRAPHICS_INVALID_PIXELFORMAT _HRESULT_TYPEDEF_(0xC026233DL)
#define ERROR_GRAPHICS_INVALID_COLORBASIS _HRESULT_TYPEDEF_(0xC026233EL)
#define ERROR_GRAPHICS_INVALID_PIXELVALUEACCESSMODE _HRESULT_TYPEDEF_(0xC026233FL)
#define ERROR_GRAPHICS_TARGET_NOT_IN_TOPOLOGY _HRESULT_TYPEDEF_(0xC0262340L)
#define ERROR_GRAPHICS_NO_DISPLAY_MODE_MANAGEMENT_SUPPORT _HRESULT_TYPEDEF_(0xC0262341L)
#define ERROR_GRAPHICS_VIDPN_SOURCE_IN_USE _HRESULT_TYPEDEF_(0xC0262342L)
#define ERROR_GRAPHICS_CANT_ACCESS_ACTIVE_VIDPN _HRESULT_TYPEDEF_(0xC0262343L)
#define ERROR_GRAPHICS_INVALID_PATH_IMPORTANCE_ORDINAL _HRESULT_TYPEDEF_(0xC0262344L)
#define ERROR_GRAPHICS_INVALID_PATH_CONTENT_GEOMETRY_TRANSFORMATION _HRESULT_TYPEDEF_(0xC0262345L)
#define ERROR_GRAPHICS_PATH_CONTENT_GEOMETRY_TRANSFORMATION_NOT_SUPPORTED _HRESULT_TYPEDEF_(0xC0262346L)
#define ERROR_GRAPHICS_INVALID_GAMMA_RAMP _HRESULT_TYPEDEF_(0xC0262347L)
#define ERROR_GRAPHICS_GAMMA_RAMP_NOT_SUPPORTED _HRESULT_TYPEDEF_(0xC0262348L)
#define ERROR_GRAPHICS_MULTISAMPLING_NOT_SUPPORTED _HRESULT_TYPEDEF_(0xC0262349L)
#define ERROR_GRAPHICS_MODE_NOT_IN_MODESET _HRESULT_TYPEDEF_(0xC026234AL)
#define ERROR_GRAPHICS_DATASET_IS_EMPTY  _HRESULT_TYPEDEF_(0x0026234BL)
#define ERROR_GRAPHICS_NO_MORE_ELEMENTS_IN_DATASET _HRESULT_TYPEDEF_(0x0026234CL)
#define ERROR_GRAPHICS_INVALID_VIDPN_TOPOLOGY_RECOMMENDATION_REASON _HRESULT_TYPEDEF_(0xC026234DL)
#define ERROR_GRAPHICS_INVALID_PATH_CONTENT_TYPE _HRESULT_TYPEDEF_(0xC026234EL)
#define ERROR_GRAPHICS_INVALID_COPYPROTECTION_TYPE _HRESULT_TYPEDEF_(0xC026234FL)
#define ERROR_GRAPHICS_UNASSIGNED_MODESET_ALREADY_EXISTS _HRESULT_TYPEDEF_(0xC0262350L)
#define ERROR_GRAPHICS_PATH_CONTENT_GEOMETRY_TRANSFORMATION_NOT_PINNED _HRESULT_TYPEDEF_(0x00262351L)
#define ERROR_GRAPHICS_INVALID_SCANLINE_ORDERING _HRESULT_TYPEDEF_(0xC0262352L)
#define ERROR_GRAPHICS_TOPOLOGY_CHANGES_NOT_ALLOWED _HRESULT_TYPEDEF_(0xC0262353L)
#define ERROR_GRAPHICS_NO_AVAILABLE_IMPORTANCE_ORDINALS _HRESULT_TYPEDEF_(0xC0262354L)
#define ERROR_GRAPHICS_INCOMPATIBLE_PRIVATE_FORMAT _HRESULT_TYPEDEF_(0xC0262355L)
#define ERROR_GRAPHICS_INVALID_MODE_PRUNING_ALGORITHM _HRESULT_TYPEDEF_(0xC0262356L)
#define ERROR_GRAPHICS_INVALID_MONITOR_CAPABILITY_ORIGIN _HRESULT_TYPEDEF_(0xC0262357L)
#define ERROR_GRAPHICS_INVALID_MONITOR_FREQUENCYRANGE_CONSTRAINT _HRESULT_TYPEDEF_(0xC0262358L)
#define ERROR_GRAPHICS_MAX_NUM_PATHS_REACHED _HRESULT_TYPEDEF_(0xC0262359L)
#define ERROR_GRAPHICS_CANCEL_VIDPN_TOPOLOGY_AUGMENTATION _HRESULT_TYPEDEF_(0xC026235AL)
#define ERROR_GRAPHICS_INVALID_CLIENT_TYPE _HRESULT_TYPEDEF_(0xC026235BL)
#define ERROR_GRAPHICS_CLIENTVIDPN_NOT_SET _HRESULT_TYPEDEF_(0xC026235CL)
#define ERROR_GRAPHICS_SPECIFIED_CHILD_ALREADY_CONNECTED _HRESULT_TYPEDEF_(0xC0262400L)
#define ERROR_GRAPHICS_CHILD_DESCRIPTOR_NOT_SUPPORTED _HRESULT_TYPEDEF_(0xC0262401L)
#define ERROR_GRAPHICS_UNKNOWN_CHILD_STATUS _HRESULT_TYPEDEF_(0x4026242FL)
#define ERROR_GRAPHICS_NOT_A_LINKED_ADAPTER _HRESULT_TYPEDEF_(0xC0262430L)
#define ERROR_GRAPHICS_LEADLINK_NOT_ENUMERATED _HRESULT_TYPEDEF_(0xC0262431L)
#define ERROR_GRAPHICS_CHAINLINKS_NOT_ENUMERATED _HRESULT_TYPEDEF_(0xC0262432L)
#define ERROR_GRAPHICS_ADAPTER_CHAIN_NOT_READY _HRESULT_TYPEDEF_(0xC0262433L)
#define ERROR_GRAPHICS_CHAINLINKS_NOT_STARTED _HRESULT_TYPEDEF_(0xC0262434L)
#define ERROR_GRAPHICS_CHAINLINKS_NOT_POWERED_ON _HRESULT_TYPEDEF_(0xC0262435L)
#define ERROR_GRAPHICS_INCONSISTENT_DEVICE_LINK_STATE _HRESULT_TYPEDEF_(0xC0262436L)
#define ERROR_GRAPHICS_LEADLINK_START_DEFERRED _HRESULT_TYPEDEF_(0x40262437L)
#define ERROR_GRAPHICS_NOT_POST_DEVICE_DRIVER _HRESULT_TYPEDEF_(0xC0262438L)
#define ERROR_GRAPHICS_POLLING_TOO_FREQUENTLY _HRESULT_TYPEDEF_(0x40262439L)
#define ERROR_GRAPHICS_START_DEFERRED  _HRESULT_TYPEDEF_(0x4026243AL)
#define ERROR_GRAPHICS_ADAPTER_ACCESS_NOT_EXCLUDED _HRESULT_TYPEDEF_(0xC026243BL)
#define ERROR_GRAPHICS_DEPENDABLE_CHILD_STATUS _HRESULT_TYPEDEF_(0x4026243CL)
#define ERROR_GRAPHICS_OPM_NOT_SUPPORTED _HRESULT_TYPEDEF_(0xC0262500L)
#define ERROR_GRAPHICS_COPP_NOT_SUPPORTED _HRESULT_TYPEDEF_(0xC0262501L)
#define ERROR_GRAPHICS_UAB_NOT_SUPPORTED _HRESULT_TYPEDEF_(0xC0262502L)
#define ERROR_GRAPHICS_OPM_INVALID_ENCRYPTED_PARAMETERS _HRESULT_TYPEDEF_(0xC0262503L)
#define ERROR_GRAPHICS_OPM_NO_VIDEO_OUTPUTS_EXIST _HRESULT_TYPEDEF_(0xC0262505L)
#define ERROR_GRAPHICS_OPM_INTERNAL_ERROR _HRESULT_TYPEDEF_(0xC026250BL)
#define ERROR_GRAPHICS_OPM_INVALID_HANDLE _HRESULT_TYPEDEF_(0xC026250CL)
#define ERROR_GRAPHICS_PVP_INVALID_CERTIFICATE_LENGTH _HRESULT_TYPEDEF_(0xC026250EL)
#define ERROR_GRAPHICS_OPM_SPANNING_MODE_ENABLED _HRESULT_TYPEDEF_(0xC026250FL)
#define ERROR_GRAPHICS_OPM_THEATER_MODE_ENABLED _HRESULT_TYPEDEF_(0xC0262510L)
#define ERROR_GRAPHICS_PVP_HFS_FAILED  _HRESULT_TYPEDEF_(0xC0262511L)
#define ERROR_GRAPHICS_OPM_INVALID_SRM  _HRESULT_TYPEDEF_(0xC0262512L)
#define ERROR_GRAPHICS_OPM_OUTPUT_DOES_NOT_SUPPORT_HDCP _HRESULT_TYPEDEF_(0xC0262513L)
#define ERROR_GRAPHICS_OPM_OUTPUT_DOES_NOT_SUPPORT_ACP _HRESULT_TYPEDEF_(0xC0262514L)
#define ERROR_GRAPHICS_OPM_OUTPUT_DOES_NOT_SUPPORT_CGMSA _HRESULT_TYPEDEF_(0xC0262515L)
#define ERROR_GRAPHICS_OPM_HDCP_SRM_NEVER_SET _HRESULT_TYPEDEF_(0xC0262516L)
#define ERROR_GRAPHICS_OPM_RESOLUTION_TOO_HIGH _HRESULT_TYPEDEF_(0xC0262517L)
#define ERROR_GRAPHICS_OPM_ALL_HDCP_HARDWARE_ALREADY_IN_USE _HRESULT_TYPEDEF_(0xC0262518L)
#define ERROR_GRAPHICS_OPM_VIDEO_OUTPUT_NO_LONGER_EXISTS _HRESULT_TYPEDEF_(0xC026251AL)
#define ERROR_GRAPHICS_OPM_SESSION_TYPE_CHANGE_IN_PROGRESS _HRESULT_TYPEDEF_(0xC026251BL)
#define ERROR_GRAPHICS_OPM_VIDEO_OUTPUT_DOES_NOT_HAVE_COPP_SEMANTICS _HRESULT_TYPEDEF_(0xC026251CL)
#define ERROR_GRAPHICS_OPM_INVALID_INFORMATION_REQUEST _HRESULT_TYPEDEF_(0xC026251DL)
#define ERROR_GRAPHICS_OPM_DRIVER_INTERNAL_ERROR _HRESULT_TYPEDEF_(0xC026251EL)
#define ERROR_GRAPHICS_OPM_VIDEO_OUTPUT_DOES_NOT_HAVE_OPM_SEMANTICS _HRESULT_TYPEDEF_(0xC026251FL)
#define ERROR_GRAPHICS_OPM_SIGNALING_NOT_SUPPORTED _HRESULT_TYPEDEF_(0xC0262520L)
#define ERROR_GRAPHICS_OPM_INVALID_CONFIGURATION_REQUEST _HRESULT_TYPEDEF_(0xC0262521L)
#define ERROR_GRAPHICS_I2C_NOT_SUPPORTED _HRESULT_TYPEDEF_(0xC0262580L)
#define ERROR_GRAPHICS_I2C_DEVICE_DOES_NOT_EXIST _HRESULT_TYPEDEF_(0xC0262581L)
#define ERROR_GRAPHICS_I2C_ERROR_TRANSMITTING_DATA _HRESULT_TYPEDEF_(0xC0262582L)
#define ERROR_GRAPHICS_I2C_ERROR_RECEIVING_DATA _HRESULT_TYPEDEF_(0xC0262583L)
#define ERROR_GRAPHICS_DDCCI_VCP_NOT_SUPPORTED _HRESULT_TYPEDEF_(0xC0262584L)
#define ERROR_GRAPHICS_DDCCI_INVALID_DATA _HRESULT_TYPEDEF_(0xC0262585L)
#define ERROR_GRAPHICS_DDCCI_MONITOR_RETURNED_INVALID_TIMING_STATUS_BYTE _HRESULT_TYPEDEF_(0xC0262586L)
#define ERROR_GRAPHICS_MCA_INVALID_CAPABILITIES_STRING _HRESULT_TYPEDEF_(0xC0262587L)
#define ERROR_GRAPHICS_MCA_INTERNAL_ERROR _HRESULT_TYPEDEF_(0xC0262588L)
#define ERROR_GRAPHICS_DDCCI_INVALID_MESSAGE_COMMAND _HRESULT_TYPEDEF_(0xC0262589L)
#define ERROR_GRAPHICS_DDCCI_INVALID_MESSAGE_LENGTH _HRESULT_TYPEDEF_(0xC026258AL)
#define ERROR_GRAPHICS_DDCCI_INVALID_MESSAGE_CHECKSUM _HRESULT_TYPEDEF_(0xC026258BL)
#define ERROR_GRAPHICS_INVALID_PHYSICAL_MONITOR_HANDLE _HRESULT_TYPEDEF_(0xC026258CL)
#define ERROR_GRAPHICS_MONITOR_NO_LONGER_EXISTS _HRESULT_TYPEDEF_(0xC026258DL)
#define ERROR_GRAPHICS_DDCCI_CURRENT_CURRENT_VALUE_GREATER_THAN_MAXIMUM_VALUE _HRESULT_TYPEDEF_(0xC02625D8L)
#define ERROR_GRAPHICS_MCA_INVALID_VCP_VERSION _HRESULT_TYPEDEF_(0xC02625D9L)
#define ERROR_GRAPHICS_MCA_MONITOR_VIOLATES_MCCS_SPECIFICATION _HRESULT_TYPEDEF_(0xC02625DAL)
#define ERROR_GRAPHICS_MCA_MCCS_VERSION_MISMATCH _HRESULT_TYPEDEF_(0xC02625DBL)
#define ERROR_GRAPHICS_MCA_UNSUPPORTED_MCCS_VERSION _HRESULT_TYPEDEF_(0xC02625DCL)
#define ERROR_GRAPHICS_MCA_INVALID_TECHNOLOGY_TYPE_RETURNED _HRESULT_TYPEDEF_(0xC02625DEL)
#define ERROR_GRAPHICS_MCA_UNSUPPORTED_COLOR_TEMPERATURE _HRESULT_TYPEDEF_(0xC02625DFL)
#define ERROR_GRAPHICS_ONLY_CONSOLE_SESSION_SUPPORTED _HRESULT_TYPEDEF_(0xC02625E0L)
#define ERROR_GRAPHICS_NO_DISPLAY_DEVICE_CORRESPONDS_TO_NAME _HRESULT_TYPEDEF_(0xC02625E1L)
#define ERROR_GRAPHICS_DISPLAY_DEVICE_NOT_ATTACHED_TO_DESKTOP _HRESULT_TYPEDEF_(0xC02625E2L)
#define ERROR_GRAPHICS_MIRRORING_DEVICES_NOT_SUPPORTED _HRESULT_TYPEDEF_(0xC02625E3L)
#define ERROR_GRAPHICS_INVALID_POINTER  _HRESULT_TYPEDEF_(0xC02625E4L)
#define ERROR_GRAPHICS_NO_MONITORS_CORRESPOND_TO_DISPLAY_DEVICE _HRESULT_TYPEDEF_(0xC02625E5L)
#define ERROR_GRAPHICS_PARAMETER_ARRAY_TOO_SMALL _HRESULT_TYPEDEF_(0xC02625E6L)
#define ERROR_GRAPHICS_INTERNAL_ERROR  _HRESULT_TYPEDEF_(0xC02625E7L)
#define ERROR_GRAPHICS_SESSION_TYPE_CHANGE_IN_PROGRESS _HRESULT_TYPEDEF_(0xC02605E8L)
#define NAP_E_INVALID_PACKET  _HRESULT_TYPEDEF_(0x80270001L)
#define NAP_E_MISSING_SOH  _HRESULT_TYPEDEF_(0x80270002L)
#define NAP_E_CONFLICTING_ID  _HRESULT_TYPEDEF_(0x80270003L)
#define NAP_E_NO_CACHED_SOH  _HRESULT_TYPEDEF_(0x80270004L)
#define NAP_E_STILL_BOUND  _HRESULT_TYPEDEF_(0x80270005L)
#define NAP_E_NOT_REGISTERED  _HRESULT_TYPEDEF_(0x80270006L)
#define NAP_E_NOT_INITIALIZED  _HRESULT_TYPEDEF_(0x80270007L)
#define NAP_E_MISMATCHED_ID  _HRESULT_TYPEDEF_(0x80270008L)
#define NAP_E_NOT_PENDING  _HRESULT_TYPEDEF_(0x80270009L)
#define NAP_E_ID_NOT_FOUND  _HRESULT_TYPEDEF_(0x8027000AL)
#define NAP_E_MAXSIZE_TOO_SMALL  _HRESULT_TYPEDEF_(0x8027000BL)
#define NAP_E_SERVICE_NOT_RUNNING  _HRESULT_TYPEDEF_(0x8027000CL)
#define NAP_S_CERT_ALREADY_PRESENT  _HRESULT_TYPEDEF_(0x0027000DL)
#define NAP_E_ENTITY_DISABLED  _HRESULT_TYPEDEF_(0x8027000EL)
#define NAP_E_NETSH_GROUPPOLICY_ERROR  _HRESULT_TYPEDEF_(0x8027000FL)
#define NAP_E_TOO_MANY_CALLS  _HRESULT_TYPEDEF_(0x80270010L)
#define NAP_E_SHV_CONFIG_EXISTED  _HRESULT_TYPEDEF_(0x80270011L)
#define NAP_E_SHV_CONFIG_NOT_FOUND  _HRESULT_TYPEDEF_(0x80270012L)
#define NAP_E_SHV_TIMEOUT  _HRESULT_TYPEDEF_(0x80270013L)
#define TPM_E_ERROR_MASK  _HRESULT_TYPEDEF_(0x80280000L)
#define TPM_E_AUTHFAIL  _HRESULT_TYPEDEF_(0x80280001L)
#define TPM_E_BADINDEX  _HRESULT_TYPEDEF_(0x80280002L)
#define TPM_E_BAD_PARAMETER  _HRESULT_TYPEDEF_(0x80280003L)
#define TPM_E_AUDITFAILURE  _HRESULT_TYPEDEF_(0x80280004L)
#define TPM_E_CLEAR_DISABLED  _HRESULT_TYPEDEF_(0x80280005L)
#define TPM_E_DEACTIVATED  _HRESULT_TYPEDEF_(0x80280006L)
#define TPM_E_DISABLED  _HRESULT_TYPEDEF_(0x80280007L)
#define TPM_E_DISABLED_CMD  _HRESULT_TYPEDEF_(0x80280008L)
#define TPM_E_FAIL  _HRESULT_TYPEDEF_(0x80280009L)
#define TPM_E_BAD_ORDINAL  _HRESULT_TYPEDEF_(0x8028000AL)
#define TPM_E_INSTALL_DISABLED  _HRESULT_TYPEDEF_(0x8028000BL)
#define TPM_E_INVALID_KEYHANDLE  _HRESULT_TYPEDEF_(0x8028000CL)
#define TPM_E_KEYNOTFOUND  _HRESULT_TYPEDEF_(0x8028000DL)
#define TPM_E_INAPPROPRIATE_ENC  _HRESULT_TYPEDEF_(0x8028000EL)
#define TPM_E_MIGRATEFAIL  _HRESULT_TYPEDEF_(0x8028000FL)
#define TPM_E_INVALID_PCR_INFO  _HRESULT_TYPEDEF_(0x80280010L)
#define TPM_E_NOSPACE  _HRESULT_TYPEDEF_(0x80280011L)
#define TPM_E_NOSRK  _HRESULT_TYPEDEF_(0x80280012L)
#define TPM_E_NOTSEALED_BLOB  _HRESULT_TYPEDEF_(0x80280013L)
#define TPM_E_OWNER_SET  _HRESULT_TYPEDEF_(0x80280014L)
#define TPM_E_RESOURCES  _HRESULT_TYPEDEF_(0x80280015L)
#define TPM_E_SHORTRANDOM  _HRESULT_TYPEDEF_(0x80280016L)
#define TPM_E_SIZE  _HRESULT_TYPEDEF_(0x80280017L)
#define TPM_E_WRONGPCRVAL  _HRESULT_TYPEDEF_(0x80280018L)
#define TPM_E_BAD_PARAM_SIZE  _HRESULT_TYPEDEF_(0x80280019L)
#define TPM_E_SHA_THREAD  _HRESULT_TYPEDEF_(0x8028001AL)
#define TPM_E_SHA_ERROR  _HRESULT_TYPEDEF_(0x8028001BL)
#define TPM_E_FAILEDSELFTEST  _HRESULT_TYPEDEF_(0x8028001CL)
#define TPM_E_AUTH2FAIL  _HRESULT_TYPEDEF_(0x8028001DL)
#define TPM_E_BADTAG  _HRESULT_TYPEDEF_(0x8028001EL)
#define TPM_E_IOERROR  _HRESULT_TYPEDEF_(0x8028001FL)
#define TPM_E_ENCRYPT_ERROR  _HRESULT_TYPEDEF_(0x80280020L)
#define TPM_E_DECRYPT_ERROR  _HRESULT_TYPEDEF_(0x80280021L)
#define TPM_E_INVALID_AUTHHANDLE  _HRESULT_TYPEDEF_(0x80280022L)
#define TPM_E_NO_ENDORSEMENT  _HRESULT_TYPEDEF_(0x80280023L)
#define TPM_E_INVALID_KEYUSAGE  _HRESULT_TYPEDEF_(0x80280024L)
#define TPM_E_WRONG_ENTITYTYPE  _HRESULT_TYPEDEF_(0x80280025L)
#define TPM_E_INVALID_POSTINIT  _HRESULT_TYPEDEF_(0x80280026L)
#define TPM_E_INAPPROPRIATE_SIG  _HRESULT_TYPEDEF_(0x80280027L)
#define TPM_E_BAD_KEY_PROPERTY  _HRESULT_TYPEDEF_(0x80280028L)
#define TPM_E_BAD_MIGRATION  _HRESULT_TYPEDEF_(0x80280029L)
#define TPM_E_BAD_SCHEME  _HRESULT_TYPEDEF_(0x8028002AL)
#define TPM_E_BAD_DATASIZE  _HRESULT_TYPEDEF_(0x8028002BL)
#define TPM_E_BAD_MODE  _HRESULT_TYPEDEF_(0x8028002CL)
#define TPM_E_BAD_PRESENCE  _HRESULT_TYPEDEF_(0x8028002DL)
#define TPM_E_BAD_VERSION  _HRESULT_TYPEDEF_(0x8028002EL)
#define TPM_E_NO_WRAP_TRANSPORT  _HRESULT_TYPEDEF_(0x8028002FL)
#define TPM_E_AUDITFAIL_UNSUCCESSFUL  _HRESULT_TYPEDEF_(0x80280030L)
#define TPM_E_AUDITFAIL_SUCCESSFUL  _HRESULT_TYPEDEF_(0x80280031L)
#define TPM_E_NOTRESETABLE  _HRESULT_TYPEDEF_(0x80280032L)
#define TPM_E_NOTLOCAL  _HRESULT_TYPEDEF_(0x80280033L)
#define TPM_E_BAD_TYPE  _HRESULT_TYPEDEF_(0x80280034L)
#define TPM_E_INVALID_RESOURCE  _HRESULT_TYPEDEF_(0x80280035L)
#define TPM_E_NOTFIPS  _HRESULT_TYPEDEF_(0x80280036L)
#define TPM_E_INVALID_FAMILY  _HRESULT_TYPEDEF_(0x80280037L)
#define TPM_E_NO_NV_PERMISSION  _HRESULT_TYPEDEF_(0x80280038L)
#define TPM_E_REQUIRES_SIGN  _HRESULT_TYPEDEF_(0x80280039L)
#define TPM_E_KEY_NOTSUPPORTED  _HRESULT_TYPEDEF_(0x8028003AL)
#define TPM_E_AUTH_CONFLICT  _HRESULT_TYPEDEF_(0x8028003BL)
#define TPM_E_AREA_LOCKED  _HRESULT_TYPEDEF_(0x8028003CL)
#define TPM_E_BAD_LOCALITY  _HRESULT_TYPEDEF_(0x8028003DL)
#define TPM_E_READ_ONLY  _HRESULT_TYPEDEF_(0x8028003EL)
#define TPM_E_PER_NOWRITE  _HRESULT_TYPEDEF_(0x8028003FL)
#define TPM_E_FAMILYCOUNT  _HRESULT_TYPEDEF_(0x80280040L)
#define TPM_E_WRITE_LOCKED  _HRESULT_TYPEDEF_(0x80280041L)
#define TPM_E_BAD_ATTRIBUTES  _HRESULT_TYPEDEF_(0x80280042L)
#define TPM_E_INVALID_STRUCTURE  _HRESULT_TYPEDEF_(0x80280043L)
#define TPM_E_KEY_OWNER_CONTROL  _HRESULT_TYPEDEF_(0x80280044L)
#define TPM_E_BAD_COUNTER  _HRESULT_TYPEDEF_(0x80280045L)
#define TPM_E_NOT_FULLWRITE  _HRESULT_TYPEDEF_(0x80280046L)
#define TPM_E_CONTEXT_GAP  _HRESULT_TYPEDEF_(0x80280047L)
#define TPM_E_MAXNVWRITES  _HRESULT_TYPEDEF_(0x80280048L)
#define TPM_E_NOOPERATOR  _HRESULT_TYPEDEF_(0x80280049L)
#define TPM_E_RESOURCEMISSING  _HRESULT_TYPEDEF_(0x8028004AL)
#define TPM_E_DELEGATE_LOCK  _HRESULT_TYPEDEF_(0x8028004BL)
#define TPM_E_DELEGATE_FAMILY  _HRESULT_TYPEDEF_(0x8028004CL)
#define TPM_E_DELEGATE_ADMIN  _HRESULT_TYPEDEF_(0x8028004DL)
#define TPM_E_TRANSPORT_NOTEXCLUSIVE  _HRESULT_TYPEDEF_(0x8028004EL)
#define TPM_E_OWNER_CONTROL  _HRESULT_TYPEDEF_(0x8028004FL)
#define TPM_E_DAA_RESOURCES  _HRESULT_TYPEDEF_(0x80280050L)
#define TPM_E_DAA_INPUT_DATA0  _HRESULT_TYPEDEF_(0x80280051L)
#define TPM_E_DAA_INPUT_DATA1  _HRESULT_TYPEDEF_(0x80280052L)
#define TPM_E_DAA_ISSUER_SETTINGS  _HRESULT_TYPEDEF_(0x80280053L)
#define TPM_E_DAA_TPM_SETTINGS  _HRESULT_TYPEDEF_(0x80280054L)
#define TPM_E_DAA_STAGE  _HRESULT_TYPEDEF_(0x80280055L)
#define TPM_E_DAA_ISSUER_VALIDITY  _HRESULT_TYPEDEF_(0x80280056L)
#define TPM_E_DAA_WRONG_W  _HRESULT_TYPEDEF_(0x80280057L)
#define TPM_E_BAD_HANDLE  _HRESULT_TYPEDEF_(0x80280058L)
#define TPM_E_BAD_DELEGATE  _HRESULT_TYPEDEF_(0x80280059L)
#define TPM_E_BADCONTEXT  _HRESULT_TYPEDEF_(0x8028005AL)
#define TPM_E_TOOMANYCONTEXTS  _HRESULT_TYPEDEF_(0x8028005BL)
#define TPM_E_MA_TICKET_SIGNATURE  _HRESULT_TYPEDEF_(0x8028005CL)
#define TPM_E_MA_DESTINATION  _HRESULT_TYPEDEF_(0x8028005DL)
#define TPM_E_MA_SOURCE  _HRESULT_TYPEDEF_(0x8028005EL)
#define TPM_E_MA_AUTHORITY  _HRESULT_TYPEDEF_(0x8028005FL)
#define TPM_E_PERMANENTEK  _HRESULT_TYPEDEF_(0x80280061L)
#define TPM_E_BAD_SIGNATURE  _HRESULT_TYPEDEF_(0x80280062L)
#define TPM_E_NOCONTEXTSPACE  _HRESULT_TYPEDEF_(0x80280063L)
#define TPM_E_COMMAND_BLOCKED  _HRESULT_TYPEDEF_(0x80280400L)
#define TPM_E_INVALID_HANDLE  _HRESULT_TYPEDEF_(0x80280401L)
#define TPM_E_DUPLICATE_VHANDLE  _HRESULT_TYPEDEF_(0x80280402L)
#define TPM_E_EMBEDDED_COMMAND_BLOCKED  _HRESULT_TYPEDEF_(0x80280403L)
#define TPM_E_EMBEDDED_COMMAND_UNSUPPORTED _HRESULT_TYPEDEF_(0x80280404L)
#define TPM_E_RETRY  _HRESULT_TYPEDEF_(0x80280800L)
#define TPM_E_NEEDS_SELFTEST  _HRESULT_TYPEDEF_(0x80280801L)
#define TPM_E_DOING_SELFTEST  _HRESULT_TYPEDEF_(0x80280802L)
#define TPM_E_DEFEND_LOCK_RUNNING  _HRESULT_TYPEDEF_(0x80280803L)
#define TBS_E_INTERNAL_ERROR  _HRESULT_TYPEDEF_(0x80284001L)
#define TBS_E_BAD_PARAMETER  _HRESULT_TYPEDEF_(0x80284002L)
#define TBS_E_INVALID_OUTPUT_POINTER  _HRESULT_TYPEDEF_(0x80284003L)
#define TBS_E_INVALID_CONTEXT  _HRESULT_TYPEDEF_(0x80284004L)
#define TBS_E_INSUFFICIENT_BUFFER  _HRESULT_TYPEDEF_(0x80284005L)
#define TBS_E_IOERROR  _HRESULT_TYPEDEF_(0x80284006L)
#define TBS_E_INVALID_CONTEXT_PARAM  _HRESULT_TYPEDEF_(0x80284007L)
#define TBS_E_SERVICE_NOT_RUNNING  _HRESULT_TYPEDEF_(0x80284008L)
#define TBS_E_TOO_MANY_TBS_CONTEXTS  _HRESULT_TYPEDEF_(0x80284009L)
#define TBS_E_TOO_MANY_RESOURCES  _HRESULT_TYPEDEF_(0x8028400AL)
#define TBS_E_SERVICE_START_PENDING  _HRESULT_TYPEDEF_(0x8028400BL)
#define TBS_E_PPI_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x8028400CL)
#define TBS_E_COMMAND_CANCELED  _HRESULT_TYPEDEF_(0x8028400DL)
#define TBS_E_BUFFER_TOO_LARGE  _HRESULT_TYPEDEF_(0x8028400EL)
#define TBS_E_TPM_NOT_FOUND  _HRESULT_TYPEDEF_(0x8028400FL)
#define TBS_E_SERVICE_DISABLED  _HRESULT_TYPEDEF_(0x80284010L)
#define TBS_E_NO_EVENT_LOG  _HRESULT_TYPEDEF_(0x80284011L)
#define TBS_E_ACCESS_DENIED  _HRESULT_TYPEDEF_(0x80284012L)
#define TBS_E_PROVISIONING_NOT_ALLOWED  _HRESULT_TYPEDEF_(0x80284013L)
#define TBS_E_PPI_FUNCTION_UNSUPPORTED  _HRESULT_TYPEDEF_(0x80284014L)
#define TBS_E_OWNERAUTH_NOT_FOUND  _HRESULT_TYPEDEF_(0x80284015L)
#define TBS_E_PROVISIONING_INCOMPLETE  _HRESULT_TYPEDEF_(0x80284016L)
#define TPMAPI_E_INVALID_STATE  _HRESULT_TYPEDEF_(0x80290100L)
#define TPMAPI_E_NOT_ENOUGH_DATA  _HRESULT_TYPEDEF_(0x80290101L)
#define TPMAPI_E_TOO_MUCH_DATA  _HRESULT_TYPEDEF_(0x80290102L)
#define TPMAPI_E_INVALID_OUTPUT_POINTER  _HRESULT_TYPEDEF_(0x80290103L)
#define TPMAPI_E_INVALID_PARAMETER  _HRESULT_TYPEDEF_(0x80290104L)
#define TPMAPI_E_OUT_OF_MEMORY  _HRESULT_TYPEDEF_(0x80290105L)
#define TPMAPI_E_BUFFER_TOO_SMALL  _HRESULT_TYPEDEF_(0x80290106L)
#define TPMAPI_E_INTERNAL_ERROR  _HRESULT_TYPEDEF_(0x80290107L)
#define TPMAPI_E_ACCESS_DENIED  _HRESULT_TYPEDEF_(0x80290108L)
#define TPMAPI_E_AUTHORIZATION_FAILED  _HRESULT_TYPEDEF_(0x80290109L)
#define TPMAPI_E_INVALID_CONTEXT_HANDLE  _HRESULT_TYPEDEF_(0x8029010AL)
#define TPMAPI_E_TBS_COMMUNICATION_ERROR _HRESULT_TYPEDEF_(0x8029010BL)
#define TPMAPI_E_TPM_COMMAND_ERROR  _HRESULT_TYPEDEF_(0x8029010CL)
#define TPMAPI_E_MESSAGE_TOO_LARGE  _HRESULT_TYPEDEF_(0x8029010DL)
#define TPMAPI_E_INVALID_ENCODING  _HRESULT_TYPEDEF_(0x8029010EL)
#define TPMAPI_E_INVALID_KEY_SIZE  _HRESULT_TYPEDEF_(0x8029010FL)
#define TPMAPI_E_ENCRYPTION_FAILED  _HRESULT_TYPEDEF_(0x80290110L)
#define TPMAPI_E_INVALID_KEY_PARAMS  _HRESULT_TYPEDEF_(0x80290111L)
#define TPMAPI_E_INVALID_MIGRATION_AUTHORIZATION_BLOB _HRESULT_TYPEDEF_(0x80290112L)
#define TPMAPI_E_INVALID_PCR_INDEX  _HRESULT_TYPEDEF_(0x80290113L)
#define TPMAPI_E_INVALID_DELEGATE_BLOB  _HRESULT_TYPEDEF_(0x80290114L)
#define TPMAPI_E_INVALID_CONTEXT_PARAMS  _HRESULT_TYPEDEF_(0x80290115L)
#define TPMAPI_E_INVALID_KEY_BLOB  _HRESULT_TYPEDEF_(0x80290116L)
#define TPMAPI_E_INVALID_PCR_DATA  _HRESULT_TYPEDEF_(0x80290117L)
#define TPMAPI_E_INVALID_OWNER_AUTH  _HRESULT_TYPEDEF_(0x80290118L)
#define TPMAPI_E_FIPS_RNG_CHECK_FAILED  _HRESULT_TYPEDEF_(0x80290119L)
#define TPMAPI_E_EMPTY_TCG_LOG  _HRESULT_TYPEDEF_(0x8029011AL)
#define TPMAPI_E_INVALID_TCG_LOG_ENTRY  _HRESULT_TYPEDEF_(0x8029011BL)
#define TPMAPI_E_TCG_SEPARATOR_ABSENT  _HRESULT_TYPEDEF_(0x8029011CL)
#define TPMAPI_E_TCG_INVALID_DIGEST_ENTRY _HRESULT_TYPEDEF_(0x8029011DL)
#define TPMAPI_E_POLICY_DENIES_OPERATION _HRESULT_TYPEDEF_(0x8029011EL)
#define TBSIMP_E_BUFFER_TOO_SMALL  _HRESULT_TYPEDEF_(0x80290200L)
#define TBSIMP_E_CLEANUP_FAILED  _HRESULT_TYPEDEF_(0x80290201L)
#define TBSIMP_E_INVALID_CONTEXT_HANDLE  _HRESULT_TYPEDEF_(0x80290202L)
#define TBSIMP_E_INVALID_CONTEXT_PARAM  _HRESULT_TYPEDEF_(0x80290203L)
#define TBSIMP_E_TPM_ERROR  _HRESULT_TYPEDEF_(0x80290204L)
#define TBSIMP_E_HASH_BAD_KEY  _HRESULT_TYPEDEF_(0x80290205L)
#define TBSIMP_E_DUPLICATE_VHANDLE  _HRESULT_TYPEDEF_(0x80290206L)
#define TBSIMP_E_INVALID_OUTPUT_POINTER  _HRESULT_TYPEDEF_(0x80290207L)
#define TBSIMP_E_INVALID_PARAMETER  _HRESULT_TYPEDEF_(0x80290208L)
#define TBSIMP_E_RPC_INIT_FAILED  _HRESULT_TYPEDEF_(0x80290209L)
#define TBSIMP_E_SCHEDULER_NOT_RUNNING  _HRESULT_TYPEDEF_(0x8029020AL)
#define TBSIMP_E_COMMAND_CANCELED  _HRESULT_TYPEDEF_(0x8029020BL)
#define TBSIMP_E_OUT_OF_MEMORY  _HRESULT_TYPEDEF_(0x8029020CL)
#define TBSIMP_E_LIST_NO_MORE_ITEMS  _HRESULT_TYPEDEF_(0x8029020DL)
#define TBSIMP_E_LIST_NOT_FOUND  _HRESULT_TYPEDEF_(0x8029020EL)
#define TBSIMP_E_NOT_ENOUGH_SPACE  _HRESULT_TYPEDEF_(0x8029020FL)
#define TBSIMP_E_NOT_ENOUGH_TPM_CONTEXTS _HRESULT_TYPEDEF_(0x80290210L)
#define TBSIMP_E_COMMAND_FAILED  _HRESULT_TYPEDEF_(0x80290211L)
#define TBSIMP_E_UNKNOWN_ORDINAL  _HRESULT_TYPEDEF_(0x80290212L)
#define TBSIMP_E_RESOURCE_EXPIRED  _HRESULT_TYPEDEF_(0x80290213L)
#define TBSIMP_E_INVALID_RESOURCE  _HRESULT_TYPEDEF_(0x80290214L)
#define TBSIMP_E_NOTHING_TO_UNLOAD  _HRESULT_TYPEDEF_(0x80290215L)
#define TBSIMP_E_HASH_TABLE_FULL  _HRESULT_TYPEDEF_(0x80290216L)
#define TBSIMP_E_TOO_MANY_TBS_CONTEXTS  _HRESULT_TYPEDEF_(0x80290217L)
#define TBSIMP_E_TOO_MANY_RESOURCES  _HRESULT_TYPEDEF_(0x80290218L)
#define TBSIMP_E_PPI_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x80290219L)
#define TBSIMP_E_TPM_INCOMPATIBLE  _HRESULT_TYPEDEF_(0x8029021AL)
#define TBSIMP_E_NO_EVENT_LOG  _HRESULT_TYPEDEF_(0x8029021BL)
#define TPM_E_PPI_ACPI_FAILURE  _HRESULT_TYPEDEF_(0x80290300L)
#define TPM_E_PPI_USER_ABORT  _HRESULT_TYPEDEF_(0x80290301L)
#define TPM_E_PPI_BIOS_FAILURE  _HRESULT_TYPEDEF_(0x80290302L)
#define TPM_E_PPI_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x80290303L)
#define TPM_E_PPI_BLOCKED_IN_BIOS  _HRESULT_TYPEDEF_(0x80290304L)
#define TPM_E_PCP_ERROR_MASK  _HRESULT_TYPEDEF_(0x80290400L)
#define TPM_E_PCP_DEVICE_NOT_READY  _HRESULT_TYPEDEF_(0x80290401L)
#define TPM_E_PCP_INVALID_HANDLE  _HRESULT_TYPEDEF_(0x80290402L)
#define TPM_E_PCP_INVALID_PARAMETER  _HRESULT_TYPEDEF_(0x80290403L)
#define TPM_E_PCP_FLAG_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x80290404L)
#define TPM_E_PCP_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x80290405L)
#define TPM_E_PCP_BUFFER_TOO_SMALL  _HRESULT_TYPEDEF_(0x80290406L)
#define TPM_E_PCP_INTERNAL_ERROR  _HRESULT_TYPEDEF_(0x80290407L)
#define TPM_E_PCP_AUTHENTICATION_FAILED  _HRESULT_TYPEDEF_(0x80290408L)
#define TPM_E_PCP_AUTHENTICATION_IGNORED _HRESULT_TYPEDEF_(0x80290409L)
#define TPM_E_PCP_POLICY_NOT_FOUND  _HRESULT_TYPEDEF_(0x8029040AL)
#define TPM_E_PCP_PROFILE_NOT_FOUND  _HRESULT_TYPEDEF_(0x8029040BL)
#define TPM_E_PCP_VALIDATION_FAILED  _HRESULT_TYPEDEF_(0x8029040CL)

#ifdef WIN_OMIT_TSS_TPM_RETURN_CODES
#undef TPM_E_AREA_LOCKED
#undef TPM_E_AUDITFAILURE
#undef TPM_E_AUDITFAIL_SUCCESSFUL
#undef TPM_E_AUDITFAIL_UNSUCCESSFUL
#undef TPM_E_AUTH2FAIL
#undef TPM_E_AUTHFAIL
#undef TPM_E_AUTH_CONFLICT
#undef TPM_E_BADCONTEXT
#undef TPM_E_BADINDEX
#undef TPM_E_BADTAG
#undef TPM_E_BAD_ATTRIBUTES
#undef TPM_E_BAD_COUNTER
#undef TPM_E_BAD_DATASIZE
#undef TPM_E_BAD_DELEGATE
#undef TPM_E_BAD_HANDLE
#undef TPM_E_BAD_KEY_PROPERTY
#undef TPM_E_BAD_LOCALITY
#undef TPM_E_BAD_MIGRATION
#undef TPM_E_BAD_MODE
#undef TPM_E_BAD_ORDINAL
#undef TPM_E_BAD_PARAMETER
#undef TPM_E_BAD_PARAM_SIZE
#undef TPM_E_BAD_PRESENCE
#undef TPM_E_BAD_SCHEME
#undef TPM_E_BAD_SIGNATURE
#undef TPM_E_BAD_TYPE
#undef TPM_E_BAD_VERSION
#undef TPM_E_CLEAR_DISABLED
#undef TPM_E_CONTEXT_GAP
#undef TPM_E_DAA_INPUT_DATA0
#undef TPM_E_DAA_INPUT_DATA1
#undef TPM_E_DAA_ISSUER_SETTINGS
#undef TPM_E_DAA_ISSUER_VALIDITY
#undef TPM_E_DAA_RESOURCES
#undef TPM_E_DAA_STAGE
#undef TPM_E_DAA_TPM_SETTINGS
#undef TPM_E_DAA_WRONG_W
#undef TPM_E_DEACTIVATED
#undef TPM_E_DECRYPT_ERROR
#undef TPM_E_DEFEND_LOCK_RUNNING
#undef TPM_E_DELEGATE_ADMIN
#undef TPM_E_DELEGATE_FAMILY
#undef TPM_E_DELEGATE_LOCK
#undef TPM_E_DISABLED
#undef TPM_E_DISABLED_CMD
#undef TPM_E_DOING_SELFTEST
#undef TPM_E_ENCRYPT_ERROR
#undef TPM_E_FAIL
#undef TPM_E_FAILEDSELFTEST
#undef TPM_E_FAMILYCOUNT
#undef TPM_E_INAPPROPRIATE_ENC
#undef TPM_E_INAPPROPRIATE_SIG
#undef TPM_E_INSTALL_DISABLED
#undef TPM_E_INVALID_AUTHHANDLE
#undef TPM_E_INVALID_FAMILY
#undef TPM_E_INVALID_KEYHANDLE
#undef TPM_E_INVALID_KEYUSAGE
#undef TPM_E_INVALID_PCR_INFO
#undef TPM_E_INVALID_POSTINIT
#undef TPM_E_INVALID_RESOURCE
#undef TPM_E_INVALID_STRUCTURE
#undef TPM_E_IOERROR
#undef TPM_E_KEYNOTFOUND
#undef TPM_E_KEY_NOTSUPPORTED
#undef TPM_E_KEY_OWNER_CONTROL
#undef TPM_E_MAXNVWRITES
#undef TPM_E_MA_AUTHORITY
#undef TPM_E_MA_DESTINATION
#undef TPM_E_MA_SOURCE
#undef TPM_E_MA_TICKET_SIGNATURE
#undef TPM_E_MIGRATEFAIL
#undef TPM_E_NEEDS_SELFTEST
#undef TPM_E_NOCONTEXTSPACE
#undef TPM_E_NOOPERATOR
#undef TPM_E_NOSPACE
#undef TPM_E_NOSRK
#undef TPM_E_NOTFIPS
#undef TPM_E_NOTLOCAL
#undef TPM_E_NOTRESETABLE
#undef TPM_E_NOTSEALED_BLOB
#undef TPM_E_NOT_FULLWRITE
#undef TPM_E_NO_ENDORSEMENT
#undef TPM_E_NO_NV_PERMISSION
#undef TPM_E_NO_WRAP_TRANSPORT
#undef TPM_E_OWNER_CONTROL
#undef TPM_E_OWNER_SET
#undef TPM_E_PERMANENTEK
#undef TPM_E_PER_NOWRITE
#undef TPM_E_READ_ONLY
#undef TPM_E_REQUIRES_SIGN
#undef TPM_E_RESOURCEMISSING
#undef TPM_E_RESOURCES
#undef TPM_E_RETRY
#undef TPM_E_SHA_ERROR
#undef TPM_E_SHA_THREAD
#undef TPM_E_SHORTRANDOM
#undef TPM_E_SIZE
#undef TPM_E_TOOMANYCONTEXTS
#undef TPM_E_TRANSPORT_NOTEXCLUSIVE
#undef TPM_E_WRITE_LOCKED
#undef TPM_E_WRONGPCRVAL
#undef TPM_E_WRONG_ENTITYTYPE
#undef TPM_SUCCESS
#endif /* WIN_OMIT_TSS_TPM_RETURN_CODES */

#define PLA_E_DCS_NOT_FOUND  _HRESULT_TYPEDEF_(0x80300002L)
#define PLA_E_DCS_IN_USE  _HRESULT_TYPEDEF_(0x803000AAL)
#define PLA_E_TOO_MANY_FOLDERS  _HRESULT_TYPEDEF_(0x80300045L)
#define PLA_E_NO_MIN_DISK  _HRESULT_TYPEDEF_(0x80300070L)
#define PLA_E_DCS_ALREADY_EXISTS  _HRESULT_TYPEDEF_(0x803000B7L)
#define PLA_S_PROPERTY_IGNORED  _HRESULT_TYPEDEF_(0x00300100L)
#define PLA_E_PROPERTY_CONFLICT  _HRESULT_TYPEDEF_(0x80300101L)
#define PLA_E_DCS_SINGLETON_REQUIRED  _HRESULT_TYPEDEF_(0x80300102L)
#define PLA_E_CREDENTIALS_REQUIRED  _HRESULT_TYPEDEF_(0x80300103L)
#define PLA_E_DCS_NOT_RUNNING  _HRESULT_TYPEDEF_(0x80300104L)
#define PLA_E_CONFLICT_INCL_EXCL_API  _HRESULT_TYPEDEF_(0x80300105L)
#define PLA_E_NETWORK_EXE_NOT_VALID  _HRESULT_TYPEDEF_(0x80300106L)
#define PLA_E_EXE_ALREADY_CONFIGURED  _HRESULT_TYPEDEF_(0x80300107L)
#define PLA_E_EXE_PATH_NOT_VALID  _HRESULT_TYPEDEF_(0x80300108L)
#define PLA_E_DC_ALREADY_EXISTS  _HRESULT_TYPEDEF_(0x80300109L)
#define PLA_E_DCS_START_WAIT_TIMEOUT  _HRESULT_TYPEDEF_(0x8030010AL)
#define PLA_E_DC_START_WAIT_TIMEOUT  _HRESULT_TYPEDEF_(0x8030010BL)
#define PLA_E_REPORT_WAIT_TIMEOUT  _HRESULT_TYPEDEF_(0x8030010CL)
#define PLA_E_NO_DUPLICATES  _HRESULT_TYPEDEF_(0x8030010DL)
#define PLA_E_EXE_FULL_PATH_REQUIRED  _HRESULT_TYPEDEF_(0x8030010EL)
#define PLA_E_INVALID_SESSION_NAME  _HRESULT_TYPEDEF_(0x8030010FL)
#define PLA_E_PLA_CHANNEL_NOT_ENABLED  _HRESULT_TYPEDEF_(0x80300110L)
#define PLA_E_TASKSCHED_CHANNEL_NOT_ENABLED _HRESULT_TYPEDEF_(0x80300111L)
#define PLA_E_RULES_MANAGER_FAILED  _HRESULT_TYPEDEF_(0x80300112L)
#define PLA_E_CABAPI_FAILURE  _HRESULT_TYPEDEF_(0x80300113L)
#define FVE_E_LOCKED_VOLUME  _HRESULT_TYPEDEF_(0x80310000L)
#define FVE_E_NOT_ENCRYPTED  _HRESULT_TYPEDEF_(0x80310001L)
#define FVE_E_NO_TPM_BIOS  _HRESULT_TYPEDEF_(0x80310002L)
#define FVE_E_NO_MBR_METRIC  _HRESULT_TYPEDEF_(0x80310003L)
#define FVE_E_NO_BOOTSECTOR_METRIC  _HRESULT_TYPEDEF_(0x80310004L)
#define FVE_E_NO_BOOTMGR_METRIC  _HRESULT_TYPEDEF_(0x80310005L)
#define FVE_E_WRONG_BOOTMGR  _HRESULT_TYPEDEF_(0x80310006L)
#define FVE_E_SECURE_KEY_REQUIRED  _HRESULT_TYPEDEF_(0x80310007L)
#define FVE_E_NOT_ACTIVATED  _HRESULT_TYPEDEF_(0x80310008L)
#define FVE_E_ACTION_NOT_ALLOWED  _HRESULT_TYPEDEF_(0x80310009L)
#define FVE_E_AD_SCHEMA_NOT_INSTALLED  _HRESULT_TYPEDEF_(0x8031000AL)
#define FVE_E_AD_INVALID_DATATYPE  _HRESULT_TYPEDEF_(0x8031000BL)
#define FVE_E_AD_INVALID_DATASIZE  _HRESULT_TYPEDEF_(0x8031000CL)
#define FVE_E_AD_NO_VALUES  _HRESULT_TYPEDEF_(0x8031000DL)
#define FVE_E_AD_ATTR_NOT_SET  _HRESULT_TYPEDEF_(0x8031000EL)
#define FVE_E_AD_GUID_NOT_FOUND  _HRESULT_TYPEDEF_(0x8031000FL)
#define FVE_E_BAD_INFORMATION  _HRESULT_TYPEDEF_(0x80310010L)
#define FVE_E_TOO_SMALL  _HRESULT_TYPEDEF_(0x80310011L)
#define FVE_E_SYSTEM_VOLUME  _HRESULT_TYPEDEF_(0x80310012L)
#define FVE_E_FAILED_WRONG_FS  _HRESULT_TYPEDEF_(0x80310013L)
#define FVE_E_BAD_PARTITION_SIZE  _HRESULT_TYPEDEF_(0x80310014L)
#define FVE_E_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x80310015L)
#define FVE_E_BAD_DATA  _HRESULT_TYPEDEF_(0x80310016L)
#define FVE_E_VOLUME_NOT_BOUND  _HRESULT_TYPEDEF_(0x80310017L)
#define FVE_E_TPM_NOT_OWNED  _HRESULT_TYPEDEF_(0x80310018L)
#define FVE_E_NOT_DATA_VOLUME  _HRESULT_TYPEDEF_(0x80310019L)
#define FVE_E_AD_INSUFFICIENT_BUFFER  _HRESULT_TYPEDEF_(0x8031001AL)
#define FVE_E_CONV_READ  _HRESULT_TYPEDEF_(0x8031001BL)
#define FVE_E_CONV_WRITE  _HRESULT_TYPEDEF_(0x8031001CL)
#define FVE_E_KEY_REQUIRED  _HRESULT_TYPEDEF_(0x8031001DL)
#define FVE_E_CLUSTERING_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x8031001EL)
#define FVE_E_VOLUME_BOUND_ALREADY  _HRESULT_TYPEDEF_(0x8031001FL)
#define FVE_E_OS_NOT_PROTECTED  _HRESULT_TYPEDEF_(0x80310020L)
#define FVE_E_PROTECTION_DISABLED  _HRESULT_TYPEDEF_(0x80310021L)
#define FVE_E_RECOVERY_KEY_REQUIRED  _HRESULT_TYPEDEF_(0x80310022L)
#define FVE_E_FOREIGN_VOLUME  _HRESULT_TYPEDEF_(0x80310023L)
#define FVE_E_OVERLAPPED_UPDATE  _HRESULT_TYPEDEF_(0x80310024L)
#define FVE_E_TPM_SRK_AUTH_NOT_ZERO  _HRESULT_TYPEDEF_(0x80310025L)
#define FVE_E_FAILED_SECTOR_SIZE  _HRESULT_TYPEDEF_(0x80310026L)
#define FVE_E_FAILED_AUTHENTICATION  _HRESULT_TYPEDEF_(0x80310027L)
#define FVE_E_NOT_OS_VOLUME  _HRESULT_TYPEDEF_(0x80310028L)
#define FVE_E_AUTOUNLOCK_ENABLED  _HRESULT_TYPEDEF_(0x80310029L)
#define FVE_E_WRONG_BOOTSECTOR  _HRESULT_TYPEDEF_(0x8031002AL)
#define FVE_E_WRONG_SYSTEM_FS  _HRESULT_TYPEDEF_(0x8031002BL)
#define FVE_E_POLICY_PASSWORD_REQUIRED  _HRESULT_TYPEDEF_(0x8031002CL)
#define FVE_E_CANNOT_SET_FVEK_ENCRYPTED  _HRESULT_TYPEDEF_(0x8031002DL)
#define FVE_E_CANNOT_ENCRYPT_NO_KEY  _HRESULT_TYPEDEF_(0x8031002EL)
#define FVE_E_BOOTABLE_CDDVD  _HRESULT_TYPEDEF_(0x80310030L)
#define FVE_E_PROTECTOR_EXISTS  _HRESULT_TYPEDEF_(0x80310031L)
#define FVE_E_RELATIVE_PATH  _HRESULT_TYPEDEF_(0x80310032L)
#define FVE_E_PROTECTOR_NOT_FOUND  _HRESULT_TYPEDEF_(0x80310033L)
#define FVE_E_INVALID_KEY_FORMAT  _HRESULT_TYPEDEF_(0x80310034L)
#define FVE_E_INVALID_PASSWORD_FORMAT  _HRESULT_TYPEDEF_(0x80310035L)
#define FVE_E_FIPS_RNG_CHECK_FAILED  _HRESULT_TYPEDEF_(0x80310036L)
#define FVE_E_FIPS_PREVENTS_RECOVERY_PASSWORD _HRESULT_TYPEDEF_(0x80310037L)
#define FVE_E_FIPS_PREVENTS_EXTERNAL_KEY_EXPORT _HRESULT_TYPEDEF_(0x80310038L)
#define FVE_E_NOT_DECRYPTED  _HRESULT_TYPEDEF_(0x80310039L)
#define FVE_E_INVALID_PROTECTOR_TYPE  _HRESULT_TYPEDEF_(0x8031003AL)
#define FVE_E_NO_PROTECTORS_TO_TEST  _HRESULT_TYPEDEF_(0x8031003BL)
#define FVE_E_KEYFILE_NOT_FOUND  _HRESULT_TYPEDEF_(0x8031003CL)
#define FVE_E_KEYFILE_INVALID  _HRESULT_TYPEDEF_(0x8031003DL)
#define FVE_E_KEYFILE_NO_VMK  _HRESULT_TYPEDEF_(0x8031003EL)
#define FVE_E_TPM_DISABLED  _HRESULT_TYPEDEF_(0x8031003FL)
#define FVE_E_NOT_ALLOWED_IN_SAFE_MODE  _HRESULT_TYPEDEF_(0x80310040L)
#define FVE_E_TPM_INVALID_PCR  _HRESULT_TYPEDEF_(0x80310041L)
#define FVE_E_TPM_NO_VMK  _HRESULT_TYPEDEF_(0x80310042L)
#define FVE_E_PIN_INVALID  _HRESULT_TYPEDEF_(0x80310043L)
#define FVE_E_AUTH_INVALID_APPLICATION  _HRESULT_TYPEDEF_(0x80310044L)
#define FVE_E_AUTH_INVALID_CONFIG  _HRESULT_TYPEDEF_(0x80310045L)
#define FVE_E_FIPS_DISABLE_PROTECTION_NOT_ALLOWED _HRESULT_TYPEDEF_(0x80310046L)
#define FVE_E_FS_NOT_EXTENDED  _HRESULT_TYPEDEF_(0x80310047L)
#define FVE_E_FIRMWARE_TYPE_NOT_SUPPORTED _HRESULT_TYPEDEF_(0x80310048L)
#define FVE_E_NO_LICENSE  _HRESULT_TYPEDEF_(0x80310049L)
#define FVE_E_NOT_ON_STACK  _HRESULT_TYPEDEF_(0x8031004AL)
#define FVE_E_FS_MOUNTED  _HRESULT_TYPEDEF_(0x8031004BL)
#define FVE_E_TOKEN_NOT_IMPERSONATED  _HRESULT_TYPEDEF_(0x8031004CL)
#define FVE_E_DRY_RUN_FAILED  _HRESULT_TYPEDEF_(0x8031004DL)
#define FVE_E_REBOOT_REQUIRED  _HRESULT_TYPEDEF_(0x8031004EL)
#define FVE_E_DEBUGGER_ENABLED  _HRESULT_TYPEDEF_(0x8031004FL)
#define FVE_E_RAW_ACCESS  _HRESULT_TYPEDEF_(0x80310050L)
#define FVE_E_RAW_BLOCKED  _HRESULT_TYPEDEF_(0x80310051L)
#define FVE_E_BCD_APPLICATIONS_PATH_INCORRECT _HRESULT_TYPEDEF_(0x80310052L)
#define FVE_E_NOT_ALLOWED_IN_VERSION  _HRESULT_TYPEDEF_(0x80310053L)
#define FVE_E_NO_AUTOUNLOCK_MASTER_KEY  _HRESULT_TYPEDEF_(0x80310054L)
#define FVE_E_MOR_FAILED  _HRESULT_TYPEDEF_(0x80310055L)
#define FVE_E_HIDDEN_VOLUME  _HRESULT_TYPEDEF_(0x80310056L)
#define FVE_E_TRANSIENT_STATE  _HRESULT_TYPEDEF_(0x80310057L)
#define FVE_E_PUBKEY_NOT_ALLOWED  _HRESULT_TYPEDEF_(0x80310058L)
#define FVE_E_VOLUME_HANDLE_OPEN  _HRESULT_TYPEDEF_(0x80310059L)
#define FVE_E_NO_FEATURE_LICENSE  _HRESULT_TYPEDEF_(0x8031005AL)
#define FVE_E_INVALID_STARTUP_OPTIONS  _HRESULT_TYPEDEF_(0x8031005BL)
#define FVE_E_POLICY_RECOVERY_PASSWORD_NOT_ALLOWED _HRESULT_TYPEDEF_(0x8031005CL)
#define FVE_E_POLICY_RECOVERY_PASSWORD_REQUIRED _HRESULT_TYPEDEF_(0x8031005DL)
#define FVE_E_POLICY_RECOVERY_KEY_NOT_ALLOWED _HRESULT_TYPEDEF_(0x8031005EL)
#define FVE_E_POLICY_RECOVERY_KEY_REQUIRED _HRESULT_TYPEDEF_(0x8031005FL)
#define FVE_E_POLICY_STARTUP_PIN_NOT_ALLOWED _HRESULT_TYPEDEF_(0x80310060L)
#define FVE_E_POLICY_STARTUP_PIN_REQUIRED _HRESULT_TYPEDEF_(0x80310061L)
#define FVE_E_POLICY_STARTUP_KEY_NOT_ALLOWED _HRESULT_TYPEDEF_(0x80310062L)
#define FVE_E_POLICY_STARTUP_KEY_REQUIRED _HRESULT_TYPEDEF_(0x80310063L)
#define FVE_E_POLICY_STARTUP_PIN_KEY_NOT_ALLOWED _HRESULT_TYPEDEF_(0x80310064L)
#define FVE_E_POLICY_STARTUP_PIN_KEY_REQUIRED _HRESULT_TYPEDEF_(0x80310065L)
#define FVE_E_POLICY_STARTUP_TPM_NOT_ALLOWED _HRESULT_TYPEDEF_(0x80310066L)
#define FVE_E_POLICY_STARTUP_TPM_REQUIRED _HRESULT_TYPEDEF_(0x80310067L)
#define FVE_E_POLICY_INVALID_PIN_LENGTH  _HRESULT_TYPEDEF_(0x80310068L)
#define FVE_E_KEY_PROTECTOR_NOT_SUPPORTED _HRESULT_TYPEDEF_(0x80310069L)
#define FVE_E_POLICY_PASSPHRASE_NOT_ALLOWED _HRESULT_TYPEDEF_(0x8031006AL)
#define FVE_E_POLICY_PASSPHRASE_REQUIRED _HRESULT_TYPEDEF_(0x8031006BL)
#define FVE_E_FIPS_PREVENTS_PASSPHRASE  _HRESULT_TYPEDEF_(0x8031006CL)
#define FVE_E_OS_VOLUME_PASSPHRASE_NOT_ALLOWED _HRESULT_TYPEDEF_(0x8031006DL)
#define FVE_E_INVALID_BITLOCKER_OID  _HRESULT_TYPEDEF_(0x8031006EL)
#define FVE_E_VOLUME_TOO_SMALL  _HRESULT_TYPEDEF_(0x8031006FL)
#define FVE_E_DV_NOT_SUPPORTED_ON_FS  _HRESULT_TYPEDEF_(0x80310070L)
#define FVE_E_DV_NOT_ALLOWED_BY_GP  _HRESULT_TYPEDEF_(0x80310071L)
#define FVE_E_POLICY_USER_CERTIFICATE_NOT_ALLOWED _HRESULT_TYPEDEF_(0x80310072L)
#define FVE_E_POLICY_USER_CERTIFICATE_REQUIRED _HRESULT_TYPEDEF_(0x80310073L)
#define FVE_E_POLICY_USER_CERT_MUST_BE_HW _HRESULT_TYPEDEF_(0x80310074L)
#define FVE_E_POLICY_USER_CONFIGURE_FDV_AUTOUNLOCK_NOT_ALLOWED _HRESULT_TYPEDEF_(0x80310075L)
#define FVE_E_POLICY_USER_CONFIGURE_RDV_AUTOUNLOCK_NOT_ALLOWED _HRESULT_TYPEDEF_(0x80310076L)
#define FVE_E_POLICY_USER_CONFIGURE_RDV_NOT_ALLOWED _HRESULT_TYPEDEF_(0x80310077L)
#define FVE_E_POLICY_USER_ENABLE_RDV_NOT_ALLOWED _HRESULT_TYPEDEF_(0x80310078L)
#define FVE_E_POLICY_USER_DISABLE_RDV_NOT_ALLOWED _HRESULT_TYPEDEF_(0x80310079L)
#define FVE_E_POLICY_INVALID_PASSPHRASE_LENGTH _HRESULT_TYPEDEF_(0x80310080L)
#define FVE_E_POLICY_PASSPHRASE_TOO_SIMPLE _HRESULT_TYPEDEF_(0x80310081L)
#define FVE_E_RECOVERY_PARTITION  _HRESULT_TYPEDEF_(0x80310082L)
#define FVE_E_POLICY_CONFLICT_FDV_RK_OFF_AUK_ON _HRESULT_TYPEDEF_(0x80310083L)
#define FVE_E_POLICY_CONFLICT_RDV_RK_OFF_AUK_ON _HRESULT_TYPEDEF_(0x80310084L)
#define FVE_E_NON_BITLOCKER_OID  _HRESULT_TYPEDEF_(0x80310085L)
#define FVE_E_POLICY_PROHIBITS_SELFSIGNED _HRESULT_TYPEDEF_(0x80310086L)
#define FVE_E_POLICY_CONFLICT_RO_AND_STARTUP_KEY_REQUIRED _HRESULT_TYPEDEF_(0x80310087L)
#define FVE_E_CONV_RECOVERY_FAILED  _HRESULT_TYPEDEF_(0x80310088L)
#define FVE_E_VIRTUALIZED_SPACE_TOO_BIG  _HRESULT_TYPEDEF_(0x80310089L)
#define FVE_E_POLICY_CONFLICT_OSV_RP_OFF_ADB_ON _HRESULT_TYPEDEF_(0x80310090L)
#define FVE_E_POLICY_CONFLICT_FDV_RP_OFF_ADB_ON _HRESULT_TYPEDEF_(0x80310091L)
#define FVE_E_POLICY_CONFLICT_RDV_RP_OFF_ADB_ON _HRESULT_TYPEDEF_(0x80310092L)
#define FVE_E_NON_BITLOCKER_KU  _HRESULT_TYPEDEF_(0x80310093L)
#define FVE_E_PRIVATEKEY_AUTH_FAILED  _HRESULT_TYPEDEF_(0x80310094L)
#define FVE_E_REMOVAL_OF_DRA_FAILED  _HRESULT_TYPEDEF_(0x80310095L)
#define FVE_E_OPERATION_NOT_SUPPORTED_ON_VISTA_VOLUME _HRESULT_TYPEDEF_(0x80310096L)
#define FVE_E_CANT_LOCK_AUTOUNLOCK_ENABLED_VOLUME _HRESULT_TYPEDEF_(0x80310097L)
#define FVE_E_FIPS_HASH_KDF_NOT_ALLOWED  _HRESULT_TYPEDEF_(0x80310098L)
#define FVE_E_ENH_PIN_INVALID  _HRESULT_TYPEDEF_(0x80310099L)
#define FVE_E_INVALID_PIN_CHARS  _HRESULT_TYPEDEF_(0x8031009AL)
#define FVE_E_INVALID_DATUM_TYPE  _HRESULT_TYPEDEF_(0x8031009BL)
#define FVE_E_EFI_ONLY  _HRESULT_TYPEDEF_(0x8031009CL)
#define FVE_E_MULTIPLE_NKP_CERTS  _HRESULT_TYPEDEF_(0x8031009DL)
#define FVE_E_REMOVAL_OF_NKP_FAILED  _HRESULT_TYPEDEF_(0x8031009EL)
#define FVE_E_INVALID_NKP_CERT  _HRESULT_TYPEDEF_(0x8031009FL)
#define FVE_E_NO_EXISTING_PIN  _HRESULT_TYPEDEF_(0x803100A0L)
#define FVE_E_PROTECTOR_CHANGE_PIN_MISMATCH _HRESULT_TYPEDEF_(0x803100A1L)
#define FVE_E_PIN_PROTECTOR_CHANGE_BY_STD_USER_DISALLOWED _HRESULT_TYPEDEF_(0x803100A2L)
#define FVE_E_PROTECTOR_CHANGE_MAX_PIN_CHANGE_ATTEMPTS_REACHED _HRESULT_TYPEDEF_(0x803100A3L)
#define FVE_E_POLICY_PASSPHRASE_REQUIRES_ASCII _HRESULT_TYPEDEF_(0x803100A4L)
#define FVE_E_FULL_ENCRYPTION_NOT_ALLOWED_ON_TP_STORAGE _HRESULT_TYPEDEF_(0x803100A5L)
#define FVE_E_WIPE_NOT_ALLOWED_ON_TP_STORAGE _HRESULT_TYPEDEF_(0x803100A6L)
#define FVE_E_KEY_LENGTH_NOT_SUPPORTED_BY_EDRIVE _HRESULT_TYPEDEF_(0x803100A7L)
#define FVE_E_NO_EXISTING_PASSPHRASE  _HRESULT_TYPEDEF_(0x803100A8L)
#define FVE_E_PROTECTOR_CHANGE_PASSPHRASE_MISMATCH _HRESULT_TYPEDEF_(0x803100A9L)
#define FVE_E_PASSPHRASE_TOO_LONG  _HRESULT_TYPEDEF_(0x803100AAL)
#define FVE_E_NO_PASSPHRASE_WITH_TPM  _HRESULT_TYPEDEF_(0x803100ABL)
#define FVE_E_NO_TPM_WITH_PASSPHRASE  _HRESULT_TYPEDEF_(0x803100ACL)
#define FVE_E_NOT_ALLOWED_ON_CSV_STACK  _HRESULT_TYPEDEF_(0x803100ADL)
#define FVE_E_NOT_ALLOWED_ON_CLUSTER  _HRESULT_TYPEDEF_(0x803100AEL)
#define FVE_E_EDRIVE_NO_FAILOVER_TO_SW  _HRESULT_TYPEDEF_(0x803100AFL)
#define FVE_E_EDRIVE_BAND_IN_USE  _HRESULT_TYPEDEF_(0x803100B0L)
#define FVE_E_EDRIVE_DISALLOWED_BY_GP  _HRESULT_TYPEDEF_(0x803100B1L)
#define FVE_E_EDRIVE_INCOMPATIBLE_VOLUME _HRESULT_TYPEDEF_(0x803100B2L)
#define FVE_E_NOT_ALLOWED_TO_UPGRADE_WHILE_CONVERTING _HRESULT_TYPEDEF_(0x803100B3L)
#define FVE_E_EDRIVE_DV_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x803100B4L)
#define FVE_E_NO_PREBOOT_KEYBOARD_DETECTED _HRESULT_TYPEDEF_(0x803100B5L)
#define FVE_E_NO_PREBOOT_KEYBOARD_OR_WINRE_DETECTED _HRESULT_TYPEDEF_(0x803100B6L)
#define FVE_E_POLICY_REQUIRES_STARTUP_PIN_ON_TOUCH_DEVICE _HRESULT_TYPEDEF_(0x803100B7L)
#define FVE_E_POLICY_REQUIRES_RECOVERY_PASSWORD_ON_TOUCH_DEVICE _HRESULT_TYPEDEF_(0x803100B8L)
#define FVE_E_WIPE_CANCEL_NOT_APPLICABLE _HRESULT_TYPEDEF_(0x803100B9L)
#define FVE_E_SECUREBOOT_DISABLED  _HRESULT_TYPEDEF_(0x803100BAL)
#define FVE_E_SECUREBOOT_CONFIGURATION_INVALID _HRESULT_TYPEDEF_(0x803100BBL)
#define FVE_E_EDRIVE_DRY_RUN_FAILED  _HRESULT_TYPEDEF_(0x803100BCL)
#define FVE_E_SHADOW_COPY_PRESENT  _HRESULT_TYPEDEF_(0x803100BDL)
#define FVE_E_POLICY_INVALID_ENHANCED_BCD_SETTINGS _HRESULT_TYPEDEF_(0x803100BEL)
#define FVE_E_EDRIVE_INCOMPATIBLE_FIRMWARE _HRESULT_TYPEDEF_(0x803100BFL)
#define FVE_E_PROTECTOR_CHANGE_MAX_PASSPHRASE_CHANGE_ATTEMPTS_REACHED _HRESULT_TYPEDEF_(0x803100C0L)
#define FVE_E_PASSPHRASE_PROTECTOR_CHANGE_BY_STD_USER_DISALLOWED _HRESULT_TYPEDEF_(0x803100C1L)
#define FVE_E_LIVEID_ACCOUNT_SUSPENDED  _HRESULT_TYPEDEF_(0x803100C2L)
#define FVE_E_LIVEID_ACCOUNT_BLOCKED  _HRESULT_TYPEDEF_(0x803100C3L)
#define FVE_E_NOT_PROVISIONED_ON_ALL_VOLUMES _HRESULT_TYPEDEF_(0x803100C4L)
#define FVE_E_DE_FIXED_DATA_NOT_SUPPORTED _HRESULT_TYPEDEF_(0x803100C5L)
#define FVE_E_DE_HARDWARE_NOT_COMPLIANT  _HRESULT_TYPEDEF_(0x803100C6L)
#define FVE_E_DE_WINRE_NOT_CONFIGURED  _HRESULT_TYPEDEF_(0x803100C7L)
#define FVE_E_DE_PROTECTION_SUSPENDED  _HRESULT_TYPEDEF_(0x803100C8L)
#define FVE_E_DE_OS_VOLUME_NOT_PROTECTED _HRESULT_TYPEDEF_(0x803100C9L)
#define FVE_E_DE_DEVICE_LOCKEDOUT  _HRESULT_TYPEDEF_(0x803100CAL)
#define FVE_E_DE_PROTECTION_NOT_YET_ENABLED _HRESULT_TYPEDEF_(0x803100CBL)
#define FVE_E_INVALID_PIN_CHARS_DETAILED _HRESULT_TYPEDEF_(0x803100CCL)
#define FVE_E_DEVICE_LOCKOUT_COUNTER_UNAVAILABLE _HRESULT_TYPEDEF_(0x803100CDL)
#define FVE_E_DEVICELOCKOUT_COUNTER_MISMATCH _HRESULT_TYPEDEF_(0x803100CEL)
#define FVE_E_BUFFER_TOO_LARGE  _HRESULT_TYPEDEF_(0x803100CFL)
#define FVE_E_NO_SUCH_CAPABILITY_ON_TARGET _HRESULT_TYPEDEF_(0x803100D0L)
#define FVE_E_DE_PREVENTED_FOR_OS  _HRESULT_TYPEDEF_(0x803100D1L)
#define FVE_E_DE_VOLUME_OPTED_OUT  _HRESULT_TYPEDEF_(0x803100D2L)
#define FVE_E_DE_VOLUME_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x803100D3L)
#define FVE_E_EOW_NOT_SUPPORTED_IN_VERSION _HRESULT_TYPEDEF_(0x803100D4L)
#define FVE_E_ADBACKUP_NOT_ENABLED  _HRESULT_TYPEDEF_(0x803100D5L)
#define FVE_E_VOLUME_EXTEND_PREVENTS_EOW_DECRYPT _HRESULT_TYPEDEF_(0x803100D6L)
#define FVE_E_NOT_DE_VOLUME  _HRESULT_TYPEDEF_(0x803100D7L)
#define FVE_E_PROTECTION_CANNOT_BE_DISABLED _HRESULT_TYPEDEF_(0x803100D8L)
#define FVE_E_OSV_KSR_NOT_ALLOWED  _HRESULT_TYPEDEF_(0x803100D9L)
#define FWP_E_CALLOUT_NOT_FOUND  _HRESULT_TYPEDEF_(0x80320001L)
#define FWP_E_CONDITION_NOT_FOUND  _HRESULT_TYPEDEF_(0x80320002L)
#define FWP_E_FILTER_NOT_FOUND  _HRESULT_TYPEDEF_(0x80320003L)
#define FWP_E_LAYER_NOT_FOUND  _HRESULT_TYPEDEF_(0x80320004L)
#define FWP_E_PROVIDER_NOT_FOUND  _HRESULT_TYPEDEF_(0x80320005L)
#define FWP_E_PROVIDER_CONTEXT_NOT_FOUND _HRESULT_TYPEDEF_(0x80320006L)
#define FWP_E_SUBLAYER_NOT_FOUND  _HRESULT_TYPEDEF_(0x80320007L)
#define FWP_E_NOT_FOUND  _HRESULT_TYPEDEF_(0x80320008L)
#define FWP_E_ALREADY_EXISTS  _HRESULT_TYPEDEF_(0x80320009L)
#define FWP_E_IN_USE  _HRESULT_TYPEDEF_(0x8032000AL)
#define FWP_E_DYNAMIC_SESSION_IN_PROGRESS _HRESULT_TYPEDEF_(0x8032000BL)
#define FWP_E_WRONG_SESSION  _HRESULT_TYPEDEF_(0x8032000CL)
#define FWP_E_NO_TXN_IN_PROGRESS  _HRESULT_TYPEDEF_(0x8032000DL)
#define FWP_E_TXN_IN_PROGRESS  _HRESULT_TYPEDEF_(0x8032000EL)
#define FWP_E_TXN_ABORTED  _HRESULT_TYPEDEF_(0x8032000FL)
#define FWP_E_SESSION_ABORTED  _HRESULT_TYPEDEF_(0x80320010L)
#define FWP_E_INCOMPATIBLE_TXN  _HRESULT_TYPEDEF_(0x80320011L)
#define FWP_E_TIMEOUT  _HRESULT_TYPEDEF_(0x80320012L)
#define FWP_E_NET_EVENTS_DISABLED  _HRESULT_TYPEDEF_(0x80320013L)
#define FWP_E_INCOMPATIBLE_LAYER  _HRESULT_TYPEDEF_(0x80320014L)
#define FWP_E_KM_CLIENTS_ONLY  _HRESULT_TYPEDEF_(0x80320015L)
#define FWP_E_LIFETIME_MISMATCH  _HRESULT_TYPEDEF_(0x80320016L)
#define FWP_E_BUILTIN_OBJECT  _HRESULT_TYPEDEF_(0x80320017L)
#define FWP_E_TOO_MANY_CALLOUTS  _HRESULT_TYPEDEF_(0x80320018L)
#define FWP_E_NOTIFICATION_DROPPED  _HRESULT_TYPEDEF_(0x80320019L)
#define FWP_E_TRAFFIC_MISMATCH  _HRESULT_TYPEDEF_(0x8032001AL)
#define FWP_E_INCOMPATIBLE_SA_STATE  _HRESULT_TYPEDEF_(0x8032001BL)
#define FWP_E_NULL_POINTER  _HRESULT_TYPEDEF_(0x8032001CL)
#define FWP_E_INVALID_ENUMERATOR  _HRESULT_TYPEDEF_(0x8032001DL)
#define FWP_E_INVALID_FLAGS  _HRESULT_TYPEDEF_(0x8032001EL)
#define FWP_E_INVALID_NET_MASK  _HRESULT_TYPEDEF_(0x8032001FL)
#define FWP_E_INVALID_RANGE  _HRESULT_TYPEDEF_(0x80320020L)
#define FWP_E_INVALID_INTERVAL  _HRESULT_TYPEDEF_(0x80320021L)
#define FWP_E_ZERO_LENGTH_ARRAY  _HRESULT_TYPEDEF_(0x80320022L)
#define FWP_E_NULL_DISPLAY_NAME  _HRESULT_TYPEDEF_(0x80320023L)
#define FWP_E_INVALID_ACTION_TYPE  _HRESULT_TYPEDEF_(0x80320024L)
#define FWP_E_INVALID_WEIGHT  _HRESULT_TYPEDEF_(0x80320025L)
#define FWP_E_MATCH_TYPE_MISMATCH  _HRESULT_TYPEDEF_(0x80320026L)
#define FWP_E_TYPE_MISMATCH  _HRESULT_TYPEDEF_(0x80320027L)
#define FWP_E_OUT_OF_BOUNDS  _HRESULT_TYPEDEF_(0x80320028L)
#define FWP_E_RESERVED  _HRESULT_TYPEDEF_(0x80320029L)
#define FWP_E_DUPLICATE_CONDITION  _HRESULT_TYPEDEF_(0x8032002AL)
#define FWP_E_DUPLICATE_KEYMOD  _HRESULT_TYPEDEF_(0x8032002BL)
#define FWP_E_ACTION_INCOMPATIBLE_WITH_LAYER _HRESULT_TYPEDEF_(0x8032002CL)
#define FWP_E_ACTION_INCOMPATIBLE_WITH_SUBLAYER _HRESULT_TYPEDEF_(0x8032002DL)
#define FWP_E_CONTEXT_INCOMPATIBLE_WITH_LAYER _HRESULT_TYPEDEF_(0x8032002EL)
#define FWP_E_CONTEXT_INCOMPATIBLE_WITH_CALLOUT _HRESULT_TYPEDEF_(0x8032002FL)
#define FWP_E_INCOMPATIBLE_AUTH_METHOD  _HRESULT_TYPEDEF_(0x80320030L)
#define FWP_E_INCOMPATIBLE_DH_GROUP  _HRESULT_TYPEDEF_(0x80320031L)
#define FWP_E_EM_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x80320032L)
#define FWP_E_NEVER_MATCH  _HRESULT_TYPEDEF_(0x80320033L)
#define FWP_E_PROVIDER_CONTEXT_MISMATCH  _HRESULT_TYPEDEF_(0x80320034L)
#define FWP_E_INVALID_PARAMETER  _HRESULT_TYPEDEF_(0x80320035L)
#define FWP_E_TOO_MANY_SUBLAYERS  _HRESULT_TYPEDEF_(0x80320036L)
#define FWP_E_CALLOUT_NOTIFICATION_FAILED _HRESULT_TYPEDEF_(0x80320037L)
#define FWP_E_INVALID_AUTH_TRANSFORM  _HRESULT_TYPEDEF_(0x80320038L)
#define FWP_E_INVALID_CIPHER_TRANSFORM  _HRESULT_TYPEDEF_(0x80320039L)
#define FWP_E_INCOMPATIBLE_CIPHER_TRANSFORM _HRESULT_TYPEDEF_(0x8032003AL)
#define FWP_E_INVALID_TRANSFORM_COMBINATION _HRESULT_TYPEDEF_(0x8032003BL)
#define FWP_E_DUPLICATE_AUTH_METHOD  _HRESULT_TYPEDEF_(0x8032003CL)
#define FWP_E_INVALID_TUNNEL_ENDPOINT  _HRESULT_TYPEDEF_(0x8032003DL)
#define FWP_E_L2_DRIVER_NOT_READY  _HRESULT_TYPEDEF_(0x8032003EL)
#define FWP_E_KEY_DICTATOR_ALREADY_REGISTERED _HRESULT_TYPEDEF_(0x8032003FL)
#define FWP_E_KEY_DICTATION_INVALID_KEYING_MATERIAL _HRESULT_TYPEDEF_(0x80320040L)
#define FWP_E_CONNECTIONS_DISABLED  _HRESULT_TYPEDEF_(0x80320041L)
#define FWP_E_INVALID_DNS_NAME  _HRESULT_TYPEDEF_(0x80320042L)
#define FWP_E_STILL_ON  _HRESULT_TYPEDEF_(0x80320043L)
#define FWP_E_IKEEXT_NOT_RUNNING  _HRESULT_TYPEDEF_(0x80320044L)
#define FWP_E_DROP_NOICMP  _HRESULT_TYPEDEF_(0x80320104L)
#define WS_S_ASYNC  _HRESULT_TYPEDEF_(0x003D0000L)
#define WS_S_END  _HRESULT_TYPEDEF_(0x003D0001L)
#define WS_E_INVALID_FORMAT  _HRESULT_TYPEDEF_(0x803D0000L)
#define WS_E_OBJECT_FAULTED  _HRESULT_TYPEDEF_(0x803D0001L)
#define WS_E_NUMERIC_OVERFLOW  _HRESULT_TYPEDEF_(0x803D0002L)
#define WS_E_INVALID_OPERATION  _HRESULT_TYPEDEF_(0x803D0003L)
#define WS_E_OPERATION_ABORTED  _HRESULT_TYPEDEF_(0x803D0004L)
#define WS_E_ENDPOINT_ACCESS_DENIED  _HRESULT_TYPEDEF_(0x803D0005L)
#define WS_E_OPERATION_TIMED_OUT  _HRESULT_TYPEDEF_(0x803D0006L)
#define WS_E_OPERATION_ABANDONED  _HRESULT_TYPEDEF_(0x803D0007L)
#define WS_E_QUOTA_EXCEEDED  _HRESULT_TYPEDEF_(0x803D0008L)
#define WS_E_NO_TRANSLATION_AVAILABLE  _HRESULT_TYPEDEF_(0x803D0009L)
#define WS_E_SECURITY_VERIFICATION_FAILURE _HRESULT_TYPEDEF_(0x803D000AL)
#define WS_E_ADDRESS_IN_USE  _HRESULT_TYPEDEF_(0x803D000BL)
#define WS_E_ADDRESS_NOT_AVAILABLE  _HRESULT_TYPEDEF_(0x803D000CL)
#define WS_E_ENDPOINT_NOT_FOUND  _HRESULT_TYPEDEF_(0x803D000DL)
#define WS_E_ENDPOINT_NOT_AVAILABLE  _HRESULT_TYPEDEF_(0x803D000EL)
#define WS_E_ENDPOINT_FAILURE  _HRESULT_TYPEDEF_(0x803D000FL)
#define WS_E_ENDPOINT_UNREACHABLE  _HRESULT_TYPEDEF_(0x803D0010L)
#define WS_E_ENDPOINT_ACTION_NOT_SUPPORTED _HRESULT_TYPEDEF_(0x803D0011L)
#define WS_E_ENDPOINT_TOO_BUSY  _HRESULT_TYPEDEF_(0x803D0012L)
#define WS_E_ENDPOINT_FAULT_RECEIVED  _HRESULT_TYPEDEF_(0x803D0013L)
#define WS_E_ENDPOINT_DISCONNECTED  _HRESULT_TYPEDEF_(0x803D0014L)
#define WS_E_PROXY_FAILURE  _HRESULT_TYPEDEF_(0x803D0015L)
#define WS_E_PROXY_ACCESS_DENIED  _HRESULT_TYPEDEF_(0x803D0016L)
#define WS_E_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x803D0017L)
#define WS_E_PROXY_REQUIRES_BASIC_AUTH  _HRESULT_TYPEDEF_(0x803D0018L)
#define WS_E_PROXY_REQUIRES_DIGEST_AUTH  _HRESULT_TYPEDEF_(0x803D0019L)
#define WS_E_PROXY_REQUIRES_NTLM_AUTH  _HRESULT_TYPEDEF_(0x803D001AL)
#define WS_E_PROXY_REQUIRES_NEGOTIATE_AUTH _HRESULT_TYPEDEF_(0x803D001BL)
#define WS_E_SERVER_REQUIRES_BASIC_AUTH  _HRESULT_TYPEDEF_(0x803D001CL)
#define WS_E_SERVER_REQUIRES_DIGEST_AUTH _HRESULT_TYPEDEF_(0x803D001DL)
#define WS_E_SERVER_REQUIRES_NTLM_AUTH  _HRESULT_TYPEDEF_(0x803D001EL)
#define WS_E_SERVER_REQUIRES_NEGOTIATE_AUTH _HRESULT_TYPEDEF_(0x803D001FL)
#define WS_E_INVALID_ENDPOINT_URL  _HRESULT_TYPEDEF_(0x803D0020L)
#define WS_E_OTHER  _HRESULT_TYPEDEF_(0x803D0021L)
#define WS_E_SECURITY_TOKEN_EXPIRED  _HRESULT_TYPEDEF_(0x803D0022L)
#define WS_E_SECURITY_SYSTEM_FAILURE  _HRESULT_TYPEDEF_(0x803D0023L)

#ifdef RC_INVOKED
#define _NDIS_ERROR_TYPEDEF_(_sc)  _sc
#else /* !RC_INVOKED */
#define _NDIS_ERROR_TYPEDEF_(_sc)  (DWORD)(_sc)
#endif /* !RC_INVOKED */

#define ERROR_NDIS_INTERFACE_CLOSING  _NDIS_ERROR_TYPEDEF_(0x80340002L)
#define ERROR_NDIS_BAD_VERSION  _NDIS_ERROR_TYPEDEF_(0x80340004L)
#define ERROR_NDIS_BAD_CHARACTERISTICS  _NDIS_ERROR_TYPEDEF_(0x80340005L)
#define ERROR_NDIS_ADAPTER_NOT_FOUND  _NDIS_ERROR_TYPEDEF_(0x80340006L)
#define ERROR_NDIS_OPEN_FAILED  _NDIS_ERROR_TYPEDEF_(0x80340007L)
#define ERROR_NDIS_DEVICE_FAILED  _NDIS_ERROR_TYPEDEF_(0x80340008L)
#define ERROR_NDIS_MULTICAST_FULL  _NDIS_ERROR_TYPEDEF_(0x80340009L)
#define ERROR_NDIS_MULTICAST_EXISTS  _NDIS_ERROR_TYPEDEF_(0x8034000AL)
#define ERROR_NDIS_MULTICAST_NOT_FOUND  _NDIS_ERROR_TYPEDEF_(0x8034000BL)
#define ERROR_NDIS_REQUEST_ABORTED  _NDIS_ERROR_TYPEDEF_(0x8034000CL)
#define ERROR_NDIS_RESET_IN_PROGRESS  _NDIS_ERROR_TYPEDEF_(0x8034000DL)
#define ERROR_NDIS_NOT_SUPPORTED  _NDIS_ERROR_TYPEDEF_(0x803400BBL)
#define ERROR_NDIS_INVALID_PACKET  _NDIS_ERROR_TYPEDEF_(0x8034000FL)
#define ERROR_NDIS_ADAPTER_NOT_READY  _NDIS_ERROR_TYPEDEF_(0x80340011L)
#define ERROR_NDIS_INVALID_LENGTH  _NDIS_ERROR_TYPEDEF_(0x80340014L)
#define ERROR_NDIS_INVALID_DATA  _NDIS_ERROR_TYPEDEF_(0x80340015L)
#define ERROR_NDIS_BUFFER_TOO_SHORT  _NDIS_ERROR_TYPEDEF_(0x80340016L)
#define ERROR_NDIS_INVALID_OID  _NDIS_ERROR_TYPEDEF_(0x80340017L)
#define ERROR_NDIS_ADAPTER_REMOVED  _NDIS_ERROR_TYPEDEF_(0x80340018L)
#define ERROR_NDIS_UNSUPPORTED_MEDIA  _NDIS_ERROR_TYPEDEF_(0x80340019L)
#define ERROR_NDIS_GROUP_ADDRESS_IN_USE  _NDIS_ERROR_TYPEDEF_(0x8034001AL)
#define ERROR_NDIS_FILE_NOT_FOUND  _NDIS_ERROR_TYPEDEF_(0x8034001BL)
#define ERROR_NDIS_ERROR_READING_FILE  _NDIS_ERROR_TYPEDEF_(0x8034001CL)
#define ERROR_NDIS_ALREADY_MAPPED  _NDIS_ERROR_TYPEDEF_(0x8034001DL)
#define ERROR_NDIS_RESOURCE_CONFLICT  _NDIS_ERROR_TYPEDEF_(0x8034001EL)
#define ERROR_NDIS_MEDIA_DISCONNECTED  _NDIS_ERROR_TYPEDEF_(0x8034001FL)
#define ERROR_NDIS_INVALID_ADDRESS  _NDIS_ERROR_TYPEDEF_(0x80340022L)
#define ERROR_NDIS_INVALID_DEVICE_REQUEST _NDIS_ERROR_TYPEDEF_(0x80340010L)
#define ERROR_NDIS_PAUSED  _NDIS_ERROR_TYPEDEF_(0x8034002AL)
#define ERROR_NDIS_INTERFACE_NOT_FOUND  _NDIS_ERROR_TYPEDEF_(0x8034002BL)
#define ERROR_NDIS_UNSUPPORTED_REVISION  _NDIS_ERROR_TYPEDEF_(0x8034002CL)
#define ERROR_NDIS_INVALID_PORT  _NDIS_ERROR_TYPEDEF_(0x8034002DL)
#define ERROR_NDIS_INVALID_PORT_STATE  _NDIS_ERROR_TYPEDEF_(0x8034002EL)
#define ERROR_NDIS_LOW_POWER_STATE  _NDIS_ERROR_TYPEDEF_(0x8034002FL)
#define ERROR_NDIS_REINIT_REQUIRED  _NDIS_ERROR_TYPEDEF_(0x80340030L)
#define ERROR_NDIS_DOT11_AUTO_CONFIG_ENABLED _NDIS_ERROR_TYPEDEF_(0x80342000L)
#define ERROR_NDIS_DOT11_MEDIA_IN_USE  _NDIS_ERROR_TYPEDEF_(0x80342001L)
#define ERROR_NDIS_DOT11_POWER_STATE_INVALID _NDIS_ERROR_TYPEDEF_(0x80342002L)
#define ERROR_NDIS_PM_WOL_PATTERN_LIST_FULL _NDIS_ERROR_TYPEDEF_(0x80342003L)
#define ERROR_NDIS_PM_PROTOCOL_OFFLOAD_LIST_FULL _NDIS_ERROR_TYPEDEF_(0x80342004L)
#define ERROR_NDIS_DOT11_AP_CHANNEL_CURRENTLY_NOT_AVAILABLE _NDIS_ERROR_TYPEDEF_(0x80342005L)
#define ERROR_NDIS_DOT11_AP_BAND_CURRENTLY_NOT_AVAILABLE _NDIS_ERROR_TYPEDEF_(0x80342006L)
#define ERROR_NDIS_DOT11_AP_CHANNEL_NOT_ALLOWED _NDIS_ERROR_TYPEDEF_(0x80342007L)
#define ERROR_NDIS_DOT11_AP_BAND_NOT_ALLOWED _NDIS_ERROR_TYPEDEF_(0x80342008L)
#define ERROR_NDIS_INDICATION_REQUIRED  _NDIS_ERROR_TYPEDEF_(0x00340001L)
#define ERROR_NDIS_OFFLOAD_POLICY  _NDIS_ERROR_TYPEDEF_(0xC034100FL)
#define ERROR_NDIS_OFFLOAD_CONNECTION_REJECTED _NDIS_ERROR_TYPEDEF_(0xC0341012L)
#define ERROR_NDIS_OFFLOAD_PATH_REJECTED _NDIS_ERROR_TYPEDEF_(0xC0341013L)
#define ERROR_HV_INVALID_HYPERCALL_CODE  _NDIS_ERROR_TYPEDEF_(0xC0350002L)
#define ERROR_HV_INVALID_HYPERCALL_INPUT _NDIS_ERROR_TYPEDEF_(0xC0350003L)
#define ERROR_HV_INVALID_ALIGNMENT  _NDIS_ERROR_TYPEDEF_(0xC0350004L)
#define ERROR_HV_INVALID_PARAMETER  _NDIS_ERROR_TYPEDEF_(0xC0350005L)
#define ERROR_HV_ACCESS_DENIED  _NDIS_ERROR_TYPEDEF_(0xC0350006L)
#define ERROR_HV_INVALID_PARTITION_STATE _NDIS_ERROR_TYPEDEF_(0xC0350007L)
#define ERROR_HV_OPERATION_DENIED  _NDIS_ERROR_TYPEDEF_(0xC0350008L)
#define ERROR_HV_UNKNOWN_PROPERTY  _NDIS_ERROR_TYPEDEF_(0xC0350009L)
#define ERROR_HV_PROPERTY_VALUE_OUT_OF_RANGE _NDIS_ERROR_TYPEDEF_(0xC035000AL)
#define ERROR_HV_INSUFFICIENT_MEMORY  _NDIS_ERROR_TYPEDEF_(0xC035000BL)
#define ERROR_HV_PARTITION_TOO_DEEP  _NDIS_ERROR_TYPEDEF_(0xC035000CL)
#define ERROR_HV_INVALID_PARTITION_ID  _NDIS_ERROR_TYPEDEF_(0xC035000DL)
#define ERROR_HV_INVALID_VP_INDEX  _NDIS_ERROR_TYPEDEF_(0xC035000EL)
#define ERROR_HV_INVALID_PORT_ID  _NDIS_ERROR_TYPEDEF_(0xC0350011L)
#define ERROR_HV_INVALID_CONNECTION_ID  _NDIS_ERROR_TYPEDEF_(0xC0350012L)
#define ERROR_HV_INSUFFICIENT_BUFFERS  _NDIS_ERROR_TYPEDEF_(0xC0350013L)
#define ERROR_HV_NOT_ACKNOWLEDGED  _NDIS_ERROR_TYPEDEF_(0xC0350014L)
#define ERROR_HV_INVALID_VP_STATE  _NDIS_ERROR_TYPEDEF_(0xC0350015L)
#define ERROR_HV_ACKNOWLEDGED  _NDIS_ERROR_TYPEDEF_(0xC0350016L)
#define ERROR_HV_INVALID_SAVE_RESTORE_STATE _NDIS_ERROR_TYPEDEF_(0xC0350017L)
#define ERROR_HV_INVALID_SYNIC_STATE  _NDIS_ERROR_TYPEDEF_(0xC0350018L)
#define ERROR_HV_OBJECT_IN_USE  _NDIS_ERROR_TYPEDEF_(0xC0350019L)
#define ERROR_HV_INVALID_PROXIMITY_DOMAIN_INFO _NDIS_ERROR_TYPEDEF_(0xC035001AL)
#define ERROR_HV_NO_DATA  _NDIS_ERROR_TYPEDEF_(0xC035001BL)
#define ERROR_HV_INACTIVE  _NDIS_ERROR_TYPEDEF_(0xC035001CL)
#define ERROR_HV_NO_RESOURCES  _NDIS_ERROR_TYPEDEF_(0xC035001DL)
#define ERROR_HV_FEATURE_UNAVAILABLE  _NDIS_ERROR_TYPEDEF_(0xC035001EL)
#define ERROR_HV_INSUFFICIENT_BUFFER  _NDIS_ERROR_TYPEDEF_(0xC0350033L)
#define ERROR_HV_INSUFFICIENT_DEVICE_DOMAINS _NDIS_ERROR_TYPEDEF_(0xC0350038L)
#define ERROR_HV_CPUID_FEATURE_VALIDATION _NDIS_ERROR_TYPEDEF_(0xC035003CL)
#define ERROR_HV_CPUID_XSAVE_FEATURE_VALIDATION _NDIS_ERROR_TYPEDEF_(0xC035003DL)
#define ERROR_HV_PROCESSOR_STARTUP_TIMEOUT _NDIS_ERROR_TYPEDEF_(0xC035003EL)
#define ERROR_HV_SMX_ENABLED  _NDIS_ERROR_TYPEDEF_(0xC035003FL)
#define ERROR_HV_INVALID_LP_INDEX  _NDIS_ERROR_TYPEDEF_(0xC0350041L)
#define ERROR_HV_INVALID_REGISTER_VALUE  _NDIS_ERROR_TYPEDEF_(0xC0350050L)
#define ERROR_HV_INVALID_VTL_STATE  _NDIS_ERROR_TYPEDEF_(0xC0350051L)
#define ERROR_HV_NX_NOT_DETECTED  _NDIS_ERROR_TYPEDEF_(0xC0350055L)
#define ERROR_HV_INVALID_DEVICE_ID  _NDIS_ERROR_TYPEDEF_(0xC0350057L)
#define ERROR_HV_INVALID_DEVICE_STATE  _NDIS_ERROR_TYPEDEF_(0xC0350058L)
#define ERROR_HV_PENDING_PAGE_REQUESTS  _NDIS_ERROR_TYPEDEF_(0x00350059L)
#define ERROR_HV_PAGE_REQUEST_INVALID  _NDIS_ERROR_TYPEDEF_(0xC0350060L)
#define ERROR_HV_INVALID_CPU_GROUP_ID  _NDIS_ERROR_TYPEDEF_(0xC035006FL)
#define ERROR_HV_INVALID_CPU_GROUP_STATE _NDIS_ERROR_TYPEDEF_(0xC0350070L)
#define ERROR_HV_NOT_ALLOWED_WITH_NESTED_VIRT_ACTIVE _NDIS_ERROR_TYPEDEF_(0xC0350071L)
#define ERROR_HV_NOT_PRESENT  _NDIS_ERROR_TYPEDEF_(0xC0351000L)
#define ERROR_VID_DUPLICATE_HANDLER  _NDIS_ERROR_TYPEDEF_(0xC0370001L)
#define ERROR_VID_TOO_MANY_HANDLERS  _NDIS_ERROR_TYPEDEF_(0xC0370002L)
#define ERROR_VID_QUEUE_FULL  _NDIS_ERROR_TYPEDEF_(0xC0370003L)
#define ERROR_VID_HANDLER_NOT_PRESENT  _NDIS_ERROR_TYPEDEF_(0xC0370004L)
#define ERROR_VID_INVALID_OBJECT_NAME  _NDIS_ERROR_TYPEDEF_(0xC0370005L)
#define ERROR_VID_PARTITION_NAME_TOO_LONG _NDIS_ERROR_TYPEDEF_(0xC0370006L)
#define ERROR_VID_MESSAGE_QUEUE_NAME_TOO_LONG _NDIS_ERROR_TYPEDEF_(0xC0370007L)
#define ERROR_VID_PARTITION_ALREADY_EXISTS _NDIS_ERROR_TYPEDEF_(0xC0370008L)
#define ERROR_VID_PARTITION_DOES_NOT_EXIST _NDIS_ERROR_TYPEDEF_(0xC0370009L)
#define ERROR_VID_PARTITION_NAME_NOT_FOUND _NDIS_ERROR_TYPEDEF_(0xC037000AL)
#define ERROR_VID_MESSAGE_QUEUE_ALREADY_EXISTS _NDIS_ERROR_TYPEDEF_(0xC037000BL)
#define ERROR_VID_EXCEEDED_MBP_ENTRY_MAP_LIMIT _NDIS_ERROR_TYPEDEF_(0xC037000CL)
#define ERROR_VID_MB_STILL_REFERENCED  _NDIS_ERROR_TYPEDEF_(0xC037000DL)
#define ERROR_VID_CHILD_GPA_PAGE_SET_CORRUPTED _NDIS_ERROR_TYPEDEF_(0xC037000EL)
#define ERROR_VID_INVALID_NUMA_SETTINGS  _NDIS_ERROR_TYPEDEF_(0xC037000FL)
#define ERROR_VID_INVALID_NUMA_NODE_INDEX _NDIS_ERROR_TYPEDEF_(0xC0370010L)
#define ERROR_VID_NOTIFICATION_QUEUE_ALREADY_ASSOCIATED _NDIS_ERROR_TYPEDEF_(0xC0370011L)
#define ERROR_VID_INVALID_MEMORY_BLOCK_HANDLE _NDIS_ERROR_TYPEDEF_(0xC0370012L)
#define ERROR_VID_PAGE_RANGE_OVERFLOW  _NDIS_ERROR_TYPEDEF_(0xC0370013L)
#define ERROR_VID_INVALID_MESSAGE_QUEUE_HANDLE _NDIS_ERROR_TYPEDEF_(0xC0370014L)
#define ERROR_VID_INVALID_GPA_RANGE_HANDLE _NDIS_ERROR_TYPEDEF_(0xC0370015L)
#define ERROR_VID_NO_MEMORY_BLOCK_NOTIFICATION_QUEUE _NDIS_ERROR_TYPEDEF_(0xC0370016L)
#define ERROR_VID_MEMORY_BLOCK_LOCK_COUNT_EXCEEDED _NDIS_ERROR_TYPEDEF_(0xC0370017L)
#define ERROR_VID_INVALID_PPM_HANDLE  _NDIS_ERROR_TYPEDEF_(0xC0370018L)
#define ERROR_VID_MBPS_ARE_LOCKED  _NDIS_ERROR_TYPEDEF_(0xC0370019L)
#define ERROR_VID_MESSAGE_QUEUE_CLOSED  _NDIS_ERROR_TYPEDEF_(0xC037001AL)
#define ERROR_VID_VIRTUAL_PROCESSOR_LIMIT_EXCEEDED _NDIS_ERROR_TYPEDEF_(0xC037001BL)
#define ERROR_VID_STOP_PENDING  _NDIS_ERROR_TYPEDEF_(0xC037001CL)
#define ERROR_VID_INVALID_PROCESSOR_STATE _NDIS_ERROR_TYPEDEF_(0xC037001DL)
#define ERROR_VID_EXCEEDED_KM_CONTEXT_COUNT_LIMIT _NDIS_ERROR_TYPEDEF_(0xC037001EL)
#define ERROR_VID_KM_INTERFACE_ALREADY_INITIALIZED _NDIS_ERROR_TYPEDEF_(0xC037001FL)
#define ERROR_VID_MB_PROPERTY_ALREADY_SET_RESET _NDIS_ERROR_TYPEDEF_(0xC0370020L)
#define ERROR_VID_MMIO_RANGE_DESTROYED  _NDIS_ERROR_TYPEDEF_(0xC0370021L)
#define ERROR_VID_INVALID_CHILD_GPA_PAGE_SET _NDIS_ERROR_TYPEDEF_(0xC0370022L)
#define ERROR_VID_RESERVE_PAGE_SET_IS_BEING_USED _NDIS_ERROR_TYPEDEF_(0xC0370023L)
#define ERROR_VID_RESERVE_PAGE_SET_TOO_SMALL _NDIS_ERROR_TYPEDEF_(0xC0370024L)
#define ERROR_VID_MBP_ALREADY_LOCKED_USING_RESERVED_PAGE _NDIS_ERROR_TYPEDEF_(0xC0370025L)
#define ERROR_VID_MBP_COUNT_EXCEEDED_LIMIT _NDIS_ERROR_TYPEDEF_(0xC0370026L)
#define ERROR_VID_SAVED_STATE_CORRUPT  _NDIS_ERROR_TYPEDEF_(0xC0370027L)
#define ERROR_VID_SAVED_STATE_UNRECOGNIZED_ITEM _NDIS_ERROR_TYPEDEF_(0xC0370028L)
#define ERROR_VID_SAVED_STATE_INCOMPATIBLE _NDIS_ERROR_TYPEDEF_(0xC0370029L)
#define ERROR_VID_VTL_ACCESS_DENIED  _NDIS_ERROR_TYPEDEF_(0xC037002AL)
#define ERROR_VMCOMPUTE_TERMINATED_DURING_START _NDIS_ERROR_TYPEDEF_(0xC0370100L)
#define ERROR_VMCOMPUTE_IMAGE_MISMATCH  _NDIS_ERROR_TYPEDEF_(0xC0370101L)
#define ERROR_VMCOMPUTE_HYPERV_NOT_INSTALLED _NDIS_ERROR_TYPEDEF_(0xC0370102L)
#define ERROR_VMCOMPUTE_OPERATION_PENDING _NDIS_ERROR_TYPEDEF_(0xC0370103L)
#define ERROR_VMCOMPUTE_TOO_MANY_NOTIFICATIONS _NDIS_ERROR_TYPEDEF_(0xC0370104L)
#define ERROR_VMCOMPUTE_INVALID_STATE  _NDIS_ERROR_TYPEDEF_(0xC0370105L)
#define ERROR_VMCOMPUTE_UNEXPECTED_EXIT  _NDIS_ERROR_TYPEDEF_(0xC0370106L)
#define ERROR_VMCOMPUTE_TERMINATED  _NDIS_ERROR_TYPEDEF_(0xC0370107L)
#define ERROR_VMCOMPUTE_CONNECT_FAILED  _NDIS_ERROR_TYPEDEF_(0xC0370108L)
#define ERROR_VMCOMPUTE_TIMEOUT  _NDIS_ERROR_TYPEDEF_(0xC0370109L)
#define ERROR_VMCOMPUTE_CONNECTION_CLOSED _NDIS_ERROR_TYPEDEF_(0xC037010AL)
#define ERROR_VMCOMPUTE_UNKNOWN_MESSAGE  _NDIS_ERROR_TYPEDEF_(0xC037010BL)
#define ERROR_VMCOMPUTE_UNSUPPORTED_PROTOCOL_VERSION _NDIS_ERROR_TYPEDEF_(0xC037010CL)
#define ERROR_VMCOMPUTE_INVALID_JSON  _NDIS_ERROR_TYPEDEF_(0xC037010DL)
#define ERROR_VMCOMPUTE_SYSTEM_NOT_FOUND _NDIS_ERROR_TYPEDEF_(0xC037010EL)
#define ERROR_VMCOMPUTE_SYSTEM_ALREADY_EXISTS _NDIS_ERROR_TYPEDEF_(0xC037010FL)
#define ERROR_VMCOMPUTE_SYSTEM_ALREADY_STOPPED _NDIS_ERROR_TYPEDEF_(0xC0370110L)
#define ERROR_VNET_VIRTUAL_SWITCH_NAME_NOT_FOUND _NDIS_ERROR_TYPEDEF_(0xC0370200L)
#define ERROR_VID_REMOTE_NODE_PARENT_GPA_PAGES_USED _NDIS_ERROR_TYPEDEF_(0x80370001L)
#define ERROR_VOLMGR_INCOMPLETE_REGENERATION _NDIS_ERROR_TYPEDEF_(0x80380001L)
#define ERROR_VOLMGR_INCOMPLETE_DISK_MIGRATION _NDIS_ERROR_TYPEDEF_(0x80380002L)
#define ERROR_VOLMGR_DATABASE_FULL  _NDIS_ERROR_TYPEDEF_(0xC0380001L)
#define ERROR_VOLMGR_DISK_CONFIGURATION_CORRUPTED _NDIS_ERROR_TYPEDEF_(0xC0380002L)
#define ERROR_VOLMGR_DISK_CONFIGURATION_NOT_IN_SYNC _NDIS_ERROR_TYPEDEF_(0xC0380003L)
#define ERROR_VOLMGR_PACK_CONFIG_UPDATE_FAILED _NDIS_ERROR_TYPEDEF_(0xC0380004L)
#define ERROR_VOLMGR_DISK_CONTAINS_NON_SIMPLE_VOLUME _NDIS_ERROR_TYPEDEF_(0xC0380005L)
#define ERROR_VOLMGR_DISK_DUPLICATE  _NDIS_ERROR_TYPEDEF_(0xC0380006L)
#define ERROR_VOLMGR_DISK_DYNAMIC  _NDIS_ERROR_TYPEDEF_(0xC0380007L)
#define ERROR_VOLMGR_DISK_ID_INVALID  _NDIS_ERROR_TYPEDEF_(0xC0380008L)
#define ERROR_VOLMGR_DISK_INVALID  _NDIS_ERROR_TYPEDEF_(0xC0380009L)
#define ERROR_VOLMGR_DISK_LAST_VOTER  _NDIS_ERROR_TYPEDEF_(0xC038000AL)
#define ERROR_VOLMGR_DISK_LAYOUT_INVALID _NDIS_ERROR_TYPEDEF_(0xC038000BL)
#define ERROR_VOLMGR_DISK_LAYOUT_NON_BASIC_BETWEEN_BASIC_PARTITIONS _NDIS_ERROR_TYPEDEF_(0xC038000CL)
#define ERROR_VOLMGR_DISK_LAYOUT_NOT_CYLINDER_ALIGNED _NDIS_ERROR_TYPEDEF_(0xC038000DL)
#define ERROR_VOLMGR_DISK_LAYOUT_PARTITIONS_TOO_SMALL _NDIS_ERROR_TYPEDEF_(0xC038000EL)
#define ERROR_VOLMGR_DISK_LAYOUT_PRIMARY_BETWEEN_LOGICAL_PARTITIONS _NDIS_ERROR_TYPEDEF_(0xC038000FL)
#define ERROR_VOLMGR_DISK_LAYOUT_TOO_MANY_PARTITIONS _NDIS_ERROR_TYPEDEF_(0xC0380010L)
#define ERROR_VOLMGR_DISK_MISSING  _NDIS_ERROR_TYPEDEF_(0xC0380011L)
#define ERROR_VOLMGR_DISK_NOT_EMPTY  _NDIS_ERROR_TYPEDEF_(0xC0380012L)
#define ERROR_VOLMGR_DISK_NOT_ENOUGH_SPACE _NDIS_ERROR_TYPEDEF_(0xC0380013L)
#define ERROR_VOLMGR_DISK_REVECTORING_FAILED _NDIS_ERROR_TYPEDEF_(0xC0380014L)
#define ERROR_VOLMGR_DISK_SECTOR_SIZE_INVALID _NDIS_ERROR_TYPEDEF_(0xC0380015L)
#define ERROR_VOLMGR_DISK_SET_NOT_CONTAINED _NDIS_ERROR_TYPEDEF_(0xC0380016L)
#define ERROR_VOLMGR_DISK_USED_BY_MULTIPLE_MEMBERS _NDIS_ERROR_TYPEDEF_(0xC0380017L)
#define ERROR_VOLMGR_DISK_USED_BY_MULTIPLE_PLEXES _NDIS_ERROR_TYPEDEF_(0xC0380018L)
#define ERROR_VOLMGR_DYNAMIC_DISK_NOT_SUPPORTED _NDIS_ERROR_TYPEDEF_(0xC0380019L)
#define ERROR_VOLMGR_EXTENT_ALREADY_USED _NDIS_ERROR_TYPEDEF_(0xC038001AL)
#define ERROR_VOLMGR_EXTENT_NOT_CONTIGUOUS _NDIS_ERROR_TYPEDEF_(0xC038001BL)
#define ERROR_VOLMGR_EXTENT_NOT_IN_PUBLIC_REGION _NDIS_ERROR_TYPEDEF_(0xC038001CL)
#define ERROR_VOLMGR_EXTENT_NOT_SECTOR_ALIGNED _NDIS_ERROR_TYPEDEF_(0xC038001DL)
#define ERROR_VOLMGR_EXTENT_OVERLAPS_EBR_PARTITION _NDIS_ERROR_TYPEDEF_(0xC038001EL)
#define ERROR_VOLMGR_EXTENT_VOLUME_LENGTHS_DO_NOT_MATCH _NDIS_ERROR_TYPEDEF_(0xC038001FL)
#define ERROR_VOLMGR_FAULT_TOLERANT_NOT_SUPPORTED _NDIS_ERROR_TYPEDEF_(0xC0380020L)
#define ERROR_VOLMGR_INTERLEAVE_LENGTH_INVALID _NDIS_ERROR_TYPEDEF_(0xC0380021L)
#define ERROR_VOLMGR_MAXIMUM_REGISTERED_USERS _NDIS_ERROR_TYPEDEF_(0xC0380022L)
#define ERROR_VOLMGR_MEMBER_IN_SYNC  _NDIS_ERROR_TYPEDEF_(0xC0380023L)
#define ERROR_VOLMGR_MEMBER_INDEX_DUPLICATE _NDIS_ERROR_TYPEDEF_(0xC0380024L)
#define ERROR_VOLMGR_MEMBER_INDEX_INVALID _NDIS_ERROR_TYPEDEF_(0xC0380025L)
#define ERROR_VOLMGR_MEMBER_MISSING  _NDIS_ERROR_TYPEDEF_(0xC0380026L)
#define ERROR_VOLMGR_MEMBER_NOT_DETACHED _NDIS_ERROR_TYPEDEF_(0xC0380027L)
#define ERROR_VOLMGR_MEMBER_REGENERATING _NDIS_ERROR_TYPEDEF_(0xC0380028L)
#define ERROR_VOLMGR_ALL_DISKS_FAILED  _NDIS_ERROR_TYPEDEF_(0xC0380029L)
#define ERROR_VOLMGR_NO_REGISTERED_USERS _NDIS_ERROR_TYPEDEF_(0xC038002AL)
#define ERROR_VOLMGR_NO_SUCH_USER  _NDIS_ERROR_TYPEDEF_(0xC038002BL)
#define ERROR_VOLMGR_NOTIFICATION_RESET  _NDIS_ERROR_TYPEDEF_(0xC038002CL)
#define ERROR_VOLMGR_NUMBER_OF_MEMBERS_INVALID _NDIS_ERROR_TYPEDEF_(0xC038002DL)
#define ERROR_VOLMGR_NUMBER_OF_PLEXES_INVALID _NDIS_ERROR_TYPEDEF_(0xC038002EL)
#define ERROR_VOLMGR_PACK_DUPLICATE  _NDIS_ERROR_TYPEDEF_(0xC038002FL)
#define ERROR_VOLMGR_PACK_ID_INVALID  _NDIS_ERROR_TYPEDEF_(0xC0380030L)
#define ERROR_VOLMGR_PACK_INVALID  _NDIS_ERROR_TYPEDEF_(0xC0380031L)
#define ERROR_VOLMGR_PACK_NAME_INVALID  _NDIS_ERROR_TYPEDEF_(0xC0380032L)
#define ERROR_VOLMGR_PACK_OFFLINE  _NDIS_ERROR_TYPEDEF_(0xC0380033L)
#define ERROR_VOLMGR_PACK_HAS_QUORUM  _NDIS_ERROR_TYPEDEF_(0xC0380034L)
#define ERROR_VOLMGR_PACK_WITHOUT_QUORUM _NDIS_ERROR_TYPEDEF_(0xC0380035L)
#define ERROR_VOLMGR_PARTITION_STYLE_INVALID _NDIS_ERROR_TYPEDEF_(0xC0380036L)
#define ERROR_VOLMGR_PARTITION_UPDATE_FAILED _NDIS_ERROR_TYPEDEF_(0xC0380037L)
#define ERROR_VOLMGR_PLEX_IN_SYNC  _NDIS_ERROR_TYPEDEF_(0xC0380038L)
#define ERROR_VOLMGR_PLEX_INDEX_DUPLICATE _NDIS_ERROR_TYPEDEF_(0xC0380039L)
#define ERROR_VOLMGR_PLEX_INDEX_INVALID  _NDIS_ERROR_TYPEDEF_(0xC038003AL)
#define ERROR_VOLMGR_PLEX_LAST_ACTIVE  _NDIS_ERROR_TYPEDEF_(0xC038003BL)
#define ERROR_VOLMGR_PLEX_MISSING  _NDIS_ERROR_TYPEDEF_(0xC038003CL)
#define ERROR_VOLMGR_PLEX_REGENERATING  _NDIS_ERROR_TYPEDEF_(0xC038003DL)
#define ERROR_VOLMGR_PLEX_TYPE_INVALID  _NDIS_ERROR_TYPEDEF_(0xC038003EL)
#define ERROR_VOLMGR_PLEX_NOT_RAID5  _NDIS_ERROR_TYPEDEF_(0xC038003FL)
#define ERROR_VOLMGR_PLEX_NOT_SIMPLE  _NDIS_ERROR_TYPEDEF_(0xC0380040L)
#define ERROR_VOLMGR_STRUCTURE_SIZE_INVALID _NDIS_ERROR_TYPEDEF_(0xC0380041L)
#define ERROR_VOLMGR_TOO_MANY_NOTIFICATION_REQUESTS _NDIS_ERROR_TYPEDEF_(0xC0380042L)
#define ERROR_VOLMGR_TRANSACTION_IN_PROGRESS _NDIS_ERROR_TYPEDEF_(0xC0380043L)
#define ERROR_VOLMGR_UNEXPECTED_DISK_LAYOUT_CHANGE _NDIS_ERROR_TYPEDEF_(0xC0380044L)
#define ERROR_VOLMGR_VOLUME_CONTAINS_MISSING_DISK _NDIS_ERROR_TYPEDEF_(0xC0380045L)
#define ERROR_VOLMGR_VOLUME_ID_INVALID  _NDIS_ERROR_TYPEDEF_(0xC0380046L)
#define ERROR_VOLMGR_VOLUME_LENGTH_INVALID _NDIS_ERROR_TYPEDEF_(0xC0380047L)
#define ERROR_VOLMGR_VOLUME_LENGTH_NOT_SECTOR_SIZE_MULTIPLE _NDIS_ERROR_TYPEDEF_(0xC0380048L)
#define ERROR_VOLMGR_VOLUME_NOT_MIRRORED _NDIS_ERROR_TYPEDEF_(0xC0380049L)
#define ERROR_VOLMGR_VOLUME_NOT_RETAINED _NDIS_ERROR_TYPEDEF_(0xC038004AL)
#define ERROR_VOLMGR_VOLUME_OFFLINE  _NDIS_ERROR_TYPEDEF_(0xC038004BL)
#define ERROR_VOLMGR_VOLUME_RETAINED  _NDIS_ERROR_TYPEDEF_(0xC038004CL)
#define ERROR_VOLMGR_NUMBER_OF_EXTENTS_INVALID _NDIS_ERROR_TYPEDEF_(0xC038004DL)
#define ERROR_VOLMGR_DIFFERENT_SECTOR_SIZE _NDIS_ERROR_TYPEDEF_(0xC038004EL)
#define ERROR_VOLMGR_BAD_BOOT_DISK  _NDIS_ERROR_TYPEDEF_(0xC038004FL)
#define ERROR_VOLMGR_PACK_CONFIG_OFFLINE _NDIS_ERROR_TYPEDEF_(0xC0380050L)
#define ERROR_VOLMGR_PACK_CONFIG_ONLINE  _NDIS_ERROR_TYPEDEF_(0xC0380051L)
#define ERROR_VOLMGR_NOT_PRIMARY_PACK  _NDIS_ERROR_TYPEDEF_(0xC0380052L)
#define ERROR_VOLMGR_PACK_LOG_UPDATE_FAILED _NDIS_ERROR_TYPEDEF_(0xC0380053L)
#define ERROR_VOLMGR_NUMBER_OF_DISKS_IN_PLEX_INVALID _NDIS_ERROR_TYPEDEF_(0xC0380054L)
#define ERROR_VOLMGR_NUMBER_OF_DISKS_IN_MEMBER_INVALID _NDIS_ERROR_TYPEDEF_(0xC0380055L)
#define ERROR_VOLMGR_VOLUME_MIRRORED  _NDIS_ERROR_TYPEDEF_(0xC0380056L)
#define ERROR_VOLMGR_PLEX_NOT_SIMPLE_SPANNED _NDIS_ERROR_TYPEDEF_(0xC0380057L)
#define ERROR_VOLMGR_NO_VALID_LOG_COPIES _NDIS_ERROR_TYPEDEF_(0xC0380058L)
#define ERROR_VOLMGR_PRIMARY_PACK_PRESENT _NDIS_ERROR_TYPEDEF_(0xC0380059L)
#define ERROR_VOLMGR_NUMBER_OF_DISKS_INVALID _NDIS_ERROR_TYPEDEF_(0xC038005AL)
#define ERROR_VOLMGR_MIRROR_NOT_SUPPORTED _NDIS_ERROR_TYPEDEF_(0xC038005BL)
#define ERROR_VOLMGR_RAID5_NOT_SUPPORTED _NDIS_ERROR_TYPEDEF_(0xC038005CL)
#define ERROR_BCD_NOT_ALL_ENTRIES_IMPORTED _NDIS_ERROR_TYPEDEF_(0x80390001L)
#define ERROR_BCD_TOO_MANY_ELEMENTS  _NDIS_ERROR_TYPEDEF_(0xC0390002L)
#define ERROR_BCD_NOT_ALL_ENTRIES_SYNCHRONIZED _NDIS_ERROR_TYPEDEF_(0x80390003L)
#define ERROR_VHD_DRIVE_FOOTER_MISSING  _NDIS_ERROR_TYPEDEF_(0xC03A0001L)
#define ERROR_VHD_DRIVE_FOOTER_CHECKSUM_MISMATCH _NDIS_ERROR_TYPEDEF_(0xC03A0002L)
#define ERROR_VHD_DRIVE_FOOTER_CORRUPT  _NDIS_ERROR_TYPEDEF_(0xC03A0003L)
#define ERROR_VHD_FORMAT_UNKNOWN  _NDIS_ERROR_TYPEDEF_(0xC03A0004L)
#define ERROR_VHD_FORMAT_UNSUPPORTED_VERSION _NDIS_ERROR_TYPEDEF_(0xC03A0005L)
#define ERROR_VHD_SPARSE_HEADER_CHECKSUM_MISMATCH _NDIS_ERROR_TYPEDEF_(0xC03A0006L)
#define ERROR_VHD_SPARSE_HEADER_UNSUPPORTED_VERSION _NDIS_ERROR_TYPEDEF_(0xC03A0007L)
#define ERROR_VHD_SPARSE_HEADER_CORRUPT  _NDIS_ERROR_TYPEDEF_(0xC03A0008L)
#define ERROR_VHD_BLOCK_ALLOCATION_FAILURE _NDIS_ERROR_TYPEDEF_(0xC03A0009L)
#define ERROR_VHD_BLOCK_ALLOCATION_TABLE_CORRUPT _NDIS_ERROR_TYPEDEF_(0xC03A000AL)
#define ERROR_VHD_INVALID_BLOCK_SIZE  _NDIS_ERROR_TYPEDEF_(0xC03A000BL)
#define ERROR_VHD_BITMAP_MISMATCH  _NDIS_ERROR_TYPEDEF_(0xC03A000CL)
#define ERROR_VHD_PARENT_VHD_NOT_FOUND  _NDIS_ERROR_TYPEDEF_(0xC03A000DL)
#define ERROR_VHD_CHILD_PARENT_ID_MISMATCH _NDIS_ERROR_TYPEDEF_(0xC03A000EL)
#define ERROR_VHD_CHILD_PARENT_TIMESTAMP_MISMATCH _NDIS_ERROR_TYPEDEF_(0xC03A000FL)
#define ERROR_VHD_METADATA_READ_FAILURE  _NDIS_ERROR_TYPEDEF_(0xC03A0010L)
#define ERROR_VHD_METADATA_WRITE_FAILURE _NDIS_ERROR_TYPEDEF_(0xC03A0011L)
#define ERROR_VHD_INVALID_SIZE  _NDIS_ERROR_TYPEDEF_(0xC03A0012L)
#define ERROR_VHD_INVALID_FILE_SIZE  _NDIS_ERROR_TYPEDEF_(0xC03A0013L)
#define ERROR_VIRTDISK_PROVIDER_NOT_FOUND _NDIS_ERROR_TYPEDEF_(0xC03A0014L)
#define ERROR_VIRTDISK_NOT_VIRTUAL_DISK  _NDIS_ERROR_TYPEDEF_(0xC03A0015L)
#define ERROR_VHD_PARENT_VHD_ACCESS_DENIED _NDIS_ERROR_TYPEDEF_(0xC03A0016L)
#define ERROR_VHD_CHILD_PARENT_SIZE_MISMATCH _NDIS_ERROR_TYPEDEF_(0xC03A0017L)
#define ERROR_VHD_DIFFERENCING_CHAIN_CYCLE_DETECTED _NDIS_ERROR_TYPEDEF_(0xC03A0018L)
#define ERROR_VHD_DIFFERENCING_CHAIN_ERROR_IN_PARENT _NDIS_ERROR_TYPEDEF_(0xC03A0019L)
#define ERROR_VIRTUAL_DISK_LIMITATION  _NDIS_ERROR_TYPEDEF_(0xC03A001AL)
#define ERROR_VHD_INVALID_TYPE  _NDIS_ERROR_TYPEDEF_(0xC03A001BL)
#define ERROR_VHD_INVALID_STATE  _NDIS_ERROR_TYPEDEF_(0xC03A001CL)
#define ERROR_VIRTDISK_UNSUPPORTED_DISK_SECTOR_SIZE _NDIS_ERROR_TYPEDEF_(0xC03A001DL)
#define ERROR_VIRTDISK_DISK_ALREADY_OWNED _NDIS_ERROR_TYPEDEF_(0xC03A001EL)
#define ERROR_VIRTDISK_DISK_ONLINE_AND_WRITABLE _NDIS_ERROR_TYPEDEF_(0xC03A001FL)
#define ERROR_CTLOG_TRACKING_NOT_INITIALIZED _NDIS_ERROR_TYPEDEF_(0xC03A0020L)
#define ERROR_CTLOG_LOGFILE_SIZE_EXCEEDED_MAXSIZE _NDIS_ERROR_TYPEDEF_(0xC03A0021L)
#define ERROR_CTLOG_VHD_CHANGED_OFFLINE  _NDIS_ERROR_TYPEDEF_(0xC03A0022L)
#define ERROR_CTLOG_INVALID_TRACKING_STATE _NDIS_ERROR_TYPEDEF_(0xC03A0023L)
#define ERROR_CTLOG_INCONSISTENT_TRACKING_FILE _NDIS_ERROR_TYPEDEF_(0xC03A0024L)
#define ERROR_VHD_RESIZE_WOULD_TRUNCATE_DATA _NDIS_ERROR_TYPEDEF_(0xC03A0025L)
#define ERROR_VHD_COULD_NOT_COMPUTE_MINIMUM_VIRTUAL_SIZE _NDIS_ERROR_TYPEDEF_(0xC03A0026L)
#define ERROR_VHD_ALREADY_AT_OR_BELOW_MINIMUM_VIRTUAL_SIZE _NDIS_ERROR_TYPEDEF_(0xC03A0027L)
#define ERROR_VHD_METADATA_FULL  _NDIS_ERROR_TYPEDEF_(0xC03A0028L)
#define ERROR_VHD_INVALID_CHANGE_TRACKING_ID _NDIS_ERROR_TYPEDEF_(0xC03A0029L)
#define ERROR_VHD_CHANGE_TRACKING_DISABLED _NDIS_ERROR_TYPEDEF_(0xC03A002AL)
#define ERROR_VHD_MISSING_CHANGE_TRACKING_INFORMATION _NDIS_ERROR_TYPEDEF_(0xC03A0030L)
#define ERROR_QUERY_STORAGE_ERROR  _NDIS_ERROR_TYPEDEF_(0x803A0001L)
#define ERROR_HNS_PORT_ALLOCATED  _NDIS_ERROR_TYPEDEF_(0xC03B0001L)
#define ERROR_HNS_MAPPING_NOT_SUPPORTED  _NDIS_ERROR_TYPEDEF_(0xC03B0002L)
#define SDIAG_E_CANCELLED  _NDIS_ERROR_TYPEDEF_(0x803C0100L)
#define SDIAG_E_SCRIPT  _NDIS_ERROR_TYPEDEF_(0x803C0101L)
#define SDIAG_E_POWERSHELL  _NDIS_ERROR_TYPEDEF_(0x803C0102L)
#define SDIAG_E_MANAGEDHOST  _NDIS_ERROR_TYPEDEF_(0x803C0103L)
#define SDIAG_E_NOVERIFIER  _NDIS_ERROR_TYPEDEF_(0x803C0104L)
#define SDIAG_S_CANNOTRUN  _NDIS_ERROR_TYPEDEF_(0x003C0105L)
#define SDIAG_E_DISABLED  _NDIS_ERROR_TYPEDEF_(0x803C0106L)
#define SDIAG_E_TRUST  _NDIS_ERROR_TYPEDEF_(0x803C0107L)
#define SDIAG_E_CANNOTRUN  _NDIS_ERROR_TYPEDEF_(0x803C0108L)
#define SDIAG_E_VERSION  _NDIS_ERROR_TYPEDEF_(0x803C0109L)
#define SDIAG_E_RESOURCE  _NDIS_ERROR_TYPEDEF_(0x803C010AL)
#define SDIAG_E_ROOTCAUSE  _NDIS_ERROR_TYPEDEF_(0x803C010BL)
#define WPN_E_CHANNEL_CLOSED  _HRESULT_TYPEDEF_(0x803E0100L)
#define WPN_E_CHANNEL_REQUEST_NOT_COMPLETE _HRESULT_TYPEDEF_(0x803E0101L)
#define WPN_E_INVALID_APP  _HRESULT_TYPEDEF_(0x803E0102L)
#define WPN_E_OUTSTANDING_CHANNEL_REQUEST _HRESULT_TYPEDEF_(0x803E0103L)
#define WPN_E_DUPLICATE_CHANNEL  _HRESULT_TYPEDEF_(0x803E0104L)
#define WPN_E_PLATFORM_UNAVAILABLE  _HRESULT_TYPEDEF_(0x803E0105L)
#define WPN_E_NOTIFICATION_POSTED  _HRESULT_TYPEDEF_(0x803E0106L)
#define WPN_E_NOTIFICATION_HIDDEN  _HRESULT_TYPEDEF_(0x803E0107L)
#define WPN_E_NOTIFICATION_NOT_POSTED  _HRESULT_TYPEDEF_(0x803E0108L)
#define WPN_E_CLOUD_DISABLED  _HRESULT_TYPEDEF_(0x803E0109L)
#define WPN_E_CLOUD_INCAPABLE  _HRESULT_TYPEDEF_(0x803E0110L)
#define WPN_E_CLOUD_AUTH_UNAVAILABLE  _HRESULT_TYPEDEF_(0x803E011AL)
#define WPN_E_CLOUD_SERVICE_UNAVAILABLE  _HRESULT_TYPEDEF_(0x803E011BL)
#define WPN_E_FAILED_LOCK_SCREEN_UPDATE_INTIALIZATION _HRESULT_TYPEDEF_(0x803E011CL)
#define WPN_E_NOTIFICATION_DISABLED  _HRESULT_TYPEDEF_(0x803E0111L)
#define WPN_E_NOTIFICATION_INCAPABLE  _HRESULT_TYPEDEF_(0x803E0112L)
#define WPN_E_INTERNET_INCAPABLE  _HRESULT_TYPEDEF_(0x803E0113L)
#define WPN_E_NOTIFICATION_TYPE_DISABLED _HRESULT_TYPEDEF_(0x803E0114L)
#define WPN_E_NOTIFICATION_SIZE  _HRESULT_TYPEDEF_(0x803E0115L)
#define WPN_E_TAG_SIZE  _HRESULT_TYPEDEF_(0x803E0116L)
#define WPN_E_ACCESS_DENIED  _HRESULT_TYPEDEF_(0x803E0117L)
#define WPN_E_DUPLICATE_REGISTRATION  _HRESULT_TYPEDEF_(0x803E0118L)
#define WPN_E_PUSH_NOTIFICATION_INCAPABLE _HRESULT_TYPEDEF_(0x803E0119L)
#define WPN_E_DEV_ID_SIZE  _HRESULT_TYPEDEF_(0x803E0120L)
#define WPN_E_TAG_ALPHANUMERIC  _HRESULT_TYPEDEF_(0x803E012AL)
#define WPN_E_INVALID_HTTP_STATUS_CODE  _HRESULT_TYPEDEF_(0x803E012BL)
#define WPN_E_OUT_OF_SESSION  _HRESULT_TYPEDEF_(0x803E0200L)
#define WPN_E_POWER_SAVE  _HRESULT_TYPEDEF_(0x803E0201L)
#define WPN_E_IMAGE_NOT_FOUND_IN_CACHE  _HRESULT_TYPEDEF_(0x803E0202L)
#define WPN_E_ALL_URL_NOT_COMPLETED  _HRESULT_TYPEDEF_(0x803E0203L)
#define WPN_E_INVALID_CLOUD_IMAGE  _HRESULT_TYPEDEF_(0x803E0204L)
#define WPN_E_NOTIFICATION_ID_MATCHED  _HRESULT_TYPEDEF_(0x803E0205L)
#define WPN_E_CALLBACK_ALREADY_REGISTERED _HRESULT_TYPEDEF_(0x803E0206L)
#define WPN_E_TOAST_NOTIFICATION_DROPPED _HRESULT_TYPEDEF_(0x803E0207L)
#define WPN_E_STORAGE_LOCKED  _HRESULT_TYPEDEF_(0x803E0208L)
#define WPN_E_GROUP_SIZE  _HRESULT_TYPEDEF_(0x803E0209L)
#define WPN_E_GROUP_ALPHANUMERIC  _HRESULT_TYPEDEF_(0x803E020AL)
#define WPN_E_CLOUD_DISABLED_FOR_APP  _HRESULT_TYPEDEF_(0x803E020BL)
#define E_MBN_CONTEXT_NOT_ACTIVATED  _HRESULT_TYPEDEF_(0x80548201L)
#define E_MBN_BAD_SIM  _HRESULT_TYPEDEF_(0x80548202L)
#define E_MBN_DATA_CLASS_NOT_AVAILABLE  _HRESULT_TYPEDEF_(0x80548203L)
#define E_MBN_INVALID_ACCESS_STRING  _HRESULT_TYPEDEF_(0x80548204L)
#define E_MBN_MAX_ACTIVATED_CONTEXTS  _HRESULT_TYPEDEF_(0x80548205L)
#define E_MBN_PACKET_SVC_DETACHED  _HRESULT_TYPEDEF_(0x80548206L)
#define E_MBN_PROVIDER_NOT_VISIBLE  _HRESULT_TYPEDEF_(0x80548207L)
#define E_MBN_RADIO_POWER_OFF  _HRESULT_TYPEDEF_(0x80548208L)
#define E_MBN_SERVICE_NOT_ACTIVATED  _HRESULT_TYPEDEF_(0x80548209L)
#define E_MBN_SIM_NOT_INSERTED  _HRESULT_TYPEDEF_(0x8054820AL)
#define E_MBN_VOICE_CALL_IN_PROGRESS  _HRESULT_TYPEDEF_(0x8054820BL)
#define E_MBN_INVALID_CACHE  _HRESULT_TYPEDEF_(0x8054820CL)
#define E_MBN_NOT_REGISTERED  _HRESULT_TYPEDEF_(0x8054820DL)
#define E_MBN_PROVIDERS_NOT_FOUND  _HRESULT_TYPEDEF_(0x8054820EL)
#define E_MBN_PIN_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x8054820FL)
#define E_MBN_PIN_REQUIRED  _HRESULT_TYPEDEF_(0x80548210L)
#define E_MBN_PIN_DISABLED  _HRESULT_TYPEDEF_(0x80548211L)
#define E_MBN_FAILURE  _HRESULT_TYPEDEF_(0x80548212L)
#define E_MBN_INVALID_PROFILE  _HRESULT_TYPEDEF_(0x80548218L)
#define E_MBN_DEFAULT_PROFILE_EXIST  _HRESULT_TYPEDEF_(0x80548219L)
#define E_MBN_SMS_ENCODING_NOT_SUPPORTED _HRESULT_TYPEDEF_(0x80548220L)
#define E_MBN_SMS_FILTER_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x80548221L)
#define E_MBN_SMS_INVALID_MEMORY_INDEX  _HRESULT_TYPEDEF_(0x80548222L)
#define E_MBN_SMS_LANG_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x80548223L)
#define E_MBN_SMS_MEMORY_FAILURE  _HRESULT_TYPEDEF_(0x80548224L)
#define E_MBN_SMS_NETWORK_TIMEOUT  _HRESULT_TYPEDEF_(0x80548225L)
#define E_MBN_SMS_UNKNOWN_SMSC_ADDRESS  _HRESULT_TYPEDEF_(0x80548226L)
#define E_MBN_SMS_FORMAT_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x80548227L)
#define E_MBN_SMS_OPERATION_NOT_ALLOWED  _HRESULT_TYPEDEF_(0x80548228L)
#define E_MBN_SMS_MEMORY_FULL  _HRESULT_TYPEDEF_(0x80548229L)
#define PEER_E_IPV6_NOT_INSTALLED  _HRESULT_TYPEDEF_(0x80630001L)
#define PEER_E_NOT_INITIALIZED  _HRESULT_TYPEDEF_(0x80630002L)
#define PEER_E_CANNOT_START_SERVICE  _HRESULT_TYPEDEF_(0x80630003L)
#define PEER_E_NOT_LICENSED  _HRESULT_TYPEDEF_(0x80630004L)
#define PEER_E_INVALID_GRAPH  _HRESULT_TYPEDEF_(0x80630010L)
#define PEER_E_DBNAME_CHANGED  _HRESULT_TYPEDEF_(0x80630011L)
#define PEER_E_DUPLICATE_GRAPH  _HRESULT_TYPEDEF_(0x80630012L)
#define PEER_E_GRAPH_NOT_READY  _HRESULT_TYPEDEF_(0x80630013L)
#define PEER_E_GRAPH_SHUTTING_DOWN  _HRESULT_TYPEDEF_(0x80630014L)
#define PEER_E_GRAPH_IN_USE  _HRESULT_TYPEDEF_(0x80630015L)
#define PEER_E_INVALID_DATABASE  _HRESULT_TYPEDEF_(0x80630016L)
#define PEER_E_TOO_MANY_ATTRIBUTES  _HRESULT_TYPEDEF_(0x80630017L)
#define PEER_E_CONNECTION_NOT_FOUND  _HRESULT_TYPEDEF_(0x80630103L)
#define PEER_E_CONNECT_SELF  _HRESULT_TYPEDEF_(0x80630106L)
#define PEER_E_ALREADY_LISTENING  _HRESULT_TYPEDEF_(0x80630107L)
#define PEER_E_NODE_NOT_FOUND  _HRESULT_TYPEDEF_(0x80630108L)
#define PEER_E_CONNECTION_FAILED  _HRESULT_TYPEDEF_(0x80630109L)
#define PEER_E_CONNECTION_NOT_AUTHENTICATED _HRESULT_TYPEDEF_(0x8063010AL)
#define PEER_E_CONNECTION_REFUSED  _HRESULT_TYPEDEF_(0x8063010BL)
#define PEER_E_CLASSIFIER_TOO_LONG  _HRESULT_TYPEDEF_(0x80630201L)
#define PEER_E_TOO_MANY_IDENTITIES  _HRESULT_TYPEDEF_(0x80630202L)
#define PEER_E_NO_KEY_ACCESS  _HRESULT_TYPEDEF_(0x80630203L)
#define PEER_E_GROUPS_EXIST  _HRESULT_TYPEDEF_(0x80630204L)
#define PEER_E_RECORD_NOT_FOUND  _HRESULT_TYPEDEF_(0x80630301L)
#define PEER_E_DATABASE_ACCESSDENIED  _HRESULT_TYPEDEF_(0x80630302L)
#define PEER_E_DBINITIALIZATION_FAILED  _HRESULT_TYPEDEF_(0x80630303L)
#define PEER_E_MAX_RECORD_SIZE_EXCEEDED  _HRESULT_TYPEDEF_(0x80630304L)
#define PEER_E_DATABASE_ALREADY_PRESENT  _HRESULT_TYPEDEF_(0x80630305L)
#define PEER_E_DATABASE_NOT_PRESENT  _HRESULT_TYPEDEF_(0x80630306L)
#define PEER_E_IDENTITY_NOT_FOUND  _HRESULT_TYPEDEF_(0x80630401L)
#define PEER_E_EVENT_HANDLE_NOT_FOUND  _HRESULT_TYPEDEF_(0x80630501L)
#define PEER_E_INVALID_SEARCH  _HRESULT_TYPEDEF_(0x80630601L)
#define PEER_E_INVALID_ATTRIBUTES  _HRESULT_TYPEDEF_(0x80630602L)
#define PEER_E_INVITATION_NOT_TRUSTED  _HRESULT_TYPEDEF_(0x80630701L)
#define PEER_E_CHAIN_TOO_LONG  _HRESULT_TYPEDEF_(0x80630703L)
#define PEER_E_INVALID_TIME_PERIOD  _HRESULT_TYPEDEF_(0x80630705L)
#define PEER_E_CIRCULAR_CHAIN_DETECTED  _HRESULT_TYPEDEF_(0x80630706L)
#define PEER_E_CERT_STORE_CORRUPTED  _HRESULT_TYPEDEF_(0x80630801L)
#define PEER_E_NO_CLOUD  _HRESULT_TYPEDEF_(0x80631001L)
#define PEER_E_CLOUD_NAME_AMBIGUOUS  _HRESULT_TYPEDEF_(0x80631005L)
#define PEER_E_INVALID_RECORD  _HRESULT_TYPEDEF_(0x80632010L)
#define PEER_E_NOT_AUTHORIZED  _HRESULT_TYPEDEF_(0x80632020L)
#define PEER_E_PASSWORD_DOES_NOT_MEET_POLICY _HRESULT_TYPEDEF_(0x80632021L)
#define PEER_E_DEFERRED_VALIDATION  _HRESULT_TYPEDEF_(0x80632030L)
#define PEER_E_INVALID_GROUP_PROPERTIES  _HRESULT_TYPEDEF_(0x80632040L)
#define PEER_E_INVALID_PEER_NAME  _HRESULT_TYPEDEF_(0x80632050L)
#define PEER_E_INVALID_CLASSIFIER  _HRESULT_TYPEDEF_(0x80632060L)
#define PEER_E_INVALID_FRIENDLY_NAME  _HRESULT_TYPEDEF_(0x80632070L)
#define PEER_E_INVALID_ROLE_PROPERTY  _HRESULT_TYPEDEF_(0x80632071L)
#define PEER_E_INVALID_CLASSIFIER_PROPERTY _HRESULT_TYPEDEF_(0x80632072L)
#define PEER_E_INVALID_RECORD_EXPIRATION _HRESULT_TYPEDEF_(0x80632080L)
#define PEER_E_INVALID_CREDENTIAL_INFO  _HRESULT_TYPEDEF_(0x80632081L)
#define PEER_E_INVALID_CREDENTIAL  _HRESULT_TYPEDEF_(0x80632082L)
#define PEER_E_INVALID_RECORD_SIZE  _HRESULT_TYPEDEF_(0x80632083L)
#define PEER_E_UNSUPPORTED_VERSION  _HRESULT_TYPEDEF_(0x80632090L)
#define PEER_E_GROUP_NOT_READY  _HRESULT_TYPEDEF_(0x80632091L)
#define PEER_E_GROUP_IN_USE  _HRESULT_TYPEDEF_(0x80632092L)
#define PEER_E_INVALID_GROUP  _HRESULT_TYPEDEF_(0x80632093L)
#define PEER_E_NO_MEMBERS_FOUND  _HRESULT_TYPEDEF_(0x80632094L)
#define PEER_E_NO_MEMBER_CONNECTIONS  _HRESULT_TYPEDEF_(0x80632095L)
#define PEER_E_UNABLE_TO_LISTEN  _HRESULT_TYPEDEF_(0x80632096L)
#define PEER_E_IDENTITY_DELETED  _HRESULT_TYPEDEF_(0x806320A0L)
#define PEER_E_SERVICE_NOT_AVAILABLE  _HRESULT_TYPEDEF_(0x806320A1L)
#define PEER_E_CONTACT_NOT_FOUND  _HRESULT_TYPEDEF_(0x80636001L)
#define PEER_S_GRAPH_DATA_CREATED  _HRESULT_TYPEDEF_(0x00630001L)
#define PEER_S_NO_EVENT_DATA  _HRESULT_TYPEDEF_(0x00630002L)
#define PEER_S_ALREADY_CONNECTED  _HRESULT_TYPEDEF_(0x00632000L)
#define PEER_S_SUBSCRIPTION_EXISTS  _HRESULT_TYPEDEF_(0x00636000L)
#define PEER_S_NO_CONNECTIVITY  _HRESULT_TYPEDEF_(0x00630005L)
#define PEER_S_ALREADY_A_MEMBER  _HRESULT_TYPEDEF_(0x00630006L)
#define PEER_E_CANNOT_CONVERT_PEER_NAME  _HRESULT_TYPEDEF_(0x80634001L)
#define PEER_E_INVALID_PEER_HOST_NAME  _HRESULT_TYPEDEF_(0x80634002L)
#define PEER_E_NO_MORE  _HRESULT_TYPEDEF_(0x80634003L)
#define PEER_E_PNRP_DUPLICATE_PEER_NAME  _HRESULT_TYPEDEF_(0x80634005L)
#define PEER_E_INVITE_CANCELLED  _HRESULT_TYPEDEF_(0x80637000L)
#define PEER_E_INVITE_RESPONSE_NOT_AVAILABLE _HRESULT_TYPEDEF_(0x80637001L)
#define PEER_E_NOT_SIGNED_IN  _HRESULT_TYPEDEF_(0x80637003L)
#define PEER_E_PRIVACY_DECLINED  _HRESULT_TYPEDEF_(0x80637004L)
#define PEER_E_TIMEOUT  _HRESULT_TYPEDEF_(0x80637005L)
#define PEER_E_INVALID_ADDRESS  _HRESULT_TYPEDEF_(0x80637007L)
#define PEER_E_FW_EXCEPTION_DISABLED  _HRESULT_TYPEDEF_(0x80637008L)
#define PEER_E_FW_BLOCKED_BY_POLICY  _HRESULT_TYPEDEF_(0x80637009L)
#define PEER_E_FW_BLOCKED_BY_SHIELDS_UP  _HRESULT_TYPEDEF_(0x8063700AL)
#define PEER_E_FW_DECLINED  _HRESULT_TYPEDEF_(0x8063700BL)
#define UI_E_CREATE_FAILED  _HRESULT_TYPEDEF_(0x802A0001L)
#define UI_E_SHUTDOWN_CALLED  _HRESULT_TYPEDEF_(0x802A0002L)
#define UI_E_ILLEGAL_REENTRANCY  _HRESULT_TYPEDEF_(0x802A0003L)
#define UI_E_OBJECT_SEALED  _HRESULT_TYPEDEF_(0x802A0004L)
#define UI_E_VALUE_NOT_SET  _HRESULT_TYPEDEF_(0x802A0005L)
#define UI_E_VALUE_NOT_DETERMINED  _HRESULT_TYPEDEF_(0x802A0006L)
#define UI_E_INVALID_OUTPUT  _HRESULT_TYPEDEF_(0x802A0007L)
#define UI_E_BOOLEAN_EXPECTED  _HRESULT_TYPEDEF_(0x802A0008L)
#define UI_E_DIFFERENT_OWNER  _HRESULT_TYPEDEF_(0x802A0009L)
#define UI_E_AMBIGUOUS_MATCH  _HRESULT_TYPEDEF_(0x802A000AL)
#define UI_E_FP_OVERFLOW  _HRESULT_TYPEDEF_(0x802A000BL)
#define UI_E_WRONG_THREAD  _HRESULT_TYPEDEF_(0x802A000CL)
#define UI_E_STORYBOARD_ACTIVE  _HRESULT_TYPEDEF_(0x802A0101L)
#define UI_E_STORYBOARD_NOT_PLAYING  _HRESULT_TYPEDEF_(0x802A0102L)
#define UI_E_START_KEYFRAME_AFTER_END  _HRESULT_TYPEDEF_(0x802A0103L)
#define UI_E_END_KEYFRAME_NOT_DETERMINED _HRESULT_TYPEDEF_(0x802A0104L)
#define UI_E_LOOPS_OVERLAP  _HRESULT_TYPEDEF_(0x802A0105L)
#define UI_E_TRANSITION_ALREADY_USED  _HRESULT_TYPEDEF_(0x802A0106L)
#define UI_E_TRANSITION_NOT_IN_STORYBOARD _HRESULT_TYPEDEF_(0x802A0107L)
#define UI_E_TRANSITION_ECLIPSED  _HRESULT_TYPEDEF_(0x802A0108L)
#define UI_E_TIME_BEFORE_LAST_UPDATE  _HRESULT_TYPEDEF_(0x802A0109L)
#define UI_E_TIMER_CLIENT_ALREADY_CONNECTED _HRESULT_TYPEDEF_(0x802A010AL)
#define UI_E_INVALID_DIMENSION  _HRESULT_TYPEDEF_(0x802A010BL)
#define UI_E_PRIMITIVE_OUT_OF_BOUNDS  _HRESULT_TYPEDEF_(0x802A010CL)
#define UI_E_WINDOW_CLOSED  _HRESULT_TYPEDEF_(0x802A0201L)
#define E_BLUETOOTH_ATT_INVALID_HANDLE  _HRESULT_TYPEDEF_(0x80650001L)
#define E_BLUETOOTH_ATT_READ_NOT_PERMITTED _HRESULT_TYPEDEF_(0x80650002L)
#define E_BLUETOOTH_ATT_WRITE_NOT_PERMITTED _HRESULT_TYPEDEF_(0x80650003L)
#define E_BLUETOOTH_ATT_INVALID_PDU  _HRESULT_TYPEDEF_(0x80650004L)
#define E_BLUETOOTH_ATT_INSUFFICIENT_AUTHENTICATION _HRESULT_TYPEDEF_(0x80650005L)
#define E_BLUETOOTH_ATT_REQUEST_NOT_SUPPORTED _HRESULT_TYPEDEF_(0x80650006L)
#define E_BLUETOOTH_ATT_INVALID_OFFSET  _HRESULT_TYPEDEF_(0x80650007L)
#define E_BLUETOOTH_ATT_INSUFFICIENT_AUTHORIZATION _HRESULT_TYPEDEF_(0x80650008L)
#define E_BLUETOOTH_ATT_PREPARE_QUEUE_FULL _HRESULT_TYPEDEF_(0x80650009L)
#define E_BLUETOOTH_ATT_ATTRIBUTE_NOT_FOUND _HRESULT_TYPEDEF_(0x8065000AL)
#define E_BLUETOOTH_ATT_ATTRIBUTE_NOT_LONG _HRESULT_TYPEDEF_(0x8065000BL)
#define E_BLUETOOTH_ATT_INSUFFICIENT_ENCRYPTION_KEY_SIZE _HRESULT_TYPEDEF_(0x8065000CL)
#define E_BLUETOOTH_ATT_INVALID_ATTRIBUTE_VALUE_LENGTH _HRESULT_TYPEDEF_(0x8065000DL)
#define E_BLUETOOTH_ATT_UNLIKELY  _HRESULT_TYPEDEF_(0x8065000EL)
#define E_BLUETOOTH_ATT_INSUFFICIENT_ENCRYPTION _HRESULT_TYPEDEF_(0x8065000FL)
#define E_BLUETOOTH_ATT_UNSUPPORTED_GROUP_TYPE _HRESULT_TYPEDEF_(0x80650010L)
#define E_BLUETOOTH_ATT_INSUFFICIENT_RESOURCES _HRESULT_TYPEDEF_(0x80650011L)
#define E_BLUETOOTH_ATT_UNKNOWN_ERROR  _HRESULT_TYPEDEF_(0x80651000L)
#define E_AUDIO_ENGINE_NODE_NOT_FOUND  _HRESULT_TYPEDEF_(0x80660001L)
#define E_HDAUDIO_EMPTY_CONNECTION_LIST  _HRESULT_TYPEDEF_(0x80660002L)
#define E_HDAUDIO_CONNECTION_LIST_NOT_SUPPORTED _HRESULT_TYPEDEF_(0x80660003L)
#define E_HDAUDIO_NO_LOGICAL_DEVICES_CREATED _HRESULT_TYPEDEF_(0x80660004L)
#define E_HDAUDIO_NULL_LINKED_LIST_ENTRY _HRESULT_TYPEDEF_(0x80660005L)
#define STATEREPOSITORY_E_CONCURRENCY_LOCKING_FAILURE _HRESULT_TYPEDEF_(0x80670001L)
#define STATEREPOSITORY_E_STATEMENT_INPROGRESS _HRESULT_TYPEDEF_(0x80670002L)
#define STATEREPOSITORY_E_CONFIGURATION_INVALID _HRESULT_TYPEDEF_(0x80670003L)
#define STATEREPOSITORY_E_UNKNOWN_SCHEMA_VERSION _HRESULT_TYPEDEF_(0x80670004L)
#define STATEREPOSITORY_ERROR_DICTIONARY_CORRUPTED _HRESULT_TYPEDEF_(0x80670005L)
#define STATEREPOSITORY_E_BLOCKED  _HRESULT_TYPEDEF_(0x80670006L)
#define STATEREPOSITORY_E_BUSY_RETRY  _HRESULT_TYPEDEF_(0x80670007L)
#define STATEREPOSITORY_E_BUSY_RECOVERY_RETRY _HRESULT_TYPEDEF_(0x80670008L)
#define STATEREPOSITORY_E_LOCKED_RETRY  _HRESULT_TYPEDEF_(0x80670009L)
#define STATEREPOSITORY_E_LOCKED_SHAREDCACHE_RETRY _HRESULT_TYPEDEF_(0x8067000AL)
#define STATEREPOSITORY_E_TRANSACTION_REQUIRED _HRESULT_TYPEDEF_(0x8067000BL)
#define ERROR_SPACES_POOL_WAS_DELETED  _HRESULT_TYPEDEF_(0x00E70001L)
#define ERROR_SPACES_FAULT_DOMAIN_TYPE_INVALID _HRESULT_TYPEDEF_(0x80E70001L)
#define ERROR_SPACES_INTERNAL_ERROR  _HRESULT_TYPEDEF_(0x80E70002L)
#define ERROR_SPACES_RESILIENCY_TYPE_INVALID _HRESULT_TYPEDEF_(0x80E70003L)
#define ERROR_SPACES_DRIVE_SECTOR_SIZE_INVALID _HRESULT_TYPEDEF_(0x80E70004L)
#define ERROR_SPACES_DRIVE_REDUNDANCY_INVALID _HRESULT_TYPEDEF_(0x80E70006L)
#define ERROR_SPACES_NUMBER_OF_DATA_COPIES_INVALID _HRESULT_TYPEDEF_(0x80E70007L)
#define ERROR_SPACES_PARITY_LAYOUT_INVALID _HRESULT_TYPEDEF_(0x80E70008L)
#define ERROR_SPACES_INTERLEAVE_LENGTH_INVALID _HRESULT_TYPEDEF_(0x80E70009L)
#define ERROR_SPACES_NUMBER_OF_COLUMNS_INVALID _HRESULT_TYPEDEF_(0x80E7000AL)
#define ERROR_SPACES_NOT_ENOUGH_DRIVES  _HRESULT_TYPEDEF_(0x80E7000BL)
#define ERROR_SPACES_EXTENDED_ERROR  _HRESULT_TYPEDEF_(0x80E7000CL)
#define ERROR_SPACES_PROVISIONING_TYPE_INVALID _HRESULT_TYPEDEF_(0x80E7000DL)
#define ERROR_SPACES_ALLOCATION_SIZE_INVALID _HRESULT_TYPEDEF_(0x80E7000EL)
#define ERROR_SPACES_ENCLOSURE_AWARE_INVALID _HRESULT_TYPEDEF_(0x80E7000FL)
#define ERROR_SPACES_WRITE_CACHE_SIZE_INVALID _HRESULT_TYPEDEF_(0x80E70010L)
#define ERROR_SPACES_NUMBER_OF_GROUPS_INVALID _HRESULT_TYPEDEF_(0x80E70011L)
#define ERROR_SPACES_DRIVE_OPERATIONAL_STATE_INVALID _HRESULT_TYPEDEF_(0x80E70012L)
#define ERROR_VOLSNAP_BOOTFILE_NOT_VALID _HRESULT_TYPEDEF_(0x80820001L)
#define ERROR_VOLSNAP_ACTIVATION_TIMEOUT _HRESULT_TYPEDEF_(0x80820002L)
#define ERROR_TIERING_NOT_SUPPORTED_ON_VOLUME _HRESULT_TYPEDEF_(0x80830001L)
#define ERROR_TIERING_VOLUME_DISMOUNT_IN_PROGRESS _HRESULT_TYPEDEF_(0x80830002L)
#define ERROR_TIERING_STORAGE_TIER_NOT_FOUND _HRESULT_TYPEDEF_(0x80830003L)
#define ERROR_TIERING_INVALID_FILE_ID  _HRESULT_TYPEDEF_(0x80830004L)
#define ERROR_TIERING_WRONG_CLUSTER_NODE _HRESULT_TYPEDEF_(0x80830005L)
#define ERROR_TIERING_ALREADY_PROCESSING _HRESULT_TYPEDEF_(0x80830006L)
#define ERROR_TIERING_CANNOT_PIN_OBJECT  _HRESULT_TYPEDEF_(0x80830007L)
#define ERROR_SECCORE_INVALID_COMMAND  _HRESULT_TYPEDEF_(0xC0E80000L)
#define ERROR_NO_APPLICABLE_APP_LICENSES_FOUND _HRESULT_TYPEDEF_(0xC0EA0001L)
#define ERROR_CLIP_LICENSE_NOT_FOUND  _HRESULT_TYPEDEF_(0xC0EA0002L)
#define ERROR_CLIP_DEVICE_LICENSE_MISSING _HRESULT_TYPEDEF_(0xC0EA0003L)
#define ERROR_CLIP_LICENSE_INVALID_SIGNATURE _HRESULT_TYPEDEF_(0xC0EA0004L)
#define ERROR_CLIP_KEYHOLDER_LICENSE_MISSING_OR_INVALID _HRESULT_TYPEDEF_(0xC0EA0005L)
#define ERROR_CLIP_LICENSE_EXPIRED  _HRESULT_TYPEDEF_(0xC0EA0006L)
#define ERROR_CLIP_LICENSE_SIGNED_BY_UNKNOWN_SOURCE _HRESULT_TYPEDEF_(0xC0EA0007L)
#define ERROR_CLIP_LICENSE_NOT_SIGNED  _HRESULT_TYPEDEF_(0xC0EA0008L)
#define ERROR_CLIP_LICENSE_HARDWARE_ID_OUT_OF_TOLERANCE _HRESULT_TYPEDEF_(0xC0EA0009L)
#define ERROR_CLIP_LICENSE_DEVICE_ID_MISMATCH _HRESULT_TYPEDEF_(0xC0EA000AL)
#define DXGI_STATUS_OCCLUDED  _HRESULT_TYPEDEF_(0x087A0001L)
#define DXGI_STATUS_CLIPPED  _HRESULT_TYPEDEF_(0x087A0002L)
#define DXGI_STATUS_NO_REDIRECTION  _HRESULT_TYPEDEF_(0x087A0004L)
#define DXGI_STATUS_NO_DESKTOP_ACCESS  _HRESULT_TYPEDEF_(0x087A0005L)
#define DXGI_STATUS_GRAPHICS_VIDPN_SOURCE_IN_USE _HRESULT_TYPEDEF_(0x087A0006L)
#define DXGI_STATUS_MODE_CHANGED  _HRESULT_TYPEDEF_(0x087A0007L)
#define DXGI_STATUS_MODE_CHANGE_IN_PROGRESS _HRESULT_TYPEDEF_(0x087A0008L)
#define DXGI_ERROR_INVALID_CALL  _HRESULT_TYPEDEF_(0x887A0001L)
#define DXGI_ERROR_NOT_FOUND  _HRESULT_TYPEDEF_(0x887A0002L)
#define DXGI_ERROR_MORE_DATA  _HRESULT_TYPEDEF_(0x887A0003L)
#define DXGI_ERROR_UNSUPPORTED  _HRESULT_TYPEDEF_(0x887A0004L)
#define DXGI_ERROR_DEVICE_REMOVED  _HRESULT_TYPEDEF_(0x887A0005L)
#define DXGI_ERROR_DEVICE_HUNG  _HRESULT_TYPEDEF_(0x887A0006L)
#define DXGI_ERROR_DEVICE_RESET  _HRESULT_TYPEDEF_(0x887A0007L)
#define DXGI_ERROR_WAS_STILL_DRAWING  _HRESULT_TYPEDEF_(0x887A000AL)
#define DXGI_ERROR_FRAME_STATISTICS_DISJOINT _HRESULT_TYPEDEF_(0x887A000BL)
#define DXGI_ERROR_GRAPHICS_VIDPN_SOURCE_IN_USE _HRESULT_TYPEDEF_(0x887A000CL)
#define DXGI_ERROR_DRIVER_INTERNAL_ERROR _HRESULT_TYPEDEF_(0x887A0020L)
#define DXGI_ERROR_NONEXCLUSIVE  _HRESULT_TYPEDEF_(0x887A0021L)
#define DXGI_ERROR_NOT_CURRENTLY_AVAILABLE _HRESULT_TYPEDEF_(0x887A0022L)
#define DXGI_ERROR_REMOTE_CLIENT_DISCONNECTED _HRESULT_TYPEDEF_(0x887A0023L)
#define DXGI_ERROR_REMOTE_OUTOFMEMORY  _HRESULT_TYPEDEF_(0x887A0024L)
#define DXGI_ERROR_ACCESS_LOST  _HRESULT_TYPEDEF_(0x887A0026L)
#define DXGI_ERROR_WAIT_TIMEOUT  _HRESULT_TYPEDEF_(0x887A0027L)
#define DXGI_ERROR_SESSION_DISCONNECTED  _HRESULT_TYPEDEF_(0x887A0028L)
#define DXGI_ERROR_RESTRICT_TO_OUTPUT_STALE _HRESULT_TYPEDEF_(0x887A0029L)
#define DXGI_ERROR_CANNOT_PROTECT_CONTENT _HRESULT_TYPEDEF_(0x887A002AL)
#define DXGI_ERROR_ACCESS_DENIED  _HRESULT_TYPEDEF_(0x887A002BL)
#define DXGI_ERROR_NAME_ALREADY_EXISTS  _HRESULT_TYPEDEF_(0x887A002CL)
#define DXGI_ERROR_SDK_COMPONENT_MISSING _HRESULT_TYPEDEF_(0x887A002DL)
#define DXGI_ERROR_NOT_CURRENT  _HRESULT_TYPEDEF_(0x887A002EL)
#define DXGI_ERROR_HW_PROTECTION_OUTOFMEMORY _HRESULT_TYPEDEF_(0x887A0030L)
#define DXGI_STATUS_UNOCCLUDED  _HRESULT_TYPEDEF_(0x087A0009L)
#define DXGI_STATUS_DDA_WAS_STILL_DRAWING _HRESULT_TYPEDEF_(0x087A000AL)
#define DXGI_ERROR_MODE_CHANGE_IN_PROGRESS _HRESULT_TYPEDEF_(0x887A0025L)
#define DXGI_STATUS_PRESENT_REQUIRED  _HRESULT_TYPEDEF_(0x087A002FL)
#define DXGI_DDI_ERR_WASSTILLDRAWING  _HRESULT_TYPEDEF_(0x887B0001L)
#define DXGI_DDI_ERR_UNSUPPORTED  _HRESULT_TYPEDEF_(0x887B0002L)
#define DXGI_DDI_ERR_NONEXCLUSIVE  _HRESULT_TYPEDEF_(0x887B0003L)
#define D3D10_ERROR_TOO_MANY_UNIQUE_STATE_OBJECTS _HRESULT_TYPEDEF_(0x88790001L)
#define D3D10_ERROR_FILE_NOT_FOUND  _HRESULT_TYPEDEF_(0x88790002L)
#define D3D11_ERROR_TOO_MANY_UNIQUE_STATE_OBJECTS _HRESULT_TYPEDEF_(0x887C0001L)
#define D3D11_ERROR_FILE_NOT_FOUND  _HRESULT_TYPEDEF_(0x887C0002L)
#define D3D11_ERROR_TOO_MANY_UNIQUE_VIEW_OBJECTS _HRESULT_TYPEDEF_(0x887C0003L)
#define D3D11_ERROR_DEFERRED_CONTEXT_MAP_WITHOUT_INITIAL_DISCARD _HRESULT_TYPEDEF_(0x887C0004L)
#define D3D12_ERROR_ADAPTER_NOT_FOUND  _HRESULT_TYPEDEF_(0x887E0001L)
#define D3D12_ERROR_DRIVER_VERSION_MISMATCH _HRESULT_TYPEDEF_(0x887E0002L)
#define D2DERR_WRONG_STATE  _HRESULT_TYPEDEF_(0x88990001L)
#define D2DERR_NOT_INITIALIZED  _HRESULT_TYPEDEF_(0x88990002L)
#define D2DERR_UNSUPPORTED_OPERATION  _HRESULT_TYPEDEF_(0x88990003L)
#define D2DERR_SCANNER_FAILED  _HRESULT_TYPEDEF_(0x88990004L)
#define D2DERR_SCREEN_ACCESS_DENIED  _HRESULT_TYPEDEF_(0x88990005L)
#define D2DERR_DISPLAY_STATE_INVALID  _HRESULT_TYPEDEF_(0x88990006L)
#define D2DERR_ZERO_VECTOR  _HRESULT_TYPEDEF_(0x88990007L)
#define D2DERR_INTERNAL_ERROR  _HRESULT_TYPEDEF_(0x88990008L)
#define D2DERR_DISPLAY_FORMAT_NOT_SUPPORTED _HRESULT_TYPEDEF_(0x88990009L)
#define D2DERR_INVALID_CALL  _HRESULT_TYPEDEF_(0x8899000AL)
#define D2DERR_NO_HARDWARE_DEVICE  _HRESULT_TYPEDEF_(0x8899000BL)
#define D2DERR_RECREATE_TARGET  _HRESULT_TYPEDEF_(0x8899000CL)
#define D2DERR_TOO_MANY_SHADER_ELEMENTS  _HRESULT_TYPEDEF_(0x8899000DL)
#define D2DERR_SHADER_COMPILE_FAILED  _HRESULT_TYPEDEF_(0x8899000EL)
#define D2DERR_MAX_TEXTURE_SIZE_EXCEEDED _HRESULT_TYPEDEF_(0x8899000FL)
#define D2DERR_UNSUPPORTED_VERSION  _HRESULT_TYPEDEF_(0x88990010L)
#define D2DERR_BAD_NUMBER  _HRESULT_TYPEDEF_(0x88990011L)
#define D2DERR_WRONG_FACTORY  _HRESULT_TYPEDEF_(0x88990012L)
#define D2DERR_LAYER_ALREADY_IN_USE  _HRESULT_TYPEDEF_(0x88990013L)
#define D2DERR_POP_CALL_DID_NOT_MATCH_PUSH _HRESULT_TYPEDEF_(0x88990014L)
#define D2DERR_WRONG_RESOURCE_DOMAIN  _HRESULT_TYPEDEF_(0x88990015L)
#define D2DERR_PUSH_POP_UNBALANCED  _HRESULT_TYPEDEF_(0x88990016L)
#define D2DERR_RENDER_TARGET_HAS_LAYER_OR_CLIPRECT _HRESULT_TYPEDEF_(0x88990017L)
#define D2DERR_INCOMPATIBLE_BRUSH_TYPES  _HRESULT_TYPEDEF_(0x88990018L)
#define D2DERR_WIN32_ERROR  _HRESULT_TYPEDEF_(0x88990019L)
#define D2DERR_TARGET_NOT_GDI_COMPATIBLE _HRESULT_TYPEDEF_(0x8899001AL)
#define D2DERR_TEXT_EFFECT_IS_WRONG_TYPE _HRESULT_TYPEDEF_(0x8899001BL)
#define D2DERR_TEXT_RENDERER_NOT_RELEASED _HRESULT_TYPEDEF_(0x8899001CL)
#define D2DERR_EXCEEDS_MAX_BITMAP_SIZE  _HRESULT_TYPEDEF_(0x8899001DL)
#define D2DERR_INVALID_GRAPH_CONFIGURATION _HRESULT_TYPEDEF_(0x8899001EL)
#define D2DERR_INVALID_INTERNAL_GRAPH_CONFIGURATION _HRESULT_TYPEDEF_(0x8899001FL)
#define D2DERR_CYCLIC_GRAPH  _HRESULT_TYPEDEF_(0x88990020L)
#define D2DERR_BITMAP_CANNOT_DRAW  _HRESULT_TYPEDEF_(0x88990021L)
#define D2DERR_OUTSTANDING_BITMAP_REFERENCES _HRESULT_TYPEDEF_(0x88990022L)
#define D2DERR_ORIGINAL_TARGET_NOT_BOUND _HRESULT_TYPEDEF_(0x88990023L)
#define D2DERR_INVALID_TARGET  _HRESULT_TYPEDEF_(0x88990024L)
#define D2DERR_BITMAP_BOUND_AS_TARGET  _HRESULT_TYPEDEF_(0x88990025L)
#define D2DERR_INSUFFICIENT_DEVICE_CAPABILITIES _HRESULT_TYPEDEF_(0x88990026L)
#define D2DERR_INTERMEDIATE_TOO_LARGE  _HRESULT_TYPEDEF_(0x88990027L)
#define D2DERR_EFFECT_IS_NOT_REGISTERED  _HRESULT_TYPEDEF_(0x88990028L)
#define D2DERR_INVALID_PROPERTY  _HRESULT_TYPEDEF_(0x88990029L)
#define D2DERR_NO_SUBPROPERTIES  _HRESULT_TYPEDEF_(0x8899002AL)
#define D2DERR_PRINT_JOB_CLOSED  _HRESULT_TYPEDEF_(0x8899002BL)
#define D2DERR_PRINT_FORMAT_NOT_SUPPORTED _HRESULT_TYPEDEF_(0x8899002CL)
#define D2DERR_TOO_MANY_TRANSFORM_INPUTS _HRESULT_TYPEDEF_(0x8899002DL)
#define D2DERR_INVALID_GLYPH_IMAGE  _HRESULT_TYPEDEF_(0x8899002EL)
#define DWRITE_E_FILEFORMAT  _HRESULT_TYPEDEF_(0x88985000L)
#define DWRITE_E_UNEXPECTED  _HRESULT_TYPEDEF_(0x88985001L)
#define DWRITE_E_NOFONT  _HRESULT_TYPEDEF_(0x88985002L)
#define DWRITE_E_FILENOTFOUND  _HRESULT_TYPEDEF_(0x88985003L)
#define DWRITE_E_FILEACCESS  _HRESULT_TYPEDEF_(0x88985004L)
#define DWRITE_E_FONTCOLLECTIONOBSOLETE  _HRESULT_TYPEDEF_(0x88985005L)
#define DWRITE_E_ALREADYREGISTERED  _HRESULT_TYPEDEF_(0x88985006L)
#define DWRITE_E_CACHEFORMAT  _HRESULT_TYPEDEF_(0x88985007L)
#define DWRITE_E_CACHEVERSION  _HRESULT_TYPEDEF_(0x88985008L)
#define DWRITE_E_UNSUPPORTEDOPERATION  _HRESULT_TYPEDEF_(0x88985009L)
#define DWRITE_E_TEXTRENDERERINCOMPATIBLE _HRESULT_TYPEDEF_(0x8898500AL)
#define DWRITE_E_FLOWDIRECTIONCONFLICTS  _HRESULT_TYPEDEF_(0x8898500BL)
#define DWRITE_E_NOCOLOR  _HRESULT_TYPEDEF_(0x8898500CL)
#define WINCODEC_ERR_WRONGSTATE  _HRESULT_TYPEDEF_(0x88982F04L)
#define WINCODEC_ERR_VALUEOUTOFRANGE  _HRESULT_TYPEDEF_(0x88982F05L)
#define WINCODEC_ERR_UNKNOWNIMAGEFORMAT  _HRESULT_TYPEDEF_(0x88982F07L)
#define WINCODEC_ERR_UNSUPPORTEDVERSION  _HRESULT_TYPEDEF_(0x88982F0BL)
#define WINCODEC_ERR_NOTINITIALIZED  _HRESULT_TYPEDEF_(0x88982F0CL)
#define WINCODEC_ERR_ALREADYLOCKED  _HRESULT_TYPEDEF_(0x88982F0DL)
#define WINCODEC_ERR_PROPERTYNOTFOUND  _HRESULT_TYPEDEF_(0x88982F40L)
#define WINCODEC_ERR_PROPERTYNOTSUPPORTED _HRESULT_TYPEDEF_(0x88982F41L)
#define WINCODEC_ERR_PROPERTYSIZE  _HRESULT_TYPEDEF_(0x88982F42L)
#define WINCODEC_ERR_CODECPRESENT  _HRESULT_TYPEDEF_(0x88982F43L)
#define WINCODEC_ERR_CODECNOTHUMBNAIL  _HRESULT_TYPEDEF_(0x88982F44L)
#define WINCODEC_ERR_PALETTEUNAVAILABLE  _HRESULT_TYPEDEF_(0x88982F45L)
#define WINCODEC_ERR_CODECTOOMANYSCANLINES _HRESULT_TYPEDEF_(0x88982F46L)
#define WINCODEC_ERR_INTERNALERROR  _HRESULT_TYPEDEF_(0x88982F48L)
#define WINCODEC_ERR_SOURCERECTDOESNOTMATCHDIMENSIONS _HRESULT_TYPEDEF_(0x88982F49L)
#define WINCODEC_ERR_COMPONENTNOTFOUND  _HRESULT_TYPEDEF_(0x88982F50L)
#define WINCODEC_ERR_IMAGESIZEOUTOFRANGE _HRESULT_TYPEDEF_(0x88982F51L)
#define WINCODEC_ERR_TOOMUCHMETADATA  _HRESULT_TYPEDEF_(0x88982F52L)
#define WINCODEC_ERR_BADIMAGE  _HRESULT_TYPEDEF_(0x88982F60L)
#define WINCODEC_ERR_BADHEADER  _HRESULT_TYPEDEF_(0x88982F61L)
#define WINCODEC_ERR_FRAMEMISSING  _HRESULT_TYPEDEF_(0x88982F62L)
#define WINCODEC_ERR_BADMETADATAHEADER  _HRESULT_TYPEDEF_(0x88982F63L)
#define WINCODEC_ERR_BADSTREAMDATA  _HRESULT_TYPEDEF_(0x88982F70L)
#define WINCODEC_ERR_STREAMWRITE  _HRESULT_TYPEDEF_(0x88982F71L)
#define WINCODEC_ERR_STREAMREAD  _HRESULT_TYPEDEF_(0x88982F72L)
#define WINCODEC_ERR_STREAMNOTAVAILABLE  _HRESULT_TYPEDEF_(0x88982F73L)
#define WINCODEC_ERR_UNSUPPORTEDPIXELFORMAT _HRESULT_TYPEDEF_(0x88982F80L)
#define WINCODEC_ERR_UNSUPPORTEDOPERATION _HRESULT_TYPEDEF_(0x88982F81L)
#define WINCODEC_ERR_INVALIDREGISTRATION _HRESULT_TYPEDEF_(0x88982F8AL)
#define WINCODEC_ERR_COMPONENTINITIALIZEFAILURE _HRESULT_TYPEDEF_(0x88982F8BL)
#define WINCODEC_ERR_INSUFFICIENTBUFFER  _HRESULT_TYPEDEF_(0x88982F8CL)
#define WINCODEC_ERR_DUPLICATEMETADATAPRESENT _HRESULT_TYPEDEF_(0x88982F8DL)
#define WINCODEC_ERR_PROPERTYUNEXPECTEDTYPE _HRESULT_TYPEDEF_(0x88982F8EL)
#define WINCODEC_ERR_UNEXPECTEDSIZE  _HRESULT_TYPEDEF_(0x88982F8FL)
#define WINCODEC_ERR_INVALIDQUERYREQUEST _HRESULT_TYPEDEF_(0x88982F90L)
#define WINCODEC_ERR_UNEXPECTEDMETADATATYPE _HRESULT_TYPEDEF_(0x88982F91L)
#define WINCODEC_ERR_REQUESTONLYVALIDATMETADATAROOT _HRESULT_TYPEDEF_(0x88982F92L)
#define WINCODEC_ERR_INVALIDQUERYCHARACTER _HRESULT_TYPEDEF_(0x88982F93L)
#define WINCODEC_ERR_WIN32ERROR  _HRESULT_TYPEDEF_(0x88982F94L)
#define WINCODEC_ERR_INVALIDPROGRESSIVELEVEL _HRESULT_TYPEDEF_(0x88982F95L)
#define WINCODEC_ERR_INVALIDJPEGSCANINDEX _HRESULT_TYPEDEF_(0x88982F96L)
#define MILERR_OBJECTBUSY  _HRESULT_TYPEDEF_(0x88980001L)
#define MILERR_INSUFFICIENTBUFFER  _HRESULT_TYPEDEF_(0x88980002L)
#define MILERR_WIN32ERROR  _HRESULT_TYPEDEF_(0x88980003L)
#define MILERR_SCANNER_FAILED  _HRESULT_TYPEDEF_(0x88980004L)
#define MILERR_SCREENACCESSDENIED  _HRESULT_TYPEDEF_(0x88980005L)
#define MILERR_DISPLAYSTATEINVALID  _HRESULT_TYPEDEF_(0x88980006L)
#define MILERR_NONINVERTIBLEMATRIX  _HRESULT_TYPEDEF_(0x88980007L)
#define MILERR_ZEROVECTOR  _HRESULT_TYPEDEF_(0x88980008L)
#define MILERR_TERMINATED  _HRESULT_TYPEDEF_(0x88980009L)
#define MILERR_BADNUMBER  _HRESULT_TYPEDEF_(0x8898000AL)
#define MILERR_INTERNALERROR  _HRESULT_TYPEDEF_(0x88980080L)
#define MILERR_DISPLAYFORMATNOTSUPPORTED _HRESULT_TYPEDEF_(0x88980084L)
#define MILERR_INVALIDCALL  _HRESULT_TYPEDEF_(0x88980085L)
#define MILERR_ALREADYLOCKED  _HRESULT_TYPEDEF_(0x88980086L)
#define MILERR_NOTLOCKED  _HRESULT_TYPEDEF_(0x88980087L)
#define MILERR_DEVICECANNOTRENDERTEXT  _HRESULT_TYPEDEF_(0x88980088L)
#define MILERR_GLYPHBITMAPMISSED  _HRESULT_TYPEDEF_(0x88980089L)
#define MILERR_MALFORMEDGLYPHCACHE  _HRESULT_TYPEDEF_(0x8898008AL)
#define MILERR_GENERIC_IGNORE  _HRESULT_TYPEDEF_(0x8898008BL)
#define MILERR_MALFORMED_GUIDELINE_DATA  _HRESULT_TYPEDEF_(0x8898008CL)
#define MILERR_NO_HARDWARE_DEVICE  _HRESULT_TYPEDEF_(0x8898008DL)
#define MILERR_NEED_RECREATE_AND_PRESENT _HRESULT_TYPEDEF_(0x8898008EL)
#define MILERR_ALREADY_INITIALIZED  _HRESULT_TYPEDEF_(0x8898008FL)
#define MILERR_MISMATCHED_SIZE  _HRESULT_TYPEDEF_(0x88980090L)
#define MILERR_NO_REDIRECTION_SURFACE_AVAILABLE _HRESULT_TYPEDEF_(0x88980091L)
#define MILERR_REMOTING_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x88980092L)
#define MILERR_QUEUED_PRESENT_NOT_SUPPORTED _HRESULT_TYPEDEF_(0x88980093L)
#define MILERR_NOT_QUEUING_PRESENTS  _HRESULT_TYPEDEF_(0x88980094L)
#define MILERR_NO_REDIRECTION_SURFACE_RETRY_LATER _HRESULT_TYPEDEF_(0x88980095L)
#define MILERR_TOOMANYSHADERELEMNTS  _HRESULT_TYPEDEF_(0x88980096L)
#define MILERR_MROW_READLOCK_FAILED  _HRESULT_TYPEDEF_(0x88980097L)
#define MILERR_MROW_UPDATE_FAILED  _HRESULT_TYPEDEF_(0x88980098L)
#define MILERR_SHADER_COMPILE_FAILED  _HRESULT_TYPEDEF_(0x88980099L)
#define MILERR_MAX_TEXTURE_SIZE_EXCEEDED _HRESULT_TYPEDEF_(0x8898009AL)
#define MILERR_QPC_TIME_WENT_BACKWARD  _HRESULT_TYPEDEF_(0x8898009BL)
#define MILERR_DXGI_ENUMERATION_OUT_OF_SYNC _HRESULT_TYPEDEF_(0x8898009DL)
#define MILERR_ADAPTER_NOT_FOUND  _HRESULT_TYPEDEF_(0x8898009EL)
#define MILERR_COLORSPACE_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x8898009FL)
#define MILERR_PREFILTER_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x889800A0L)
#define MILERR_DISPLAYID_ACCESS_DENIED  _HRESULT_TYPEDEF_(0x889800A1L)
#define UCEERR_INVALIDPACKETHEADER  _HRESULT_TYPEDEF_(0x88980400L)
#define UCEERR_UNKNOWNPACKET  _HRESULT_TYPEDEF_(0x88980401L)
#define UCEERR_ILLEGALPACKET  _HRESULT_TYPEDEF_(0x88980402L)
#define UCEERR_MALFORMEDPACKET  _HRESULT_TYPEDEF_(0x88980403L)
#define UCEERR_ILLEGALHANDLE  _HRESULT_TYPEDEF_(0x88980404L)
#define UCEERR_HANDLELOOKUPFAILED  _HRESULT_TYPEDEF_(0x88980405L)
#define UCEERR_RENDERTHREADFAILURE  _HRESULT_TYPEDEF_(0x88980406L)
#define UCEERR_CTXSTACKFRSTTARGETNULL  _HRESULT_TYPEDEF_(0x88980407L)
#define UCEERR_CONNECTIONIDLOOKUPFAILED  _HRESULT_TYPEDEF_(0x88980408L)
#define UCEERR_BLOCKSFULL  _HRESULT_TYPEDEF_(0x88980409L)
#define UCEERR_MEMORYFAILURE  _HRESULT_TYPEDEF_(0x8898040AL)
#define UCEERR_PACKETRECORDOUTOFRANGE  _HRESULT_TYPEDEF_(0x8898040BL)
#define UCEERR_ILLEGALRECORDTYPE  _HRESULT_TYPEDEF_(0x8898040CL)
#define UCEERR_OUTOFHANDLES  _HRESULT_TYPEDEF_(0x8898040DL)
#define UCEERR_UNCHANGABLE_UPDATE_ATTEMPTED _HRESULT_TYPEDEF_(0x8898040EL)
#define UCEERR_NO_MULTIPLE_WORKER_THREADS _HRESULT_TYPEDEF_(0x8898040FL)
#define UCEERR_REMOTINGNOTSUPPORTED  _HRESULT_TYPEDEF_(0x88980410L)
#define UCEERR_MISSINGENDCOMMAND  _HRESULT_TYPEDEF_(0x88980411L)
#define UCEERR_MISSINGBEGINCOMMAND  _HRESULT_TYPEDEF_(0x88980412L)
#define UCEERR_CHANNELSYNCTIMEDOUT  _HRESULT_TYPEDEF_(0x88980413L)
#define UCEERR_CHANNELSYNCABANDONED  _HRESULT_TYPEDEF_(0x88980414L)
#define UCEERR_UNSUPPORTEDTRANSPORTVERSION _HRESULT_TYPEDEF_(0x88980415L)
#define UCEERR_TRANSPORTUNAVAILABLE  _HRESULT_TYPEDEF_(0x88980416L)
#define UCEERR_FEEDBACK_UNSUPPORTED  _HRESULT_TYPEDEF_(0x88980417L)
#define UCEERR_COMMANDTRANSPORTDENIED  _HRESULT_TYPEDEF_(0x88980418L)
#define UCEERR_GRAPHICSSTREAMUNAVAILABLE _HRESULT_TYPEDEF_(0x88980419L)
#define UCEERR_GRAPHICSSTREAMALREADYOPEN _HRESULT_TYPEDEF_(0x88980420L)
#define UCEERR_TRANSPORTDISCONNECTED  _HRESULT_TYPEDEF_(0x88980421L)
#define UCEERR_TRANSPORTOVERLOADED  _HRESULT_TYPEDEF_(0x88980422L)
#define UCEERR_PARTITION_ZOMBIED  _HRESULT_TYPEDEF_(0x88980423L)
#define MILAVERR_NOCLOCK  _HRESULT_TYPEDEF_(0x88980500L)
#define MILAVERR_NOMEDIATYPE  _HRESULT_TYPEDEF_(0x88980501L)
#define MILAVERR_NOVIDEOMIXER  _HRESULT_TYPEDEF_(0x88980502L)
#define MILAVERR_NOVIDEOPRESENTER  _HRESULT_TYPEDEF_(0x88980503L)
#define MILAVERR_NOREADYFRAMES  _HRESULT_TYPEDEF_(0x88980504L)
#define MILAVERR_MODULENOTLOADED  _HRESULT_TYPEDEF_(0x88980505L)
#define MILAVERR_WMPFACTORYNOTREGISTERED _HRESULT_TYPEDEF_(0x88980506L)
#define MILAVERR_INVALIDWMPVERSION  _HRESULT_TYPEDEF_(0x88980507L)
#define MILAVERR_INSUFFICIENTVIDEORESOURCES _HRESULT_TYPEDEF_(0x88980508L)
#define MILAVERR_VIDEOACCELERATIONNOTAVAILABLE _HRESULT_TYPEDEF_(0x88980509L)
#define MILAVERR_REQUESTEDTEXTURETOOBIG  _HRESULT_TYPEDEF_(0x8898050AL)
#define MILAVERR_SEEKFAILED  _HRESULT_TYPEDEF_(0x8898050BL)
#define MILAVERR_UNEXPECTEDWMPFAILURE  _HRESULT_TYPEDEF_(0x8898050CL)
#define MILAVERR_MEDIAPLAYERCLOSED  _HRESULT_TYPEDEF_(0x8898050DL)
#define MILAVERR_UNKNOWNHARDWAREERROR  _HRESULT_TYPEDEF_(0x8898050EL)
#define MILEFFECTSERR_UNKNOWNPROPERTY  _HRESULT_TYPEDEF_(0x8898060EL)
#define MILEFFECTSERR_EFFECTNOTPARTOFGROUP _HRESULT_TYPEDEF_(0x8898060FL)
#define MILEFFECTSERR_NOINPUTSOURCEATTACHED _HRESULT_TYPEDEF_(0x88980610L)
#define MILEFFECTSERR_CONNECTORNOTCONNECTED _HRESULT_TYPEDEF_(0x88980611L)
#define MILEFFECTSERR_CONNECTORNOTASSOCIATEDWITHEFFECT _HRESULT_TYPEDEF_(0x88980612L)
#define MILEFFECTSERR_RESERVED  _HRESULT_TYPEDEF_(0x88980613L)
#define MILEFFECTSERR_CYCLEDETECTED  _HRESULT_TYPEDEF_(0x88980614L)
#define MILEFFECTSERR_EFFECTINMORETHANONEGRAPH _HRESULT_TYPEDEF_(0x88980615L)
#define MILEFFECTSERR_EFFECTALREADYINAGRAPH _HRESULT_TYPEDEF_(0x88980616L)
#define MILEFFECTSERR_EFFECTHASNOCHILDREN _HRESULT_TYPEDEF_(0x88980617L)
#define MILEFFECTSERR_ALREADYATTACHEDTOLISTENER _HRESULT_TYPEDEF_(0x88980618L)
#define MILEFFECTSERR_NOTAFFINETRANSFORM _HRESULT_TYPEDEF_(0x88980619L)
#define MILEFFECTSERR_EMPTYBOUNDS  _HRESULT_TYPEDEF_(0x8898061AL)
#define MILEFFECTSERR_OUTPUTSIZETOOLARGE _HRESULT_TYPEDEF_(0x8898061BL)
#define DWMERR_STATE_TRANSITION_FAILED  _HRESULT_TYPEDEF_(0x88980700L)
#define DWMERR_THEME_FAILED  _HRESULT_TYPEDEF_(0x88980701L)
#define DWMERR_CATASTROPHIC_FAILURE  _HRESULT_TYPEDEF_(0x88980702L)
#define DCOMPOSITION_ERROR_WINDOW_ALREADY_COMPOSED _HRESULT_TYPEDEF_(0x88980800L)
#define DCOMPOSITION_ERROR_SURFACE_BEING_RENDERED _HRESULT_TYPEDEF_(0x88980801L)
#define DCOMPOSITION_ERROR_SURFACE_NOT_BEING_RENDERED _HRESULT_TYPEDEF_(0x88980802L)
#define ONL_E_INVALID_AUTHENTICATION_TARGET _HRESULT_TYPEDEF_(0x80860001L)
#define ONL_E_ACCESS_DENIED_BY_TOU  _HRESULT_TYPEDEF_(0x80860002L)
#define ONL_E_INVALID_APPLICATION  _HRESULT_TYPEDEF_(0x80860003L)
#define ONL_E_PASSWORD_UPDATE_REQUIRED  _HRESULT_TYPEDEF_(0x80860004L)
#define ONL_E_ACCOUNT_UPDATE_REQUIRED  _HRESULT_TYPEDEF_(0x80860005L)
#define ONL_E_FORCESIGNIN  _HRESULT_TYPEDEF_(0x80860006L)
#define ONL_E_ACCOUNT_LOCKED  _HRESULT_TYPEDEF_(0x80860007L)
#define ONL_E_PARENTAL_CONSENT_REQUIRED  _HRESULT_TYPEDEF_(0x80860008L)
#define ONL_E_EMAIL_VERIFICATION_REQUIRED _HRESULT_TYPEDEF_(0x80860009L)
#define ONL_E_ACCOUNT_SUSPENDED_COMPROIMISE _HRESULT_TYPEDEF_(0x8086000AL)
#define ONL_E_ACCOUNT_SUSPENDED_ABUSE  _HRESULT_TYPEDEF_(0x8086000BL)
#define ONL_E_ACTION_REQUIRED  _HRESULT_TYPEDEF_(0x8086000CL)
#define ONL_CONNECTION_COUNT_LIMIT  _HRESULT_TYPEDEF_(0x8086000DL)
#define ONL_E_CONNECTED_ACCOUNT_CAN_NOT_SIGNOUT _HRESULT_TYPEDEF_(0x8086000EL)
#define ONL_E_USER_AUTHENTICATION_REQUIRED _HRESULT_TYPEDEF_(0x8086000FL)
#define ONL_E_REQUEST_THROTTLED  _HRESULT_TYPEDEF_(0x80860010L)
#define FA_E_MAX_PERSISTED_ITEMS_REACHED _HRESULT_TYPEDEF_(0x80270220L)
#define FA_E_HOMEGROUP_NOT_AVAILABLE  _HRESULT_TYPEDEF_(0x80270222L)
#define E_MONITOR_RESOLUTION_TOO_LOW  _HRESULT_TYPEDEF_(0x80270250L)
#define E_ELEVATED_ACTIVATION_NOT_SUPPORTED _HRESULT_TYPEDEF_(0x80270251L)
#define E_UAC_DISABLED  _HRESULT_TYPEDEF_(0x80270252L)
#define E_FULL_ADMIN_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x80270253L)
#define E_APPLICATION_NOT_REGISTERED  _HRESULT_TYPEDEF_(0x80270254L)
#define E_MULTIPLE_EXTENSIONS_FOR_APPLICATION _HRESULT_TYPEDEF_(0x80270255L)
#define E_MULTIPLE_PACKAGES_FOR_FAMILY  _HRESULT_TYPEDEF_(0x80270256L)
#define E_APPLICATION_MANAGER_NOT_RUNNING _HRESULT_TYPEDEF_(0x80270257L)
#define S_STORE_LAUNCHED_FOR_REMEDIATION _HRESULT_TYPEDEF_(0x00270258L)
#define S_APPLICATION_ACTIVATION_ERROR_HANDLED_BY_DIALOG _HRESULT_TYPEDEF_(0x00270259L)
#define E_APPLICATION_ACTIVATION_TIMED_OUT _HRESULT_TYPEDEF_(0x8027025AL)
#define E_APPLICATION_ACTIVATION_EXEC_FAILURE _HRESULT_TYPEDEF_(0x8027025BL)
#define E_APPLICATION_TEMPORARY_LICENSE_ERROR _HRESULT_TYPEDEF_(0x8027025CL)
#define E_APPLICATION_TRIAL_LICENSE_EXPIRED _HRESULT_TYPEDEF_(0x8027025DL)
#define E_SKYDRIVE_ROOT_TARGET_FILE_SYSTEM_NOT_SUPPORTED _HRESULT_TYPEDEF_(0x80270260L)
#define E_SKYDRIVE_ROOT_TARGET_OVERLAP  _HRESULT_TYPEDEF_(0x80270261L)
#define E_SKYDRIVE_ROOT_TARGET_CANNOT_INDEX _HRESULT_TYPEDEF_(0x80270262L)
#define E_SKYDRIVE_FILE_NOT_UPLOADED  _HRESULT_TYPEDEF_(0x80270263L)
#define E_SKYDRIVE_UPDATE_AVAILABILITY_FAIL _HRESULT_TYPEDEF_(0x80270264L)
#define E_SKYDRIVE_ROOT_TARGET_VOLUME_ROOT_NOT_SUPPORTED _HRESULT_TYPEDEF_(0x80270265L)
#define E_SYNCENGINE_FILE_SIZE_OVER_LIMIT _HRESULT_TYPEDEF_(0x8802B001L)
#define E_SYNCENGINE_FILE_SIZE_EXCEEDS_REMAINING_QUOTA _HRESULT_TYPEDEF_(0x8802B002L)
#define E_SYNCENGINE_UNSUPPORTED_FILE_NAME _HRESULT_TYPEDEF_(0x8802B003L)
#define E_SYNCENGINE_FOLDER_ITEM_COUNT_LIMIT_EXCEEDED _HRESULT_TYPEDEF_(0x8802B004L)
#define E_SYNCENGINE_FILE_SYNC_PARTNER_ERROR _HRESULT_TYPEDEF_(0x8802B005L)
#define E_SYNCENGINE_SYNC_PAUSED_BY_SERVICE _HRESULT_TYPEDEF_(0x8802B006L)
#define E_SYNCENGINE_FILE_IDENTIFIER_UNKNOWN _HRESULT_TYPEDEF_(0x8802C002L)
#define E_SYNCENGINE_SERVICE_AUTHENTICATION_FAILED _HRESULT_TYPEDEF_(0x8802C003L)
#define E_SYNCENGINE_UNKNOWN_SERVICE_ERROR _HRESULT_TYPEDEF_(0x8802C004L)
#define E_SYNCENGINE_SERVICE_RETURNED_UNEXPECTED_SIZE _HRESULT_TYPEDEF_(0x8802C005L)
#define E_SYNCENGINE_REQUEST_BLOCKED_BY_SERVICE _HRESULT_TYPEDEF_(0x8802C006L)
#define E_SYNCENGINE_REQUEST_BLOCKED_DUE_TO_CLIENT_ERROR _HRESULT_TYPEDEF_(0x8802C007L)
#define E_SYNCENGINE_FOLDER_INACCESSIBLE _HRESULT_TYPEDEF_(0x8802D001L)
#define E_SYNCENGINE_UNSUPPORTED_FOLDER_NAME _HRESULT_TYPEDEF_(0x8802D002L)
#define E_SYNCENGINE_UNSUPPORTED_MARKET  _HRESULT_TYPEDEF_(0x8802D003L)
#define E_SYNCENGINE_PATH_LENGTH_LIMIT_EXCEEDED _HRESULT_TYPEDEF_(0x8802D004L)
#define E_SYNCENGINE_REMOTE_PATH_LENGTH_LIMIT_EXCEEDED _HRESULT_TYPEDEF_(0x8802D005L)
#define E_SYNCENGINE_CLIENT_UPDATE_NEEDED _HRESULT_TYPEDEF_(0x8802D006L)
#define E_SYNCENGINE_PROXY_AUTHENTICATION_REQUIRED _HRESULT_TYPEDEF_(0x8802D007L)
#define E_SYNCENGINE_STORAGE_SERVICE_PROVISIONING_FAILED _HRESULT_TYPEDEF_(0x8802D008L)
#define E_SYNCENGINE_UNSUPPORTED_REPARSE_POINT _HRESULT_TYPEDEF_(0x8802D009L)
#define E_SYNCENGINE_STORAGE_SERVICE_BLOCKED _HRESULT_TYPEDEF_(0x8802D00AL)
#define E_SYNCENGINE_FOLDER_IN_REDIRECTION _HRESULT_TYPEDEF_(0x8802D00BL)
#define EAS_E_POLICY_NOT_MANAGED_BY_OS  _HRESULT_TYPEDEF_(0x80550001L)
#define EAS_E_POLICY_COMPLIANT_WITH_ACTIONS _HRESULT_TYPEDEF_(0x80550002L)
#define EAS_E_REQUESTED_POLICY_NOT_ENFORCEABLE _HRESULT_TYPEDEF_(0x80550003L)
#define EAS_E_CURRENT_USER_HAS_BLANK_PASSWORD _HRESULT_TYPEDEF_(0x80550004L)
#define EAS_E_REQUESTED_POLICY_PASSWORD_EXPIRATION_INCOMPATIBLE _HRESULT_TYPEDEF_(0x80550005L)
#define EAS_E_USER_CANNOT_CHANGE_PASSWORD _HRESULT_TYPEDEF_(0x80550006L)
#define EAS_E_ADMINS_HAVE_BLANK_PASSWORD _HRESULT_TYPEDEF_(0x80550007L)
#define EAS_E_ADMINS_CANNOT_CHANGE_PASSWORD _HRESULT_TYPEDEF_(0x80550008L)
#define EAS_E_LOCAL_CONTROLLED_USERS_CANNOT_CHANGE_PASSWORD _HRESULT_TYPEDEF_(0x80550009L)
#define EAS_E_PASSWORD_POLICY_NOT_ENFORCEABLE_FOR_CONNECTED_ADMINS _HRESULT_TYPEDEF_(0x8055000AL)
#define EAS_E_CONNECTED_ADMINS_NEED_TO_CHANGE_PASSWORD _HRESULT_TYPEDEF_(0x8055000BL)
#define EAS_E_PASSWORD_POLICY_NOT_ENFORCEABLE_FOR_CURRENT_CONNECTED_USER _HRESULT_TYPEDEF_(0x8055000CL)
#define EAS_E_CURRENT_CONNECTED_USER_NEED_TO_CHANGE_PASSWORD _HRESULT_TYPEDEF_(0x8055000DL)
#define WEB_E_UNSUPPORTED_FORMAT  _HRESULT_TYPEDEF_(0x83750001L)
#define WEB_E_INVALID_XML  _HRESULT_TYPEDEF_(0x83750002L)
#define WEB_E_MISSING_REQUIRED_ELEMENT  _HRESULT_TYPEDEF_(0x83750003L)
#define WEB_E_MISSING_REQUIRED_ATTRIBUTE _HRESULT_TYPEDEF_(0x83750004L)
#define WEB_E_UNEXPECTED_CONTENT  _HRESULT_TYPEDEF_(0x83750005L)
#define WEB_E_RESOURCE_TOO_LARGE  _HRESULT_TYPEDEF_(0x83750006L)
#define WEB_E_INVALID_JSON_STRING  _HRESULT_TYPEDEF_(0x83750007L)
#define WEB_E_INVALID_JSON_NUMBER  _HRESULT_TYPEDEF_(0x83750008L)
#define WEB_E_JSON_VALUE_NOT_FOUND  _HRESULT_TYPEDEF_(0x83750009L)
#define HTTP_E_STATUS_UNEXPECTED  _HRESULT_TYPEDEF_(0x80190001L)
#define HTTP_E_STATUS_UNEXPECTED_REDIRECTION _HRESULT_TYPEDEF_(0x80190003L)
#define HTTP_E_STATUS_UNEXPECTED_CLIENT_ERROR _HRESULT_TYPEDEF_(0x80190004L)
#define HTTP_E_STATUS_UNEXPECTED_SERVER_ERROR _HRESULT_TYPEDEF_(0x80190005L)
#define HTTP_E_STATUS_AMBIGUOUS  _HRESULT_TYPEDEF_(0x8019012CL)
#define HTTP_E_STATUS_MOVED  _HRESULT_TYPEDEF_(0x8019012DL)
#define HTTP_E_STATUS_REDIRECT  _HRESULT_TYPEDEF_(0x8019012EL)
#define HTTP_E_STATUS_REDIRECT_METHOD  _HRESULT_TYPEDEF_(0x8019012FL)
#define HTTP_E_STATUS_NOT_MODIFIED  _HRESULT_TYPEDEF_(0x80190130L)
#define HTTP_E_STATUS_USE_PROXY  _HRESULT_TYPEDEF_(0x80190131L)
#define HTTP_E_STATUS_REDIRECT_KEEP_VERB _HRESULT_TYPEDEF_(0x80190133L)
#define HTTP_E_STATUS_BAD_REQUEST  _HRESULT_TYPEDEF_(0x80190190L)
#define HTTP_E_STATUS_DENIED  _HRESULT_TYPEDEF_(0x80190191L)
#define HTTP_E_STATUS_PAYMENT_REQ  _HRESULT_TYPEDEF_(0x80190192L)
#define HTTP_E_STATUS_FORBIDDEN  _HRESULT_TYPEDEF_(0x80190193L)
#define HTTP_E_STATUS_NOT_FOUND  _HRESULT_TYPEDEF_(0x80190194L)
#define HTTP_E_STATUS_BAD_METHOD  _HRESULT_TYPEDEF_(0x80190195L)
#define HTTP_E_STATUS_NONE_ACCEPTABLE  _HRESULT_TYPEDEF_(0x80190196L)
#define HTTP_E_STATUS_PROXY_AUTH_REQ  _HRESULT_TYPEDEF_(0x80190197L)
#define HTTP_E_STATUS_REQUEST_TIMEOUT  _HRESULT_TYPEDEF_(0x80190198L)
#define HTTP_E_STATUS_CONFLICT  _HRESULT_TYPEDEF_(0x80190199L)
#define HTTP_E_STATUS_GONE  _HRESULT_TYPEDEF_(0x8019019AL)
#define HTTP_E_STATUS_LENGTH_REQUIRED  _HRESULT_TYPEDEF_(0x8019019BL)
#define HTTP_E_STATUS_PRECOND_FAILED  _HRESULT_TYPEDEF_(0x8019019CL)
#define HTTP_E_STATUS_REQUEST_TOO_LARGE  _HRESULT_TYPEDEF_(0x8019019DL)
#define HTTP_E_STATUS_URI_TOO_LONG  _HRESULT_TYPEDEF_(0x8019019EL)
#define HTTP_E_STATUS_UNSUPPORTED_MEDIA  _HRESULT_TYPEDEF_(0x8019019FL)
#define HTTP_E_STATUS_RANGE_NOT_SATISFIABLE _HRESULT_TYPEDEF_(0x801901A0L)
#define HTTP_E_STATUS_EXPECTATION_FAILED _HRESULT_TYPEDEF_(0x801901A1L)
#define HTTP_E_STATUS_SERVER_ERROR  _HRESULT_TYPEDEF_(0x801901F4L)
#define HTTP_E_STATUS_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x801901F5L)
#define HTTP_E_STATUS_BAD_GATEWAY  _HRESULT_TYPEDEF_(0x801901F6L)
#define HTTP_E_STATUS_SERVICE_UNAVAIL  _HRESULT_TYPEDEF_(0x801901F7L)
#define HTTP_E_STATUS_GATEWAY_TIMEOUT  _HRESULT_TYPEDEF_(0x801901F8L)
#define HTTP_E_STATUS_VERSION_NOT_SUP  _HRESULT_TYPEDEF_(0x801901F9L)
#define E_INVALID_PROTOCOL_OPERATION  _HRESULT_TYPEDEF_(0x83760001L)
#define E_INVALID_PROTOCOL_FORMAT  _HRESULT_TYPEDEF_(0x83760002L)
#define E_PROTOCOL_EXTENSIONS_NOT_SUPPORTED _HRESULT_TYPEDEF_(0x83760003L)
#define E_SUBPROTOCOL_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x83760004L)
#define E_PROTOCOL_VERSION_NOT_SUPPORTED _HRESULT_TYPEDEF_(0x83760005L)
#define INPUT_E_OUT_OF_ORDER  _HRESULT_TYPEDEF_(0x80400000L)
#define INPUT_E_REENTRANCY  _HRESULT_TYPEDEF_(0x80400001L)
#define INPUT_E_MULTIMODAL  _HRESULT_TYPEDEF_(0x80400002L)
#define INPUT_E_PACKET  _HRESULT_TYPEDEF_(0x80400003L)
#define INPUT_E_FRAME  _HRESULT_TYPEDEF_(0x80400004L)
#define INPUT_E_HISTORY  _HRESULT_TYPEDEF_(0x80400005L)
#define INPUT_E_DEVICE_INFO  _HRESULT_TYPEDEF_(0x80400006L)
#define INPUT_E_TRANSFORM  _HRESULT_TYPEDEF_(0x80400007L)
#define INPUT_E_DEVICE_PROPERTY  _HRESULT_TYPEDEF_(0x80400008L)
#define INET_E_INVALID_URL  _HRESULT_TYPEDEF_(0x800C0002L)
#define INET_E_NO_SESSION  _HRESULT_TYPEDEF_(0x800C0003L)
#define INET_E_CANNOT_CONNECT  _HRESULT_TYPEDEF_(0x800C0004L)
#define INET_E_RESOURCE_NOT_FOUND  _HRESULT_TYPEDEF_(0x800C0005L)
#define INET_E_OBJECT_NOT_FOUND  _HRESULT_TYPEDEF_(0x800C0006L)
#define INET_E_DATA_NOT_AVAILABLE  _HRESULT_TYPEDEF_(0x800C0007L)
#define INET_E_DOWNLOAD_FAILURE  _HRESULT_TYPEDEF_(0x800C0008L)
#define INET_E_AUTHENTICATION_REQUIRED  _HRESULT_TYPEDEF_(0x800C0009L)
#define INET_E_NO_VALID_MEDIA  _HRESULT_TYPEDEF_(0x800C000AL)
#define INET_E_CONNECTION_TIMEOUT  _HRESULT_TYPEDEF_(0x800C000BL)
#define INET_E_INVALID_REQUEST  _HRESULT_TYPEDEF_(0x800C000CL)
#define INET_E_UNKNOWN_PROTOCOL  _HRESULT_TYPEDEF_(0x800C000DL)
#define INET_E_SECURITY_PROBLEM  _HRESULT_TYPEDEF_(0x800C000EL)
#define INET_E_CANNOT_LOAD_DATA  _HRESULT_TYPEDEF_(0x800C000FL)
#define INET_E_CANNOT_INSTANTIATE_OBJECT _HRESULT_TYPEDEF_(0x800C0010L)
#define INET_E_INVALID_CERTIFICATE  _HRESULT_TYPEDEF_(0x800C0019L)
#define INET_E_REDIRECT_FAILED  _HRESULT_TYPEDEF_(0x800C0014L)
#define INET_E_REDIRECT_TO_DIR  _HRESULT_TYPEDEF_(0x800C0015L)
#define ERROR_DBG_CREATE_PROCESS_FAILURE_LOCKDOWN _HRESULT_TYPEDEF_(0x80B00001L)
#define ERROR_DBG_ATTACH_PROCESS_FAILURE_LOCKDOWN _HRESULT_TYPEDEF_(0x80B00002L)
#define ERROR_DBG_CONNECT_SERVER_FAILURE_LOCKDOWN _HRESULT_TYPEDEF_(0x80B00003L)
#define ERROR_DBG_START_SERVER_FAILURE_LOCKDOWN _HRESULT_TYPEDEF_(0x80B00004L)
#define ERROR_IO_PREEMPTED  _HRESULT_TYPEDEF_(0x89010001L)
#define JSCRIPT_E_CANTEXECUTE  _HRESULT_TYPEDEF_(0x89020001L)
#define WEP_E_NOT_PROVISIONED_ON_ALL_VOLUMES _HRESULT_TYPEDEF_(0x88010001L)
#define WEP_E_FIXED_DATA_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x88010002L)
#define WEP_E_HARDWARE_NOT_COMPLIANT  _HRESULT_TYPEDEF_(0x88010003L)
#define WEP_E_LOCK_NOT_CONFIGURED  _HRESULT_TYPEDEF_(0x88010004L)
#define WEP_E_PROTECTION_SUSPENDED  _HRESULT_TYPEDEF_(0x88010005L)
#define WEP_E_NO_LICENSE  _HRESULT_TYPEDEF_(0x88010006L)
#define WEP_E_OS_NOT_PROTECTED  _HRESULT_TYPEDEF_(0x88010007L)
#define WEP_E_UNEXPECTED_FAIL  _HRESULT_TYPEDEF_(0x88010008L)
#define WEP_E_BUFFER_TOO_LARGE  _HRESULT_TYPEDEF_(0x88010009L)
#define ERROR_SVHDX_ERROR_STORED  _HRESULT_TYPEDEF_(0xC05C0000L)
#define ERROR_SVHDX_ERROR_NOT_AVAILABLE  _HRESULT_TYPEDEF_(0xC05CFF00L)
#define ERROR_SVHDX_UNIT_ATTENTION_AVAILABLE _HRESULT_TYPEDEF_(0xC05CFF01L)
#define ERROR_SVHDX_UNIT_ATTENTION_CAPACITY_DATA_CHANGED _HRESULT_TYPEDEF_(0xC05CFF02L)
#define ERROR_SVHDX_UNIT_ATTENTION_RESERVATIONS_PREEMPTED _HRESULT_TYPEDEF_(0xC05CFF03L)
#define ERROR_SVHDX_UNIT_ATTENTION_RESERVATIONS_RELEASED _HRESULT_TYPEDEF_(0xC05CFF04L)
#define ERROR_SVHDX_UNIT_ATTENTION_REGISTRATIONS_PREEMPTED _HRESULT_TYPEDEF_(0xC05CFF05L)
#define ERROR_SVHDX_UNIT_ATTENTION_OPERATING_DEFINITION_CHANGED _HRESULT_TYPEDEF_(0xC05CFF06L)
#define ERROR_SVHDX_RESERVATION_CONFLICT _HRESULT_TYPEDEF_(0xC05CFF07L)
#define ERROR_SVHDX_WRONG_FILE_TYPE  _HRESULT_TYPEDEF_(0xC05CFF08L)
#define ERROR_SVHDX_VERSION_MISMATCH  _HRESULT_TYPEDEF_(0xC05CFF09L)
#define ERROR_VHD_SHARED  _HRESULT_TYPEDEF_(0xC05CFF0AL)
#define ERROR_SVHDX_NO_INITIATOR  _HRESULT_TYPEDEF_(0xC05CFF0BL)
#define ERROR_VHDSET_BACKING_STORAGE_NOT_FOUND _HRESULT_TYPEDEF_(0xC05CFF0CL)
#define ERROR_SMB_NO_PREAUTH_INTEGRITY_HASH_OVERLAP _HRESULT_TYPEDEF_(0xC05D0000L)
#define ERROR_SMB_BAD_CLUSTER_DIALECT  _HRESULT_TYPEDEF_(0xC05D0001L)
#define WININET_E_OUT_OF_HANDLES  _HRESULT_TYPEDEF_(0x80072EE1L)
#define WININET_E_TIMEOUT  _HRESULT_TYPEDEF_(0x80072EE2L)
#define WININET_E_EXTENDED_ERROR  _HRESULT_TYPEDEF_(0x80072EE3L)
#define WININET_E_INTERNAL_ERROR  _HRESULT_TYPEDEF_(0x80072EE4L)
#define WININET_E_INVALID_URL  _HRESULT_TYPEDEF_(0x80072EE5L)
#define WININET_E_UNRECOGNIZED_SCHEME  _HRESULT_TYPEDEF_(0x80072EE6L)
#define WININET_E_NAME_NOT_RESOLVED  _HRESULT_TYPEDEF_(0x80072EE7L)
#define WININET_E_PROTOCOL_NOT_FOUND  _HRESULT_TYPEDEF_(0x80072EE8L)
#define WININET_E_INVALID_OPTION  _HRESULT_TYPEDEF_(0x80072EE9L)
#define WININET_E_BAD_OPTION_LENGTH  _HRESULT_TYPEDEF_(0x80072EEAL)
#define WININET_E_OPTION_NOT_SETTABLE  _HRESULT_TYPEDEF_(0x80072EEBL)
#define WININET_E_SHUTDOWN  _HRESULT_TYPEDEF_(0x80072EECL)
#define WININET_E_INCORRECT_USER_NAME  _HRESULT_TYPEDEF_(0x80072EEDL)
#define WININET_E_INCORRECT_PASSWORD  _HRESULT_TYPEDEF_(0x80072EEEL)
#define WININET_E_LOGIN_FAILURE  _HRESULT_TYPEDEF_(0x80072EEFL)
#define WININET_E_INVALID_OPERATION  _HRESULT_TYPEDEF_(0x80072EF0L)
#define WININET_E_OPERATION_CANCELLED  _HRESULT_TYPEDEF_(0x80072EF1L)
#define WININET_E_INCORRECT_HANDLE_TYPE  _HRESULT_TYPEDEF_(0x80072EF2L)
#define WININET_E_INCORRECT_HANDLE_STATE _HRESULT_TYPEDEF_(0x80072EF3L)
#define WININET_E_NOT_PROXY_REQUEST  _HRESULT_TYPEDEF_(0x80072EF4L)
#define WININET_E_REGISTRY_VALUE_NOT_FOUND _HRESULT_TYPEDEF_(0x80072EF5L)
#define WININET_E_BAD_REGISTRY_PARAMETER _HRESULT_TYPEDEF_(0x80072EF6L)
#define WININET_E_NO_DIRECT_ACCESS  _HRESULT_TYPEDEF_(0x80072EF7L)
#define WININET_E_NO_CONTEXT  _HRESULT_TYPEDEF_(0x80072EF8L)
#define WININET_E_NO_CALLBACK  _HRESULT_TYPEDEF_(0x80072EF9L)
#define WININET_E_REQUEST_PENDING  _HRESULT_TYPEDEF_(0x80072EFAL)
#define WININET_E_INCORRECT_FORMAT  _HRESULT_TYPEDEF_(0x80072EFBL)
#define WININET_E_ITEM_NOT_FOUND  _HRESULT_TYPEDEF_(0x80072EFCL)
#define WININET_E_CANNOT_CONNECT  _HRESULT_TYPEDEF_(0x80072EFDL)
#define WININET_E_CONNECTION_ABORTED  _HRESULT_TYPEDEF_(0x80072EFEL)
#define WININET_E_CONNECTION_RESET  _HRESULT_TYPEDEF_(0x80072EFFL)
#define WININET_E_FORCE_RETRY  _HRESULT_TYPEDEF_(0x80072F00L)
#define WININET_E_INVALID_PROXY_REQUEST  _HRESULT_TYPEDEF_(0x80072F01L)
#define WININET_E_NEED_UI  _HRESULT_TYPEDEF_(0x80072F02L)
#define WININET_E_HANDLE_EXISTS  _HRESULT_TYPEDEF_(0x80072F04L)
#define WININET_E_SEC_CERT_DATE_INVALID  _HRESULT_TYPEDEF_(0x80072F05L)
#define WININET_E_SEC_CERT_CN_INVALID  _HRESULT_TYPEDEF_(0x80072F06L)
#define WININET_E_HTTP_TO_HTTPS_ON_REDIR _HRESULT_TYPEDEF_(0x80072F07L)
#define WININET_E_HTTPS_TO_HTTP_ON_REDIR _HRESULT_TYPEDEF_(0x80072F08L)
#define WININET_E_MIXED_SECURITY  _HRESULT_TYPEDEF_(0x80072F09L)
#define WININET_E_CHG_POST_IS_NON_SECURE _HRESULT_TYPEDEF_(0x80072F0AL)
#define WININET_E_POST_IS_NON_SECURE  _HRESULT_TYPEDEF_(0x80072F0BL)
#define WININET_E_CLIENT_AUTH_CERT_NEEDED _HRESULT_TYPEDEF_(0x80072F0CL)
#define WININET_E_INVALID_CA  _HRESULT_TYPEDEF_(0x80072F0DL)
#define WININET_E_CLIENT_AUTH_NOT_SETUP  _HRESULT_TYPEDEF_(0x80072F0EL)
#define WININET_E_ASYNC_THREAD_FAILED  _HRESULT_TYPEDEF_(0x80072F0FL)
#define WININET_E_REDIRECT_SCHEME_CHANGE _HRESULT_TYPEDEF_(0x80072F10L)
#define WININET_E_DIALOG_PENDING  _HRESULT_TYPEDEF_(0x80072F11L)
#define WININET_E_RETRY_DIALOG  _HRESULT_TYPEDEF_(0x80072F12L)
#define WININET_E_NO_NEW_CONTAINERS  _HRESULT_TYPEDEF_(0x80072F13L)
#define WININET_E_HTTPS_HTTP_SUBMIT_REDIR _HRESULT_TYPEDEF_(0x80072F14L)
#define WININET_E_SEC_CERT_ERRORS  _HRESULT_TYPEDEF_(0x80072F17L)
#define WININET_E_SEC_CERT_REV_FAILED  _HRESULT_TYPEDEF_(0x80072F19L)
#define WININET_E_HEADER_NOT_FOUND  _HRESULT_TYPEDEF_(0x80072F76L)
#define WININET_E_DOWNLEVEL_SERVER  _HRESULT_TYPEDEF_(0x80072F77L)
#define WININET_E_INVALID_SERVER_RESPONSE _HRESULT_TYPEDEF_(0x80072F78L)
#define WININET_E_INVALID_HEADER  _HRESULT_TYPEDEF_(0x80072F79L)
#define WININET_E_INVALID_QUERY_REQUEST  _HRESULT_TYPEDEF_(0x80072F7AL)
#define WININET_E_HEADER_ALREADY_EXISTS  _HRESULT_TYPEDEF_(0x80072F7BL)
#define WININET_E_REDIRECT_FAILED  _HRESULT_TYPEDEF_(0x80072F7CL)
#define WININET_E_SECURITY_CHANNEL_ERROR _HRESULT_TYPEDEF_(0x80072F7DL)
#define WININET_E_UNABLE_TO_CACHE_FILE  _HRESULT_TYPEDEF_(0x80072F7EL)
#define WININET_E_TCPIP_NOT_INSTALLED  _HRESULT_TYPEDEF_(0x80072F7FL)
#define WININET_E_DISCONNECTED  _HRESULT_TYPEDEF_(0x80072F83L)
#define WININET_E_SERVER_UNREACHABLE  _HRESULT_TYPEDEF_(0x80072F84L)
#define WININET_E_PROXY_SERVER_UNREACHABLE _HRESULT_TYPEDEF_(0x80072F85L)
#define WININET_E_BAD_AUTO_PROXY_SCRIPT  _HRESULT_TYPEDEF_(0x80072F86L)
#define WININET_E_UNABLE_TO_DOWNLOAD_SCRIPT _HRESULT_TYPEDEF_(0x80072F87L)
#define WININET_E_SEC_INVALID_CERT  _HRESULT_TYPEDEF_(0x80072F89L)
#define WININET_E_SEC_CERT_REVOKED  _HRESULT_TYPEDEF_(0x80072F8AL)
#define WININET_E_FAILED_DUETOSECURITYCHECK _HRESULT_TYPEDEF_(0x80072F8BL)
#define WININET_E_NOT_INITIALIZED  _HRESULT_TYPEDEF_(0x80072F8CL)
#define WININET_E_LOGIN_FAILURE_DISPLAY_ENTITY_BODY _HRESULT_TYPEDEF_(0x80072F8EL)
#define WININET_E_DECODING_FAILED  _HRESULT_TYPEDEF_(0x80072F8FL)
#define WININET_E_NOT_REDIRECTED  _HRESULT_TYPEDEF_(0x80072F80L)
#define WININET_E_COOKIE_NEEDS_CONFIRMATION _HRESULT_TYPEDEF_(0x80072F81L)
#define WININET_E_COOKIE_DECLINED  _HRESULT_TYPEDEF_(0x80072F82L)
#define WININET_E_REDIRECT_NEEDS_CONFIRMATION _HRESULT_TYPEDEF_(0x80072F88L)
#define SQLITE_E_ERROR  _HRESULT_TYPEDEF_(0x87AF0001L)
#define SQLITE_E_INTERNAL  _HRESULT_TYPEDEF_(0x87AF0002L)
#define SQLITE_E_PERM  _HRESULT_TYPEDEF_(0x87AF0003L)
#define SQLITE_E_ABORT  _HRESULT_TYPEDEF_(0x87AF0004L)
#define SQLITE_E_BUSY  _HRESULT_TYPEDEF_(0x87AF0005L)
#define SQLITE_E_LOCKED  _HRESULT_TYPEDEF_(0x87AF0006L)
#define SQLITE_E_NOMEM  _HRESULT_TYPEDEF_(0x87AF0007L)
#define SQLITE_E_READONLY  _HRESULT_TYPEDEF_(0x87AF0008L)
#define SQLITE_E_INTERRUPT  _HRESULT_TYPEDEF_(0x87AF0009L)
#define SQLITE_E_IOERR  _HRESULT_TYPEDEF_(0x87AF000AL)
#define SQLITE_E_CORRUPT  _HRESULT_TYPEDEF_(0x87AF000BL)
#define SQLITE_E_NOTFOUND  _HRESULT_TYPEDEF_(0x87AF000CL)
#define SQLITE_E_FULL  _HRESULT_TYPEDEF_(0x87AF000DL)
#define SQLITE_E_CANTOPEN  _HRESULT_TYPEDEF_(0x87AF000EL)
#define SQLITE_E_PROTOCOL  _HRESULT_TYPEDEF_(0x87AF000FL)
#define SQLITE_E_EMPTY  _HRESULT_TYPEDEF_(0x87AF0010L)
#define SQLITE_E_SCHEMA  _HRESULT_TYPEDEF_(0x87AF0011L)
#define SQLITE_E_TOOBIG  _HRESULT_TYPEDEF_(0x87AF0012L)
#define SQLITE_E_CONSTRAINT  _HRESULT_TYPEDEF_(0x87AF0013L)
#define SQLITE_E_MISMATCH  _HRESULT_TYPEDEF_(0x87AF0014L)
#define SQLITE_E_MISUSE  _HRESULT_TYPEDEF_(0x87AF0015L)
#define SQLITE_E_NOLFS  _HRESULT_TYPEDEF_(0x87AF0016L)
#define SQLITE_E_AUTH  _HRESULT_TYPEDEF_(0x87AF0017L)
#define SQLITE_E_FORMAT  _HRESULT_TYPEDEF_(0x87AF0018L)
#define SQLITE_E_RANGE  _HRESULT_TYPEDEF_(0x87AF0019L)
#define SQLITE_E_NOTADB  _HRESULT_TYPEDEF_(0x87AF001AL)
#define SQLITE_E_NOTICE  _HRESULT_TYPEDEF_(0x87AF001BL)
#define SQLITE_E_WARNING  _HRESULT_TYPEDEF_(0x87AF001CL)
#define SQLITE_E_ROW  _HRESULT_TYPEDEF_(0x87AF0064L)
#define SQLITE_E_DONE  _HRESULT_TYPEDEF_(0x87AF0065L)
#define SQLITE_E_IOERR_READ  _HRESULT_TYPEDEF_(0x87AF010AL)
#define SQLITE_E_IOERR_SHORT_READ  _HRESULT_TYPEDEF_(0x87AF020AL)
#define SQLITE_E_IOERR_WRITE  _HRESULT_TYPEDEF_(0x87AF030AL)
#define SQLITE_E_IOERR_FSYNC  _HRESULT_TYPEDEF_(0x87AF040AL)
#define SQLITE_E_IOERR_DIR_FSYNC  _HRESULT_TYPEDEF_(0x87AF050AL)
#define SQLITE_E_IOERR_TRUNCATE  _HRESULT_TYPEDEF_(0x87AF060AL)
#define SQLITE_E_IOERR_FSTAT  _HRESULT_TYPEDEF_(0x87AF070AL)
#define SQLITE_E_IOERR_UNLOCK  _HRESULT_TYPEDEF_(0x87AF080AL)
#define SQLITE_E_IOERR_RDLOCK  _HRESULT_TYPEDEF_(0x87AF090AL)
#define SQLITE_E_IOERR_DELETE  _HRESULT_TYPEDEF_(0x87AF0A0AL)
#define SQLITE_E_IOERR_BLOCKED  _HRESULT_TYPEDEF_(0x87AF0B0AL)
#define SQLITE_E_IOERR_NOMEM  _HRESULT_TYPEDEF_(0x87AF0C0AL)
#define SQLITE_E_IOERR_ACCESS  _HRESULT_TYPEDEF_(0x87AF0D0AL)
#define SQLITE_E_IOERR_CHECKRESERVEDLOCK _HRESULT_TYPEDEF_(0x87AF0E0AL)
#define SQLITE_E_IOERR_LOCK  _HRESULT_TYPEDEF_(0x87AF0F0AL)
#define SQLITE_E_IOERR_CLOSE  _HRESULT_TYPEDEF_(0x87AF100AL)
#define SQLITE_E_IOERR_DIR_CLOSE  _HRESULT_TYPEDEF_(0x87AF110AL)
#define SQLITE_E_IOERR_SHMOPEN  _HRESULT_TYPEDEF_(0x87AF120AL)
#define SQLITE_E_IOERR_SHMSIZE  _HRESULT_TYPEDEF_(0x87AF130AL)
#define SQLITE_E_IOERR_SHMLOCK  _HRESULT_TYPEDEF_(0x87AF140AL)
#define SQLITE_E_IOERR_SHMMAP  _HRESULT_TYPEDEF_(0x87AF150AL)
#define SQLITE_E_IOERR_SEEK  _HRESULT_TYPEDEF_(0x87AF160AL)
#define SQLITE_E_IOERR_DELETE_NOENT  _HRESULT_TYPEDEF_(0x87AF170AL)
#define SQLITE_E_IOERR_MMAP  _HRESULT_TYPEDEF_(0x87AF180AL)
#define SQLITE_E_IOERR_GETTEMPPATH  _HRESULT_TYPEDEF_(0x87AF190AL)
#define SQLITE_E_IOERR_CONVPATH  _HRESULT_TYPEDEF_(0x87AF1A0AL)
#define SQLITE_E_IOERR_VNODE  _HRESULT_TYPEDEF_(0x87AF1A02L)
#define SQLITE_E_IOERR_AUTH  _HRESULT_TYPEDEF_(0x87AF1A03L)
#define SQLITE_E_LOCKED_SHAREDCACHE  _HRESULT_TYPEDEF_(0x87AF0106L)
#define SQLITE_E_BUSY_RECOVERY  _HRESULT_TYPEDEF_(0x87AF0105L)
#define SQLITE_E_BUSY_SNAPSHOT  _HRESULT_TYPEDEF_(0x87AF0205L)
#define SQLITE_E_CANTOPEN_NOTEMPDIR  _HRESULT_TYPEDEF_(0x87AF010EL)
#define SQLITE_E_CANTOPEN_ISDIR  _HRESULT_TYPEDEF_(0x87AF020EL)
#define SQLITE_E_CANTOPEN_FULLPATH  _HRESULT_TYPEDEF_(0x87AF030EL)
#define SQLITE_E_CANTOPEN_CONVPATH  _HRESULT_TYPEDEF_(0x87AF040EL)
#define SQLITE_E_CORRUPT_VTAB  _HRESULT_TYPEDEF_(0x87AF010BL)
#define SQLITE_E_READONLY_RECOVERY  _HRESULT_TYPEDEF_(0x87AF0108L)
#define SQLITE_E_READONLY_CANTLOCK  _HRESULT_TYPEDEF_(0x87AF0208L)
#define SQLITE_E_READONLY_ROLLBACK  _HRESULT_TYPEDEF_(0x87AF0308L)
#define SQLITE_E_READONLY_DBMOVED  _HRESULT_TYPEDEF_(0x87AF0408L)
#define SQLITE_E_ABORT_ROLLBACK  _HRESULT_TYPEDEF_(0x87AF0204L)
#define SQLITE_E_CONSTRAINT_CHECK  _HRESULT_TYPEDEF_(0x87AF0113L)
#define SQLITE_E_CONSTRAINT_COMMITHOOK  _HRESULT_TYPEDEF_(0x87AF0213L)
#define SQLITE_E_CONSTRAINT_FOREIGNKEY  _HRESULT_TYPEDEF_(0x87AF0313L)
#define SQLITE_E_CONSTRAINT_FUNCTION  _HRESULT_TYPEDEF_(0x87AF0413L)
#define SQLITE_E_CONSTRAINT_NOTNULL  _HRESULT_TYPEDEF_(0x87AF0513L)
#define SQLITE_E_CONSTRAINT_PRIMARYKEY  _HRESULT_TYPEDEF_(0x87AF0613L)
#define SQLITE_E_CONSTRAINT_TRIGGER  _HRESULT_TYPEDEF_(0x87AF0713L)
#define SQLITE_E_CONSTRAINT_UNIQUE  _HRESULT_TYPEDEF_(0x87AF0813L)
#define SQLITE_E_CONSTRAINT_VTAB  _HRESULT_TYPEDEF_(0x87AF0913L)
#define SQLITE_E_CONSTRAINT_ROWID  _HRESULT_TYPEDEF_(0x87AF0A13L)
#define SQLITE_E_NOTICE_RECOVER_WAL  _HRESULT_TYPEDEF_(0x87AF011BL)
#define SQLITE_E_NOTICE_RECOVER_ROLLBACK _HRESULT_TYPEDEF_(0x87AF021BL)
#define SQLITE_E_WARNING_AUTOINDEX  _HRESULT_TYPEDEF_(0x87AF011CL)
#define UTC_E_TOGGLE_TRACE_STARTED  _HRESULT_TYPEDEF_(0x87C51001L)
#define UTC_E_ALTERNATIVE_TRACE_CANNOT_PREEMPT _HRESULT_TYPEDEF_(0x87C51002L)
#define UTC_E_AOT_NOT_RUNNING  _HRESULT_TYPEDEF_(0x87C51003L)
#define UTC_E_SCRIPT_TYPE_INVALID  _HRESULT_TYPEDEF_(0x87C51004L)
#define UTC_E_SCENARIODEF_NOT_FOUND  _HRESULT_TYPEDEF_(0x87C51005L)
#define UTC_E_TRACEPROFILE_NOT_FOUND  _HRESULT_TYPEDEF_(0x87C51006L)
#define UTC_E_FORWARDER_ALREADY_ENABLED  _HRESULT_TYPEDEF_(0x87C51007L)
#define UTC_E_FORWARDER_ALREADY_DISABLED _HRESULT_TYPEDEF_(0x87C51008L)
#define UTC_E_EVENTLOG_ENTRY_MALFORMED  _HRESULT_TYPEDEF_(0x87C51009L)
#define UTC_E_DIAGRULES_SCHEMAVERSION_MISMATCH _HRESULT_TYPEDEF_(0x87C5100AL)
#define UTC_E_SCRIPT_TERMINATED  _HRESULT_TYPEDEF_(0x87C5100BL)
#define UTC_E_INVALID_CUSTOM_FILTER  _HRESULT_TYPEDEF_(0x87C5100CL)
#define UTC_E_TRACE_NOT_RUNNING  _HRESULT_TYPEDEF_(0x87C5100DL)
#define UTC_E_REESCALATED_TOO_QUICKLY  _HRESULT_TYPEDEF_(0x87C5100EL)
#define UTC_E_ESCALATION_ALREADY_RUNNING _HRESULT_TYPEDEF_(0x87C5100FL)
#define UTC_E_PERFTRACK_ALREADY_TRACING  _HRESULT_TYPEDEF_(0x87C51010L)
#define UTC_E_REACHED_MAX_ESCALATIONS  _HRESULT_TYPEDEF_(0x87C51011L)
#define UTC_E_FORWARDER_PRODUCER_MISMATCH _HRESULT_TYPEDEF_(0x87C51012L)
#define UTC_E_INTENTIONAL_SCRIPT_FAILURE _HRESULT_TYPEDEF_(0x87C51013L)
#define UTC_E_SQM_INIT_FAILED  _HRESULT_TYPEDEF_(0x87C51014L)
#define UTC_E_NO_WER_LOGGER_SUPPORTED  _HRESULT_TYPEDEF_(0x87C51015L)
#define UTC_E_TRACERS_DONT_EXIST  _HRESULT_TYPEDEF_(0x87C51016L)
#define UTC_E_WINRT_INIT_FAILED  _HRESULT_TYPEDEF_(0x87C51017L)
#define UTC_E_SCENARIODEF_SCHEMAVERSION_MISMATCH _HRESULT_TYPEDEF_(0x87C51018L)
#define UTC_E_INVALID_FILTER  _HRESULT_TYPEDEF_(0x87C51019L)
#define UTC_E_EXE_TERMINATED  _HRESULT_TYPEDEF_(0x87C5101AL)
#define UTC_E_ESCALATION_NOT_AUTHORIZED  _HRESULT_TYPEDEF_(0x87C5101BL)
#define UTC_E_SETUP_NOT_AUTHORIZED  _HRESULT_TYPEDEF_(0x87C5101CL)
#define UTC_E_CHILD_PROCESS_FAILED  _HRESULT_TYPEDEF_(0x87C5101DL)
#define UTC_E_COMMAND_LINE_NOT_AUTHORIZED _HRESULT_TYPEDEF_(0x87C5101EL)
#define UTC_E_CANNOT_LOAD_SCENARIO_EDITOR_XML _HRESULT_TYPEDEF_(0x87C5101FL)
#define UTC_E_ESCALATION_TIMED_OUT  _HRESULT_TYPEDEF_(0x87C51020L)
#define UTC_E_SETUP_TIMED_OUT  _HRESULT_TYPEDEF_(0x87C51021L)
#define UTC_E_TRIGGER_MISMATCH  _HRESULT_TYPEDEF_(0x87C51022L)
#define UTC_E_TRIGGER_NOT_FOUND  _HRESULT_TYPEDEF_(0x87C51023L)
#define UTC_E_SIF_NOT_SUPPORTED  _HRESULT_TYPEDEF_(0x87C51024L)
#define UTC_E_DELAY_TERMINATED  _HRESULT_TYPEDEF_(0x87C51025L)
#define UTC_E_DEVICE_TICKET_ERROR  _HRESULT_TYPEDEF_(0x87C51026L)
#define UTC_E_TRACE_BUFFER_LIMIT_EXCEEDED _HRESULT_TYPEDEF_(0x87C51027L)
#define UTC_E_API_RESULT_UNAVAILABLE  _HRESULT_TYPEDEF_(0x87C51028L)
#define UTC_E_RPC_TIMEOUT  _HRESULT_TYPEDEF_(0x87C51029L)
#define UTC_E_RPC_WAIT_FAILED  _HRESULT_TYPEDEF_(0x87C5102AL)
#define UTC_E_API_BUSY  _HRESULT_TYPEDEF_(0x87C5102BL)
#define UTC_E_TRACE_MIN_DURATION_REQUIREMENT_NOT_MET _HRESULT_TYPEDEF_(0x87C5102CL)
#define UTC_E_EXCLUSIVITY_NOT_AVAILABLE  _HRESULT_TYPEDEF_(0x87C5102DL)
#define UTC_E_GETFILE_FILE_PATH_NOT_APPROVED _HRESULT_TYPEDEF_(0x87C5102EL)
#define UTC_E_ESCALATION_DIRECTORY_ALREADY_EXISTS _HRESULT_TYPEDEF_(0x87C5102FL)

#endif /* _WINERROR_H */
